#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <cmath>

using namespace std;

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  int n, m, q;
  cin >> n >> m >> q;

  vector<vector<int>> a(n, vector<int>(m));

  vector<pair<int, int>> rows(n), cols(m);

  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      cin >> a[i][j];
      rows[i] = max(rows[i], { a[i][j], j });
      cols[j] = max(cols[j], { a[i][j], i });
    }
  }

  int cur = 0;
  if (n <= m) {
    for (int i = 0; i < n; ++i) {
      int bj = rows[i].second;
      if (cols[bj].second == i) cur++;
    }
  }
  else {
    for (int j = 0; j < m; ++j) {
      int bi = cols[j].second;
      if (rows[bi].second == j) cur++;
    }
  }

  while (q--) {
    int r, c, x;
    cin >> r >> c >> x;
    r--, c--;

    a[r][c] = x;

    rows[r] = max(rows[r], { a[r][c], c });
    cols[c] = max(cols[c], { a[r][c], r });

    int cur = 0;
    if (n <= m) {
      for (int i = 0; i < n; ++i) {
        int bj = rows[i].second;
        if (cols[bj].second == i) cur++;
      }
    }
    else {
      for (int j = 0; j < m; ++j) {
        int bi = cols[j].second;
        if (rows[bi].second == j) cur++;
      }
    }

    cout << cur << '\n';
  }

  return 0;
}