#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <cmath>

using namespace std;

const int MAXN = 501;

int a[MAXN][MAXN];
int vuln[MAXN][MAXN];

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  cin.tie(0);
  ios::sync_with_stdio(0);

  int n;
  cin >> n;

  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      cin >> a[i][j];
      --a[i][j];
      vuln[i][a[i][j]] = j;
    }
  }

  int p;
  cin >> p;

  vector<int> ans;

  if (p == 1) {
    for (int i = 0; i < n; ++i) {
      bool killed = false;
      for (int j = 0; j < n; ++j) {
        // j -> i
        if (vuln[i][i] > vuln[i][j]) {
          killed = true;
          break;
        }
      }
      if (!killed) ans.push_back(i);
    }
  }
  else {
    for (int v = 0; v < n; ++v) {
      vector<int> type(n);
      for (int i = 0; i < n; ++i) {
        type[i] = i;
      }
      // infect
      vector<int> left;
      int alive = 1;

      for (int i = 0; i < n; ++i) {
        if (type[i] == v) continue;
        if (vuln[i][i] > vuln[i][v]) {
          type[i] = v;
          alive++;
        }
        else {
          left.push_back(i);
        }
      }

      for (int i = 0; i < n; ++i) {
        if (type[i] != v) continue;
        bool killed = false;
        for (int j : left) {
          // j -> i
          if (vuln[i][v] > vuln[i][j]) {
            killed = true;
            break;
          }
        }
        if (killed) alive--;
      }
      if (alive > 0) ans.push_back(v);
    }
  }

  cout << ans.size() << '\n';
  for (int id : ans)
    cout << id + 1 << ' ';
  cout << '\n';

  return 0;
}