#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/Stack:480000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>

using namespace std;

const int MAXMEM = (int)480e6;
char MEM[MAXMEM];
size_t mempos = 0;

inline void* operator new (size_t n) {
  void *res = (void*)(MEM + mempos);
  mempos += n;
  return res;
}
inline void operator delete(void*) {}

const int MAXN = 400001;
int a[MAXN];

typedef long long LL;

const LL INF = (LL)1e9 + 3 * MAXN;

struct Fenwick {
  unordered_map<int, int> _sum;

  Fenwick() {
    _sum.rehash((int)1e6);
  }

  void inc(int pos, int delta) {
    for (LL i = pos; i < INF; i = i | (i + 1)) {
      _sum[i] += delta;
    }
  }

  int sum(int pos) {
    int s = 0;
    for (int i = pos; i > -1; i = (i & (i + 1)) - 1)
      s += _sum[i];
    return s;
  }
};

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  int n, p;
  scanf("%d%d", &n, &p);

  for (int i = 0; i < n; ++i)
    scanf("%d", &a[i]);

  if (p == 1) {
    for (int i = 1; i < n; ++i)
      a[i] += i;

    Fenwick left, right;

    for (int i = 0; i < n; ++i)
      right.inc(a[i], 1);

    int shift = 2 * n;
    for (int i = 0; i < n; ++i) {
      right.inc(a[i], -1);

      int p = right.sum(a[i] - 1) + left.sum(a[i] + shift - 1);
      printf("%d\n", p + 1);

      left.inc(a[i] + shift, 1);
      shift -= 2;
    }
  }
  else {
    for (int i = 0; i < n; ++i) {
      int mx = 0;
      for (int delta = 0; i < n && (i + delta < n || i - delta >= 0); ++delta) {
        int less = 0;
        for (int j = 0; j < n; ++j) {
          int add;
          
          if (j < i) {
            if (i >= delta)
              add = max(0, delta - (i - j));
            else
              add = delta + (i - j);
          }
          else {
            if (i + delta < n)
              add = max(0, delta - (j - i));
            else
              add = delta + (j - i);
          }

          if (a[j] + add < a[i] + delta) less++;
        }
        mx = max(mx, less);
      }
      printf("%d\n", mx + 1);
    }
  }

  return 0;
}