#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/Stack:480000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>

using namespace std;

const int MAXN = 400001;
int a[MAXN];

const int INF = (int)2e9;

struct Fenwick {
  unordered_map<int, int> _sum;

  void inc(int pos, int delta) {
    for (long long i = pos; i < INF; i = i | (i + 1)) {
      _sum[i] += delta;
    }
  }

  int sum(int pos) {
    int s = 0;
    for (int i = pos; i > -1; i = (i & (i + 1)) - 1)
      s += _sum[i];
    return s;
  }

  int sum(int L, int R) {
    return sum(R) - sum(L - 1);
  }
};

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);

  int n, p;
  cin >> n >> p;
  
  for (int i = 0; i < n; ++i)
    cin >> a[i];

  if (p == 1) {
    for (int i = 1; i < n; ++i)
      a[i] += i;
    
    Fenwick left, right;

    for (int i = 0; i < n; ++i)
      right.inc(a[i], 1);
    
    int shift = 2 * n;
    for (int i = 0; i < n; ++i) {
      right.inc(a[i], -1);

      int p = right.sum(a[i] - 1) + left.sum(a[i] + shift - 1);
      cout << p + 1 << '\n';

      left.inc(a[i] + shift, 1);
      shift -= 2;
    }
  }
  else {

  }

  return 0;
}