#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

struct node
{
	int sum;
	node* l;
	node* r;
	node() : sum(0), l(NULL), r(NULL) {};
};

void inc(node* &root, int l, int r, int v, int tmp)
{
	if (l >= r || l > v || r <= v)
		return;
	if (root == NULL)
		root = new node();
	if (l + 1 == r)
	{
		root->sum += tmp;
		return;
	}
	int m = (l + r) / 2;
	inc(root->l, l, m, v, tmp);
	inc(root->r, m, r, v, tmp);
	root->sum = (root->l == NULL ? 0 : root->l->sum) + (root->r == NULL ? 0 : root->r->sum);
}

ll gets(node* root, int l, int r, int L)
{
	if (l + 1 > r || root == NULL || r <= L)
		return 0ll;
	if (L <= l)
		return root->sum;
	int m = (l + r) / 2;
	return gets(root->l, l, m, L) + gets(root->r, m, r, L);
}

const int INF = 1e9 + 10;
node* tree;
ll ans = 0;
int n;
vector <pair <int, int > > a;
vector <int > arr;

void sum(int aa, ll k, int bb)
{
	ans = max(ans, aa * k + gets(tree, 0, INF, bb) * bb);
}

void get(int x, int k)
{
	sum(x, k, 0);
	for (int i = 0; i < arr.size(); i++)
		sum(x, k, arr[i]);
}

void play()
{
	for (int i = 0; i < n; i++)
	{
		if (i != 0)
		{
			inc(tree, 0, INF, a[i - 1].second, 1);
			arr.push_back(a[i - 1].second);
		}
		get(a[i].first, n - i);
	}
}


int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;
	sort(a.begin(), a.end());

	play();

	cout << ans;
	return 0;
}