﻿#include "stdafx.h"

#pragma GCC optimize ("Ofast")

#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef pair <ll, ll> pll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)
#define mp make_pair

const int MAXN = 510;
ld deg[MAXN];
ld INF;
int n, m, k;
ld g[MAXN][MAXN];
pll vertex[MAXN];


ld getDist(ll a, ll b) {
	return max(deg[abs(vertex[a].first - vertex[b].first)], deg[abs(vertex[a].second - vertex[b].second)]);
}

void read() {
	cin >> n >> m >> k;
	for (int i = 0; i < k; i++) {
		int x, y;
		cin >> x >> y; x--, y--;
		vertex[i] = mp(x, y);
	}
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			if (i != j) {
				g[i][j] = getDist(i, j);
			}
		}
	}
}

ld dist[MAXN];
ll pred[MAXN];
bool used[MAXN];

void solve() {
	for (int i = 0; i < k; i++) {
		dist[i] = INF;
		pred[i] = i;
	}
	dist[0] = 0;
	for (int i = 0; i < k; i++) {
		int v = -1;
		for (int j = 0; j < k; j++) {
			if (!used[j] && (v == -1 || dist[v] > dist[j])) {
				v = j;
			}
		}
		if (v == -1) break;
		used[v] = true;
		for (int j = 0; j < k; j++) {
			if (!used[j] && dist[v] + g[v][j] < dist[j]) {
				dist[j] = dist[v] + g[v][j];
				pred[j] = v;
			}
		}
	}
	vector <int> ans;
	int v = k - 1;
	while (pred[v] != v) {
		ans.push_back(v);
		v = pred[v];
	}
	ans.push_back(v);
	reverse(all(ans));
	cout << ans.size() << '\n';
	for (auto now : ans){
		cout << now + 1 << ' ';
	}
}

int main() {
	deg[0] = 1;
	for (int i = 1; i < MAXN; i++) {
		deg[i] = deg[i - 1] * 2;
	}
	INF = deg[MAXN - 1];
	read();
	solve();
}