#pragma GCC optimize("O3")

#include <bits/stdc++.h>
using namespace std;

const int MAXN = 400000;
int n;
int a[MAXN];
int xs[3 * MAXN];
int xssz;
vector<int> ci, ca, cs;

struct Fenvick {
    vector<int> fv;

    Fenvick() {
        fv.resize(xssz);
    }

    inline void clear() {
        fv.assign(xssz, 0);
    }

    inline void add(int i) {
        while (i < fv.size()) {
            fv[i]++;
            i = i | (i + 1);
        }
    }

    inline void rem(int i) {
        while (i < fv.size()) {
            fv[i]--;
            i = i | (i + 1);
        }
    }

    inline int get(int i) {
        i--;
        int s = 0;
        while (i >= 0) {
            s += fv[i];
            i = (i & (i + 1)) - 1;
        }
        return s;
    }
};

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int p;
    cin >> n >> p;
    if (p == 1) {
        return 1;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> ans1(n), ans2(n);

    vector<pair<int, int>> ord(n);
    for (int i = 0; i < n; i++) {
        ord[i] = {a[i] + n - 1 - i, i};
    }
    sort(ord.begin(), ord.end());
    int eq = 0;
    for (int i = 0; i < ord.size(); i++) {
        if (i > 0 && ord[i].first == ord[i - 1].first) {
            eq++;
        } else {
            eq = 0;
        }

        if (ord[i].second < n / 2) {
            int j = ord[i].second;
            ans1[j] = i - eq;
        }
    }

    for (int i = 0; i < n; i++) {
        ord[i] = {a[i] + i, i};
    }
    sort(ord.begin(), ord.end());
    eq = 0;
    for (int i = 0; i < ord.size(); i++) {
        if (i > 0 && ord[i].first == ord[i - 1].first) {
            eq++;
        } else {
            eq = 0;
        }

        if (ord[i].second >= n / 2) {
            int j = ord[i].second;
            ans1[j] = i - eq;
        }
    }

    for (int i = 0; i < n; i++) {
        xs[xssz++] = a[i];
        xs[xssz++] = a[i] + n - 1 - i;
        xs[xssz++] = a[i] + i;
    }
    sort(xs, xs + xssz);
    xssz = unique(xs, xs + xssz) - xs;

    ci.resize(n);
    ca.resize(n);
    cs.resize(n);
    for (int i = 0; i < n; i++) {
        ci[i] = lower_bound(xs, xs + xssz, a[i]) - xs;
        ca[i] = lower_bound(xs, xs + xssz, a[i] + i) - xs;
        cs[i] = lower_bound(xs, xs + xssz, a[i] + n - 1 - i) - xs;
    }


    Fenvick fv1;
    for (int i = 0; i < n / 2; i++) {
        ans2[i] += fv1.get(ca[i]);
        fv1.add(ca[i]);
    }
    fv1.clear();
    Fenvick fv2;
    for (int i = 0; i < n; i++) {
        fv1.add(ci[i]);
    }
    for (int i = 0; i < n / 2; i++) {
        ans2[i] += fv1.get(ca[i]) + fv2.get(cs[i]);
        if (i + 1 < n / 2) {
            fv1.rem(ci[2 * i]);
            fv1.rem(ci[2 * i + 1]);
            fv2.add(cs[2 * i]);
            fv2.add(cs[2 * i + 1]);
            fv2.rem(cs[i]);
        }
    }

    reverse(a, a + n);
    reverse(ci.begin(), ci.end());
    reverse(ca.begin(), ca.end());
    reverse(cs.begin(), cs.end());
    ca.swap(cs);

    fv1.clear();
    for (int i = 0; i < n - n / 2; i++) {
        ans2[n - 1 - i] += fv1.get(ca[i]);
        fv1.add(ca[i]);
    }
    fv1.clear();
    fv2.clear();
    for (int i = 0; i < n; i++) {
        fv1.add(ci[i]);
    }
    for (int i = 0; i < n - n / 2; i++) {
        ans2[n - 1 - i] += fv1.get(ca[i]) + fv2.get(cs[i]);
        if (i + 1 < n - n / 2) {
            fv1.rem(ci[2 * i]);
            fv1.rem(ci[2 * i + 1]);
            fv2.add(cs[2 * i]);
            fv2.add(cs[2 * i + 1]);
            fv2.rem(cs[i]);
        }
    }

    for (int i = 0; i < n; i++) {
        cout << max(ans1[i], ans2[i]) + 1 << "\n";
    }

    return 0;
}