#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <math.h>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <deque>
#include <iterator>
#include <random>
using namespace std;
typedef long long ll;

int n;
vector<int> a;
vector<pair<int, int> > tmn, tmx;

void build(int v, int tl, int tr) {
	if (tl == tr) {
		tmn[v] = { a[tl], tl };
		tmx[v] = { a[tl], tl };
	}
	else {
		int mid = (tl + tr) / 2;
		build(2 * v, tl, mid);
		build(2 * v + 1, mid + 1, tr);
		if (tmn[2 * v + 1].first < tmn[2 * v].first) {
			tmn[v] = tmn[2 * v + 1];
		}
		else {
			tmn[v] = tmn[2 * v];
		}
		if (tmx[2 * v].first > tmx[2 * v + 1].first) {
			tmx[v] = tmx[2 * v];
		}
		else {
			tmx[v] = tmx[2 * v + 1];
		}
	}
}

pair<int, int> getmin(int v, int tl, int tr, int l, int r) {
	if (l == tl && r == tr) {
		return tmn[v];
	}
	else {
		int mid = (tl + tr) / 2;
		pair<int, int> ans;
		if (l <= mid && r > mid) {
			pair<int, int> a1 = getmin(2 * v, tl, mid, l, min(r, mid));
			pair<int, int> a2 = getmin(2 * v + 1, mid + 1, tr, max(l, mid + 1), r);
			if (a2.first < a1.first) {
				ans = a2;
			}
			else {
				ans = a1;
			}
		}
		else if (l <= mid) {
			ans = getmin(2 * v, tl, mid, l, min(r, mid));
		}
		else {
			ans = getmin(2 * v + 1, mid + 1, tr, max(l, mid + 1), r);
		}
		return ans;
	}
}

pair<int, int> getmax(int v, int tl, int tr, int l, int r) {
	if (l == tl && r == tr) {
		return tmx[v];
	}
	else {
		int mid = (tl + tr) / 2;
		pair<int, int> ans;
		if (l <= mid && r > mid) {
			pair<int, int> a1 = getmax(2 * v, tl, mid, l, min(r, mid));
			pair<int, int> a2 = getmax(2 * v + 1, mid + 1, tr, max(l, mid + 1), r);
			if (a1.first > a2.first) {
				ans = a1;
			}
			else {
				ans = a2;
			}
		}
		else if (l <= mid) {
			ans = getmax(2 * v, tl, mid, l, min(r, mid));
		}
		else {
			ans = getmax(2 * v + 1, mid + 1, tr, max(l, mid + 1), r);
		}
		return ans;
	}
}

int ans(int l, int r) {
	if (l == r) {
		return 1;
	}
	pair<int, int> mx = getmax(1, 0, n - 1, l, r);
	if (mx.second == l) {
		return 1 + ans(l + 1, r);
	}
	pair<int, int> mn = getmin(1, 0, n - 1, l, mx.second - 1);
	if (mn.second == l && mx.second == r) {
		return 1;
	}
	else if (mn.second == l) {
		return 1 + ans(mx.second + 1, r);
	}
	else if (mx.second == r) {
		return 1 + ans(l, mn.second - 1);
	}
	else {
		return 1 + ans(l, mn.second - 1) + ans(mx.second + 1, r);
	}
}

int main() {
#pragma warning(disable:4996)
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n;
	a = vector<int>(n);
	tmn = vector<pair<int, int> >(4 * n + 100000);
	tmx = vector<pair<int, int> >(4 * n + 100000);
	for (int i = 0; i < n; i++) {
		scanf("%d", &a[i]);
	}
	build(1, 0, n - 1);
	cout << ans(0, n - 1);
	return 0;
}