#include<iostream>
#include<algorithm>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<ctime>
#include<cmath>
#include<iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<double> vd;
typedef vector<ld> vld;
typedef vector<bool> vb;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int inf = 1e9 + 9;
const ll linf = 1e18 + 1;
const ld eps = 1e-7;

#define it(v) v.begin(), v.end()
#define mp make_pair
#define pb push_back
#define eb emplace_back
#define fst first
#define scn second

const int logn = 20;
vi lg, pow2(logn);

struct sparse_mn
{
	vector<vector<pii>> tb;
	int n;

	sparse_mn(vi &a)
	{
		n = a.size();
		build(a);
	}

	void build(vi &a)
	{
		tb.pb(vector<pii>());
		for (int i = 0; i < n; i++)
		{
			tb[0].eb(a[i], i);
		}
		for (int i = 1; i <= lg[n]; i++)
		{
			tb.pb(vector<pii>());
			for (int j = 0; j < n - pow2[i] + 1; j++)
			{
				tb[i].pb(min(tb[i - 1][j], tb[i - 1][j + pow2[i - 1]]));
			}
		}
	}

	pii query(int l, int r)
	{
		int len = r - l + 1;
		return min(tb[lg[len]][l], tb[lg[len]][r - pow2[lg[len]] + 1]);
	}
};

struct sparse_mx
{
	vector<vector<pii>> tb;
	int n;

	sparse_mx(vi &a)
	{
		n = a.size();
		build(a);
	}

	void build(vi &a)
	{
		tb.pb(vector<pii>());
		for (int i = 0; i < n; i++)
		{
			tb[0].eb(a[i], i);
		}
		for (int i = 1; i <= lg[n]; i++)
		{
			tb.pb(vector<pii>());
			for (int j = 0; j < n - pow2[i] + 1; j++)
			{
				tb[i].pb(max(tb[i - 1][j], tb[i - 1][j + pow2[i - 1]]));
			}
		}
	}

	pii query(int l, int r)
	{
		int len = r - l + 1;
		return max(tb[lg[len]][l], tb[lg[len]][r - pow2[lg[len]] + 1]);
	}
};

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout << setprecision(10) << fixed;
	int n;
	cin >> n;
	vi a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	lg.assign(n + 1, 0);
	for (int i = 1; i < n + 1; i++)
	{
		lg[i] = floorl(log2l(i) + eps);
	}
	pow2[0] = 1;
	for (int i = 1; i < logn; i++)
	{
		pow2[i] = pow2[i - 1] * 2;
	}
	sparse_mn minim(a);
	sparse_mx maxim(a);
	int left = 0, res = 0;
	while (left < n)
	{
		int l = left, r = n;
		while (r - l > 1)
		{
			int mid = (l + r) / 2;
			pii ans = minim.query(l, mid);
			if (ans.fst < a[left])
			{
				r = mid;
			}
			else
			{
				l = mid;
			}
		}
		int right = l;
		res++;
		left = maxim.query(left, right).scn + 1;
	}
	cout << res;
}

