#include <bits/stdc++.h>

#define ll long long
#define ld long double

using namespace std;

const int maxN = 125005;
const int BUBEN = 300;
const ll INF = 2e9;
const ld eps = 1e-6;

struct Data {
    ll a, b;

    Data() {}
    Data(ll _a, ll _b) : a(_a), b(_b) {}
};

bool operator < (const Data& d1, const Data& d2) {
    return d1.a < d2.a;
}

struct Line {
    ld k, b;
    Line() {}
    Line(ld _k, ld _b) : k(_k), b(_b) {}
};

struct Point {
    ld x, y;
    Point() {}
    Point(ld _x, ld _y) : x(_x), y(_y) {}
};

Point perLine(Line l1, Line l2) {
    ld x = (l2.b - l1.b) / (l1.k - l2.k);
    ld y = x * l1.k + l1.b;
    return Point(x, y);
}

struct CHT {
    deque<Line> cht;
    int lst;
    void add(Line l) {
        while (cht.size() > 1) {
            Point p = perLine(cht.back(), cht[cht.size() - 2]);
            if (p.y <= p.x * l.k + l.b + eps) cht.pop_back();
            else break;
        }
        cht.push_back(l);
    }

    ll get(ll x) {
        if (cht.size() == 0) return 0;
        while (lst < cht.size() - 1 && perLine(cht[lst], cht[lst + 1]).x + eps < x) lst++;
        return round(cht[lst].k * x + cht[lst].b);
    }

    void clear() {
        cht.clear();
        lst = 0;
    }
};

Data arr[maxN];
ll crr[maxN];
ll toAdd[maxN / BUBEN + 50];
vector<int> ord[maxN / BUBEN + 50];
CHT cht[maxN / BUBEN + 50];

vector<int> coords;

void add(int l, int r, int x) {
    int lb = l / BUBEN;
    int rb = (r - 1) / BUBEN;

    for (int i = lb + 1; i <= rb - 1; i++) toAdd[i] += x;

    //cout << lb << " " << rb << " " << l << " " << r << endl;

    for (int i = lb * BUBEN; i < (lb + 1) * BUBEN; i++) crr[i] += toAdd[lb];
    toAdd[lb] = 0;
    for (int i = rb * BUBEN; i < (rb + 1) * BUBEN; i++) crr[i] += toAdd[rb];
    toAdd[rb] = 0;

    for (int i = l; i < min((lb + 1) * BUBEN, r); i++) crr[i] += x;
    if (lb != rb) {
        for (int i = rb * BUBEN; i < r; i++) crr[i] += x;
    }

    cht[lb].clear();
    cht[rb].clear();
    for (int i : ord[lb]) {
        cht[lb].add(Line(coords[i], coords[i] * crr[i]));
    }
    if (lb != rb) {
        for (int i : ord[rb]) {
            cht[rb].add(Line(coords[i], coords[i] * crr[i]));
        }
    }

    /*
    cout << l << endl;
    for (int i = 0; i < 10; i++) cout << crr[i] << " ";
    cout << endl;

    for (int i = l; i < r; i++) crr[i] += x;
    //*/
}

ll get(int n) {
    //*
    int r = (n + BUBEN - 1) / BUBEN;

    ll res = 0;
    for (int i = 0; i <= r; i++) {
        res = max(res, cht[i].get(toAdd[i]));
    }

    return res;
    //*/

    /*
    ll res = 0;
    for (int i = 0; i < n; i++) res = max(res, crr[i] * coords[i]);
    return res;
    //*/
}

void build(int n) {
    int R = (n + BUBEN - 1) / BUBEN;
    for (int i = 0; i <= R; i++) {
        int l = i * BUBEN, r = min(n, (i + 1) * BUBEN);
        if (l >= r) break;

        for (int j = l; j < r; j++) ord[i].push_back(j);
        sort(ord[i].begin(), ord[i].end(), [](int i, int j) {return coords[i] < coords[j];});
    }
}

int get_ind(int b) {
    return lower_bound(coords.begin(), coords.end(), b) - coords.begin();
}

int main() {
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    coords.resize(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].a >> arr[i].b;
        coords[i] = arr[i].b;
    }
    arr[n] = Data(INF, INF);
    coords[n] = INF;

    sort(coords.begin(), coords.end());
    coords.resize(unique(coords.begin(), coords.end()) - coords.begin());

    build(coords.size());

    sort(arr, arr + n + 1);
    reverse(arr, arr + n + 1);

    ll ans = arr[n].a * n;
    add(0, get_ind(arr[n].b) + 1, 1);
    for (int j = n - 1; j >= 0; j--) {
        /*for (int i = 0; i < 10; i++) {
            cout << crr[i] + toAdd[i / BUBEN] << " ";
        }
        cout << endl;*/
        //if (j == 6) return 0;

        ans = max(ans, arr[j].a * j + get(coords.size()));
        add(0, get_ind(arr[j].b) + 1, 1);
    }

    cout << ans << endl;

    return 0;
}
