#include <bits/stdc++.h>

using namespace std;

const int maxN = 400005;
const int INF = 1e9;

int arr[maxN];
int fw[maxN];
int fwL[maxN];
int fwR[maxN];

void add(int* fw, int i, int n, int x) {
    for (; i < n; i = i|(i + 1)) fw[i] += x;
}

int get(int* fw, int i) {
    if (i < 0) return 0;

    int res = 0;
    for (; i >= 0; i = (i&(i + 1)) - 1) res += fw[i];
    return res;
}

int get_ind(vector<int>& coords, int x) {
    return lower_bound(coords.begin(), coords.end(), x) - coords.begin();
}

int ans[maxN];

void build(vector<int>& c) {
    sort(c.begin(), c.end());
    c.resize(unique(c.begin(), c.end()) - c.begin());
}

vector<int> solve(int n) {
    vector<int> ans(n, 0);

    vector<int> cL;
    for (int i = 0; i < n; i++) cL.push_back(arr[i] + i);
    build(cL);

    for (int i = 0; i < n; i++) fw[i] = 0, fwL[i] = 0, fwR[i] = 0;
    for (int i = 0; i < n; i++) add(fw, get_ind(cL, arr[i] + i), cL.size(), 1);

    for (int i = 0; i < n; i++) {
        ans[i] = max(ans[i], get(fw, get_ind(cL, arr[i] + i) - 1) + 1);
    }

    vector<int> c0, cR;
    for (int i = 0; i < n; i++) c0.push_back(arr[i]);
    build(c0);

    for (int i = 0; i < n; i++) fw[i] = 0;

    add(fwL, get_ind(cL, arr[0]), cL.size(), 1);

    int deltaR = 0;
    for (int i = 1; i < n; i++) {
        cR.push_back(arr[i] - deltaR);
        if (2 * i < n) cR.push_back(arr[2 * i] - deltaR);
        if (2 * i + 1 < n) cR.push_back(arr[2 * i + 1] - 1 - deltaR);
        deltaR += 2;
    }
    build(cR);
    deltaR = 0;

    for (int i = 1; i < n; i++) {
        int cntL = get(fwL, get_ind(cL, arr[i] + i) - 1);
        int cnt = get(fw, get_ind(c0, arr[i]) - 1);
        int cntR = get(fwR, get_ind(cR, arr[i] - deltaR) - 1);

        ans[i] = max(ans[i], cntL + cnt + cntR + 1);

        add(fwL, get_ind(cL, arr[i] + i), cL.size(), 1);
        if (2 * i < n) {
            add(fw, get_ind(c0, arr[2 * i]), c0.size(), -1);
            add(fwR, get_ind(cR, arr[2 * i + 1] - deltaR), cR.size(), 1);
        }
        else break;
        if (2 * i + 1 < n) {
            add(fw, get_ind(c0, arr[2 * i + 1]), c0.size(), -1);
            add(fwR, get_ind(cR, arr[2 * i + 1] - 1 - deltaR), cR.size(), 1);
        }
        deltaR += 2;
    }

    return ans;
}

int main() {
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, p;
    cin >> n >> p;

    assert(p == 2);

    for (int i = 0; i < n; i++) cin >> arr[i];

    auto v = solve(n);
    for (int i = 0; i < n; i++) ans[i] = v[i];
    reverse(arr, arr + n);
    v = solve(n);
    for (int i = 0; i < n; i++) ans[i] = max(ans[i], v[n - 1 - i]);

    for (int i = 0; i < n; i++) cout << ans[i] << " ";
    cout << endl;

    return 0;
}
