#include <bits/stdc++.h>

using namespace std;

const int maxN = 400005;
const int INF = 1e9;

struct Vert {
    Vert *left, *right;
    int val;
    int cnt;
    int w;

    Vert() {
        left = 0;
        right = 0;
        cnt = 1;
        w = rand();
    }

    Vert(int _val) {
        left = 0;
        right = 0;
        w = rand();
        cnt = 1;
        val = _val;
    }
};

int getCnt(Vert* v) {
    if (!v) return 0;
    return v->cnt;
}

void update(Vert* v) {
    v->cnt = 1 + getCnt(v->left) + getCnt(v->right);
}

pair<Vert*, Vert*> split(Vert* v, int x) {
    if (!v) return {0, 0};

    if (v->val < x) {
        auto p = split(v->right, x);
        v->right = p.first;
        update(v);
        return {v, p.second};
    }
    else {
        auto p = split(v->left, x);
        v->left = p.second;
        update(v);
        return {p.first, v};
    }
}

Vert* merge(Vert* left, Vert* right) {
    if (!left) return right;
    if (!right) return left;

    if (left->w > right->w) {
        left->right = merge(left->right, right);
        update(left);
        return left;
    }
    else {
        right->left = merge(left, right->left);
        update(right);
        return right;
    }
}

Vert* add(Vert* v, int x) {
    auto p = split(v, x);
    v = merge(p.first, new Vert(x));
    v = merge(v, p.second);
    return v;
}

Vert* del(Vert* v, int x) {
    auto p = split(v, x);
    auto p2 = split(p.second, x + 1);
    if (p2.first) p2.first = merge(p2.first->left, p2.first->right);
    p.second = merge(p2.first, p2.second);
    v = merge(p.first, p.second);
    return v;
}

int get(Vert* &v, int x) {
    auto p = split(v, x);
    int res = getCnt(p.first);
    v = merge(p.first, p.second);
    return res;
}

void print(Vert* v) {
    if (!v) return;
    cout << v << ": " << v->left << " " << v->right << " " << v->val << " " << v->cnt << endl;
    print(v->left);
    print(v->right);
}

int arr[maxN];

int main() {
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, p;
    cin >> n >> p;

    assert(p == 1);

    for (int i = 0; i < n; i++) cin >> arr[i];

    Vert* left = 0;
    Vert* right = 0;
    int deltaL = 0;
    int deltaR = 0;

    for (int i = 1; i < n; i++) {
        right = add(right, arr[i] + i);
    }

    /*print(right);
    return 0;*/

    for (int i = 0; i < n; i++) {
        int cntl = get(left, arr[i] - deltaL);
        int cntr = get(right, arr[i] + deltaR);

        cout << (cntl + cntr + 1) << " ";

        left = add(left, arr[i] - deltaL); deltaL++;
        right = del(right, arr[i + 1] + i + 1); deltaR--;
    }
    cout << endl;

    return 0;
}
