#include "bits/stdc++.h"

#define mp make_pair
#define len(v) ((int)v.size())
#define pb push_back
#define x first
#define y second
#define less aoenutshaeonsus

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

int n, m, k;
vector<pii> v;
vector<vector<int>> g;
vector<int> kek(10005);

int get_dist(int i, int j) {
	return max(abs(v[i].x - v[j].x), abs(v[i].y - v[j].y));
}

int get_dir(int x) {
	if (x > 0) return 1;
	if (x < 0) return -1;
	return 0;
}

struct Node {
	Node *l = NULL, *r = NULL;
	int tl, tr;
	int value = 0;
	int hash = 0;
	bool mod_zero = false;
};

bool is_list(Node *node) {
	return node->tl + 1 == node->tr;	
}

bool included_by(Node *node, int ql, int qr) {
	return ql <= node->tl && node->tr <= qr;
}

bool intersects(Node *node, int ql, int qr) {
	return !(node->tr <= ql || qr <= node->tl);
}

int get_value(Node *node) {
	if (node->mod_zero) return 0;
	return node->value;
}

int get_hash(Node *node) {
	if (node->mod_zero) return 0;
	return node->hash;
}


Node *create(int _tl, int _tr) {
	Node *node = new Node();
	node->tl = _tl;
	node->tr = _tr;
	if (!is_list(node)) {
		node->l = create(_tl, (_tl + _tr) / 2);
		node->r = create((_tl + _tr) / 2, _tr);
	}
	return node;
}

Node *clone(Node *node) {
	Node *cl = new Node();
	cl->tl = node->tl;
	cl->tr = node->tr;
	cl->value = node->value;
	cl->hash = node->hash;
	cl->mod_zero = node->mod_zero;
	cl->l = node->l;
	cl->r = node->r;
	return cl;
}

Node *push_zero(Node *node) {
	Node *cl = clone(node);
	cl->mod_zero = true;
	return cl;
}

Node *push(Node *node) {
	if (!node->mod_zero) return node;
	Node *cl = clone(node);
	cl->value = 0;
	if (!is_list(cl)) {
		cl->l = push_zero(cl->l);
		cl->r = push_zero(cl->r);
	}
	cl->mod_zero = false;
	return cl;
}

Node *set_zero(Node *node, int ql, int qr) {
	node = push(node);
	if (included_by(node, ql, qr)) {
		Node *cl = clone(node);
		cl->mod_zero = true;
		return cl;
	} else {
		Node *cl = clone(node);
		if (intersects(node->l, ql, qr)) {
			cl->l = set_zero(cl->l, ql, qr);
		}
		if (intersects(node->r, ql, qr)) {
			cl->r = set_zero(cl->r, ql, qr);
		}
		cl->value = get_value(cl->l) + get_value(cl->r);
		cl->hash = get_hash(cl->l) + get_hash(cl->r);
		return cl;
	}
}

Node *set_one(Node *node, int i) {
	node = push(node);
	if (is_list(node)) {
		Node *cl = clone(node);
		cl->value = 1;
		cl->hash = kek[cl->tl];
		return cl;
	} else {
		Node *cl = clone(node);
		if (i < node->l->tr) {
			cl->l = set_one(node->l, i); 
		} else {
			cl->r = set_one(node->r, i);
		}
		cl->value = get_value(cl->l) + get_value(cl->r);
		cl->hash = get_hash(cl->l) + get_hash(cl->r);
		return cl;
	}
}


int cnt_ones(Node *node, int L) {
	node = push(node);
	if (is_list(node)) {
		if (node->tl < L) return 0;
		return node->value;
	} else {
		if (node->tr <= L) return 0;
		if (L <= node->tl) {
			if (get_value(node->l) == node->l->tr - node->l->tl) {
				return get_value(node->l) + cnt_ones(node->r, L);
			} else {
				return cnt_ones(node->l, L);
			}
		} else {
			int ls = cnt_ones(node->l, L);
			if (ls == max(node->l->tr - L, 0)) {
				ls += cnt_ones(node->r, L);
			}
			return ls;
		}
	}
}

int less(Node *a, Node *b) {
	a = push(a);
	b = push(b);
	if (is_list(a)) {
		if (a->value < b->value) return -1;
		if (a->value > b->value) return 1;
		return 0;
	} else {
		if (get_hash(a->r) == get_hash(b->r)) {
			return less(a->l, b->l);
		} else {
			return less(a->r, b->r);
		}
	}
}

Node *emp = create(0, 10001);

struct Num {
	Node *v = emp;

	Num() {}
	Num(int bit) {
		v = set_one(v, bit);
	}

	Num(Node *_v) {
		v = _v;
	}

	Num add(int i) {
		Node *cl = clone(v);
		int ones = cnt_ones(cl, i);	
		if (ones) {
			cl = set_zero(cl, i, i + ones);
		}
		return set_one(cl, i + ones);
	}

	friend bool operator<(const Num &a, const Num &b) {
		return less(a.v, b.v) == -1;
	}

	friend bool operator>(const Num &a, const Num &b) {
		return b < a;
	}
};

signed main() {
	{
		for (int i = 0; i < len(kek); i++) {
			kek[i] = rand() % 10000;
		}
	}
	{
		cin >> n >> m >> k;
		v.resize(k);
		for (int i = 0; i < k; i++) {
			cin >> v[i].x >> v[i].y;
		}
	}
	{
		g.resize(k);
		for (int i = 0; i < k; i++) {
			for (int dx = -1; dx <= 1; dx++) {
				for (int dy = -1; dy <= 1; dy++) {
					int _min = 1e9;
					for (int j = 0; j < k; j++) {
						if (get_dir(v[i].x - v[j].x) == dx && get_dir(v[i].y - v[j].y) == dy) {
							_min = min(_min, get_dist(i, j));
						}
					}
					for (int j = 0; j < k; j++) {
						if (get_dir(v[i].x - v[j].x) == dx && get_dir(v[i].y - v[j].y) == dy) {
							if (get_dist(i, j) == _min) {
								if (len(g[i]) < 10) {
									g[i].pb(j);
								}
							}	
						}
					}
				}
			}
		}
	}
	{
		vector<Num> dist(k, Num(max(n, m) + 1));
		vector<int> pref(k, -1);
		dist[0] = Num();
		auto cmp = [&dist](int a, int b) {
			return dist[a] > dist[b];
		};
		priority_queue<int, vector<int>, decltype(cmp)> deq(cmp);
		deq.push(0);

		while (!deq.empty()) {
			int p = deq.top();
			deq.pop();

			for (int sub : g[p]) {
				if (dist[p].add(get_dist(p, sub)) < dist[sub]) {
					dist[sub] = dist[p].add(get_dist(p, sub));
					pref[sub] = p;
					deq.push(sub);
				}
			}
		}
		vector<int> path;
		int end = k - 1;
		while (end != -1) {
			path.pb(end);
			end = pref[end];
		}
		cout << len(path) << endl;
		reverse(path.begin(), path.end());
		for (int x : path) {
			cout << x + 1 << " ";
		}
		cout << endl;
	}
}