#include "bits/stdc++.h"
#define pb push_back
#define right aoeuthoaneuhts
#define find aoehtuaoeuhso
#define len(v) ((int)v.size())

using namespace std;

typedef pair<int, int> pii;

int n;
vector<int> v;

struct Node {
	Node *l = NULL, *r = NULL;
	int tl, tr;
	int value = 0;

	bool is_list() {
		return tl + 1 == tr;
	}

	bool included_by(int ql, int qr) {
		return ql <= tl && tr <= qr;
	}

	Node *get_left() {
		if (!l) {
			l = new Node(tl, (tl + tr) / 2);
		}
		return l;
	}

	Node *get_right() {
		if (!r) {
			r = new Node((tl + tr) / 2, tr);
		}
		return r;
	}

	Node(int _tl, int _tr) {
		tl = _tl;
		tr = _tr;
	}
};

struct Fen {
	int N = 1e9;
	int COR = 1e6;
	unordered_map<int, int> T;

	void add(int i, int d) {
		i += COR;
		for (; i < N; i = (i | (i + 1))) {
			T[i] += d;
		}
	}

	int get(int i) {
		i += COR;
		int rez = 0;
		for (; i >= 0; i = (i & (i + 1)) - 1) {
			rez += T[i];
		}
		return rez;
	}
};


struct Keker {
	int cur = 0;
	vector<int> v;
	Fen L, R;
	int dl = 0;
	int dr = 0;

	Keker(vector<int> _v) {
		v = _v;
		for (int i = 0; i < len(v); i++) {
			R.add(v[i] + i, 1);
		}
	}

	void move_right() {
		R.add(v[cur] - dr, -1);
		L.add(v[cur] - dl, 1);
		dl++;
		dr--;
		cur++;
	}

	void move_left() {
		L.add(v[cur - 1] - dl, -1);
		R.add(v[cur - 1] - dr - 1, 1);
		dl--;
		dr++;
		cur--;
	}

	int cnt_less(int x) {
		return L.get(x - 1 - dl) + R.get(x - 1 - dr);
	}
};

vector<int> solve(vector<int> v) {
	vector<int> rez(n, 1e9);
	for (int i = 0; i < n; i++) {
		Keker kek(v);
		for (int j = 0; j < n; j++) {
			rez[i] = min(rez[i], kek.cnt_less(abs(i - j) + v[i]));
			if (j != n - 1) {
				kek.move_right();
			}
		}
	}
	return rez;
}

signed main() {
	// {
	// 	Keker kek({1, 1, 1});
	// 	kek.move_right();
	// 	cout << kek.cnt_less(3) << endl;
	// 	cout << kek.cnt_less(2) << endl;
	// 	kek.move_left();
	// 	cout << kek.cnt_less(1) << " " << kek.cnt_less(2) << " " << kek.cnt_less(3) << endl;
	// 	// return 0;
	// }
	{
		int p;
		cin >> n >> p;
		v.resize(n);
	}
	{
		for (int i = 0; i < n; i++) {
			cin >> v[i];
		}
	}
	{
		vector<int> rez = solve(v);
		for (int x : rez) {
			cout << x + 1 << "\n";
		}
	}
	
}