#include "bits/stdc++.h"
#define pb push_back
#define right aoeuthoaneuhts
#define find aoehtuaoeuhso
#define len(v) ((int)v.size())


using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

int n;
vector<int> v;

struct Node {
	Node *l = NULL, *r = NULL;
	int tl, tr;
	int value = 0;

	bool is_list() {
		return tl + 1 == tr;
	}

	bool included_by(int ql, int qr) {
		return ql <= tl && tr <= qr;
	}

	Node *get_left() {
		if (!l) {
			l = new Node(tl, (tl + tr) / 2);
		}
		return l;
	}

	Node *get_right() {
		if (!r) {
			r = new Node((tl + tr) / 2, tr);
		}
		return r;
	}

	Node(int _tl, int _tr) {
		tl = _tl;
		tr = _tr;
	}

	void update(int ind, int d) {
		if (is_list()) {
			value += d;
		} else {
			if (ind < get_left()->tr) {
				get_left()->update(ind, d);
			} else {
				get_right()->update(ind, d);
			}
			value = get_left()->value + get_right()->value;
		}
	}

	int query(int R) {
		if (tr <= R) return value;
		if (is_list()) return 0;
		if (R <= get_left()->tr) {
			return get_left()->query(R);
		} else {
			return get_left()->value + get_right()->query(R);
		}
	}
};

struct Fen {
	Node *node = new Node(-1e6, 1e9 + 1e6);

	Fen() {
		
	}

	void add(int i, int d) {
		node->update(i, d);
	}

	int get(int i) {
		return node->query(i + 1);
	}

	int cnt_less(int x) {
		return node->query(x);
	}
};


struct Keker {
	int cur = 0;
	vector<int> v;
	Fen L, R;
	int dl = 0;
	int dr = 0;

	Keker(vector<int> _v) {
		v = _v;
		for (int i = 0; i < len(v); i++) {
			R.add(v[i] + i, 1);
		}
	}

	void move_right() {
		R.add(v[cur] - dr, -1);
		L.add(v[cur] - dl, 1);
		dl++;
		dr--;
		cur++;
	}

	void move_left() {
		L.add(v[cur - 1] - dl, -1);
		R.add(v[cur - 1] - dr - 1, 1);
		dl--;
		dr++;
		cur--;
	}

	int cnt_less(int x) {
		return L.get(x - 1 - dl) + R.get(x - 1 - dr);
	}
};

vector<int> solve(vector<int> v) {
	// cout << "____" << endl;
	vector<int> rez(n);
	
	Fen fen;
	for (int i = 0; i < n; i++) {
		fen.add(v[i] + (n - i - 1), 1);
	}
	int i = 0;
	for (;; i++) {
		int d = n - 1 - i;
		if (i >= d) break;
		rez[i] = fen.cnt_less(v[i] + d);
	}
	Fen L, R, T;
	int cnt = 0;
	for (int j = n - 1; j >= i; j--) {
		R.add(v[j] + cnt, 1);
		cnt++;
	}

	vector<int> adds(n);

	int pos = i - (n - 1 - i);
	for (int j = pos; j < i; j++) {
		L.add(v[j] + (j - pos), 1);
		adds[j] = v[j] + (j - pos);
		// cout << "+ " << v[j] + (j - pos) << endl;
	}
	for (int j = 0; j < pos; j++) {
		T.add(v[j], 1);
	}

	int pp = pos;

	int dl = 0;

	for (; i < n - 1; i++) {
		int d = n - 1 - i;
		if (i == n - 2) {
			// cout << L.cnt_less(v[i] + d - dl) << " " << R.cnt_less(v[i] + d) << " " <<  T.cnt_less(v[i] + d) << endl;
		}
		rez[i] = L.cnt_less(v[i] + d - dl) + R.cnt_less(v[i] + d) + T.cnt_less(v[i] + d);

		R.add(v[i] + (n - 1 - i), -1);

		T.add(v[pos], 1);
		T.add(v[pos + 1], 1);

		L.add(adds[pos], -1);
		// cout << "- " << adds[pos] << endl;
		L.add(adds[pos + 1], -1);
		// cout << "- " << adds[pos + 1] << endl;

		L.add(v[i] - dl + i - pos, 1);
		adds[i] = v[i] - dl + i - pos;
		// cout << "+ " << adds[i] << endl;
		// cout << v[i] - dl + 2 << " + " << endl;

		dl -= 2;
		pos += 2;
	}

	return rez;
}


vector<int> bad(vector<int> v) {
	vector<int> rez;
	vector<int> A = solve(v);
	reverse(v.begin(), v.end());
	vector<int> B = solve(v);
	reverse(B.begin(), B.end());
	for (int x = 0; x < n; x++) {
		rez.pb(max(A[x], B[x]) + 1);
	}
	return rez;
}

signed main() {
	{
		ios_base::sync_with_stdio(false);
		cin.tie(0);
		cout.tie(0);
	}
	{
		int p;
		cin >> n >> p;
		v.resize(n);
	}
	{
		for (int i = 0; i < n; i++) {
			cin >> v[i];
		}
	}
	{
		// vector<int> A = good(v);
		vector<int> B = bad(v);
		// for (int x : A) {
		// 	cout << x << " ";
		// }
		// cout << endl;
		for (int x : B) {
			cout << x << "\n";
		}

		// if (A != B) {
			// cout << "Fuck" << endl;
			// assert(false);
		// }
	}
}