#include <bits/stdc++.h>
  
using namespace std;
  
typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;
  
#define X first
#define Y second
#define mk make_pair
#define all(v) (v).begin(), (v).end()
#define inb push_back
  
int solve1(int n);
int solve2(int n);
  
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, p;
    cin >> n >> p;
    if (p == 1)
        solve1(n);
    else
        solve2(n);
    return 0;
}
 
 
struct FenwickTree
{
    int n;
    vi t;
    FenwickTree() {};
    FenwickTree(int n) : n(n), t(vi(n)) {};
    void clear()
    {
        t.assign(n, 0);
    }
    void add(int pos)
    {
        for (; pos < n; pos = (pos | (pos + 1)))
            t[pos]++;
    }
    int get(int pos)
    {
        int ans = 0;
        for (; pos >= 0; pos = (pos & (pos + 1)) - 1)
            ans += t[pos];
        return ans;
    }
};
 
int solve1(int n)
{
    vi a(n);
    vi xs(2 * n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        xs[2 * i] = a[i] + i;
        xs[2 * i + 1] = a[i] + n - i - 1;
    }
    sort(all(xs));
    xs.resize(unique(all(xs)) - xs.begin());
    FenwickTree T(xs.size());
    vi ans(n);
    //suffix
    for (int i = n - 1; i >= 0; --i)
    {
        int id = lower_bound(all(xs), a[i] + i) - xs.begin();
        ans[i] += T.get(id - 1);
        T.add(id);
    }
    T.clear();
    //prefix
    for (int i = 0; i < n; ++i)
    {
        int id = lower_bound(all(xs), a[i] + n - i - 1) - xs.begin();
        ans[i] += T.get(id - 1);
        T.add(id);
    }
    for (int i = 0; i < n; ++i)
    {
        printf("%d\n", ans[i] + 1);
    }
    return 0;
}
 
const int INF = 1e9 + 7;
 
int solve2(int n)
{
    vi a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
	if (n > 105)
	{
		vi xs;
		for (int i = 0; i < n; ++i)
		{
			xs.inb(a[i]);
		}
		for (int i = 0; i < n; ++i)
			cout << lower_bound(all(xs), a[i]) - xs.begin() + 1;
		return 0;
	}
    vi ans(n);
    vi cur(n);
    for (int msk = 0; msk < (1 << n); ++msk)
    {
        int f = msk > 0;
        if (f)
        {
            int lst = -INF;
            for (int i = 0; i < n; ++i)
            {
                if ((msk >> i) & 1)
                    lst = i;
                cur[i] = a[i] + i - lst;            
            }
            lst = INF;
            for (int i = n - 1; i >= 0; --i)
            {
                if ((msk >> i) & 1)
                    lst = i;
                cur[i] = min(cur[i], a[i] + lst - i);
            }
        }
        else
        {
            for (int i = 0; i < n; ++i)
                cur[i] = a[i];
        }
        for (int i = 0; i < n; ++i)
        {
            int cans = 0;
            for (int j = 0; j < n; ++j)
            {
                cans += (cur[j] < cur[i]);
            }
            ans[i] = max(cans, ans[i]);
        }
    }
    for (int i = 0; i < n; ++i)
    {
        printf("%d\n", ans[i] + 1);
    }
    return 0;
}