#include <stdio.h>
#include <algorithm>
 
struct data {
    long long a, b;
};

bool _less(const data &d1, const data &d2) {
	if (d1.a != d2.a) {
		return d1.a < d2.a;
	}
	return d1.b < d2.b;
}

struct node {
	long long val;
	node *left, *right;
	
	node(){}
	node(long long val, node *left, node *right): val(val), left(left), right(right) {}
};

node *set(node *n, int ind, long long val, int tl, int tr) {
	if (tl == tr) {
		return new node(val, NULL, NULL);
	}
	node *res = new node();
	if (!n) {
		res->left = res->right = NULL;
	} else {
		res->left = n->left;
		res->right = n->right;
	}
	if (ind <= tl + (tr - tl) / 2) {
		res->left = set(res->left, ind, val, tl, tl + (tr - tl) / 2);
		res->val = (res->left ? res->left->val : 0) + (res->right ? res->right->val : 0);
		return res;
	}
	res->right = set(res->right, ind, val, tl + (tr - tl) / 2 + 1, tr);
	res->val = (res->left ? res->left->val : 0) + (res->right ? res->right->val : 0);
	return res;
}

long long get(node *n, int l, int r, int tl, int tr) {
	if (!n) {
		return 0;
	}
	if (tl == l && tr == r) {
		return n->val;
	}
	int m = tl + (tr - tl) / 2;
	if (r <= m) {
		return get(n->left, l, r, tl, m);
	}
	if (l >= m + 1) {
		return get(n->right, l, r, m + 1, tr);
	}
	return get(n->left, l, m, tl, m) + get(n->right, m + 1, r, m + 1, tr);
}
 
int main() {
    int n;
    scanf("%d", &n);
    data arr[n];
    long long b[n];
    for (int i = 0; i < n; i++) {
        scanf("%lld%lld", &arr[i].a, &arr[i].b);
        b[i] = arr[i].b;
    }
    std::sort(b, b + n);
    std::sort(arr, arr + n, _less);
    node *tree[n + 1];
    tree[0] = NULL;
    for (int i = 0; i < n; i++) {
		tree[i + 1] = set(tree[i], arr[i].b, get(tree[i], arr[i].b, arr[i].b, 1, (1 << 30)) + 1, 1, (1 << 30));
	}
    long long ans = 0;
    for (int _ = 0; _ < n; _++) {
        for (int m = 0; m < n; m++) {
            long long ans1 = arr[_].a * (n - _) + get(tree[_], b[m], (1 << 30), 1, (1 << 30)) * b[m];
            if (ans1 > ans) {
				ans = ans1;
			}
        }
    }
    printf("%lld", ans);
    return 0;
}
