 #include <bits/stdc++.h>


using namespace std;
template<typename T1, typename T2> inline void chkmin(T1 & x, const T2 &y) {if (x > y)  x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, const T2 &y) {if (x < y)  x = y;}
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define pb push_back
const int MAXN = 150001;



struct line
{
	long long k, b;
	line(){}
	line(long long _k, long long _b) {
		k = _k;
		b = _b;
	}
	long long getval(long long x) {
		return k * x + b;
	}
};


struct convexhull{
	vector<line> st;
	bool better(line a, line b, line c) {
		return (b.b - a.b) * (a.k - c.k) >= (c.b - a.b) * (a.k - b.k);
	}
	void addline(line l) {
		if (sz(st) && st.back().k == l.k) {
			if (st.back().b < l.b) {
				st.pop_back();
			} else {
				return;
			}
		}
		while (sz(st) >= 2 && better(st[sz(st) - 2], st[sz(st) - 1], l)) {
			st.pop_back();
		}
		st.pb(l);
	}
	long long getmax(long long x) {
		if (sz(st) == 0) {
			return -1e18;
		}
		if (sz(st) == 1) {
			return st[0].getval(x);
		}
		int l = 0;
		int r = sz(st) - 1;
		while (l + 1 < r) {
			int mid = (l + r - 1) >> 1;
			if ((st[mid + 1].b - st[mid].b) > x * (st[mid].k - st[mid + 1].k)) {
				r = mid;
			}  else {
				l = mid + 1;
			}
		}
		long long res = -1e18;
		for (int i = max(0, l - 1); i <= min(sz(st), r - 1); i++) {
			chkmax(res, st[i].getval(x));
		}
		return res;
	}
};


bool operator <(line a, line b) {
	return a.k < b.k;
}


int n;
int a[MAXN], b[MAXN];
vector<int> vx;
line li[MAXN];
convexhull t[MAXN >> 9];
int mod[MAXN];


void rebuild(int i) {
	int l = i << 9;
	int r = min(l + 511, n - 1);
	t[i].st.clear();
	for (int j = l; j <= r; j++) {
		li[j].k += mod[i];
		t[i].addline(li[j]);
	}
	mod[i] = 0;
}


void add(int l, int r) {
	int f = l >> 9;
	int f1 = r >> 9;
	if (f == f1) {
		for (int i = l; i <= r; i++) {
			li[i].k++;
		}
		rebuild(f);
	} else {
		for (int i = l; i <= min(l - (l & 511) + 511, n - 1); i++) {
			li[i].k++;
		}
		rebuild(f);
		for (int i = r - (r & 511); i <= r; i++) {
			li[i].k++;
		}
		rebuild(f1);
		f++;
		f1--;
		for (int i = f; i <= f1; i++) {
			mod[i]++;
		}
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//assert(freopen("input.in", "r", stdin));
	cin >> n;
	vector<pair<int, int> > st;
	st.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> st[i].first >> st[i].second;
	}
	sort(all(st));
	vector<int> vx;
	for (int i = 0; i < n; i++) {
		a[i] = st[i].first;
		b[i] = st[i].second;
		vx.pb(b[i]);
	}
	vx.pb(0);
	sort(all(vx));
	vx.resize(distance(vx.begin(), unique(all(vx))));
	long long ans = 0;
	vector<pair<int, int> > sts;
	for (int j = 0; j < n; j++) {
		sts.pb({b[j], j});
		li[j] = line(0, 1LL * (n - j) * a[j]);
	}
	for (int j = 0; j <= (n - 1) >> 9; j++) {
		rebuild(j);
	}
	sort(all(sts));
	reverse(all(sts));
	int uk = -1;
	for (int i = sz(vx) - 1; i >= 0; i--) {
		while (uk + 1 < sz(sts) && sts[uk + 1].first >= vx[i]) {
			uk++;
			add(sts[uk].second + 1, n - 1);
		}
		// /cout << uk << endl;
		for (int j = 0; j <= (n - 1) >> 9; j++) {
			chkmax(ans, t[j].getmax(vx[i]) + 1LL * mod[j] * vx[i]);
		}
		//cout << ans << ' ' << vx[i] << endl;
	}  
	cout << ans << endl;
}
