#include <bits/stdc++.h>

#define ll long long
#define pii pair<int, int>
#define f first
#define s second
#define eb emplace_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

int my_rand() {
    return (rand() << 16) + rand();
}

struct node {
    int key, prior = my_rand();
    int ssz = 1;
    node *left = nullptr, *right = nullptr;

    node() {}

    node(int key) : key(key) {}
};

int get_ssz(node* &v) {
    return (v ? v->ssz : 0);
}

void update(node* &v) {
    v->ssz = get_ssz(v->left) + get_ssz(v->right) + 1;
}

pair<node*, node*> split(node* &v, const int key) {
    if (!v) {
        return {v, v};
    }
    if (v->key >= key) {
        auto spres = split(v->left, key);
        v->left = spres.s;
        update(v);
        return {spres.f, v};
    }
    else {
        auto spres = split(v->right, key);
        v->right = spres.f;
        update(v);
        return {v, spres.s};
    }
}

void insert(node* &v, node* &add) {
    if (!v) {
        v = add;
        return;
    }
    if (v->prior > add->prior) {
        insert((v->key > add->key ? v->left : v->right), add);
        update(v);
    }
    else {
        auto spres = split(v, add->key);
        add->left = spres.f;
        add->right = spres.s;
        v = add;
        update(v);
    }
}

int not_less(node* &v, const int key) {
    if (!v) {
        return 0;
    }
    if (v->key >= key) {
        return not_less(v->left, key) + get_ssz(v->right) + 1;
    }
    else {
        return not_less(v->right, key);
    }
}

int main() {
    srand(time(NULL));

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;
    vector<pii> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].f >> a[i].s;
    }
    sort(all(a));
    ll ans = 0ll;
    ll add = 0ll;
    vector<int> ss;
    ss.reserve(n);
    int j = 0;
    queue<pii> q;
    for (int i = 0; i < n; ++i) {
        ll cur = 1ll * a[i].f * (n - i);
        ans = max(ans, cur + add);
        ss.eb(a[i].s);
        add = 1ll * a[j].s * (i - j + 1);
        while (j < i && 1ll * a[j + 1].s * (i - j) >= add) {
            add = 1ll * a[j + 1].s * (i - j);
            ++j;
        }
        if (!q.empty() && i == q.front().f) {
            int cur = q.front().s;
            q.pop();
            if (add <= 1ll * a[cur].s * (i - cur + 1)) {
                add = 1ll * a[cur].s * (i - cur + 1);
            }
            else {
                int left = 0, right = n + 2;
                while (left < right - 1) {
                    int mid = (left + right) / 2;
                    if (1ll * a[cur].s * (i - cur + 1 + mid) >= 1ll * a[j].s * (i - j + 1 + mid)) {
                        right = mid;
                    }
                    else {
                        left = mid;
                    }
                }
                if (left != n + 1) {
                    q.emplace(cur + left, cur);
                }
            }
        }
        if (1ll * a[i].s >= add) {
            j = i;
            add = 1ll * a[i].s;
        }
        else {
            int left = 0, right = n + 2;
            while (left < right - 1) {
                int mid = (left + right) / 2;
                if (1ll * a[i].s * (1 + mid) >= 1ll * a[j].s * (i - j + 1 + mid)) {
                    right = mid;
                }
                else {
                    left = mid;
                }
            }
            if (left != n + 1) {
                q.emplace(i + left, i);
            }
        }
    }
    ans = max(ans, add);
    cout << ans;
    return 0;
}
