#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>

using namespace std;

#define forn(i, a, b) for (int i = a; i < b; ++i)
#define all(a) (a).begin(), (a).end()
#define np nullptr
typedef pair<int, int> PII;

struct node {
	int lg, rg, min, max, maxpos;
	node *l, *r;
	node(int X, int L, int R) {
		l = r = np;
		min = X;
		max = X;
		maxpos = L;
		lg = L;
		rg = R;
	}
};

node * build(vector<int> &a, int l, int r) {
	if (l == r) {
		return new node(a[l], l, r);
	}

	int m = (l + r) / 2;
	node *cur = new node(a[l], l, r);
	node *ls = build(a, l, m);
	node *rs = build(a, m + 1, r);
	cur->min = min(ls->min, rs->min);
	if (ls->max > rs->max) {
		cur->max = ls->max;
		cur->maxpos = ls->maxpos;
	}
	else {
		cur->max = rs->max;
		cur->maxpos = rs->maxpos;
	}
	cur->l = ls;
	cur->r = rs;

	return cur;
}

int get_min(node *v, int l, int r) {
	if (l <= v->lg && r >= v->rg)
		return v->min;
	if (v->lg > r || v->rg < l)
		return INT_MAX;
	return min(get_min(v->l, l, r), get_min(v->r, l, r));
}
int get_max(node *v, int l, int r) {
	if (l <= v->lg && r >= v->rg)
		return v->max;
	if (v->lg > r || v->rg < l)
		return INT_MIN;
	return max(get_max(v->l, l, r), get_max(v->r, l, r));
}
int get_max_pos(node *v, int l, int r, int val) {
	if (v->lg > r || v->rg < l)
		return -1;
	if (l <= v->lg && r >= v->rg)
		return v->maxpos;
	int ans = -1;
	if (get_max(v->l, l, r) == val)
		ans = get_max_pos(v->l, l, r, val);
	if (get_max(v->r, l, r) == val)
		ans = max(ans, get_max_pos(v->r, l, r, val));

	return ans;
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);

	int n;
	cin >> n;
	vector<int> a(n);
	forn(i, 0, n)
		cin >> a[i];
	node * root = build(a, 0, n - 1);

	int st = 0, ans = 0;
	while (st < n) {
		int L = st, R = n;
		while (R - L > 1) {
			int M = (L + R) / 2;
			if (get_min(root, st, M) == a[st])
				L = M;
			else
				R = M;
		}
		int fn = get_max_pos(root, st, L, get_max(root, st, L));
		st = fn + 1;
		ans++;
	}
	cout << ans << endl;
}