#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <climits>
#include <queue>
#include <cassert>
#include <algorithm>

using namespace std;

#define forn(i, a, b) for (int i = a; i < b; ++i)
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair

typedef pair<int, int> PII;
typedef long long LL;

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);

	int n, p;
	cin >> n >> p;
	vector<int> times(n);
	forn(i, 0, n)
		cin >> times[i];

	vector<PII> fn(n);
	vector<int> delay;
	if (n <= 20) {
		vector<int> minplace, maxplace;
		for (int i = 1; i < (1 << n); i++) {
			minplace.assign(n, INT_MAX);
			maxplace.assign(n, -1);
			delay.assign(n, -1);
			queue<int> q;
			forn(k, 0, n) {
				if ((i & (1 << k)) > 0) {
					delay[k] = 0;
					q.push(k);
				}
			}

			while (!q.empty()) {
				int c = q.front();
				q.pop();
				if (c > 0 && delay[c - 1] == -1) {
					delay[c - 1] = delay[c] + 1;
					q.push(c - 1);
				}
				if (c < n - 1 && delay[c + 1] == -1) {
					delay[c + 1] = delay[c] + 1;
					q.push(c + 1);
				}
			}

			forn(j, 0, n)
				fn[j] = make_pair(delay[j] + times[j], j);

			fn.push_back(make_pair(-1, -1));
			sort(all(fn));

			vector<int> place(n + 1);
			forn(t, 1, n + 1) {
				int id = fn[t].second;
				place[0] = 0;
				if (fn[t - 1].first < fn[t].first) {
					place[t] = t;
					minplace[id] = min(minplace[id], t);
					maxplace[id] = max(maxplace[id], t);
				}
				else {
					place[t] = place[t - 1];
					minplace[id] = min(minplace[id], place[t - 1]);
					maxplace[id] = max(maxplace[id], place[t - 1]);
				}
			}
		}

		if (p == 1) {
			forn(t, 0, n)
				cout << minplace[t] << endl;
		}
		else {
			forn(t, 0, n)
				cout << maxplace[t] << endl;
		}
	}
}