#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cassert>

using namespace std;

typedef long long ll;

const int N = 10000 + 10;

int n, m, k;

int max_len = 10;

struct number
{
	string num;
	number() { num = "0"; while (num.size() < max_len) num.push_back('0'); }
	number(int dist)
	{
		num = "1";
		for (int i = 0; i < dist; i++)
		{
			num.push_back('0');
		}
		reverse(num.begin(), num.end());
		while (num.size() < max_len)
		{
			num.push_back('0');
		}
		reverse(num.begin(), num.end());
	}

	bool operator<(const number &a) const
	{
		return num < a.num;
	}

	number operator+(const number &a)
	{
		number ret;
		ret.num.clear();
		int add = 0;
		for (int i = max_len - 1; i >= 0; i--)
		{
			int c1 = (int)num[i] - '0';
			int c2 = (int)a.num[i] - '0';
			int c = c1 + c2 + add;
			if (c >= 2)
			{
				add = 1;
			}
			else
			{
				add = 0;
			}
			ret.num.push_back((char)('0' + (c % 2)));
		}
		reverse(ret.num.begin(), ret.num.end());
		return ret;
	}
};

number dist[N];
vector<pair<int, number>> g[N];
int p[N];
pair<int, int> a[N];
bool used[N];

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m >> k;
	for (int i = 0; i < k; i++)
	{
		int x, y;
		cin >> x >> y;
		a[i] = { x, y };
	}

	for (int i = 0; i < k; i++)
	{
		dist[i] = number(max_len - 2);
	}

	dist[0] = number();

	for (int i = 0; i < k; i++)
	{
		for (int j = 0; j < i; j++)
		{
			g[i].push_back({ j, number(max(abs(a[i].first - a[j].first), abs(a[i].second - a[j].second))) });
			g[j].push_back({ i, number(max(abs(a[i].first - a[j].first), abs(a[i].second - a[j].second))) });
		}
	}

	number inf = number(max_len - 2);

	for (int i = 0; i < k; i++)
	{
		int u = -1;
		for (int j = 0; j < k; j++)
		{
			if (dist[j] < inf && !used[j] && (u == -1 || dist[j] < dist[u]))
			{
				u = j;
			}
		}
		if (u == -1)
		{
			break;
		}
		used[u] = true;
		for (auto it : g[u])
		{
			if (dist[u] + it.second < dist[it.first])
			{
				dist[it.first] = dist[u] + it.second;
				p[it.first] = u;
 			}
		}
	}

	vector<int> path;
	int cur = k - 1;
	while (true)
	{
		path.push_back(cur);
		if (cur == 0) break;
		cur = p[cur];
	}

	reverse(path.begin(), path.end());
	cout << path.size() << "\n";
	for (int i : path) cout << i + 1 << " ";

	system("pause");
}