#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

const int N = 300000 + 10;
const int INF = 1000000000 + 10;

int a[N];
int b[N];

pair<int, int> t[4 * N];

pair<int, int> merge(pair<int, int> a, pair<int, int> b)
{
	if (a.first > b.first) return a;
	return b;
}

void build(int v, int tl, int tr)
{
	if (tl + 1 == tr)
	{
		t[v] = { a[tl], tl };
		return;
	}
	int c = (tl + tr) / 2;
	build(2 * v, tl, c);
	build(2 * v + 1, c, tr);
	t[v] = merge(t[2 * v], t[2 * v + 1]);
}

void upd(int v, int tl, int tr, int pos)
{
	if (tl + 1 == tr)
	{
		t[v] = { -INF, -INF };
		return;
	}
	int c = (tl + tr) / 2;
	if (pos < c)
	{
		upd(2 * v, tl, c, pos);
	}
	else
	{
		upd(2 * v + 1, c, tr, pos);
	}
	t[v] = merge(t[2 * v], t[2 * v + 1]);
}

pair<int, int> get(int v, int tl, int tr, int l, int r)
{
	if (r <= tl || l >= tr)
	{
		return { -INF, -INF };
	}
	if (tl >= l && tr <= r) return t[v];
	int c = (tl + tr) / 2;
	return merge(get(2 * v, tl, c, l, r), get(2 * v + 1, c, tr, l, r));
}

signed main()
{
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		
	}

	vector<pair<int, int>> sst;
	for (int i = n - 1; i >= 0; i--)
	{
		while (sst.size() && sst.back().first >= a[i])
		{
			sst.pop_back();
		}
		if (sst.size())
		{
			b[i] = sst.back().second;
		}
		else
		{
			b[i] = n;
		}
		sst.push_back({a[i], i});
	}

	set<pair<int, int>> st;
	for (int i = 0; i < n; i++)
	{
		st.insert({a[i], i});
	}
	int ans = 0;
	build(1, 0, n);
	while (st.size())
	{
		++ans;
		auto it = *st.begin();
		int l = it.second;
		int r = get(1, 0, n, l, b[l]).second;
		for (int i = l; i <= r; i++)
		{
			st.erase({a[i], i});
			upd(1, 0, n, i);
		}
	}
	cout << ans;
	system("pause");
}