#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <unordered_map>
#include <cassert>

using namespace std;

#define all(a) (a).begin(), (a).end()

const int N = 400000 + 10;
const int M = 3000000 + 10;
const int INF = 1000000000 + 10;

typedef long long ll;

int a[N];
int b[N];
int c[N];

struct tree
{
	int t[M];

	tree()
	{
		for (int i = 0; i < M; i++)
		{
			t[i] = 0;
		}
	}

	int get(int pos)
	{
		if (pos <= 0) return 0;
		int ret = 0;
		for (int i = pos; i > 0; i -= i & (-i))
		{
			ret += t[i];
		}
		return ret;
	}

	int get(int l, int r)
	{
		return get(r) - (l == 1 ? 0 : get(l - 1));
	}

	void upd(int pos, int x)
	{
		if (pos <= 0) assert(false);
		for (int i = pos; i < M; i += i & (-i))
		{
			t[i] += x;
		}
	}
};

signed main()
{
	int n, p;
	cin >> n >> p;

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	vector<pair<int, int>> vv;
	for (int i = 0; i < n; i++) vv.push_back({ a[i], i });
	sort(all(vv));

	for (int i = 0; i < n; i++)
	{
		int ptr = 0;
		int ans = 0;
		int cnt = 0;
		set<int> st;
		for (int k = 1; k <= max(i, n - i); k++)
		{
			while (ptr < vv.size() && vv[ptr].first < a[i] + k)
			{
				if (abs(vv[ptr].second - i) >= k)
				{
					++cnt;
					st.insert(vv[ptr].second);
				}
				++ptr;
			}

			if (k > 1)
			{
				int cur = ptr;
				if (i - k + 1 >= 0 && st.find(i - k + 1) != st.end() && (a[i - k + 1] - (k - 1) >= a[i] || i - k < 0)) --cnt;
				if (i + k - 1 < n &&  st.find(i + k - 1) != st.end() && (a[i + k - 1] - (k - 1) >= a[i] || i + k >= n)) --cnt;
			}

			ans = max(ans, cnt);
		}
		cout << ans + 1 << "\n";
	}
	system("pause");
}