#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <unordered_map>
#include <cassert>

using namespace std;

#define int long long

#define all(a) (a).begin(), (a).end()

const int N = 400000 + 10;
const int M = 3000000 + 10;
const int INF = 1000000000 + 10;

typedef long long ll;

int a[N];
int b[N];
int c[N];

struct tree
{
	int t[M];

	tree()
	{
		for (int i = 0; i < M; i++)
		{
			t[i] = 0;
		}
	}

	int get(int pos)
	{
		if (pos <= 0) return 0;
		int ret = 0;
		for (int i = pos; i > 0; i -= i & (-i))
		{
			ret += t[i];
		}
		return ret;
	}

	int get(int l, int r)
	{
		return get(r) - (l == 1 ? 0 : get(l - 1));
	}

	void upd(int pos, int x)
	{
		if (pos <= 0) assert(false);
		for (int i = pos; i < M; i += i & (-i))
		{
			t[i] += x;
		}
	}
};


signed main()
{
	int n, p;
	cin >> n >> p;

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	if (p == 1)
	{
		tree t1, t2;

		//t1.t.reserve(1e7);
		//t2.t.reserve(1e7);

		for (int i = 0; i < n; i++)
		{
			cin >> a[i];
			b[i] = a[i] + i;
			c[i] = a[i] - i;
		}

		vector<int> vv;
		for (int i = 0; i < n; i++)
		{
			vv.push_back(a[i]);
			vv.push_back(b[i]);
			vv.push_back(c[i]);
		}

		sort(all(vv));
		vv.resize(unique(all(vv)) - vv.begin());

		for (int i = 0; i < n; i++)
		{
			a[i] = lower_bound(all(vv), a[i]) - vv.begin();
			b[i] = lower_bound(all(vv), b[i]) - vv.begin();
			c[i] = lower_bound(all(vv), c[i]) - vv.begin();
		}

		int add = a[0];

		for (int i = 0; i < n; i++)
		{
			add = min(a[i], add);
			add = min(b[i], add);
			add = min(c[i], add);
		}

		add *= -1;
		add += 1;

		for (int i = 0; i < n; i++)
		{
			t1.upd(b[i] + add, 1);
		}

		for (int i = 0; i < n; i++)
		{
			int ans = 1;
			t1.upd(b[i] + add, -1);
			ans += t1.get(b[i] + add - 1);
			ans += t2.get(c[i] + add - 1);
			t2.upd(c[i] + add, 1);
			cout << ans << "\n";
		}

		return 0;
	}

	for (int i = 0; i < n; i++)
	{
		int ans = 0;
		for (int k = 1; k <= max(i, n - i - 1); k++)
		{
			int cnt = 0;

			if (i + k < n)
			{
				for (int j = i + 1; j < i + k; j++)
				{
					if (a[j] < a[i] + j - i) ++cnt;
				}
			}
			else
			{
				for (int j = i + 1; j < n; j++)
				{
					if (a[j] + j - i < a[i]) ++cnt;
				}
			}

			if (i - k >= 0)
			{
				for (int j = i - 1; j > i - k; j--)
				{
					if (a[j] < a[i] + i - j) ++cnt;
				}
			}
			else
			{
				for (int j = 0; j < i; j++)
				{
					if (a[j] + i - j < a[i]) ++cnt;
				}
			}

			for (int j = i + k; j < n; j++)
			{
				if (a[j] < a[i] + k) ++cnt;
			}

			for (int j = i - k; j >= 0; j--)
			{
				if (a[j] < a[i] + k) ++cnt;
			}

			ans = max(ans, cnt);
		}

		cout << ans + 1 << "\n";
	}
	system("pause");
}