#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <unordered_map>

using namespace std;

#define all(a) (a).begin(), (a).end()

#define int long long

const int N = 400000 + 10;
const int M = 2000000000 + 10;
const int INF = 1000000000 + 10;



int a[N];

struct tree
{
	unordered_map<int, int> t;

	int get(int pos)
	{
		pos += INF + 1;
		int ret = 0;
		for (int i = pos; i > 0; i -= i & (-i))
		{
			ret += t[i];
		}
		return ret;
	}

	int get(int l, int r)
	{
		return get(r) - get(l - 1);
	}

	void upd(int pos, int x)
	{
		pos += INF + 1;
		for (int i = pos; i < M; i += i & (-i))
		{
			t[i] += x;
		}
	}
};

signed main()
{
	int n, p;
	cin >> n >> p;

	tree t1, t2;
	
	t1.t.reserve(2e7);
	t2.t.reserve(2e7);

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		t1.upd(a[i] + i, 1);
	}

	for (int i = 0; i < n; i++)
	{
		int ans = 1;
		t1.upd(a[i] + i, -1);
		ans += t1.get(-INF, a[i] + i - 1);
		ans += t2.get(-INF, a[i] - i - 1);
		t2.upd(a[i] - i, 1);
		cout << ans << "\n";
	}

	system("pause");
}