#include <bits/stdc++.h>
using namespace std;
#define int long long

const int MAXN = 1e4, inf = 1e18;
int x[MAXN], y[MAXN];

vector <pair <int, vector <int> > > graph[MAXN];

vector <int> number(int i) {
	vector <int> ans(i + 1, 0);
	ans[i] = 1;
	return ans;
}

vector <int> sum(vector <int> A, vector <int>  B) {
	vector <int>  ans;
	int n = max(A.size(), B.size());
	int p = 0;
	A.resize(n, 0);
	B.resize(n, 0);
	for (int i = 0; i < n; i++) {
		p += A[i] + B[i];
		ans.push_back(p % 2);
		p /= 2;
	}
	if (p) ans.push_back(p);
	return ans;
}

bool cmp(vector <int>  A, vector <int>  B) {
	if (A.size() < B.size()) return true;
	if (B.size() < A.size()) return false;
	for (int i = (int)A.size() - 1; i >= 0; i--) {
		if (A[i] != B[i])
			return A[i] < B[i];
	}
	return false;
}


vector <int> dist[MAXN];
int tree[MAXN * 4];

void build(int v, int l, int r) {
	if (l == r) {
		tree[v] = l;
	} else {
		int m = (l + r) / 2;
		build(v * 2, l, m);
		build(v * 2 + 1, m + 1, r);
		if (cmp(dist[tree[v * 2]], dist[tree[v * 2 + 1]])) {
			tree[v] = tree[v * 2];
		} else {
			tree[v] = tree[v * 2 + 1];
		}
	}
} 

void update (int v, int l, int r, int pos) {
	if (l < r) {
		int m = (l + r) / 2;
		if (pos <= m) update(v * 2, l, m, pos);
		else update(v * 2 + 1, m + 1, r, pos);

		if (cmp(dist[tree[v * 2]], dist[tree[v * 2 + 1]])) {
			tree[v] = tree[v * 2];
		} else {
			tree[v] = tree[v * 2 + 1];
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);

	int n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i < k; i++) {
		cin >> x[i] >> y[i];
	}
	for (int i = 0; i < k; i++) {
		for (int j = i + 1; j < k; j++) {
			int dst = (max(abs(x[i] - x[j]), abs(y[i] - y[j])));
			graph[i].push_back({j, number(dst)});
			graph[j].push_back({i, number(dst)});
		}
	}
	for (int i = 0; i < k; i++) {
		dist[i] = number(500);
	}
	dist[0] = vector <int> ({});
	build(1, 0, k - 1);
	
	vector <int> prev(k, -1);
	vector <int> used(k, false);

	for (int i = 0; i < k; i++) {
		int id = tree[1];
		vector <int> path = dist[id];

		used[id] = true;
		dist[id] = number(500);
		update(1, 0, k - 1, id);
		for (auto e : graph[id]) {
			if (!used[e.first] && !cmp(dist[e.first], sum(path, e.second)) ) {
				dist[e.first] = sum(path, e.second);
				prev[e.first] = id;
				update(1, 0, k - 1, e.first);
			}
		}		
	}
	vector <int> ans;
	for (int i = k - 1; i >= 0; i = prev[i])
		ans.push_back(i);
	cout << ans.size() << endl;
	for (int i = 0; i < (int)ans.size(); i++) {
		cout << 1 + ans[ans.size() - 1 - i] << " ";
	}
	cout << endl;

	return 0;
}