#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
using namespace std;
#define all(v) v.begin(), v.end()
typedef long long ll;

template <class T>
class fenwick {
	T pref(int pos) {
		T result = 0;
		for (int i = pos; i >= 0; i = (i & (i + 1)) - 1)
			result += fenw[i];
		return result;
	}
	void _update(int pos, T val) {
		for (int i = pos; i < fenw.size(); i = i | (i + 1))
			fenw[i] += val;
	}
	vector<T> fenw;

public:
	void build(int n) {
		fenw.resize(n + 1);
	}
	void clear() {
		fenw.clear();
	}
	T get(int l, int r) {
		return pref(r + 1) - pref(l);
	}
	void update(int pos, int val) {
		_update(pos + 1, val);
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	int n, p;
	cin >> n >> p;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	vector<int> ans(n, 1);
	if (p == 1) {
		for (int i = 0; i < n; i++)
			a[i] -= i;
		set<int> s;
		for (int i = 0; i < n; i++)
			s.insert(a[i]);
		unordered_map<int, int> m;
		m.reserve(s.size());
		int cur = 0;
		for (int t : s)
			m[t] = cur++;
		fenwick<int> f;
		f.build(s.size() + 5);
		for (int i = 0; i < n; i++) {
			int pos = m[a[i]];
			f.update(pos, 1);
			if (pos > 0) ans[i] += f.get(0, pos - 1);
		}
		for (int i = 0; i < n; i++)
			a[i] += 2 * i;
		s.clear();
		for (int i = 0; i < n; i++)
			s.insert(a[i]);
		m.clear();
		m.reserve(s.size());
		cur = 0;
		for (int t : s)
			m[t] = cur++;
		f.clear();
		f.build(s.size() + 5);
		for (int i = n - 1; i >= 0; i--) {
			int pos = m[a[i]];
			f.update(pos, 1);
			if (pos > 0) ans[i] += f.get(0, pos - 1);
		}
	}
	else {
		for (int i = 0; i < n; i++) {
			int j = 0;
			for (; ; j++) {
				if (i - j < 0 && i + j >= n) break;
			}
			j--;
			//for (int j = 1; j < n; j++) {
				int left = i - j;
				int right = i + j;
				left = max(left, -1);
				right = min(right, n);
				if (left == -1 && right == n) break;
				int our = a[i] + j, place = 1;
				for (int q = 0; q < n; q++) {
					if (q == i) continue;
					int cur = a[q], plus = n;
					if (q <= left || q >= right) plus = 0;
					else {
						if (left != -1) plus = min(plus, abs(q - left));
						if (right != n) plus = min(plus, abs(q - right));
					}
					cur += plus;
					if (cur < our) place++;
				}
				ans[i] = max(ans[i], place);
			//}
		}
	}
	for (int i = 0; i < n; i++)
		cout << ans[i] << " ";
}