#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <string>
#include <bitset>
using namespace std;
#define all(v) v.begin(), v.end()
typedef long long ll;

int comp(string &s1, string &s2) {
	if (s1.size() < s2.size()) return 1;
	if (s1.size() > s2.size()) return 0;
	for (int i = 0; i < s1.size(); i++) {
		if (s1[i] < s2[i]) return 1;
		if (s1[i] > s2[i]) return 0;
	}
	return -1;
}
bool comp2(pair<string, int> &p1, pair<string, int> &p2) {
	int c = comp(p1.first, p2.first);
	if (c == -1) return p1.second < p2.second;
	else return c;
}
const int N = 10000;

int main() {
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	vector<pair<string, int>> vs(n);
	for (int i = 0; i < n; i++) {
		cin >> vs[i].first;
		vs[i].second = i;
	}
	sort(all(vs), comp2);
	vector<bitset<N>> vb(n);
	vector<bitset<N>> ans(n);
	for (int i = 0; i < n; i++) {
		for (int j = vs[i].first.size() - 1, q = 0; j >= 0; j--, q++) {
			vb[i][q] = vs[i].first[j] - '0';
		}
	}
	bitset<N> used;
	for (int i = 0; i < n; i++) {
		int last = vs[i].first.size();
		bool must = false;
		for (int j = vs[i].first.size() - 1; j >= 0; j--) {
			if (vb[i][j]) {
				if (used[j]) {
					must = true;
					break;
				}
			}
			else if (!used[j]) last = j;
		}
		if (!must) {
			ans[i] = vb[i];
			for (int j = vs[i].first.size() - 1; j >= 0; j--) {
				if (vb[i][j]) used[j] = 1;
			}
		}
		else {
			for (int j = vs[i].first.size() - 1; j > last; j--) {
				ans[i][j] = vb[i][j];
				if (vb[i][j]) used[j] = 1;
			}
			ans[i][last] = 1;
			used[last] = 1;
		}
	}
	bitset<N> ans2;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < N; j++) {
			ans2[j] = ans2[j] | ans[i][j];
		}
	}
	int beg = N - 1;
	for (int j = N - 1; j >= 0; j--) {
		if (ans2[j] != 0) {
			beg = j;
			break;
		}
	}
	for (int j = beg; j >= 0; j--) {
		cout << ans2[j];
	}
}