#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <string>
#include <bitset>
#include <cassert>
using namespace std;
#define all(v) v.begin(), v.end()
typedef long long ll;

bool comp(string &s1, string &s2) {
	if (s1.size() < s2.size()) return 1;
	if (s1.size() > s2.size()) return 0;
	for (int i = 0; i < s1.size(); i++) {
		if (s1[i] < s2[i]) return 1;
		if (s1[i] > s2[i]) return 0;
	}
	return 0;
}
const int N = 10000;

int main() {
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	vector<string> vs(n);
	for (int i = 0; i < n; i++)
		cin >> vs[i];
	sort(all(vs), comp);
	vector<bitset<N>> vb(n);
	vector<bitset<N>> ans(n);
	for (int i = 0; i < n; i++) {
		for (int j = vs[i].size() - 1, q = 0; j >= 0; j--, q++) {
			vb[i][q] = vs[i][j] - '0';
		}
	}
	bitset<N> used;
	int maxz = 0;
	for (int i = 0; i < n; i++) {
		int last = vs[i].size();
		while (used[last]) last++;
		bool must = false;
		for (int j = vs[i].size() - 1; j >= 0; j--) {
			if (vb[i][j] && used[j]) {
				must = true;
				break;
			}
			if (!vb[i][j] && !used[j]) last = j;
		}
		if (!must) {
			ans[i] = vb[i];
			for (int j = vs[i].size() - 1; j >= 0; j--) {
				if (vb[i][j]) used[j] = 1, maxz = max(maxz, j + 1);
			}
		}
		else {
			for (int j = vs[i].size() - 1; j > last; j--) {
				ans[i][j] = vb[i][j];
				if (vb[i][j]) assert(!used[j]);
				if (vb[i][j]) used[j] = 1;
			}
			ans[i][last] = 1;
			assert(!used[last]);
			used[last] = 1;
			maxz = max(maxz, last + 1);
		}
	}
	bitset<N> ans2;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < N; j++) {
			ans2[j] = ans2[j] | ans[i][j];
		}
	}
	int beg = 0;
	for (int j = N - 1; j >= 0; j--) {
		if (ans2[j] != 0) {
			beg = j;
			break;
		}
	}
	for (int j = beg; j >= 0; j--) {
		cout << ans2[j];
	}
}