#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

struct very_long{
    vector <int> v;
    very_long() {}
    very_long(string s) {
        int n = s.size();
        v.resize(n);
        for (int i = 0; i < n; i++) {
            v[i] = s[n - i - 1] - '0';
        }
    }
};

bool operator < (const very_long &a, const very_long &b) {
    if (a.v.size() < b.v.size()) {
        return true;
    }
    if (a.v.size() > b.v.size()) {
        return false;
    }
    for (int i = a.v.size() - 1; i >= 0; i--) {
        if (a.v[i] < b.v[i]) {
            return true;
        }
        if (a.v[i] > b.v[i]) {
            return false;
        }
    }
    return false;
}

void print(very_long &a) {
    if (a.v.size() == 0) {
        cout << "0\n";
    }
    else {
        int n = a.v.size();
        for (int i = 0; i < n; i++) {
            cout << a.v[n - i - 1];
        }
        cout << '\n';
    }
}

bool check(const very_long &a, const very_long &b) {
    int n = min(a.v.size(), b.v.size());
    for (int i = 0; i < n; i++) {
        if (a.v[i] == 1 && b.v[i] == 1) {
            return false;
        }
    }
    return true;
}

void add(very_long &a, very_long b) {
    int n = b.v.size();
    if (a.v.size() < n) {
        a.v.resize(n, 0);
    }
    for (int i = 0; i < n; i++) {
        a.v[i] |= b.v[i];
    }
}

int main() {
    int n, id;
    bool flag;
    very_long res;
    string s;
    cin >> n;
    vector <very_long> v(n);
    for (int i = 0; i < n; i++) {
        cin >> s;
        v[i] = very_long(s);
    }
/*
    for (int i = 0; i < n; i++) {
        print(v[i]);
    }
    cout << '\n';
*/
    for (int mask = 0; mask < (1 << n); mask++) {
        very_long tmp;
        flag = true;
        for (int i = 0; i < n; i++) {
            if ((1 & (mask >> i)) == 1) {
                if (check(tmp, v[i])) {
                    add(tmp, v[i]);
                }
                else {
                    flag = false;
                    break;
                }
            }
        }
        for (int i = 0; i < n; i++) {
            if ((1 & (mask >> i)) == 0) {
                id = v[i].v.size();
                while(id < tmp.v.size() && tmp.v[id] == 1) {
                    id++;
                }
                //cout << "asd " << mask << ' ' << i << ' ' << id << '\n';
                //print(tmp);
                if (id < tmp.v.size()) {
                    tmp.v[id] = 1;
                }
                else {
                    tmp.v.resize(id, 0);
                    tmp.v.push_back(1);
                }
            }
        }
        if (flag) {
            if (res.v.size() == 0 || tmp < res) {
                res = tmp;
            }
        }
        //cout << mask << ' ' << flag << '\n';
        //print(res);
        //print(tmp);
        //cout << '\n';
    }
    print(res);
    return 0;
}
