#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

struct very_long{
    vector <int> v;
    very_long() {}
    very_long(string s) {
        int n = s.size();
        v.resize(n);
        for (int i = 0; i < n; i++) {
            v[i] = s[n - i - 1] - '0';
        }
    }
};

void change(vector <int> &v, int id) {
    for (int i = 0; i < id; i++) {
        v[i] = 0;
    }
    v[id] = 1;
}

bool cmp(vector <int> &a, vector <int> &b, int id) {
    for (int i = id; i >= 0; i--) {
        if (a[i] > b[i]) {
            return true;
        }
        if (a[i] < b[i]) {
            return false;
        }
    }
}

vector <int> add(vector <int> v1, vector <int> v2) {
    int n, id;
    while(v1.size() < v2.size()) {
        v1.push_back(0);
    }
    while (v2.size() < v1.size()) {
        v2.push_back(0);
    }
    v1.push_back(0);
    v2.push_back(0);
    n = v1.size();
    for (int i = n - 1; i >= 0; i--) {
        if (v1[i] == 1 && v2[i] == 1) {
            id = i;
            while (v1[id] == 1 || v2[id] == 1) {
                id++;
            }
            if (cmp(v1, v2, id)) {
                change(v1, id);
            }
            else {
                change(v2, id);
            }
            break;
        }
    }
    vector <int> res(n);
    for (int i = 0; i < n; i++) {
        res[i] = v1[i] + v2[i];
    }
    if (res[n - 1] == 0) {
        res.pop_back();
        n--;
    }
    return res;
}

int main() {
    int n, id, len;
    bool flag;
    string s;
    cin >> n;
    vector <very_long> v(n);
    len = 0;
    for (int i = 0; i < n; i++) {
        cin >> s;
        v[i] = very_long(s);
    }
    vector <int> res;
    res = v[0].v;
    for (int i = 1; i < n; i++) {
        res = add(res, v[i].v);
    }
    n = res.size();
    for (int i = 0; i < n; i++) {
        cout << res[n - 1 - i];
    }
    cout << '\n';
    return 0;
}
