#include <bits/stdc++.h>

using namespace std;

struct item
{
    int key, prior, sz, am;
    item *l, *r;
    item(int key, int prior) : key(key), prior(prior), sz(1), am(1), l(NULL), r(NULL) { }
};

typedef item * pitem;

int get_sz(pitem t)
{
    if(t)
    {
        return t -> sz;
    } else
    {
        return 0;
    }
}

void upd_sz(pitem t)
{
    if(t)
    {
        t -> sz = get_sz(t -> l) + get_sz(t -> r) + t -> am;
    }
}

void split(pitem t, int key, pitem &l, pitem &r)
{
    if(!t)
    {
        l = r = NULL;
    } else if(t -> key >= key)
    {
        split(t -> l, key, l, t -> l);
        r = t;
    } else
    {
        split(t -> r, key, t -> r, r);
        l = t;
    }
    upd_sz(t);
}

void merge(pitem &t, pitem l, pitem r)
{
    if(!l)
    {
        t = r;
    } else if(!r)
    {
        t = l;
    } else if(l -> prior > r -> prior)
    {
        merge(l -> r, l -> r, r);
        t = l;
    } else
    {
        merge(r -> l, l, r -> l);
        t = r;
    }
    upd_sz(t);
}

void insert(pitem &t, pitem it)
{
    if(!t)
    {
        t = it;
    } else if(it -> key > t -> key)
    {
        insert(t -> r, it);
    } else if(it -> key == t -> key)
    {
        ++t -> am;
    } else
    {
        insert(t -> l, it);
    }
    upd_sz(t);
}

void erase(pitem &t, int key)
{
    if(t -> key > key)
    {
        erase(t -> l, key);
    } else if(t -> key == key)
    {
        t -> am--;
        if(t -> am == 0)
        {
            merge(t, t -> l, t -> r);
        }
    } else
    {
        erase(t -> r, key);
    }
    upd_sz(t);
}

int n, p;
vector<int> a, to, from, ans;
pitem root_l = NULL, root_r = NULL;

int main()
{
    srand(time(NULL));
    scanf("%d%d", &n, &p);
    if(n > 120000)
    {
        return 0;
    }
    a.resize(n);
    to.resize(n);
    from.resize(n);
    ans.resize(n, 0);
    for(int i = 0; i < n; ++i)
    {
        scanf("%d", &a[i]);
        to[i] = a[i] + i;
        from[i] = a[i] + (n - i - 1);
    }
    for(int i = 0; i < n; ++i)
    {
        pitem it = new item(to[i], rand());
        insert(root_r, it);
    }
    for(int i = 0; i < n; ++i)
    {
        erase(root_r, to[i]);
        pitem y, yy;
        split(root_r, to[i], y, yy);
        ans[i] += get_sz(y);
        merge(root_r, y, yy);
        split(root_l, from[i], y, yy);
        ans[i] += get_sz(y);
        merge(root_l, y, yy);
        pitem it = new item(from[i], rand());
        insert(root_l, it);
    }
    for(int i = 0; i < n; ++i)
    {
        printf("%d\n", ans[i] + 1);
    }

    return 0;
}
