#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;

const int mxs = 1073741824;
const int sz = 30;

int p2[sz + 1];

struct dist
{
    vector<int> num;
    bool ismx = false;
    int len;
    dist(): ismx(true) {}
    dist(int nn)
    {
        if (nn != -1) {
            num.assign(nn / sz, 0);
            num.push_back(p2[nn % sz]);
            len = num.size();
        }
        else {
            ismx = true;
        }
    }
    dist(vector<int> v)
    {
        num = v;
        len = v.size();
        ismx = len == 0;
    }
    bool mx()
    {
        return ismx;
    }
    bool operator>(dist d)
    {
        if (d.mx()) {
            return false;
        }
        if (mx()) {
            return true;
        }
        if (len > d.len) {
            return true;
        }
        if (len < d.len) {
            return false;
        }
        for (int i = len - 1; i >= 0; i--) {
            if (d.num[i] == num[i]) {
                continue;
            }
            return num[i] > d.num[i];
        }
        return false;
    }
    dist operator+(dist d)
    {
        if (d.mx() || mx()) {
            dist ans(-1);
            return ans;
        }
        dist ans(num);
        for (int i = 0; i < d.len; i++) {
            while (i >= ans.len) {
                ans.num.push_back(0);
                ans.len++;
            }
            ans.num[i] += d.num[i];
            if (ans.num[i] >= mxs) {
                while (i + 1 >= ans.len) {
                    ans.num.push_back(0);
                    ans.len++;
                }
                ans.num[i + 1] = ans.num[i] / mxs;
                ans.num[i] = ans.num[i] % mxs;
            }
        }
        return ans;
    }
};

const dist mxd(-1);

int mabs(int u)
{
    if (u < 0) {
        return -u;
    }
    return u;
}

#define fin cin

int main()
{
    //ifstream fin("input.txt");
    int n, m, k;
    fin >> n >> m >> k;
    p2[0] = 1;
    for (int i = 1; i < sz + 1; i++) {
        p2[i] = 2 * p2[i - 1];
    }
    vector< vector< pair<int, dist> > > g(k);
    vector< pair<int, int> > pt(k);
    vector< vector< pair<int, int> > > sl(max(n, m));
    vector<int> sls(k);
    for (int i = 0; i < k; i++) {
        fin >> pt[i].first >> pt[i].second;
        sl[max(pt[i].first, pt[i].second) - 1].push_back(pt[i]);
        sls[i] = max(pt[i].first, pt[i].second) - 1;
    }
    vector<int> hass;
    for (int i = 0; i < sl.size(); i++) {
        if (sl[i].size() != 0) {
            hass.push_back(i);
        }
    }
    vector<int> next(sl.size(), -1);
    for (int i = 0; i < hass.size() - 1; i++) {
        next[hass[i]] = hass[i + 1];
    }
    for (int i = 0; i < k; i++) {
        for (int j = 1; j < k; j++) {
            if (i == j) {
                continue;
            }
            if (next[sls[i]] == sls[j]) {
                g[i].push_back(pair<int, dist> (j, dist(max(mabs(pt[i].first - pt[j].first), mabs(pt[i].second - pt[j].second)))));
            }
        }
    }
    vector<dist> d(k);
    vector<bool> used(k, false);
    dist d0(0);
    d[0] = d0;
    for (int i = 1; i < k; i++) {
        d[i] = mxd;
    }
    vector<int> p(k, -1);
    for (int ii = 0; ii < k; ii++) {
        int v = -1;
        for (int i = 0; i < k; i++) {
            if (!used[i] && (v == -1 || d[v] > d[i])) {
                v = i;
            }
        }
        if (d[v].mx()) {
            break;
        }
        used[v] = true;
        for (int i = 0; i < g[v].size(); i++) {
            dist y = d[v] + g[v][i].second;
            if (d[g[v][i].first] > y) {
                d[g[v][i].first] = y;
                p[g[v][i].first] = v;
            }
        }
    }
    vector<int> path;
    int x = k - 1;
    while (x != -1) {
        path.push_back(x);
        x = p[x];
    }
    reverse(path.begin(), path.end());
    cout << path.size() << endl;
    for (int i = 0; i < path.size(); i++) {
        cout << path[i] + 1 << ' ';
    }
}
