#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;

const int mx = 1073741824;
const int sz = 30;

int p2[sz + 1];

struct dist
{
    vector<int> num;
    bool ismx = false;
    int len;
    dist(int nn)
    {
        if (nn != -1) {
            num.assign(nn / sz, 0);
            num.push_back(p2[nn % sz]);
            len = num.size();
        }
        else {
            ismx = true;
        }
    }
    dist(dist* d)
    {
        num = d->num;
        ismx = d->ismx;
        len = d->len;
    }
    bool mx()
    {
        return ismx;
    }
    bool operator>(dist d)
    {
        if (d.mx()) {
            return false;
        }
        if (mx()) {
            return true;
        }
        if (len > d.len) {
            return true;
        }
        if (len < d.len) {
            return false;
        }
        for (int i = len - 1; i >= 0; i--) {
            if (d.num[i] == num[i]) {
                continue;
            }
            return num[i] > d.num[i];
        }
        return false;
    }
    dist operator+(dist d)
    {
        if (d.mx() || mx()) {
            dist ans(-1);
            return ans;
        }
        dist ans(this);
        for (int i = 0; i < d.len; i++) {
            if (i >= ans.len) {
                ans.num.push_back(0);
                ans.len++;
            }
            ans.num[i] += d.num[i];
            if (ans.num[i] >= sz) {
                if (i + 1 >= ans.len) {
                    ans.num.push_back(0);
                    ans.len++;
                }
                ans.num[i + 1] = ans.num[i] / sz;
                ans.num[i] %= ans.num[i];
            }
        }
        return ans;
    }
};

const dist mxd(-1);

int mabs(int u)
{
    if (u < 0) {
        return -u;
    }
    return u;
}

#define fin cin

int main()
{
    //ifstream fin("input.txt");
    int n, m, k;
    fin >> n >> m >> k;
    p2[0] = 1;
    for (int i = 1; i < sz + 1; i++) {
        p2[i] = 2 * p2[i - 1];
    }
    vector< vector< pair<int, dist> > > g;
    g.resize(k);
    vector< pair<int, int> > pt(k);
    for (int i = 0; i < k; i++) {
        fin >> pt[i].first >> pt[i].second;
        for (int j = 0; j < i; j++) {
            g[i].push_back(pair<int, dist> (j, dist(max(mabs(pt[i].first - pt[j].first), mabs(pt[i].second - pt[j].second)))));
            g[j].push_back(pair<int, dist> (i, dist(max(mabs(pt[i].first - pt[j].first), mabs(pt[i].second - pt[j].second)))));
        }
    }
    vector<dist> d(k, mxd);
    vector<bool> used(k, false);
    d[0] = 0;
    vector<int> p(k, -1);
    for (int ii = 0; ii < k; ii++) {
        int v = -1;
        for (int i = 0; i < k; i++) {
            if (!used[i] && (v == -1 || d[v] > d[i])) {
                v = i;
            }
        }
        if (d[v].mx()) {
            break;
        }
        used[v] = true;
        for (int i = 0; i < k - 1; i++) {
            if (d[g[v][i].first] > d[v] + g[v][i].second) {
                d[g[v][i].first] = d[v] + g[v][i].second;
                p[g[v][i].first] = v;
            }
        }
    }
    vector<int> path;
    int x = k - 1;
    while (x != -1) {
        path.push_back(x);
        x = p[x];
    }
    reverse(path.begin(), path.end());
    cout << path.size() << endl;
    for (int i = 0; i < path.size(); i++) {
        cout << path[i] + 1 << ' ';
    }
}
