#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> a;
vector<int> bui;
int n;

vector<int> tree(1200000);

void build1(int i = 0, int l = 0, int r = n - 1)
{
    if (l == r) {
        tree[i] = bui[l];
        return;
    }
    int m = (l + r) / 2;
    build1(2 * i + 1, l, m);
    build1(2 * i + 2, m + 1, r);
    tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}

void build()
{
    bui.assign(n, 0);
    tree.assign(tree.size(), 0);/*
    for (int i = 0; i < n; i++) {
        bui[a[i]]++;
    }
    build1();*/
}

int ask(int vl, int vr, int i = 0, int l = 0, int r = n - 1)
{
    if (vl > vr) {
        return 0;
    }
    if (l == vl && r == vr) {
        return tree[i];
    }
    int m = (l + r) / 2;
    if (m >= vr) {
        return ask(vl, vr, 2 * i + 1, l, m);
    }
    if (vl > m) {
        return ask(vl, vr, 2 * i + 2, m + 1, r);
    }
    return ask(vl, m, 2 * i + 1, l, m) + ask(m + 1, vr, 2 * i + 2, m + 1, r);
}

void ch(int ind, int l = 0, int r = n - 1, int i = 0)
{
    if (l == r) {
        tree[i]++;
        return;
    }
    int m = (l + r) / 2;
    if (ind <= m) {
        ch(ind, l, m, 2 * i + 1);
    }
    else {
        ch(ind, m + 1, r, 2 * i + 2);
    }
    tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}

#define fin cin

int main()
{
    //ifstream fin("input.txt");
    int p;
    fin >> n >> p;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        fin >> a[i];
    }
    if (p == 1) {
        int lt[n], rt[n];
        for (int ii = 0; ii < 2; ii++) {
            for (int i = 0; i < n; i++) {
                a[i] -= i;
            }
            vector<int> b(n);
            for (int i = 0; i < n; i++) {
                b[i] = a[i];
            }
            sort(b.begin(), b.end());
            vector<int> c;
            c.push_back(b[0]);
            for (int i = 1; i < n; i++) {
                if (b[i] != b[i - 1]) {
                    c.push_back(b[i]);
                }
            }
            for (int i = 0; i < n; i++) {
                int l = 0, r = c.size();
                while (r - l > 1) {
                    int m = (r + l) / 2;
                    if (c[m] > a[i]) {
                        r = m;
                    }
                    else {
                        l = m;
                    }
                }
                a[i] = l;
            }
            build();
            for (int i = 0; i < n; i++) {
                if (ii == 0) {
                    lt[i] = ask(0, a[i] - 1);
                }
                else {
                    rt[n - 1 - i] = ask(0, a[i] - 1);
                }
                ch(a[i]);
            }
            for (int i = 0; i < n; i++) {
                a[i] = c[a[i]];
                a[i] += i;
            }
            reverse(a.begin(), a.end());
        }
        for (int i = 0; i < n; i++) {
            cout << lt[i] + rt[i] + 1 << endl;
        }
    }
    else {
        int lt[n], rt[n];
        vector<int> ans(n, 0);
        for (int ii = 0; ii < 2; ii++) {
            for (int i = 0; i < n; i++) {
                a[i] += i;
            }
            vector<int> b(n);
            for (int i = 0; i < n; i++) {
                b[i] = a[i];
            }
            sort(b.begin(), b.end());
            vector<int> c;
            c.push_back(b[0]);
            for (int i = 1; i < n; i++) {
                if (b[i] != b[i - 1]) {
                    c.push_back(b[i]);
                }
            }
            for (int i = 0; i < n; i++) {
                int l = 0, r = c.size();
                while (r - l > 1) {
                    int m = (r + l) / 2;
                    if (c[m] > a[i]) {
                        r = m;
                    }
                    else {
                        l = m;
                    }
                }
                a[i] = l;
            }
            build();
            for (int i = 0; i < n; i++) {
                ch(a[i]);
            }
            for (int i = 0; i < n; i++) {
                if (ii == 0) {
                    lt[i] = ask(0, a[i] - 1);
                    ans[i] = max(ans[i], lt[i]);
                }
                else {
                    rt[n - 1 - i] = ask(0, a[i] - 1);
                    ans[n - 1 - i] = max(ans[n - 1 - i], rt[n - 1 - i]);
                }
            }
            for (int i = 0; i < n; i++) {
                a[i] = c[a[i]];
                a[i] -= i;
            }
            /*for (int i = 0; i < (n + 1) / 2; i++) {
                for (int j = 0; j <= i; j++) {
                    a[j] += j;
                }
                for (int j = 0; j < i; j++) {
                    a[i + j + 1] += i - j - 1;
                }
                int u = 0;
                for (int j = 0; j < n; j++) {
                    if (a[j] < a[i]) {
                        u++;
                    }
                }
                for (int j = 0; j <= i; j++) {
                    a[j] -= j;
                }
                for (int j = 0; j < i; j++) {
                    a[i + j + 1] -= i - j - 1;
                }
                if (ii == 0) {
                    ans[i] = max(ans[i], u);
                }
                else {
                    ans[n - 1 - i] = max(ans[n - 1 - i], u);
                }
            }*/
            reverse(a.begin(), a.end());
        }
        for (int i = 0; i < n; i++) {
            cout << ans[i] + 1 << endl;
        }
        /*
        for (int ii = 0; ii < 2; ii++) {
            for (int i = 0; i < n; i++) {
                a[i] += i;
            }
            vector<int> b(n);
            for (int i = 0; i < n; i++) {
                b[i] = a[i];
            }
            sort(b.begin(), b.end());
            vector<int> c;
            c.push_back(b[0]);
            for (int i = 1; i < n; i++) {
                if (b[i] != b[i - 1]) {
                    c.push_back(b[i]);
                }
            }
            for (int i = 0; i < n; i++) {
                int l = 0, r = c.size();
                while (r - l > 1) {
                    int m = (r + l) / 2;
                    if (c[m] > a[i]) {
                        r = m;
                    }
                    else {
                        l = m;
                    }
                }
                a[i] = l;
            }
            build();
            for (int i = (n + 1) / 2; i < n; i++) {
                if (ii == 0) {
                    rt[i] += ask(2 * i - n, a[i] - 1) + ask(0, 2 * i - n - 1);
                    ans[i] = max(ans[i], lt[i]);
                }
                else {
                    lt[n - 1 - i] += ask(0, a[i] - 1);
                    ans[n - 1 - i] = max(ans[n - 1 - i], lt[n - 1 - i]);
                }
                ch(a[i]);
            }
            for (int i = 0; i < n; i++) {
                a[i] = c[a[i]];
                a[i] -= i;
            }
            reverse(a.begin(), a.end());
        }*/
        /*
        vector< pair<int, int> > tos(n);
        for (int i = 0; i < n; i++) {
            tos[i] = make_pair(a[i] + i, i);
        }
        int mx[n];
        sort(tos.begin(), tos.end());
        mx[tos[0].second] = 0;
        for (int i = 1; i < n; i++) {
            if (tos[i].first != tos[i - 1].first) {
                mx[tos[i].second] = i;
            }
            else {
                mx[tos[i].second] = mx[tos[i - 1].second];
            }
        }
        reverse(a.begin(), a.end());
        for (int i = 0; i < n; i++) {
            tos[i] = make_pair(a[i] + i, i);
        }
        int mx1[n];
        sort(tos.begin(), tos.end());
        mx1[tos[0].second] = 0;
        for (int i = 1; i < n; i++) {
            if (tos[i].first != tos[i - 1].first) {
                mx1[tos[i].second] = i;
            }
            else {
                mx1[tos[i].second] = mx1[tos[i - 1].second];
            }
        }
        reverse(mx1, mx1 + n);
        for (int i = 0; i < n; i++) {
            cout << max(mx[i], mx1[i]) + 1 << endl;
        }*/
    }
}
