#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define F first
#define S second
#define add push_back
#define pw(x) (1ll << (x))

const ll INF = (ll)1e9 + 2018;

const int N = 5010;
const int L = 20;
int arr[N], dp[N], tmax[L][N], logs[N];
pair <int, int> t[N * 4];

void buildsp(int n) {
	logs[1] = 0;
	for (int i = 2; i < N; i++) {
		logs[i] = logs[i / 2] + 1;
	}
	for (int i = 1; i <= n; i++) {
		tmax[0][i] = arr[i];
	}
	for (int l = 1; l < L; l++) {
		for (int i = 1; i + pw(l) <= n + 1; i++) {
			tmax[l][i] = max(tmax[l - 1][i], tmax[l - 1][i + pw(l - 1)]);
		}
	}
}

int get(int l, int r) {
	int lg = logs[r - l + 1];
	return max(tmax[lg][l], tmax[lg][r - pw(lg) + 1]);
}

void relax(int v) {
	if (t[v * 2].F == t[v * 2 + 1].F) {
		t[v].F = t[v * 2].F;
		int l = t[v * 2].S, r = t[v * 2 + 1].S;
		if (dp[l - 1] < dp[r - 1]) {
			t[v].S = l;
		} else {
			t[v].S = r;
		}
	}
	t[v] = min(t[v * 2], t[v * 2 + 1]);
}

void build(int v, int l, int r) {
	t[v] = {INF, -1};
	if (l == r) {
		return;
	}
	int m = (l + r) / 2;
	build(v * 2, l, m);
	build(v * 2 + 1, m + 1, r);
}

pair <int, int> query(int v, int l, int r, int a, int b) {
	if (a > r || l > b) {
		return {INF, -1};
	}
	if (a <= l && r <= b) {
		return t[v];
	}
	int m = (l + r) / 2;
	auto res1 = query(v * 2, l, m, a, b);
	auto res2 = query(v * 2 + 1, m + 1, r, a, b);
	if (res1.F == res2.F) {
		if (res1.F == INF) {
			return res1;
		}
		int l = res1.S, r = res2.S;
		if (dp[l - 1] < dp[r - 1]) {
			return {res1.F, l};
		} else {
			return {res1.F, r};
		}
	}
	return min(res1, res2);
}

void update(int v, int l, int r, int p) {
	if (l == r) {
		t[v] = {arr[l], l};
		return;
	}
	int m = (l + r) / 2;
	if (p <= m) {
		update(v * 2, l, m, p);
	} else {
		update(v * 2 + 1, m + 1, r, p);
	}
	relax(v);
}

void $main() {
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> arr[i];
	}
	buildsp(n);
	build(1, 1, n);
	dp[1] = 1;
	update(1, 1, n, 1);
	for (int i = 2; i <= n; i++) {
		int l = 0, r = i, m;
		while (l + 1 < r) {
			m = (l + r) / 2;
			if (get(m, i) > arr[i]) {
				l = m;
			} else {
				r = m;
			}
		}
		dp[i] = dp[i - 1] + 1;
		/*int mn = arr[i], dpmn = INF;
		for (int j = i - 1; j >= r; j--) {
			if (arr[j] == mn) {
				dpmn = min(dpmn, dp[j - 1]);
			}
			if (arr[j] < mn) {
				mn = arr[j];
				dpmn = dp[j - 1];
			}
		}*/
		auto res = query(1, 1, n, r, i);
		if (res.F != INF) {
			dp[i] = min(dp[i], dp[res.S - 1] + 1);
		}
		update(1, 1, n, i);
		//cout << i << " " << r << endl;
	}
	cout << dp[n];
}

int main() {
	ios::sync_with_stdio(0);
#ifdef flaax
	freopen("input.txt", "r", stdin);
#endif
	$main();
}