#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

#ifndef LOCAL
#define endl "\n"
#define DBG(x)
#else
#define DBG(x) cout << #x << " = " << x << endl;
#endif

template<typename t>
istream &operator>>(istream &in, vector<t> &x) {
    for (auto &y : x) {
        in >> y;
    }
    return in;
};

ostream &operator<<(ostream& out, const vector<int>& a) {
    for (auto x : a) {
        out << x << " ";
    }
    return out;
}

template<typename t>
ostream &operator<<(ostream& out, const vector<t> &a) {
    for (auto &x : a) {
        out << x << endl;
    }
    return out;
}

template<typename t1, typename t2>
istream &operator>>(istream &in, pair<t1, t2> &a) {
    in >> a.first >> a.second;
    return in;
};

void printpath(vector<int> &ans, vector<int> &p, int ind) {
    if (ind == -1) {
        return;
    }
    ans.push_back(ind + 1);
    printpath(ans, p, p[ind]);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<pair<int, int> > > gr(k, vector<pair<int, int> >(k));
    vector<pair<int, int> > l(k);
    cin >> l;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            gr[i].push_back(make_pair(j, 1 << max(abs(l[i].first - l[j].first), abs(l[i].second - l[j].second))));
            gr[j].push_back(make_pair(i, 1 << max(abs(l[i].first - l[j].first), abs(l[i].second - l[j].second))));
        }
    }
    vector<int> dist(k, 1 << 30);
    vector<int> used(k, 0);
    vector<int> p(k, -1);
    dist[0] = 0;
    for (int i = 0; i < k; ++i) {
        int maxc = -1;
        for (int j = 0; j < k; ++j) {
            if (!used[j] && (maxc == -1 || dist[maxc] > dist[j])) {
                maxc = j;
            }
        }
        used[maxc] = 1;
        for (auto &x : gr[maxc]) {
            if (dist[x.first] > dist[maxc] + x.second) {
                dist[x.first] = dist[maxc] + x.second;
                p[x.first] = maxc;
            }
        }
    }
    vector<int> ans;
    printpath(ans, p, k - 1);
    reverse(ans.begin(), ans.end());
    cout << ans.size() << endl << ans << endl;
    //cout << dist << endl;
    return 0;
}