#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int int64_t

#ifndef LOCAL
#define endl "\n"
#define DBG(x)
#else
#define DBG(x) cout << #x << " = " << x << endl;
#endif

template<typename t>
istream &operator>>(istream &in, vector<t> &x) {
    for (auto &y : x) {
        in >> y;
    }
    return in;
};

ostream &operator<<(ostream &out, const vector<int> &a) {
    for (auto x : a) {
        out << x << " ";
    }
    return out;
}

template<typename t>
ostream &operator<<(ostream &out, const vector<t> &a) {
    for (auto &x : a) {
        out << x << endl;
    }
    return out;
}

template<typename t1, typename t2>
istream &operator>>(istream &in, pair<t1, t2> &a) {
    in >> a.first >> a.second;
    return in;
};

void printpath(vector<int> &ans, vector<int> &p, int ind) {
    if (ind == -1) {
        return;
    }
    ans.push_back(ind + 1);
    printpath(ans, p, p[ind]);
}

vector<bool> add(vector<bool> a, int x) {
    assert(x < a.size());
    x = a.size() - x;
    while (x >= 0 && a[x]) {
        a[x--] = 0;
    }
    if (x >= 0) {
        a[x] = 1;
    } else {
        a = vector<bool>(a.size(), 1);
    }
    return a;
}

ostream &operator<<(ostream &out, const vector<bool> &a) {
    for (auto x : a) {
        out << x;
    }
    return out;
}

bool cmp(const vector<bool> &a, const vector<bool> &b) {
    int i = 0;
    while (i < a.size() && a[i] == b[i]) {
        ++i;
    }
    return i < a.size() && a[i] < b[i];
}

template<typename t1, typename t2>
ostream &operator<<(ostream &out, const pair<t1, t2> &a) {
    out << a.first << " " << a.second;
    return out;
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("/home/roi/CLionProjects/A/input.txt", "rt", stdin);
#endif
    int n, m, k;
    cin >> n >> m >> k;
    n = max(n, m);
    n += 10;
    vector<vector<pair<int, int> > > gr(k, vector<pair<int, int> >(k));
    vector<pair<int, int> > l(k);
    cin >> l;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            gr[i][j] = (make_pair(j, max(abs(l[i].first - l[j].first), abs(l[i].second - l[j].second))));
        }
    }
    vector<vector<bool> > dist(k, vector<bool>(n, 1));
    vector<int> used(k, 0);
    vector<int> p(k, -1);
    dist[0] = vector<bool>(n + 10, 0);
    for (int i = 0; i < k; ++i) {
        int maxc = -1;
        for (int j = 0; j < k; ++j) {
            if (!used[j] && (maxc == -1 || cmp(dist[j], dist[maxc]))) {
                maxc = j;
            }
        }
        used[maxc] = 1;
        for (auto &x : gr[maxc]) {
            vector<bool> nd = add(dist[maxc], x.second);
            if (cmp(nd, dist[x.first])) {
                dist[x.first] = nd;
                p[x.first] = maxc;
            }
        }
    }
    vector<int> ans;
    printpath(ans, p, k - 1);
    reverse(ans.begin(), ans.end());
    cout << ans.size() << endl << ans << endl;
    return 0;
}