#include <iostream>
#include <vector>
#include <queue>
#include <bitset>

using namespace std;

const int N = 500;

int n;
bool used[N];
bitset<N> can[N];
bitset<N> dp[N], need[N];
vector<int> g[N];
vector<int> gr[N];

signed main()
{
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		bool flag = 0;
		for (int j = 0; j < n; ++j)
		{
			int now;
			cin >> now;
			--now;

			if (now == i)
			{
				flag = 1;
				need[i][now] = 1;
			}
			else if (!flag)
			{
				g[i].push_back(now);
				gr[now].push_back(i);
				can[i][now] = 1;
			}
			else if (flag)
			{
				need[i][now] = 1;
			}
		}
	}

	int p;
	cin >> p;

	if (p == 1)
	{
		vector<int> res;
		for (int i = 0; i < n; ++i)
		{
			if (g[i].size() == 0)
			{
				res.push_back(i);
			}
		}

		cout << res.size() << "\n";
		for (int i = 0; i < res.size(); ++i)
		{
			cout << res[i] + 1 << " ";
		}
	}
	else
	{
		for (int i = 0; i < n; ++i)
		{
			memset(used, 0, N);
			queue<int> q;
			q.push(i);

			while (!q.empty())
			{
				int v = q.front();
				q.pop();
				dp[v].set(i);
				used[v] = 1;

				for (int u = 0; u < n; ++u)
				{
					if (!used[u] && can[u][i])
					{
						q.push(u);
					}
				}
			}
		}

		vector<int> res;

		for (int col = 0; col < n; ++col)
		{
			bool this_col = 0;
			for (int alive = 0; alive < n; ++alive)
			{
				if (dp[alive][col])
				{
					bool flag = 1;
					for (int u : g[alive])
					{
						if (!(need[alive] & can[u]).any())
						{
							flag = 0;
						}
					}
					if (flag)
					{
						this_col = 1;
					}
				}
			}
			if (this_col)
			{
				res.push_back(col);
			}
		}

		cout << res.size() << "\n";
		for (int i = 0; i < res.size(); ++i)
		{
			cout << res[i] + 1 << " ";
		}
	}
	
	return 0;
}

/*
4
3 2 4 1
1 4 2 3
3 1 2 4
1 4 2 3
2
*/