#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const int N = 10005;
const int MAXC = (1 << 21);

int n, m, k;
vector<pair<int, int> > vert;
vector<pair<int, int> > g[N];
int d[N];
int pr[N];

set<pair<int, int> > st;

bool cmph(pair<int, int> a, pair<int, int> b)
{
	if (a.first == b.first)
	{
		return a.second < b.second;
	}
	return a.first < b.first;
}

bool cmpv(pair<int, int> a, pair<int, int> b)
{
	if (a.first == b.first)
	{
		return a.first < b.first;
	}
	return a.second < b.second;
}

int dist(pair<int, int> a, pair<int, int> b)
{
	return ((max(abs(a.first - b.first), abs(a.second - b.second))));
}

signed main()
{
	cin >> n >> m >> k;
	for (int i = 0; i < k; ++i)
	{
		int x, y;
		cin >> x >> y;
		--x, --y;
		vert.push_back({ x, y });
	}

	for (int i = 0; i < k; ++i)
	{
		pair<int, int> mh = { MAXC, MAXC }, mv = { MAXC, MAXC };
		int ih = -1, iv = -1;
		for (int j = 0; j < k; ++j)
		{
			if (i != j && cmph(vert[j], mh) && (vert[j].first >= vert[i].first && vert[j].second >= vert[i].second))
			{
				mh = vert[j];
				ih = j;
			}
			if (i != j && cmpv(vert[j], mh) && (vert[j].first >= vert[i].first && vert[j].second >= vert[i].second))
			{
				mv = vert[j];
				iv = j;
			}
		}

		if (ih != -1)
		{
			g[i].push_back({ ih, dist(vert[i], mh) });
		}
		if (iv != -1)
		{
			g[i].push_back({ iv, dist(vert[i], mv) });
		}
	}

	st.insert({ 0, 0 });
	d[0] = 0;
	pr[0] = -1;

	for (int i = 1; i < k; ++i)
	{
		st.insert({ MAXC, i });
		d[i] = MAXC;
	}

	while (!st.empty())
	{
		pair<int, int> now = *st.begin();
		st.erase(st.begin());

		for (pair<int, int> u : g[now.second])
		{
			if (d[u.first] >= now.first + u.second) //!
			{
				st.erase(st.find({ d[u.first], u.first }));

				d[u.first] = now.first + u.second;
				pr[u.first] = now.second;

				st.insert({ d[u.first], u.first });
			}
		}
	}

	vector<int> res;
	int v = k - 1;
	while (pr[v] != -1)
	{
		res.push_back(v);
		v = pr[v];
	}

	res.push_back(0);

	reverse(res.begin(), res.end());

	cout << res.size() << "\n";

	for (int i = 0; i < res.size(); ++i)
	{
		cout << res[i] + 1 << " ";
	}
	
	return 0;
}

/*
5 6 9
1 1
4 3
4 6
2 5
3 1
3 3
3 6
5 4
5 6
*/