#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

using namespace std;

const int INF = (int)1e9 + 7;
const int N = 300007;

int n, res;
int arr[N];
int to[N];
int l[N];
vector<int> lr[N];
pair<int, int> ev[N];
map<int, int> fst;
int tmp[N];

struct node
{
	int l, r, val;

	node()
	{
		val = INF;
	}
};

struct STMN
{
	node d[N];

	STMN() {}

	STMN(int n)
	{
		build(1, n);

		for (int i = 0; i < 4 * n; ++i)
		{
			d[i].val = INF;
		}
	}

	void build(int l, int r, int v = 1)
	{
		d[v].l = l;
		d[v].r = r;

		if (l == r)
		{
			return;
		}

		int m = (l + r) >> 1;
		build(l, m, v * 2);
		build(m + 1, r, v * 2 + 1);
	}

	void update(int i, int mod, int v = 1)
	{
		if (d[v].l == d[v].r)
		{
			d[v].val = mod;
			return;
		}

		int m = (d[v].l + d[v].r) >> 1;

		if (i <= m)
		{
			update(i, mod, v * 2);
		}
		else
		{
			update(i, mod, v * 2 + 1);
		}

		d[v].val = min(d[v * 2].val, d[v * 2 + 1].val);
	}

	int get(int l, int r, int v = 1)
	{
		if (l > r || d[v].l > r || d[v].r < l)
		{
			return INF;
		}

		if (d[v].l >= l && d[v].r <= r)
		{
			return d[v].val;
		}

		return min(get(l, r, v * 2), get(l, r, v * 2 + 1));
	}
};

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);

	cin >> n;
	map<int, int> mp;
	for (int i = 0; i < n; ++i)
	{
		cin >> arr[i];
		tmp[i] = arr[i];
	}
	sort(tmp, tmp + n);
	for (int i = 0; i < n; ++i)
	{
		if (!mp.count(tmp[i]))
		{
			mp[tmp[i]] = i + 1;
		}
	}
	for (int i = 0; i < n; ++i)
	{
		arr[i] = mp[arr[i]];
	}

	//l to

	STMN t(n);

	for (int i = n - 1; i >= 0; --i)
	{
		int pos = t.get(1, arr[i] - 1);
		if (pos == INF)
		{
			pos = n;
		}
		t.update(arr[i], i);
		to[i] = pos - 1;
	}

	STMN t2(n);

	for (int i = 0; i < n; ++i)
	{
		int pos = t2.get(arr[i] + 1, n);
		if (pos == INF)
		{
			pos = 1;
		}
		t2.update(arr[i], -i);
		l[i] = -pos + 1;
	}

	for (int i = 0; i < n; ++i)
	{
		lr[l[i]].push_back(i);
		ev[2 * i] = { i + 1, 0 };
		ev[2 * i + 1] = { l[i], 1 };
	}

	sort(ev, ev + 2 * n);

	int i = 0, ind = 0;

	set<int> valid, hlp;

	while (i < n)
	{
		while (ind < 2 * n && ev[ind].first <= i)
		{
			if (ev[ind].second == 1) // open
			{
				for (int rb : lr[ev[ind].first])
				{
					valid.insert(rb);
					hlp.insert(-rb);
				}
			}
			else
			{
				valid.erase(ev[ind].first - 1);
				hlp.erase(-(ev[ind].first - 1));
			}

			++ind;
		}

		if (valid.upper_bound(to[i]) == valid.end())
		{
			int nxt = -(*hlp.begin());
			++res;
			i = nxt + 1;
		}
		else
		{
			int nxt = *valid.upper_bound(to[i]);
			nxt = -(*hlp.upper_bound(-nxt));
			++res;
			i = nxt + 1;
		}
	}
	cout << res << endl;
	return 0;
}

/*
6
2 3 1 1 5 1
*/