#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

mt19937_64 rnd(239);

const int M = 2 * 1e5 + 239;

struct Node
{
    Node *l, *r;
    pair<ll, int> x;
    ll y;
    ll mn, sz, f, mxf;

    Node(ll a, int id)
    {
        y = rnd();
        x = make_pair(a, id);
        sz = 1;
        mn = a;
        f = a;
        mxf = a;
        l = NULL;
        r = NULL;
    }
};

ll getf(Node *p)
{
    return ((p == NULL) ? 0 : p->f);
}

ll getsz(Node *p)
{
    return ((p == NULL) ? 0 : p->sz);
}

ll getmn(Node *p)
{
    return ((p == NULL) ? 0 : p->mn);
}

ll getmxf(Node *p)
{
    return ((p == NULL) ? 0 : p->mxf);
}

void upd(Node *p)
{
    if (p == NULL) return;
    p->sz = 1 + getsz(p->l) + getsz(p->r);
    p->mn = min(min(getmn(p->l), getsz(p->r)), p->x.first);
    p->f = p->sz * p->mn;
    p->mxf = max(max(getmxf(p->l), getmxf(p->r)), p->mxf);
}

pair<Node*, Node*> split(Node *p, pair<ll, int> x)
{
    Node *nul = NULL;
    if (p == NULL) return make_pair(nul, nul);
    if (p->x <= x)
    {
        pair<Node*, Node*> t = split(p->r, x);
        p->r = t.first;
        upd(p);
        return make_pair(p, t.second);
    }
    else
    {
        pair<Node*, Node*> t = split(p->l, x);
        p->l = t.second;
        upd(p);
        return make_pair(t.first, p);
    }
}

Node* merge_(Node *l, Node *r)
{
    if (l == NULL) return r;
    if (r == NULL) return l;
    if (l->y < r->y)
    {
        Node *nw = merge_(l, r->l);
        r->l = nw;
        upd(r);
        return r;
    }
    else
    {
        Node *nw = merge_(l->r, r);
        l->r = nw;
        upd(l);
        return l;
    }
}

Node *root;

int n;
ll a[M], b[M];

void add(ll az, int id)
{
    pair<Node*, Node*> t = split(root, make_pair(az, id));
    Node *now = new Node(az, id);
    root = merge_(merge_(t.first, now), t.second);
}

int main()
{   /*
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout); /**/
    cin.sync_with_stdio(0);
    root = NULL;
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i] >> b[i];
    vector<pair<ll, ll> > p;
    for (int i = 0; i < n; i++)
        p.push_back(make_pair(a[i], b[i]));
    sort(p.begin(), p.end());
    for (int i = 0; i < n; i++)
        a[i] = p[i].first, b[i] = p[i].second;
    a[n] = 0;
    ll ans = a[0] * (ll)n;
    for (int i = 0; i < n; i++)
    {
        add(b[i], i);
        ans = max(ans, root->mxf + a[i + 1] * (ll)(n - i - 1));
    }
    cout << ans;
    return 0;
}
