#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

typedef unsigned long long ll;
typedef long double ld;

const int M = 1e4 + 10;
const ll INF = 1e18;
const int BIG = 1e9 + 239;
const ll B = ((ll)1 << (ll)63);
const int K = 160;
const int S = 63;

struct number
{
    int mx;
    array<ll, K> v;

    number()
    {
        mx = 0;
        for (int i = 0; i < K; i++)
            v[i] = 0;
    }

    void add(int i)
    {
        int in = i / S;
        ll d = ((ll)1 << (ll)(i % S));
        while (d != 0)
        {
            ll nd = (v[in] + d) >> (ll)63;
            v[in] = (v[in] + d) & (B - 1);
            if (v[in] != 0) mx = max(in, mx);
            d = nd;
            in++;
        }
    }

    bool operator<(const number &a) const
    {
        if (mx != a.mx) return (mx < a.mx);
        for (int i = mx; i >= 0; i--)
        {
            if (v[i] == a.v[i]) continue;
            return (v[i] < a.v[i]);
        }
        return false;
    }

    bool operator==(const number &a) const
    {
        if (mx != a.mx) return false;
        for (int i = mx; i >= 0; i--)
            if (v[i] != a.v[i])
                return false;
        return true;
    }
};

int n, m, k;
pair<int, int> p[M];
number dist[M];
int pr[M], d[M], g[M];
bool used[M];

int main()
{   /*
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout); /**/
    cin.sync_with_stdio(0);
    cin >> n >> m >> k;
    for (int i = 0; i < k; i++)
        cin >> p[i].first >> p[i].second;
    for (int i = 1; i < k; i++)
        dist[i].add(K * S - 1);
    for (int i = 0; i < k; i++)
        d[i] = max(n, m), g[i] = -1;
    for (int z = 0; z < k; z++)
    {
        int t = -1;
        for (int i = 0; i < k; i++)
            if (!used[i])
                if (t == -1 || (dist[i] < dist[t]) || (dist[i] == dist[t] && (rand() & 1)))
                    t = i;
        used[t] = true;
        if (t == k - 1) break;
        for (int i = 0; i < k; i++)
            if (!used[i])
            {
                int r = max(abs(p[i].first - p[t].first), abs(p[i].second - p[t].second));
                if (r >= d[i]) continue;
                if (r + g[t] <= g[i])
                {
                    //cerr << z << " " << r << " " << g[i] << "\n";
                    dist[i] = dist[t];
                    dist[i].add(r);
                    pr[i] = t;
                    continue;
                }
                number now = dist[t];
                now.add(r);
                if (now < dist[i])
                {
                    dist[i] = now;
                    pr[i] = t;
                    g[i] = r;
                }
                else
                    d[i] = r;
            }
    }
    vector<int> ans;
    int x = k - 1;
    while (x != 0)
    {
        ans.push_back(x);
        x = pr[x];
    }
    ans.push_back(x);
    reverse(ans.begin(), ans.end());
    cout << ans.size() << "\n";
    for (int t : ans)
        cout << (t + 1) << " ";
    return 0;
}
