#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

struct node {
	node* l = nullptr;
	node* r = nullptr;
	int ind;
	int value;
	node(){}
};

node* build(int L, int R, vector<int> &a) {
	node* t = new node;
	if (L == R - 1) {
		t->value = a[L];
		t->ind = L;
		return t;
	}
	int M = (L + R) / 2;
	t->l = build(L, M, a);
	t->r = build(M, R, a);
	if (t->l->value > t->r->value) {
		t->value = t->l->value;
		t->ind = t->l->ind;
	}
	else {
		t->value = t->r->value;
		t->ind = t->r->ind;
	}
	return t;
}

pair<int, int> get(node* t, int L, int R, int l, int r) {
	if (L == l && R == r) {
		return { t->value, t->ind };
	}
	int M = (L + R) / 2;
	pair<int, int> res1 = { -1, 0 };
	pair<int, int> res2 = { -1, 0 };
	if (M > l && t->l) res1 = get(t->l, L, M, l, min(r, M));
	if (M < r && t->r) res2 = get(t->r, M, R, max(l, M), r);
	if (res1.first > res2.first) return res1;
	return res2;
}

int main() {
	int n;
	cin >> n;
	int el;
	vector<int> a(n);
	vector<int> nextmin(n);
	for (int i = 0; i < n; i++) {
		cin >> el;
		a[i] = el;
		nextmin[i] = n;
	}
	node* t = build(0, n, a);
	vector<int> st;
	for (int i = 0; i < n; i++) {
		while (st.size() > 0 && a[st[st.size() - 1]] > a[i]) {
			nextmin[st[st.size() - 1]] = i;
			st.pop_back();
		}
		st.push_back(i);
	}
	st.clear();
	int cnt = 0;
	int now = 0;
	int minim;
	while (now < n) {
		//cout << now << endl;
		cnt++;
		minim = nextmin[now];
		auto res = get(t, 0, n, now, minim);
		now = res.second + 1;
	}
	cout << cnt << endl;
	//cin >> cnt;
}