#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stack>

using namespace std;

#define LL long long
const LL INF = 1e15;

vector< vector< int > > g;

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);

	vector<int> st(21);
	st[0] = 1;

	for (size_t i = 1; i < 21; i++)
	{
		st[i] = st[i - 1] * 2;
	}

	int n, m, k;
	cin >> n >> m >> k;

	vector< pair< int, int> > proc(k);
	g.resize(k, vector< int > (k, INF));

	for (size_t i = 0; i < k; i++)
	{
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		proc[i] = { a, b };
	}

	for (size_t i = 0; i < k; i++)
	{
		for (size_t j = 0; j < k; j++)
		{
			if (i == j)
				continue;
			int q = max(abs(proc[i].first - proc[j].first), abs(proc[i].second - proc[j].second));
			int r = st[q];

			g[i][j] = r;
			g[j][i] = r;
		}
	}

	vector< LL > dist(k, INF), pr(k), used(k);

	dist[0] = 0;
	pr[0] = -1;

	for (size_t i = 0; i < k - 1; i++)
	{
		int v = 0;

		while (used[v] == 1)
			v++;

		for (size_t j = v + 1; j < k; j++)
			if (used[j] == 0 && dist[j] < dist[v])
				v = j;

		used[v] = 1;

		for (size_t u = 0; u < k; u++)
		{
			if (used[u] == 0)
			{
				if (dist[u] > dist[v] + g[v][u])
				{
					pr[u] = v;
					dist[u] = dist[v] + g[v][u];
				}
			}
		}
	}

	int ans = 1;
	int now = pr[k - 1];

	stack< int > s;

	s.push(k);

	while (now != -1)
	{
		s.push(now + 1);
		ans++;
		now = pr[now];
	}

	cout << ans << "\n";
	while (!s.empty())
	{
		cout << s.top() << " ";
		s.pop();
	}

	return 0;
}