#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stack>

using namespace std;

#define LL long long
const LL INF = 1e15;

struct dl
{
	vector<int> v;
	dl(int a = 0)
	{
		v.resize(551);
		v[a] = 1;
		v[0] = 0;
	}
};

dl operator+(dl a, dl b)
{
	dl x(0);
	for (size_t i = 0; i < 550; i++)
	{
		x.v[i] += a.v[i] + b.v[i];
		x.v[i + 1] = x.v[i] / 2;
		x.v[i] = x.v[i] % 2;
	}

	return x;
}

bool operator<(dl a, dl b)
{
	for (int i = 550; i >= 0; i--)
	{
		if (a.v[i] != b.v[i])
		{
			if (a.v[i] < b.v[i])
				return 1;
			else
				return 0;
		}
	}
	return 0;
}

vector< vector< dl > > g;

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	
	ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);

	int n, m, k;
	cin >> n >> m >> k;

	vector< pair< int, int> > proc(k);
	g.resize(k, vector< dl > (k, 520));

	for (size_t i = 0; i < k; i++)
	{
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		proc[i] = { a, b };
	}

	for (size_t i = 0; i < k; i++)
	{
		for (size_t j = 0; j < k; j++)
		{
			if (i == j)
				continue;
			dl r = dl(max(abs(proc[i].first - proc[j].first), abs(proc[i].second - proc[j].second)));

			g[i][j] = r;
			g[j][i] = r;
		}
	}

	vector< dl > dist(k, 520);
	vector< int > pr(k), used(k);

	dist[0] = dl(0);
	pr[0] = -1;

	for (size_t i = 0; i < k - 1; i++)
	{
		int v = 0;

		while (used[v] == 1)
			v++;

		for (size_t j = v + 1; j < k; j++)
			if (used[j] == 0 && dist[j] < dist[v])
				v = j;

		used[v] = 1;

		for (size_t u = 0; u < k; u++)
		{
			if (used[u] == 0)
			{
				if (dist[v] + g[v][u] < dist[u])
				{
					pr[u] = v;
					dist[u] = dist[v] + g[v][u];
				}
			}
		}
	}

	int ans = 1;
	int now = pr[k - 1];

	stack< int > s;

	s.push(k);

	while (now != -1)
	{
		s.push(now + 1);
		ans++;
		now = pr[now];
	}

	cout << ans << "\n";
	while (!s.empty())
	{
		cout << s.top() << " ";
		s.pop();
	}

	return 0;
}