#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

#define LL long long

vector<int> DO;
vector<int> v, dp;

void build(int id, int l, int r)
{
	if (l == r - 1)
	{
		DO[id] = l;
		return;
	}

	int m = (l + r) / 2;

	build(id * 2, l, m);
	build(id * 2 + 1, m, r);

	if (v[DO[id * 2]] > v[DO[id * 2 + 1]])
		DO[id] = DO[id * 2];
	else
		DO[id] = DO[id * 2 + 1];
}

int take(int id, int l, int r, int x, int y)
{
	if (l >= x && r <= y)
		return DO[id];
	if (l >= y || r <= x)
		return -1;

	int m = (l + r) / 2;

	int a = take(id * 2, l, m, x, y);
	int b = take(id * 2 + 1, m, r, x, y);

	if (a == -1)
		return b;
	if (b == -1)
		return a;

	if (v[a] > v[b])
		return a;
	else
		return b;
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);

	int n;
	cin >> n;


	for (size_t i = 0; i < n; i++)
	{
		int a;
		cin >> a;
		if (v.size() == 0 || a != v[v.size() - 1])
			v.push_back(a);
	}

	n = v.size();

	set<int> s;
	map<int, int> m;
	dp.resize(n);
	dp[n - 1] = -1;
	s.insert(v[n - 1]);
	m[v[n - 1]] = n - 1;

	for (int i = n - 2; i >= 0; i--)
	{
		auto it = s.lower_bound(v[i]);
		it--;
		if (it == s.end())
			dp[i] = -1;
		else
			dp[i] = m[*it];

		s.insert(v[i]);
		m[v[i]] = i;
	}

	DO.resize(n * 4);

	build(1, 0, n);

	int ans = 0;

	for (size_t i = 0; i < n; i++)
	{
		if (dp[i] == -1)
			i = take(1, 0, n, i, n);
		else
			i = take(1, 0, n, i, dp[i]);

		ans++;
	}

	cout << ans;

	return 0;
}