#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cassert>

using namespace std;

vector<pair<int, int>> a;
map<pair<int, int>, int> proc;

vector<int> dijkstra(int n, int m)
{
	set<pair<double, pair<int, int>>> q;
	vector<vector<double>> d(n, vector<double>(m, 1e+60));
	vector<vector<int>> p(n, vector<int>(m));

	d[0][0] = 0;
	q.insert({ 0, { 0, 0 } });

	while (!q.empty()) {
		int i = q.begin()->second.first;
		int j = q.begin()->second.second;
		double w = d[i][j];
		q.erase(q.begin());

		for (int k = 0; k < a.size(); k++) {
			int x = a[k].first;
			int y = a[k].second;
			double nw = w + pow(2, max(abs(i - x), abs(j - y)));

			if (nw < d[x][y]) {
				q.erase({ d[x][y], { x, y } });
				d[x][y] = nw;
				p[x][y] = proc[{ i, j }];
				q.insert({ d[x][y], { x, y }});
			}
		}
	}

	int i = n - 1, j = m - 1;
	vector<int> res;
	res.push_back(a.size());

	while (i > 0 || j > 0) {
		res.push_back(p[i][j] + 1);
		int nexti = a[p[i][j]].first;
		int nextj = a[p[i][j]].second;
		i = nexti;
		j = nextj;
	}
	reverse(res.begin(), res.end());

	return res;
}

signed main()
{
	freopen("input.txt", "r", stdin);
	int n, m, k;
	cin >> n >> m >> k;

	a.resize(k);

	for (int i = 0; i < k; i++) {
		int x, y;
		cin >> x >> y;
		x--, y--;
		a[i] = { x, y };
		proc[{ x, y }] = i;
	}

	vector<int> ans = dijkstra(n, m);
	assert(ans[0] == 1);

	cout << ans.size() << '\n';
	for (int x : ans)
		cout << x << ' ';
}
