#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <climits>

using namespace std;

vector<int> a;
vector<pair<int, int>> t; //min-max

pair<int, int> rec(pair<int, int> a, pair<int, int> b)
{
	int mx = max(a.second, b.second);
	int mn = min(a.first, b.first);
	return { mn, mx };
}

void build(int v, int l, int r)
{
	if (l == r - 1)
		t[v] = { a[l], a[l] };
	else {
		int m = (l + r) >> 1;
		build(2 * v + 1, l, m);
		build(2 * v + 2, m, r);
		t[v] = rec(t[2 * v + 1], t[2 * v + 2]);
	}
}

pair<int, int> get(int v, int l, int r, int ql, int qr)
{
	if (qr <= l || r <= ql)
		return { INT_MAX, INT_MIN };
	else if (ql <= l && r <= qr)
		return t[v];
	else {
		int m = (l + r) >> 1;
		return rec(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
	}
}

int main()
{
	int n;
	cin >> n;

	a.resize(n);
	t.resize(4 * n);
	for (int i = 0; i < n; i++)
		cin >> a[i];

	build(0, 0, n);

	vector<int> dp(n, n);
	
	for (int i = 0; i < n; i++)
		for (int j = i; j < n; j++) {
			auto t = get(0, 0, n, i, j + 1);
			
			if (a[i] == t.first && a[j] == t.second)
				dp[j] = min(dp[j], ((i == 0) ? 1 : (dp[i - 1] + 1)));
		}

	cout << dp[n - 1];
}
