#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("Ofast")
#endif
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <functional>
#include <set>
#include <cassert>
using namespace std;
void entry(int testId);
int main() {
	if (DEV) {
		string fileName = "pub";
		string fin = fileName + ".txt";
		string fout = fileName + "-out.txt";
		freopen(fin.c_str(), "r", stdin);
		freopen(fout.c_str(), "w", stdout);
	}
	else {
		ios_base::sync_with_stdio(false);
		cin.tie(nullptr);
	}
	int i = 0;
	int k = 1e8;
	if (!DEV) k = 1;
	while (!cin.eof() && (k--)) {
		entry(i++);
		if (DEV) {
			cout << "--------\n";
		}
	}
}
using ll = long long;
#define endl "\n"
const int LEN = 20 + (1 - DEV)*(500);
struct Num {
	vector<int> digits;
	Num(): digits(LEN) {}
	static Num fromBit(int k) {
		Num res;
		res.digits[k] = 1;
		return res;
	}

	void normalize() {
		for (int i = 0; i < LEN - 1; ++i) {
			digits[i + 1] += digits[i] / 2;
			digits[i] %= 2;
		}
	}
};

Num operator+(Num lhs, Num rhs) {
	Num res;
	for (int i = 0; i < LEN; ++i) {
		res.digits[i] = lhs.digits[i] + rhs.digits[i];
	}
	res.normalize();
	return res;
}

bool operator<(Num lhs, Num rhs) {
	for (int i = LEN - 1; i >= 0; --i) {
		if (lhs.digits[i] != rhs.digits[i]) {
			return lhs.digits[i] < rhs.digits[i];
		}
	}
	return false;
}

using TTT = tuple<Num, int, int>;
void entry(int testId) {
	int n, m, k;
	cin >> n >> m >> k;
	vector<pair<int, int>> p;
	p.reserve(k);
	for (int i = 0; i < k; ++i) {
		int x, y;
		cin >> x >> y;
		--x;
		--y;
		p.emplace_back(x, y);
	}
	vector<vector<Num>> g(k, vector<Num>(k));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			int dx = abs(p[i].first - p[j].first);
			int dy = abs(p[i].second - p[j].second);
			ll d = max(dx, dy);
			g[i][j] = Num::fromBit(d);
		}
	}
	vector<Num> dist(k, Num::fromBit(LEN-1));
	vector<ll> prev(k, -1);
	vector<bool> used(k);
	prev[0] = -2;
	dist[0] = Num();
	//set<TTT> q;
	//q.emplace(Num(), -2, 0);
	for (int i = 0; i < k; ++i) {
		//auto ev = *q.begin();
		int v = -1;
		for (int j = 0; j < k; ++j) {
			if (used[j]) continue;
			if (v == -1 || dist[j] < dist[v]) {
				v = j;
			}
		}
		assert(v != -1);
		Num d = dist[v];
		used[v] = true;
		//q.erase(ev);
		//if (!(d < dist[v])) continue;
		for (int w = 0; w < k; ++w) {
			auto nd = d + g[v][w];
			if (nd < dist[w]) {
				//q.emplace(nd, v, w);
				dist[w] = nd + Num::fromBit(0);
				prev[w] = v;
			}
		}
	}
	vector<int> ans;
	int ci = k - 1;
	while (ci != -2) {
		ans.push_back(ci);
		auto ni = prev[ci];
		assert(p[ci].first <= p[ni].first && p[ci].second <= p[ni].second);
		ci = ni;
	}
	//if (DEV) cout << dist[k - 1] << endl;
	cout << ans.size() << endl;
	reverse(ans.begin(), ans.end());
	for (auto x : ans) cout << x + 1 << " ";
	cout << endl;
}