#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
using namespace std;

void entry(int testId);

int main() {
	if (DEV) {
		freopen("roi.txt", "r", stdin);
		freopen("roi-o.txt", "w", stdout);
	}
	else {
		ios_base::sync_with_stdio(false);
		cin.tie(nullptr);
	}
	int k = 0;
	int kostyl = 1e8;
	if (!DEV) kostyl = 1;
	while (kostyl-- && !cin.eof()) {
		entry(k++);
	}

	return 0;
}
#define endl "\n"
using ll = long long;
using ld = long double;
using V = pair<int, int>;

V merge(V lhs, V rhs, int F) {
	if (lhs.first == -1) return rhs;
	if (rhs.first == -1) return lhs;
	if (lhs.first > rhs.first) return merge(rhs, lhs, F);
	if (F) {//on right max
		if (lhs.second > rhs.second) {
			return lhs;
		}
		return rhs;
	}
	else { // on left min
		if (rhs.second < lhs.second) {
			return rhs;
		}
		return lhs;
	}

}
template<int F>
struct STN {
	int il;
	int ir;
	STN* l;
	STN* r;
	V val;
	int ind;
	bool leaf() {
		return ir - il == 1;
	}
	void relax() {
		if (leaf()) return;
		val = merge(l->val, r->val, F);
	}
};



template<int F>
class SegTree {
	using N = STN<F>;
	N* root = nullptr;
	N* build(vector<int>& a, int il, int ir) {
		N* v = new N;
		v->il = il;
		v->ir = ir;
		if (v->leaf()) {
			v->val = { il, a[il] };
			v->l = v->r = nullptr;
		}
		else {
			int im = (il + ir) / 2;
			v->l = build(a, il, im);
			v->r = build(a, im, ir);
		}
		v->relax();
		return v;
	}
	template<typename Cb>
	void traverse(N* v, int il, int ir, const Cb& cb) {
		if (il <= v->il && v->ir <= ir) {
			cb(v);
			return;
		}
		if (v->ir <= il || ir <= v->il) {
			return;
		}
		traverse(v->l, il, ir, cb);
		traverse(v->r, il, ir, cb);
	}
public:
	SegTree(vector<int>& vec) {
		root = build(vec, 0, vec.size());
	}
	SegTree() {}
	int getMax(int l, int r) {
		V ans{ -1, -1 };
		traverse(root, l, r, [&](N* v){
			ans = merge(ans, v->val, F);
		});
		return ans.first;
	}
};

//cut here
int n;
vector<int> a;
SegTree<0> stMin;
SegTree<1> stMax;
int solve(int l, int r) {
	if (r - l < 2) return r - l;
	int ans = 1;
	//int mx = r;
	//for (int i = r - 1; i >= l; --i) {
	//	if (mx == r || a[i] > a[mx]) {
	//		mx = i;
	//	}
	//}
	int mx = stMax.getMax(l, r);
	//int mn = r;
	//for (int i = l; i <= mx; ++i) {
	//	if (mn == r || a[i] < a[mn]) {
	//		mn = i;
	//	}
	//}
	int mn = stMin.getMax(l, mx + 1);
	ans += solve(l, mn);
	ans += solve(mx + 1, r);
	return ans;
}
void entry(int testId) {
	cin >> n;
	if (n == -1) { exit(0); }
	a.clear();
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	stMin = SegTree<0>(a);
	stMax = SegTree<1>(a);
	vector<int> b(n + 1, -1e8);
	int ans = 0;
	for (int i = n - 1; i >= 0; --i) {
		b[i] = max(b[i + 1], a[i]);
		if (a[i] > b[i + 1]) ++ans;
	}
	//cout << ans << endl;
	cout << solve(0, n) << endl;
}