#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <unordered_map>
#include <map>
#include <set>
using namespace std;

void entry(int testId);

int main() {
	if (DEV) {
		freopen("roi.txt", "r", stdin);
		freopen("roi-o.txt", "w", stdout);
	}
	else {
		ios_base::sync_with_stdio(false);
		cin.tie(nullptr);
	}
	int k = 0;
	int kostyl = 1e8;
	if (!DEV) kostyl = 1;
	while (kostyl-- && !cin.eof()) {
		entry(k++);
	}

	return 0;
}
#define endl "\n"
using ll = long long;
using ld = long double;


//cut here

using V = ll;

V merge(V lhs, V rhs) {
	return lhs + rhs;

}

struct STN {
	int il;
	int ir;
	STN* l;
	STN* r;
	V val;
	int ind;
	bool leaf() {
		return ir - il == 1;
	}
	void relax() {
		if (leaf()) return;
		val = merge(l->val, r->val);
	}
};



class SegTree {
	using N = STN;
	N* root = nullptr;
	N* build(int il, int ir) {
		N* v = new N;
		v->il = il;
		v->ir = ir;
		if (v->leaf()) {
			v->val = 0;
			v->l = v->r = nullptr;
		}
		else {
			int im = (il + ir) / 2;
			v->l = build(il, im);
			v->r = build(im, ir);
		}
		v->relax();
		return v;
	}
	template<typename Cb>
	void traverse(N* v, int il, int ir, const Cb& cb) {
		if (il <= v->il && v->ir <= ir) {
			cb(v);
			return;
		}
		if (v->ir <= il || ir <= v->il) {
			return;
		}
		traverse(v->l, il, ir, cb);
		traverse(v->r, il, ir, cb);
		v->relax();
	}
public:
	SegTree(int n) {
		root = build(0, n);
	}
	SegTree() {}
	int getMax(int l, int r) {
		V ans =0;
		traverse(root, l, r, [&](N* v) {
			ans = merge(ans, v->val);
		});
		return ans;
	}

	void inc(int i) {
		traverse(root, i, i + 1, [](N*v) {
			v->val += 1;
		});
	}
};






struct Point {
	int x;
	int y;
	int i;
};

void entry(int testId) {
	int n, p;
	cin >> n >> p;
	if (n == -1) exit(0);
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	auto solve = [&](int i, int j) {
		return abs(j - i) + a[j];
	};
	vector<Point> rotated;
	for (int i = 0; i < n; ++i) {
		int x = i;
		int y = a[i];
		rotated.push_back({ x + y, x - y, i });
	}

	set<int> coords;
	for (auto p : rotated) {
		coords.insert(p.y);
	}

	vector<int> coordsv(coords.begin(), coords.end());

	auto H = coords.size();
	for (auto& p : rotated) {
		int oy = p.y;
		int ny = lower_bound(coordsv.begin(), coordsv.end(), oy) - coordsv.begin();
		p.y = ny;
	}


	map<int, vector<Point>> events;
	SegTree rmg(H);
	//vector<int> rmq(H);
	vector<int> tans(n);
	for (auto p : rotated) {
		events[p.x].push_back(p);
	}
	for (auto it : events) {
		for (auto p : it.second) {
			int ans = 0;
			//for (int i = p.y + 1; i < H; ++i) {
			//	ans += rmq[i];
			//}
			ans = rmg.getMax(p.y + 1, H);
			tans[p.i] = ans;
		}
		for (auto p : it.second) {
			rmg.inc(p.y);
			//++rmq[p.y];
		}
	}
	for (auto t : tans) cout << t + 1 << endl;
	cout << endl;
}
