#include <bits/stdc++.h>

using namespace std;

typedef bitset<1000> big;

big to_bits(int x)
{
    big b;
    b.set(x);

    return b;
}

bool operator<(big a, big b)
{
    for (int i = 999; i >= 0; i--)
    {
        if (a[i] && !b[i])
            return false;

        if (b[i] && !a[i])
            return true;
    }

    return false;
}

big operator+(big a, big b)
{
    int cur = 0;
    big result;

    for (int i = 0; i < 1000; i++)
    {
        int sum = (int)a[i] + (int)b[i] + cur;
        result.set(i, sum % 2);
        cur = sum / 2;
    }

    return result;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    big inf, zero;
    inf.flip();

    int n, m, k, i, j;
    cin >> n >> m >> k;

    vector<pair<int, int>> points(k);
    for (i = 0; i < k; i++)
        cin >> points[i].first >> points[i].second;

    vector<vector<int>> matrix(k, vector<int>(k));
    for (i = 0; i < k; i++)
    {
        for (j = 0; j < k; j++)
        {
            int d = max(abs(points[i].first - points[j].first),
                        abs(points[i].second - points[j].second));

            matrix[i][j] = d;
            matrix[j][i] = d;
        }
    }

    vector<big> dist(k, inf);
    vector<bool> used(k, false);
    vector<int> prev(k, 0);

    dist[0] = zero;
    used[0] = true;
    prev[0] = -1;
    for (i = 0; i < k; i++)
        dist[i] = to_bits(matrix[0][i]);

    for (i = 0; i < k; i++)
    {
        int u = -1;
        for (j = 0; j < k; j++)
            if (!used[j] && (u == -1 || dist[j] < dist[u]))
                u = j;

        used[u] = true;
        for (i = 0; i < k; i++)
        {
            if (used[i])
                continue;

            big val = dist[u] + to_bits(matrix[u][i]);

            if (val < dist[i])
            {
                dist[i] = val;
                prev[i] = u;
            }
        }
    }

    int q = k - 1;
    vector<int> path;
    while (prev[q] != -1)
    {
        path.push_back(q);
        q = prev[q];
    }
    path.push_back(q);

    cout << path.size() << endl;
    for (auto it = path.rbegin(); it != path.rend(); it++)
        cout << (*it + 1) << " ";

    return 0;
}
