#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

const int INF = (int)2e9;

struct node
{
    pair<int, int> m;
    node *l = nullptr;
    node *r = nullptr;

    node()
    {
        m.first = -INF;
        m.second = -INF;
    }
};

typedef node* tree;

pair<int, int> safe(tree t)
{
    if (!t)
        return {-INF, -INF};
    else
        return t->m;
}

tree build(int L, int R, vector<int> &a)
{
    tree t = new node();

    if (L == R - 1)
    {
        t->m.first = a[L];
        t->m.second = L;
    }
    else
    {
        int M = (L + R) / 2;

        t->l = build(L, M, a);
        t->r = build(M, R, a);
        pair<int, int> p = max(safe(t->l), safe(t->r));
        t->m.first = p.first;
        t->m.second = p.second;
    }

    return t;
}

pair<int, int> get(tree t, int l, int r, int L, int R)
{
    if (l < L || r > R || l >= r || L >= R)
        return {-INF, -INF};
    if (l == L && r == R)
        return t->m;

    int M = (L + R) / 2;
    return max(get(t->l, l, min(M, r), L, M),
               get(t->r, max(l, M), r, M, R));
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, i;
    cin >> n;

    vector<int> num(n);
    for (i = 0; i < n; i++)
        cin >> num[i];

    vector<int> next_min(n, n);
    vector<int> stack;
    for (i = 0; i < n; i++)
    {
        while (!stack.empty() && num[i] < num[stack.back()])
        {
            next_min[stack.back()] = i;
            stack.pop_back();
        }

        stack.push_back(i);
    }

    i = 0;
    int ans = 0;
    tree root = build(0, n, num);
    while (i < n)
    {
        i = get(root, i, next_min[i], 0, n).second + 1;
        ans++;
    }

    cout << ans << endl;

    return 0;
}
