#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


vector<vector<int>> graph;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m, k;
    cin >> n >> m >> k;

    vector<int> xs(k), ys(k);
    for (int i = 0; i < k; ++i) {
        cin >> xs[i] >> ys[i];
    }

    graph.resize(k, vector<int>(k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            graph[i][j] = (1 << max(abs(xs[i] - xs[j]), abs(ys[i] - ys[j])));
        }
    }

    vector<int> dist(k, 1000000000), prev(k);
    dist[0] = 0;

    vector<int> used(k);
    for (int i = 0; i < k; ++i) {
        int mind = 1000000000, v;
        for (int j = 0; j < k; ++j) {
            if (!used[j] && dist[j] < mind) {
                mind = dist[j];
                v = j;
            }
        }

        used[v] = true;

        for (int j = 0; j < k; ++j) {
            if (dist[v] + graph[v][j] < dist[j]) {
                dist[j] = dist[v] + graph[v][j];
                prev[j] = v;
            }
        }
    }

    vector<int> answ{k - 1};

    int cur = k - 1;
    while (cur != 0) {
        cur = prev[cur];
        answ.push_back(cur);
    }

    reverse(answ.begin(), answ.end());

    cout << answ.size() << '\n';
    for (int i : answ) {
        cout << i + 1 << ' ';
    }

    return 0;
}