#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>


using namespace std;


bool cmp(vector<int> a, vector<int> b) {
    if (a.size() == 0) {
        return false;
    }

    if (b.size() == 0) {
        return true;
    }

    if (a.size() < b.size()) {
        return true;
    }

    if (a.size() > b.size()) {
        return false;
    }

    for (int i = a.size() - 2; i >= 0; --i) {
        if (a[i] != b[i]) {
            return b[i];
        }
    }

    return false;
}


int n, maxl = 0;
vector<vector<int>> pos;


struct CC {
    bool operator()(int a, int b) const {
        return pos[a].size() > pos[b].size();
    }
};


vector<int> answ(int k) {
    if (k == n) {
        vector<int> res;

        multiset<int, CC> left;
        for (int j = 0; j < n; ++j) {
            left.insert(j);
        }

        for (int i = 0; left.size(); ++i) {
            int cnt = 0;

            vector<int> to_erase;
            for (int j : left) {
                if (pos[j].size() <= i) {
                    to_erase.push_back(j);

                    continue;
                }

                if (pos[j][i]) {
                    if (++cnt == 2) {
                        return {};
                    }
                }
            }

            for (int j : to_erase) {
                left.erase(j);
            }

            res.push_back(cnt > 0);
        }

        res.pop_back();

        return res;
    }

    vector<int> copy = pos[k], res = answ(k + 1);

    for (int i = 0; i < pos[k].size(); ++i) {
        if (pos[k][i] == 1 || i > 0 && pos[k][i - 1] == 0) {
            if (i > 0) {
                pos[k][i - 1] = 0;
            }

            continue;
        }

        if (i > 0) {
            pos[k][i - 1] = 0;
        }

        pos[k][i] = 1;

        res = min(res, answ(k + 1), cmp);

        pos[k][i] = 0;
    }

    pos[k].back() = 0;

    pos[k].push_back(1);
    maxl = max(maxl, (int)pos[k].size());

    res = min(res, answ(k + 1), cmp);

    pos[k] = copy;

    return res;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;

    string s;

    pos.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> s;

        int k = s.length();

        maxl = max(maxl, k);

        pos[i].resize(k);
        for (int j = 0; j < k; ++j) {
            pos[i][j] = (s[k - j - 1] == '1');
        }
    }

    vector<int> res = answ(0);

    reverse(res.begin(), res.end());

    if (res.size() == 0 || res[0] == 0) {
        return 1;
    }

    for (int i : res) {
        cout << i;
    }

    return 0;
}