#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <bitset>
using namespace std;

const int len = 3e5;
int x;
int a[len], b[len];

long long ask(long long B, long long A){
	if(B > A)
		return -1ll << 50;
	long long res = 0;
	for(int i = 0;i < x;i++){
		if(A <= a[i])
			res += A;
		else if(B <= b[i])
			res += B;
	}
	return res;
}

set < pair < int, int > > ev;
vector < long long > vl;
int posMax = -1;

long long cnt(int pos){
	return (long long) vl.size() - pos;
}

void pushEvent(int pos){
	if(vl[posMax] * cnt(posMax) <= vl[pos] * cnt(pos)){
		posMax = pos;
	}
}

long long getMax(){
	while(!ev.empty() && (*ev.begin()).first < vl.size()){
		auto now = ev.begin();
		ev.erase(now);
		pushEvent((*now).second);
	}
	if(posMax == -1)
		return 0;

	return vl[posMax] * cnt(posMax);
}

void append(int val){
	vl.push_back(val);
	if(vl.size() > 1){
		long long B = val;
		long long A = vl[posMax];

		if(A - B != 0){
			long long k = (B - A * cnt(posMax)) / (A - B);

			//if((B - A * cnt(posMax)) % (A - B) != 0)
				k++;
			
			ev.insert({ vl.size() + k, vl.size() - 1 });	
		}
	} else {
		posMax = 0;
	}
}
	
int main(){
	scanf("%d", &x);

	bool isG4 = true, isG5 = true;

	for(int i = 0;i < x;i++){
		scanf("%d%d", &a[i], &b[i]);
		if(b[i] != 0)
			isG4 = false;
		if(b[i] != a[i])
			isG5 = false;
	}
	
	vector< int > v;
	for(int i = 0;i < x;i++)
		v.push_back(a[i]), v.push_back(b[i]);

	sort(v.begin(), v.end());
	v.resize(unique(v.begin(), v.end()) - v.begin());

	if(isG4){
		vector < long long > g;
		for(int i = 0;i < x;i++)
			g.push_back(a[i]);

		sort(g.begin(), g.end());

		long long ans = 0;
		for(int k = 0;k < g.size();k++)
			ans = max(ans, g[k] * (long long)(g.size() - k));

		cout << ans;
		return 0;
	}

	if(isG5){
		long long ans = 0;
		vector < long long > g;
		for(int i = 0;i < x;i++)
			g.push_back(a[i]);
		sort(g.begin(), g.end());

		for(int i = 0;i < g.size();i++){
			ans = max(ans, getMax() + g[i] * ((long long)g.size() - i));
			append(g[i]);
		}

		cout << ans;

		return 0;
	}

	long long ans = 0;
	for(int i = 0;i < v.size();i++){
		long long A = v[i], cnt = 0;

		vector < long long > g;

		for(int j = 0;j < x;j++){
			if(a[j] >= A)
				cnt++;
			else
				g.push_back(b[j]);
		}

		sort(g.begin(), g.end());

		long long now = 0;
		for(int k = 0;k < g.size();k++)
			now = max(now, g[k] * (long long)(g.size() - k));

		ans = max(ans, now + cnt * A);
	}
	cout << ans;
}