#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <bitset>
#include <queue>
using namespace std;

const int len = 20000;
int n, m, k;

const int bln = 10;

bool operator < (bitset < bln > a, bitset < bln > b){
	for(int i = bln - 1;i >= 0;i--){
		if(a[i] != b[i]){
			return a[i] == 0;
		}
	}
	return false;
}

bitset < bln > operator + (bitset < bln > a, bitset < bln > b){
	bitset < bln > c;
	int carry = 0;
	for(int i = 0;i < bln;i++){
		c[i] = 0;
		carry += a[i];
		carry += b[i];
		c[i] = carry & 1;
		carry >>= 1;
	}
	return c;
}

bitset < bln > d[len];
int p[len];

bool used[len];
int x[len], y[len];

struct myPair{
	bitset < bln > first;
	int second;
};

bool operator < (myPair a, myPair b){
	if((a.first & b.first).count() == a.first.count())
		return a.second < b.second;
	return a.first < b.first;
}

bool lower(bitset < bln > a, bitset < bln > b){
	for(int i = bln - 1;i >= 0;i--){
		if(a[i] != b[i]){
			return a[i] == 0;
		}
	}
	return false;
}
	
int main(){
	cin >> n >> m >> k;
	for(int i = 0;i < k;i++){
		cin >> x[i] >> y[i];
	}

	for(int i = 0;i < k;i++){
		p[i] = -1;
	}
	
	d[0] = 0;
	set < myPair > q;
	q.insert({ 0, 0 });
	p[0] = -2;

	while(!q.empty()){
		//int v = q.top().second;
		//q.pop();

		auto now = q.begin();
		q.erase(now);
		int v = (*now).second;

		if(used[v])
			continue;

		used[v] = true;

		for(int i = 0;i < k;i++){
			if(v == i)
				continue;
			bitset < bln > dist = 0;
			dist[max(abs(x[i] - x[v]), abs(y[i] - y[v]))] = 1;

			if(p[i] == -1 || (p[i] != -1 && lower(d[v] + dist, d[i]))){
				d[i] = d[v] + dist;
				p[i] = v;
				q.insert({ d[i], i });
			}
		}
	}

	vector < int > path;
	int pos = k - 1;
	while(pos != -2){
		path.push_back(pos);
		pos = p[pos];
	}
	reverse(path.begin(), path.end());
	cout << path.size() << endl;
	for(auto el: path)
		cout << el + 1 << ' ';
}