#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <stack>
using namespace std;

const int len = 5e5;
int x, p;
int a[len];
int ans[len];

const int sz = 400;
int b[len];
int s[len];
int t[len];

inline int block(int pos){
	return pos / sz;
}

void build(){
	for(int i = 0;i < x;i++){
		s[i] = a[i] + i;
		t[i] = a[i] + x - i - 1;
	}

	for(int i = 0;i <= block(x - 1);i++){
		sort(s + i * sz, s + min(x, (i + 1) * sz));
		sort(t + i * sz, t + min(x, (i + 1) * sz));
	}
}

int getLowerThanInS(int bl, int from, int to, int val){
	int l = bl * sz;
	int r = min(x - 1, bl * sz + sz - 1);

	if(from <= l && r <= to){
		int tl = l;
		int tr = r + 1;

		while(tr - tl > 1){
			int m = tl + tr >> 1;
			if(s[m] < val)
				tl = m;
			else
				tr = m;
		}
		if(s[tl] < val)
			return tl - l + 1;
		return 0;
	}
	int ans = 0;
	for(int i = max(l, from);i <= min(r, to);i++)
		ans += (a[i] + i) < val;
	return ans;
}

int getLowerThanInS(int from, int to, int val){
	int res = 0;
	for(int i = block(from);i <= block(to);i++)
		res += getLowerThanInS(i, from, to, val);
	return res;
}

int getLowerThanInT(int bl, int from, int to, int val){
	int l = bl * sz;
	int r = min(x - 1, bl * sz + sz - 1);

	if(from <= l && r <= to){
		int tl = l;
		int tr = r + 1;

		while(tr - tl > 1){
			int m = tl + tr >> 1;
			if(t[m] < val)
				tl = m;
			else
				tr = m;
		}
		if(t[tl] < val)
			return tl - l + 1;
		return 0;
	}
	int ans = 0;
	for(int i = max(l, from);i <= min(r, to);i++)
		ans += (a[i] + (x - 1 - i)) < val;
	return ans;
}

int getLowerThanInT(int from, int to, int val){
	int res = 0;
	for(int i = block(from);i <= block(to);i++)
		res += getLowerThanInT(i, from, to, val);
	return res;
}

int main(){
	scanf("%d%d", &x, &p);
	for(int i = 0;i < x;i++)
		scanf("%d", &a[i]);
	
	if(x <= 20 && p == 2){
		if(p == 1)
			for(int i = 0;i < x;i++)
				ans[i] = x + 1;

		vector < int > v(x, 1ll << 20);
		vector < pair < int, int > > f(x);

		for(int m = 1;m < (1 << x);m++){
			for(int i = 0;i < x;i++)
				v[i] = 1 << 20;
			for(int i = 0;i < x;i++){
				if((m & (1 << i)) != 0)
					v[i] = 0;
			}

			for(int i = 1;i < x;i++)
				v[i] = min(v[i], v[i - 1] + 1);
			for(int i = x - 2;i >= 0;i--)
				v[i] = min(v[i], v[i + 1] + 1);

			for(int i = 0;i < x;i++){
				f[i] = { a[i] + v[i], i };
			}
			
			sort(f.begin(), f.end());

			int cnt = 0;
			for(int i = 0;i < x;i++){
				if(i != 0 && f[i - 1].first != f[i].first)
					cnt = i;

				if(p == 1)
					ans[f[i].second] = min(ans[f[i].second], cnt + 1);
				else
					ans[f[i].second] = max(ans[f[i].second], cnt + 1);
			}
		}
	} else {
		build();
		for(int i = 0;i < x;i++)
			ans[i] = x + 1;

		for(int i = 0;i < x;i++){
			ans[i] = 
				getLowerThanInS(i + 1, x - 1, a[i] + i) + 
				getLowerThanInT(0, i, a[i] + (x - 1 - i)) + 1;
			//add(i + 1, x - 1, -1);
			//add(0, i, 1);
		}
	}

	for(int i = 0;i < x;i++)
		printf("%d\n", ans[i]);
}
