#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 100;
const ll INF = (ll) 1e18;

struct Graph {
    int n = MAXN;
    ll g[MAXN][MAXN];

    void add(int v, int u, ll c) {
        g[v][u] = g[u][v] = c;
    }

    ll getDist() {
        vector<ll> d(n, INF);
        int p[n];
        d[n - 1] = 0;
        vector<bool> used(n, false);
        for (int t = 0; t < n; ++t) {
            ll mini = INF;
            ll indMin = -1;
            for (int i = 0; i < n; ++i) {
                if (used[i]) continue;
                if (d[i] < mini) {
                    mini = d[i];
                    indMin = i;
                }
            }
            used[indMin] = true;
            for (int i = 0; i < n; ++i) {
                if (i == indMin) continue;
                if (d[i] > d[indMin] + g[indMin][i]) {
                    d[i] = d[indMin] + g[indMin][i];
                    p[i] = indMin;
                }
            }
        }
        vector<int> ans;
        int now = 0;
        while (now != n - 1) {
            ans.push_back(now + 1);
            now = p[now];
        }
        ans.push_back(now + 1);
        cout << ans.size() << "\n";
        for (auto x : ans) {
            cout << x << " ";
        }
        cout << "\n";
    }

    void print() {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                cout << g[i][j] << " ";
            }
            cout << "\n";
        }
    }

    Graph(int n): n(n) { }
};

int main() {
//    freopen("in.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n, m, k;
    cin >> n >> m >> k;
    Graph g(k);
    vector<pair<int, int>> ps;
    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> x >> y;
        for (int j = 0; j < ps.size(); ++j) {
            auto p = ps[j];
            g.add(i, j, (1LL << max(abs(x - p.first), abs(y - p.second))));
        }
        ps.push_back({x, y});
    }
    g.getDist();
//    g.print();
    return 0;
}
