#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 600;
const ll INF = (ll) 1e18;

struct Num {
    int num[MAXN];

    void add(const Num &a) {
        int buf = 0;
        for (int i = 0; i < MAXN; ++i) {
            num[i] = num[i] + a.num[i] + buf;
            buf = num[i] / 2;
            num[i] %= 2;
        }
    }

    bool b(const Num &a) {
        for (int i = MAXN - 1; i >= 0; --i) {
            if (num[i] > a.num[i]) return true;
            if (a.num[i] > num[i]) return false;
        }
        return false;
    }

    void set(int i) {
        num[i] = 1;
    }

    Num() {
        fill_n(num, MAXN, 0);
    }
};

struct Graph {
    int n = MAXN;
    int g[MAXN][MAXN];

    void add(int v, int u, ll c) {
        g[v][u] = g[u][v] = c;
    }

    ll getDist() {
        vector<Num> d(n);
        for (int i = 0; i < n - 1; ++i) {
            d[i].set(MAXN - 1);
        }
        int p[n];
        vector<bool> used(n, false);
        for (int t = 0; t < n; ++t) {
            Num mini;
            mini.set(MAXN - 1);
            ll indMin = -1;
            for (int i = 0; i < n; ++i) {
                if (used[i]) continue;
                if (mini.b(d[i])) {
                    mini = d[i];
                    indMin = i;
                }
            }
            used[indMin] = true;
            for (int i = 0; i < n; ++i) {
                if (i == indMin) continue;
                Num here = d[indMin];
                Num edge;
                edge.set(g[indMin][i]);
                here.add(edge);
                if (d[i].b(here)) {
                    d[i] = here;
                    p[i] = indMin;
                }
            }
        }
        vector<int> ans;
        int now = 0;
        while (now != n - 1) {
            ans.push_back(now + 1);
            now = p[now];
        }
        ans.push_back(now + 1);
        cout << ans.size() << "\n";
        for (auto x : ans) {
            cout << x << " ";
        }
        cout << "\n";
    }

//    void print() {
//        for (int i = 0; i < n; ++i) {
//            for (int j = 0; j < n; ++j) {
//                cout << g[i][j] << " ";
//            }
//            cout << "\n";
//        }
//    }

    Graph(int n): n(n) { }
};

int main() {
//    freopen("in.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n, m, k;
    cin >> n >> m >> k;
    Graph g(k);
    vector<pair<int, int>> ps;
    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> x >> y;
        for (int j = 0; j < ps.size(); ++j) {
            auto p = ps[j];
            g.add(i, j, max(abs(x - p.first), abs(y - p.second)));
        }
        ps.push_back({x, y});
    }
    g.getDist();
//    g.print();
    return 0;
}
