#include <bits/stdc++.h>

using namespace std;

const int MAXN = (int) 3e5;
const int INF = (int) 1e9;

struct TreeMin {
    int n;
    int t[2 * MAXN];

    TreeMin(int n): n(n) {
        fill_n(t, 2 * n, INF);
    }

    int get(int l, int r) {
        int res = INF;
        for (l += n, r += n; l <= r; l /= 2, r /= 2) {
            if (l % 2 == 1) res = min(res, t[l++]);
            if (r % 2 == 0) res = min(res, t[r--]);
        }
        return res;
    }

    void upd(int v, int d) {
        v += n, t[v] = d, v /= 2;
        for (; v; v /= 2) t[v] = min(t[2 * v], t[2 * v + 1]);
    }
};

struct TreeMax {
    int n;
    int t[2 * MAXN];

    TreeMax(int n): n(n) {
        fill_n(t, 2 * n, 0);
    }

    int get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l <= r; l /= 2, r /= 2) {
            if (l % 2 == 1) res = max(res, t[l++]);
            if (r % 2 == 0) res = max(res, t[r--]);
        }
        return res;
    }

    void upd(int v, int d) {
        v += n, t[v] = d, v /= 2;
        for (; v; v /= 2) t[v] = max(t[2 * v], t[2 * v + 1]);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n;
    cin >> n;
    vector<int> a(n);
    TreeMin t1(n);
    TreeMax t2(n);
    int now = 0;
    for (auto &x : a) {
        cin >> x;
        t1.upd(now, x);
        t2.upd(now, x);
        ++now;
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        ++cnt;
        int l = i, r = n;
        while (l < r - 1) {
            int m = (l + r) / 2;
//            cout << m << " " << t1.get(i, m) << "\n";
            if (t1.get(i, m) == a[i]) {
                l = m;
            } else {
                r = m;
            }
        }
//        cout << i << " " << l << "!!\n";
        int mx = t2.get(i, l);
        int j;
        for (j = i; j <= l; ++j) {
            if (a[j] == mx) {
                if (t2.get(j + 1, l) != mx) {
                    break;
                }
            }
        }
//        cout << i << " " << j << "\n";
        i = j;
    }
    cout << cnt << "\n";
    return 0;
}
/*
6
2 3 1 1 5 1
*/
