import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class A {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	public void run() {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		solve();
		out.close();
	}
	
	public String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	public long nextLong() {
		return Long.parseLong(nextToken());
	}
	
	public class Point implements Comparable<Point> {
		int x;
		int y;
		int c;
		
		public Point(int x, int y, int c) {
			this.x = x;
			this.y = y;
			this.c = c;
		}

		@Override
		public int compareTo(Point arg0) {
			return c - arg0.c;
		}
		
	}
	
	public void solve() {
		int n = nextInt();
		int m = nextInt();
		int q = nextInt();
		Point[][] a = new Point[n][m];
		for (int i = 0; i < a.length; i++) {
			for (int j = 0; j < a[0].length; j++) {
				a[i][j] = new Point(i, j, nextInt());
			}
		}
		Point[] maxx = new Point[n];
		Point[] maxy = new Point[m];
		for (int i = 0; i < maxx.length; i++) {
			maxx[i] = a[i][0];
			for (int j = 1; j < maxy.length; j++) {
				if (a[i][j].compareTo(maxx[i]) > 0) {
					maxx[i] = a[i][j];
				}
			}
		}
		for (int i = 0; i < maxy.length; i++) {
			maxy[i] = a[0][i];
			for (int j = 1; j < maxx.length; j++) {
				if (a[j][i].compareTo(maxy[i]) > 0) {
					maxy[i] = a[j][i];
				}
			}
		}
		TreeSet<Point> good = new TreeSet<>();
		for (int i = 0; i < maxx.length; i++) {
			if (maxx[i].compareTo(maxy[maxx[i].y]) == 0) {
				good.add(maxx[i]);
			}
		}
		for (int i = 0; i < q; i++) {
			int x = nextInt() - 1;
			int y = nextInt() - 1;
			int c = nextInt();
			Point p = new Point(x, y, c);
			if (p.compareTo(maxx[x]) > 0) {
				good.remove(maxx[x]);
				maxx[x] = p;
			}
			if (p.compareTo(maxy[y]) > 0) {
				good.remove(maxy[y]);
				maxy[y] = p;
			}
			if (p.compareTo(maxx[x]) == 0 && p.compareTo(maxy[y]) == 0) {
				good.add(p);
			}
			out.println(good.size());
		}
	}

	public static void main(String[] args) {
		new A().run();
	}

}
