import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class C {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	public void run() {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		solve();
		out.close();
	}
	
	public String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	public long nextLong() {
		return Long.parseLong(nextToken());
	}
	
	public class Pair implements Comparable<Pair> {
		long a;
		long b;
		
		public Pair(long a, long b) {
			this.a = a;
			this.b = b;
		}

		@Override
		public int compareTo(Pair o) {
			if (a > o.a) {
				return 1;
			}
			if (a < o.a) {
				return -1;
			}
			if (b > o.b) {
				return 1;
			}
			if (b < o.b) {
				return -1;
			}
			return 0;
		}
		
	}
	
	public void solve() {
		int n = nextInt();
		Pair[] p = new Pair[n];
		for (int i = 0; i < p.length; i++) {
			p[i] = new Pair(nextLong(), nextLong());
		}
		Arrays.sort(p);
		long ans = 0;
		for (int i = 0; i < p.length; i++) {
			long max = 0;
			long[] b = new long[i];
			for (int j = 0; j < i; j++) {
				b[j] = p[j].b;
			}
			Arrays.sort(b);
			for (int j = 0; j < i; j++) {
				max = Math.max(max, b[j] * (i - j));
			}
			ans = Math.max(ans, p[i].a * (n - i) + max);
		}
		out.println(ans);
	}

	public static void main(String[] args) {
		new C().run();
	}

}
