import java.io.*;
import java.util.*;
import java.math.*;

public class A {
	
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	PrintWriter out = new PrintWriter(System.out);
	StringTokenizer st;
	
	public String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	public long nextLong() {
		return Long.parseLong(nextToken());
	}
	
	public void run() {
		solve();
		out.close();
	}
	
	public class Pair {
		int l;
		int r;
		
		public Pair(int l, int r) {
			this.l = l;
			this.r = r;
		}
	}
	
	public void solve() {
		int n = nextInt();
		int[] a = new int[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = nextInt();
		}
		Stack<Pair> stack = new Stack<>();
		stack.add(new Pair(a[0], a[0]));
		for (int i = 1; i < n; i++) {
			Pair p = new Pair(a[i], a[i]);
			while (!stack.isEmpty()) {
				Pair p1 = stack.peek();
				if (p1.l <= p.l && p1.r <= p.r) {
					p = new Pair(p1.l, p.r);
					stack.pop();
				} else {
					break;
				}
			}
			stack.add(p);
		}
		out.println(stack.size());
	}

	public static void main(String[] args) {
		new A().run();
	}

}
