import java.io.*;
import java.util.*;
import java.math.*;

public class C {
	
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	PrintWriter out = new PrintWriter(System.out);
	StringTokenizer st;
	
	public String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	public long nextLong() {
		return Long.parseLong(nextToken());
	}
	
	public void run() {
		solve();
		out.close();
	}
	
	public class Pair implements Comparable<Pair> {
		int time;
		int n;

		public Pair(int time, int n) {
			this.time = time;
			this.n = n;
		}
		
		public Pair clone() {
			return new Pair(time, n);
		}

		@Override
		public int compareTo(Pair o) {
			return time - o.time;
		}
	}
	
	
	
	public void solve() {
		int n = nextInt();
		nextInt();
		Pair[] a = new Pair[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = new Pair(nextInt(), i);
		}
		int[] ans1 = new int[n];
		Pair[] b = new Pair[n];
		for (int i = 0; i < b.length; i++) {
			b[i] = a[i].clone();
		}
		Arrays.sort(b);
		ans1[b[0].n] = 0;
		for (int i = 1; i < b.length; i++) {
			if (b[i].time == b[i - 1].time) {
				ans1[b[i].n] = ans1[b[i - 1].n];
			} else {
				ans1[b[i].n] = i;
			}
		}
		for (int i = 0; i < b.length; i++) {
			b[i] = a[i].clone();
		}
		for (int i = 0; i < b.length; i++) {
			b[i].time += i;
		}
		int[] ans2 = new int[n];
		Arrays.sort(b);
		ans2[b[0].n] = 0;
		for (int i = 1; i < b.length; i++) {
			if (b[i].time == b[i - 1].time) {
				ans2[b[i].n] = ans2[b[i - 1].n];
			} else {
				ans2[b[i].n] = i;
			}
		}
		for (int i = 0; i < b.length; i++) {
			b[i] = a[i].clone();
		}
		for (int i = 0; i < b.length; i++) {
			b[i].time += n - i - 1;
		}
		int[] ans3 = new int[n];
		Arrays.sort(b);
		ans3[b[0].n] = 0;
		for (int i = 1; i < b.length; i++) {
			if (b[i].time == b[i - 1].time) {
				ans3[b[i].n] = ans3[b[i - 1].n];
			} else {
				ans3[b[i].n] = i;
			}
		}
		for (int i = 0; i < b.length; i++) {
			b[i] = a[i].clone();
		}
		for (int i = 0; i < b.length; i++) {
			b[i].time += Math.min(i, n - i - 1);
		}
		int[] ans4 = new int[n];
		Arrays.sort(b);
		ans4[b[0].n] = 0;
		for (int i = 1; i < b.length; i++) {
			if (b[i].time == b[i - 1].time) {
				ans4[b[i].n] = ans4[b[i - 1].n];
			} else {
				ans4[b[i].n] = i;
			}
		}
		for (int i = 0; i < ans4.length; i++) {
//			System.out.println(ans1[i] + " " + ans2[i] + " " + ans3[i] + " " + ans4[i]);
			out.println(Math.max(Math.max(ans1[i], ans2[i]), Math.max(ans3[i], ans4[i])) + 1);
		}
	}

	public static void main(String[] args) {
		new C().run();
	}

}
