import java.io.*;
import java.util.*;
import java.math.*;

public class C2 {
	
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	PrintWriter out = new PrintWriter(System.out);
	StringTokenizer st;
	
	public String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	public long nextLong() {
		return Long.parseLong(nextToken());
	}
	
	public void run() {
		solve();
		out.close();
	}
	
	public class Pair implements Comparable<Pair> {
		int time;
		int n;

		public Pair(int time, int n) {
			this.time = time;
			this.n = n;
		}
		
		public Pair clone() {
			return new Pair(time, n);
		}

		@Override
		public int compareTo(Pair o) {
			return time - o.time;
		}
	}
	
	
	
	public void solve() {
		int n = nextInt();
		nextInt();
		int[] time = new int[n];
		for (int i = 0; i < time.length; i++) {
			time[i] = nextInt();
		}
		int[] ans = new int[n];
		for (int q = 0; q < n; q++) {
			int max = Math.max(q, n - 1 - q);
			for (int w = 1; w <= max; w++) {
				int left = q - w;
				int right = q + w;
				int th = 0;
				for (int i = 0; i <= left; i++) {
					if (time[q] + w > time[i]) {
						th++;
					}
				}
				for (int i = right; i < n; i++) {
					if (time[q] + w > time[i]) {
						th++;
					}
				}
				if (left >= 0) {
					for (int i = left + 1; i < q; i++) {
						if (time[q] + q - i > time[i]) {
							th++;
						}
					}
				} else {
					for (int i = 0; i < q; i++) {
						if (time[q] - q + i > time[i]) {
							th++;
						}
					}
				}
				if (right < n) {
					for (int i = q + 1; i < right; i++) {
						if (time[q] + i - q > time[i]) {
							th++;
						}
					}
				} else {
					for (int i = q + 1; i < n; i++) {
						if (time[q] - i + q > time[i]) {
							th++;
						}
					}
				}
				ans[q] = Math.max(ans[q], th);
//				System.out.println(q + " " + left + " " + right + " " + th);
			}
		}
		for (int i = 0; i < ans.length; i++) {
			out.println(ans[i] + 1);
		}
	}

	public static void main(String[] args) {
		new C2().run();
	}

}
