import java.io.*;
import java.util.*;
import java.math.*;

public class D {
	
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	PrintWriter out = new PrintWriter(System.out);
	StringTokenizer st;
	
	public String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	public long nextLong() {
		return Long.parseLong(nextToken());
	}
	
	public void run() {
		solve();
		out.close();
	}
	
	public class Pair {
		int l;
		int r;
		
		public Pair(int l, int r) {
			this.l = l;
			this.r = r;
		}
	}
	
	public class Number implements Comparable<Number> {
		int n;
		ArrayList<Integer> list = new ArrayList<>();
		
		public Number(int n, ArrayList<Integer> list) {
			this.n = n;
			this.list = list;
		}

		public Number(int n, String s) {
			this.n = n;
			for (int i = s.length() - 1; i >= 0; i--) {
				if (s.charAt(i) == '1') {
					list.add(s.length() - i - 1);
				}
			}
		}
		
		public Number clone() {
			return new Number(n, (ArrayList<Integer>) list.clone());
		}

		@Override
		public int compareTo(Number o) {
			for (int i = 1; i <= Math.min(list.size(), o.list.size()); i++) {
				if (list.get(list.size() - i) != o.list.get(o.list.size() - i)) {
					return list.get(list.size() - i) - o.list.get(o.list.size() - i);
				}
			}
			if (list.size() != o.list.size()) {
				return list.size() - o.list.size();
			}
			return n - o.n;
		}
	}
	
	public boolean check() {
//		if (m == 5) {
//		System.out.println(m);
//			for (int i : th) {
//				System.out.print(i + " ");
//			}
//			System.out.println();
//			for (Number n : a) {
//				for (int i : n.list) {
//					System.out.print(i + " ");
//				}
//				System.out.println();
//			}
//			System.out.println();
//		}
		if (a.isEmpty()) {
			return true;
		}
		if (th.isEmpty()) {
			return false;
		}
		Number n = a.pollLast();
		if (th.peek() < n.list.get(n.list.size() - 1)) {
			return false;
		}
		if (th.peek() > n.list.get(n.list.size() - 1)) {
			th.pop();
			return check();
		}
		th.pop();
		if (n.list.size() > 1) {
			n.list.remove(n.list.size() - 1);
			a.add(n);
		}
		return check();
	}
	
	TreeSet<Number> set;
	TreeSet<Number> a;
	Stack<Integer> th;
	int m;
	
	public void solve() {
		int n = nextInt();
		set = new TreeSet<>();
		a = new TreeSet<>();
		int maxLen = 0;
		for (int i = 0; i < n; i++) {
			String s = nextToken();
			Number number = new Number(i, s);
//			System.out.println(number.n);
			maxLen = Math.max(maxLen, s.length());
//			if (i > 0) {
//				System.out.println(set.first().compareTo(number));
//				for (Number nu : set) {
//					System.out.println(nu.n);
//					for (int j : nu.list) {
//						System.out.println(j);
//					}
//				}
//				System.out.println();
//				System.out.println();
//				System.out.println(number.n);
//				for (int j : number.list) {
//					System.out.println(j);
//				}
//				System.out.println();
//			}
			set.add(number);
		}
		int l = maxLen - 1;
		int r = n + maxLen + 10;
		while (l + 1 < r) {
			m = (l + r) / 2;
			th = new Stack<>();
			for (int i = 0; i < m; i++) {
				th.add(i);
			}
			a = new TreeSet<>();
			for (Number number : set) {
				a.add(number.clone());
			}
			if (check()) {
				r = m;
			} else {
				l = m;
			}
		}
		Stack<Integer> th1 = new Stack<>();
		for (int i = 0; i < r; i++) {
			th1.add(i);
		}
		for (int i = r - 1; i >= 0; i--) {
			th = (Stack<Integer>) th1.clone();
			th.remove(i);
			a = new TreeSet<>();
			for (Number number : set) {
				a.add(number.clone());
			}
			if (check()) {
				th1.remove(i);
			}
		}
		boolean[] b = new boolean[th1.get(th1.size() - 1) + 1];
        for (int i : th1) {
            b[b.length - i - 1] = true;
        }
        for (int i = 0; i < b.length; i++) {
            out.print(b[i] ? 1 : 0);
        }
	}

	public static void main(String[] args) {
		new D().run();
	}

}
