#include <bits/stdc++.h>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define REP(i, st, n) for (int i = (st); i < (n); ++i)

typedef long long ll;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

const int N = 503;
int n, tmp;
int d[N][N];
int ord[N][N];
int a[N];
bool empt[N];
int cnt[N];
bool good[N];

void dfs() {
    bool fl = false; // made edge
    for (int i = 0; i < n; ++i) { // cell
        int old = a[i];
        for (int j = a[i] - 1; j >= 0; --j) {
            if (cnt[d[i][j]] > 0) {
                fl = true;

                a[i] = j;
                cnt[d[i][old]]--;
                cnt[d[i][j]]++;

                dfs();

                a[i] = old;
                cnt[d[i][j]]--;
                cnt[d[i][old]]++;
            }
        }
    }
    if (!fl) {
        for (int i = 0; i < n; ++i) { // virus
            if (cnt[i] > 0) {
                good[i] = true;
            }
        }
    }
}

bool goodold(int i) {
    for (int j = 0; j < n; ++j) { // cell
        if (d[j][0] == i) return true;
    }
    return false;
}

vector <int> ans, ans_stupid;

void solve_stupid() {
    fill(cnt, cnt + n + 2, 1);
    fill(good, good + n + 2, false);
    dfs();
    for (int i = 0; i < n; ++i) {
        if (good[i]) {
            ans_stupid.pb(i + 1);
        }
    }
}

void solve() {
    for (int i = 0; i < n; ++i) { // virus
        bool fl = false;
        for (int j = 0; j < n; ++j) { // to-cell
            if (ord[j][i] > ord[j][j]) continue;
            bool g1 = true;
            for (int w = ord[j][i] - 1; w >= 0; --w) {
                empt[d[j][w]] = 1;
            }

            for (int k = 0; k < n; ++k) { // cell
                if (k == j || k == i) continue;
                /*if (!empt[k]) continue;
                if (empt[d[k][0]]) g1 = false;*/
                bool fl = false;
                for (int h = ord[k][k]; h >= 0; --h) {
                    fl |= !empt[d[k][h]];
                }
                g1 &= fl;
            }

            for (int w = ord[j][i]; w >= 0; --w) {
                empt[d[j][w]] = 0;
            }
            fl |= g1;
        }
        if (fl || goodold(i)) ans.pb(i + 1);
    }
}

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> d[i][j];
            d[i][j]--;
            ord[i][d[i][j]] = j;
            if (d[i][j] == i)
                a[i] = j;
        }
    }
    cin >> tmp;
}

void stress() {
    srand(time(NULL));
    REP(itr, 0, 1130) {
        ans.clear();
        ans_stupid.clear();
        n = rand() % 5 + 1;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                d[i][j] = j;
            }
            random_shuffle(d[i], d[i] + n);
            for (int j = 0; j < n; ++j) {
                ord[i][d[i][j]] = j;
                if (d[i][j] == i)
                    a[i] = j;
            }
        }
        fill(empt, empt + n, false);

        //return 0;

        solve();
        solve_stupid();
        if (ans != ans_stupid) {
            cout << n << '\n';
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    cout << d[i][j] + 1 << ' ';
                }
                cout << endl;
            }
            cout << 2 << endl;
            cout << endl;
            for (auto el : ans) cout << el << ' '; cout << endl;
            for (auto el : ans_stupid) cout << el << ' '; cout << endl;
            break;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG
    freopen("B.in", "r", stdin);
#endif // DEBUG

    //stress();
    //return 0;

    read();
    for (int i = 0; i < n; ++i) {
        if (d[i][0] == i) {
            ans.pb(i + 1);
        }
    }
    if (tmp != 1) {
        ans.clear();
        // 2

        solve();
    }
    cout << (int)ans.size() << '\n';
    sort(all(ans));
    for (auto el : ans)
        cout << el << ' ';
    cout << '\n';
    /*cout << "STUPID\n";
    solve_stupid();
    for (auto el : ans_stupid)
        cout << el << ' ';
    cout << endl;*/


    return 0;
}
