#include <bits/stdc++.h>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define REP(i, st, n) for (int i = (st); i < (n); ++i)

typedef long long ll;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

struct node {
    ll x, sz;
    int y;
    node *l, *r;
    node() {}
    node(ll x1) : x(x1), sz(1) {
        y = RAND_MAX * rand() + rand();
        l = r = nullptr;
    }
};

ll tsz(node *t) {
    return (t != nullptr ? t->sz : 0LL);
}

void upd(node *&t) {
    if (t != nullptr) {
        t->sz = 1 + tsz(t->l) + tsz(t->r);
    }
}

node *merge(node *p, node *q) {
    if (p == nullptr) return q;
    if (q == nullptr) return p;
    if (p->y > q->y) {
        p->r = merge(p->r, q);
        upd(p);
        return p;
    }
    else {
        q->l = merge(p, q->l);
        upd(q);
        return q;
    }
}

pair <node*, node*> split(node *t, ll x) {
    if (t == nullptr) return {t, t};
    if (t->x < x) {
        auto p = split(t->r, x);
        t->r = p.f;
        upd(t);
        return {t, p.s};
    }
    else {
        auto p = split(t->l, x);
        t->l = p.s;
        upd(t);
        return {p.f, t};
    }
}

void add(node *&t, ll x) {
    auto p = split(t, x);
    t = merge(p.f, merge(new node(x), p.s));
}

const int N = 150005;
int n;
ll a[N], b[N];
ll id[N];

int cur;
node *T;

ll calc(ll A, ll B) {
    ll cost = 0;
    int vl = -1, vr = n;
    while (vr - vl > 1) {
        int vm = (vl + vr) >> 1;
        if (a[id[vm]] >= A) {
            vr = vm;
        }
        else {
            vl = vm;
        }
    }
    cost += (ll)(n - vr) * A;

    while (cur < vr - 1) {
        ++cur;
        add(T, b[id[cur]]);
    }
    auto p = split(T, B);
    cost += tsz(p.second) * B;
    T = merge(p.f, p.s);


    return cost;
}

ll check(ll A, ll B) {
    return calc(A, B + 1) - calc(A, B);
}

bool cmp(int i, int j) {
    return a[i] < a[j];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG
    freopen("C.in", "r", stdin);
#endif // DEBUG

    cur = -1;
    T = nullptr;

    cin >> n;
    set <ll> x, xb;
    bool bad = false;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        x.insert(a[i]);
//        x.insert(a[i] + 1);
        xb.insert(b[i]);
//        x.insert(b[i] + 1);
        if (a[i] != b[i] && b[i] > 0)
            bad = true;
    }
    for (int i = 0; i < n; ++i)
        id[i] = i;
    sort(id, id + n, cmp);

    ll ans = 0;
    for (ll A : x) {
        //cout << A << ": ";
        if (1) {
            for (ll B : xb) {
                if (B > A) break;
                chkmax(ans, calc(A, B));
                //cout << check(A, B) << ' ';
            }
            //cout << endl;
        }
        else {
            chkmax(ans, calc(A, 0));
        }
        /*ll bl = -1, br = A;
        while (br - bl > 1) {
            ll B = (bl + br) >> 1;
            if (check(A, B))
                bl = B;
            else
                br = B;
        }
        if (A == 70) {
            cout << bl + 1 << "KEKEKEKE\n";
        }
        chkmax(ans, calc(A, bl + 1));*/
    }
    cout << ans << '\n';

    return 0;
}
