#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define REP(i, st, n) for (int i = (st); i < (n); ++i)

typedef long long ll;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

const int INF = 2e9;
const int N = 300005;
int n;
int a[N];
int dp[N];
int le[N], ri[N];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
}

void solve_stupid() {
    for (int i = 0; i < n; ++i) {
        dp[i] = (i ? dp[i - 1] + 1 : 1);
        int minv = a[i];
        for (int k = i - 1; k >= 0; --k) {
            if (a[k] > a[i]) break;
            chkmin(minv, a[k]);
            if (a[k] == minv) {
                chkmin(dp[i], (k ? dp[k - 1] + 1 : 1));
            }
        }
    }
}

void prec() {
    // le
    stack <int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.top()] <= a[i])
            st.pop();
        le[i] = (st.empty() ? 0 : st.top() + 1);
        st.push(i);
    }
    st = stack <int> ();
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && a[st.top()] >= a[i])
            st.pop();
        ri[i] = (st.empty() ? n - 1 : st.top() - 1);
        st.push(i);
    }
}

    struct node {
        int x, y, v;
        int mnv;
        node *l, *r;
        node() {}
        node(int x1, int v1): x(x1), v(v1) {
            y = RAND_MAX * rand() + rand();
            mnv = v;
            l = r = nullptr;
        }
    };

    inline int gmin(node *t) {
        if (t == nullptr)
            return INF;
        return t->mnv;
    }

    inline void upd(node *&t) {
        if (t != nullptr) {
            t->mnv = t->v;
            if (t->l != nullptr && t->mnv > t->l->mnv) {
                t->mnv = t->l->mnv;
            }
            if (t->r != nullptr && t->mnv > t->r->mnv) {
                t->mnv = t->r->mnv;
            }
        }
    }

    node *merge(node *t1, node *t2) {
        if (t1 == nullptr) return t2;
        if (t2 == nullptr) return t1;
        if (t1->y > t2->y) {
            t1->r = merge(t1->r, t2);
            upd(t1);
            return t1;
        }
        else {
            t2->l = merge(t1, t2->l);
            upd(t2);
            return t2;
        }
    }

    pair <node*,node*> split(node *t, int x) {
        if (t == nullptr) return {t, t};
        if (t->x < x) {
            auto p = split(t->r, x);
            t->r = p.f;
            upd(t);
            return {t, p.s};
        }
        else {
            auto p = split(t->l, x);
            t->l = p.s;
            upd(t);
            return {p.f, t};
        }
    }

    inline void addt(node *&t, int x, int v) {
        auto p = split(t, x);
        t = merge(p.f, merge(new node(x, v), p.s));
    }

    inline int gett(node *&t, int x) {
        auto p = split(t, x);
        int res = gmin(p.s);
        t = p.s;
        return res;
    }

node* t[4 * N];

void init(int v, int vl, int vr) {
    t[v] = nullptr;
    if (vl == vr) return;
    int vm = (vl +vr) >> 1;
    init(v + v, vl, vm);
    init(v + v + 1, vm + 1, vr);
}

void add(int v, int vl, int vr, int pos, int val) {
    addt(t[v], ri[pos], val);
    if (vl == vr) {
        return;
    }
    int vm = (vl +vr) >> 1;
    if (pos <= vm)
        add(v + v, vl, vm, pos, val);
    else
        add(v + v + 1, vm + 1, vr, pos, val);
}

int get(int v, int vl, int vr, int l, int r, int x) {
    if (l > r) return INF;
    if (vl == l && vr == r) {
        return gett(t[v], x);
    }
    int vm = (vl + vr) >> 1;
    if (r <= vm)
        return get(v + v, vl, vm, l, r, x);
    if (l >= vm + 1)
        return get(v + v + 1, vm + 1, vr, l, r, x);
    return min(
        get(v + v, vl, vm, l, min(vm, r), x),
        get(v + v + 1, vm + 1, vr , max(vm + 1, l), r, x)
    );
}

void solve() {
    prec();
    init(1, 0, n - 1);
    dp[0] = 0;
    dp[1] = 1;
    if (ri[0] > 0) add(1, 0, n - 1, 0, dp[0]);
    for (int i = 1; i < n; ++i) {
        int k = i + 1;
        dp[k] = get(1, 0, n - 1, le[i], i, i) + 1;
        chkmin(dp[k], dp[i] + 1);
        if (ri[i] > i) add(1, 0, n - 1, i, dp[i]);
    }
}

int main() {
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG
    freopen("A.in", "r", stdin);
#endif // DEBUG

    read();
    //solve_stupid();
    //cout << dp[n - 1] << '\n';

    solve();
    cout << dp[n] << '\n';


    return 0;
}
