#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define REP(i, st, n) for (int i = (st); i < (n); ++i)

typedef long long ll;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

const int INF = 2e9;
const int N = 300005;
int n;
int a[N];
int dp[N];
int le[N], ri[N];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
}

void solve_stupid() {
    for (int i = 0; i < n; ++i) {
        dp[i] = (i ? dp[i - 1] + 1 : 1);
        int minv = a[i];
        for (int k = i - 1; k >= 0; --k) {
            if (a[k] > a[i]) break;
            chkmin(minv, a[k]);
            if (a[k] == minv) {
                chkmin(dp[i], (k ? dp[k - 1] + 1 : 1));
            }
        }
    }
}

void prec() {
    // le
    stack <int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.top()] <= a[i])
            st.pop();
        le[i] = (st.empty() ? 0 : st.top() + 1);
        st.push(i);
    }
    st = stack <int> ();
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && a[st.top()] >= a[i])
            st.pop();
        ri[i] = (st.empty() ? n - 1 : st.top() - 1);
        st.push(i);
    }
}

    struct node {
        int x, y, v;
        int mnv;
        node *l, *r;
        node() {}
        node(int x1, int v1): x(x1), v(v1) {
            y = RAND_MAX * rand() + rand();
            mnv = v;
            l = r = nullptr;
        }
    };

    inline int gmin(node *t) {
        if (t == nullptr)
            return INF;
        return t->mnv;
    }

    inline void upd(node *&t) {
        if (t != nullptr) {
            t->mnv = t->v;
            if (t->l != nullptr && t->mnv > t->l->mnv) {
                t->mnv = t->l->mnv;
            }
            if (t->r != nullptr && t->mnv > t->r->mnv) {
                t->mnv = t->r->mnv;
            }
        }
    }

    node *merge(node *t1, node *t2) {
        if (t1 == nullptr) return t2;
        if (t2 == nullptr) return t1;
        if (rand() & 1) {
            t1->r = merge(t1->r, t2);
            upd(t1);
            return t1;
        }
        else {
            t2->l = merge(t1, t2->l);
            upd(t2);
            return t2;
        }
    }

    pair <node*,node*> split(node *t, int x) {
        if (t == nullptr) return {t, t};
        if (t->x < x) {
            auto p = split(t->r, x);
            t->r = p.f;
            upd(t);
            return {t, p.s};
        }
        else {
            auto p = split(t->l, x);
            t->l = p.s;
            upd(t);
            return {p.f, t};
        }
    }

    inline void add(node *&t, int x, int v) {
        auto p = split(t, x);
        t = merge(p.f, merge(new node(x, v), p.s));
    }

    void remove(node *&t, int x) {
        if (t == nullptr) return;
        if (t->x == x) {
            t = merge(t->l, t->r);
            return;
        }
        remove((t->x < x ? t->r : t->l), x);
        upd(t);
    }

vector <int> de[N];

void solve() {
    prec();
    dp[0] = 0;

    for (int i = 0; i < n; ++i)
        de[ri[i]].pb(i);

    node *t = nullptr;
    for (int i = 0; i < n; ++i) {
        int k = i + 1;
        dp[k] = dp[k - 1] + 1;
        chkmin(dp[k], gmin(t) + 1);

        add(t, i, dp[i]);
        for (auto j : de[i])
            remove(t, j);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG
    freopen("A.in", "r", stdin);
#endif // DEBUG

    read();
    //solve_stupid();
    //cout << dp[n - 1] << '\n';

    solve();
    cout << dp[n] << '\n';


    return 0;
}
