import java.awt.image.ImagingOpException;
import java.io.*;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    public class pair implements Comparable<pair> {
        int f, s;

        pair(int a, int b) {
            f = a;
            s = b;
        }

        public int compareTo(pair p) {
            if (f == p.f) return s - p.s;
            return f - p.f;
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        long max = 0;
        pair[] a = new pair[n];
        for (int i = 0; i < n; i++) {
            a[i] = new pair(nextInt(), nextInt());
        }
        Arrays.sort(a);
        pair[] b = new pair[n];
        for (int i = 0; i < n; i++) {
            b[i] = new pair(a[i].s, i);
        }
        Arrays.sort(b);
        int[] w = new int[n];
        for (int i = 0; i < n; i++) {
            w[b[i].s] = i;
        }
        int x = 0;
        long res2 = 0;
        for (int i = 0; i < n; i++) {
            long res1 = (long) a[i].f * (n - i);
            max = Math.max(res1 + res2,max);
            while (i > x && (long)a[i - x].s * (x + 1) > (long)a[i - x + 1].s * x){
                x++;
            }
            while (x > 0 && (long)a[i - x + 2].s * (x - 1) > (long)a[i - x + 1].s * x){
                x--;
            }
            res2 = (long)a[i - x + 1].s * x;
        }
        max = Math.max(max,res2);
        out.print(max);
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}