#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <stdio.h>

using namespace std;

typedef long long ll;
typedef long double dbl;

template<class T>
void prll(vector<T> s){
    for (ll i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;
}

const ll MAX = 700;
 ll s[MAX][MAX];
ll cnt[MAX][MAX];

inline ll get(ll x1, ll y1, ll x2, ll y2){
    if (x1 > x2)
        swap(x1, x2);
    if (y1 > y2)
        swap(y1, y2);
    return s[x2 + 1][y2 + 1] + s[x1][y1] - s[x2 + 1][y1] - s[x1][y2 + 1];
}


bool check(ll x1, ll y1, ll x2, ll y2){
    if (y1 <= y2){
        if (x2 - x1 == y2 - y1)
            return get(x1, y1, x2 - 1, y2 - 1) == 1;
        if (y2 - y1 > x2 - x1)
            return get(x1, y1, x2, y2 - 1) == 1;
        else
            return get(x1, y1, x2 - 1, y2) == 1;
    }
    else{
        if (x2 - x1 == y1 - y2)
            return get(x1, y1, x2 + 1, y2 - 1) == 1;
        if (y2 - y1 > x2 - x1)
            return get(x1, y1, x2, y2 - 1) == 1;
        else
            return get(x1, y1, x2 + 1, y2) == 1;
    }
}

vector<pair<ll, ll> > g[MAX];
ll dist[MAX][MAX];
ll parent[MAX];
ll color[MAX];

bool more(ll a, ll b){
    ll cur = MAX - 1;
    while (cur >= 0 && dist[a][cur] == dist[b][cur])
        cur--;
    return cur > -1 && dist[a][cur] >= dist[b][cur];
}

ll kek[MAX];

void dijkstra(ll st, ll n){
    for (ll i = 0; i < n; i++)
        dist[i][MAX - 100] = 1;
    dist[st][MAX - 100] = 0;
    parent[st] = -1;

    for (ll i = 0; i < n; i++){
        ll x = -1;
        for (ll j = 0; j < n; j++){
            if (color[j] == 0 && (x == -1 || more(x, j)))
                x = j;
        }
        color[x] = 1;
        for (pair<ll, ll> v : g[x]){
            for (ll j = 0; j < MAX; j++)
                kek[j] = dist[x][j];
            kek[v.second]++;
            ll cur = v.second;
            while (kek[cur] == 2){
                kek[cur] = 0;
                kek[cur + 1]++;
                cur++;
            }

            cur = MAX - 1;
            while (cur > -1 && dist[v.first][cur] == kek[cur])
                cur--;
            if (cur > -1 && dist[v.first][cur] > kek[cur]){
                for (ll j = 0; j < MAX; j++)
                    dist[v.first][j] = kek[j];
                parent[v.first] = x;
            }
        }
    }
}


int main()
{
    #ifdef ONPC
        freopen("test.in", "r", stdin);
    #endif // ONPC
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n, m, k;
    cin >> n >> m >> k;
    vector<pair<ll, ll> > kek(k);
    for (ll i = 0; i < k; i++){
        ll x, y;
        cin >> x >> y;
        cnt[x - 1][y - 1] = 1;
        kek[i] = make_pair(x - 1, y - 1);
    }
    for (ll i = 0; i < n; i++)
        for (ll j = 0; j < m; j++)
            s[i + 1][j + 1] = s[i + 1][j] + s[i][j + 1] - s[i][j] + cnt[i][j];
    for (ll i = 0; i < k; i++){
        for (ll j = 0; j < k; j++){
            bool ok = true;
            if (kek[i].second > kek[j].second || (kek[i].second == kek[j].second && kek[i].first >= kek[j].first))
                ok = false;
            if (ok && get(kek[i].first, kek[i].second, kek[j].first, kek[j].second) < 5){
                ll d = max(kek[j].second - kek[i].second, abs(kek[i].first - kek[j].first));
                g[i].push_back(make_pair(j, d));
                g[j].push_back(make_pair(i, d));
            }
        }
    }
    dijkstra(0, k);
    /*for (ll i = 0; i < k; i++){
        for (ll j = 0; j < 5; j++)
            cout << dist[i][j] << " ";
        cout << endl;
    }*/
    ll cur = k - 1;
    vector<ll> answer;
    while (cur != -1){
        answer.push_back(cur + 1);
        cur = parent[cur];
    }
    cout << answer.size() << endl;
    reverse(answer.begin(), answer.end());
    prll(answer);
    return 0;
}
