#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <stdio.h>

using namespace std;

typedef long long ll;
typedef long double dbl;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;
}

const int MAX = 100;
short int s[MAX][MAX];
short int cnt[MAX][MAX];

inline int get(int x1, int y1, int x2, int y2){
    if (x1 > x2)
        swap(x1, x2);
    if (y1 > y2)
        swap(y1, y2);
    return s[x2 + 1][y2 + 1] + s[x1][y1] - s[x2 + 1][y1] - s[x1][y2 + 1];
}


bool check(int x1, int y1, int x2, int y2){
    if (y1 <= y2){
        if (x2 - x1 == y2 - y1)
            return get(x1, y1, x2 - 1, y2 - 1) == 1;
        if (y2 - y1 > x2 - x1)
            return get(x1, y1, x2, y2 - 1) == 1;
        else
            return get(x1, y1, x2 - 1, y2) == 1;
    }
    else{
        if (x2 - x1 == y1 - y2)
            return get(x1, y1, x2 + 1, y2 - 1) == 1;
        if (y2 - y1 > x2 - x1)
            return get(x1, y1, x2, y2 - 1) == 1;
        else
            return get(x1, y1, x2 + 1, y2) == 1;
    }
}

vector<pair<int, int> > g[MAX];
int dist[MAX];
int parent[MAX];
const int INF = 1e9;

void dijkstra(int st, int n){
    for (int i = 0; i < n; i++)
        dist[i] = INF;
    set<pair<int, int> > lst;
    dist[st] = 0;
    parent[st] = -1;
    for (int i = 0; i < n; i++)
        lst.insert(make_pair(dist[i], i));
    while (lst.size() > 0){
        pair<int, int> v = *(lst.begin());
        lst.erase(v);
        for (pair<int, int> u : g[v.second]){
            if (dist[u.first] > dist[v.second] + u.second){
                lst.erase(make_pair(dist[u.first], u.first));
                dist[u.first] = dist[v.second] + u.second;
                parent[u.first] = v.second;
                lst.insert(make_pair(dist[u.first], u.first));
            }
        }
    }
}


int main()
{
    #ifdef ONPC
        freopen("test.in", "r", stdin);
    #endif // ONPC
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, int> > kek(k);
    for (int i = 0; i < k; i++){
        int x, y;
        cin >> x >> y;
        cnt[x - 1][y - 1] = 1;
        kek[i] = make_pair(x - 1, y - 1);
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            s[i + 1][j + 1] = s[i + 1][j] + s[i][j + 1] - s[i][j] + cnt[i][j];
    /*for (int i = 0; i < n + 1; i++){
        for (int j = 0; j < m + 1; j++)
            cout << s[i][j] << " ";
        cout << endl;
    }/**/
    //cout << check(kek[5].first, kek[5].second, kek[1].first, kek[1].second) << endl;
    for (int i = 0; i < k; i++){
        for (int j = 0; j < k; j++){
            bool ok = true;
            if (kek[i].second > kek[j].second || (kek[i].second == kek[j].second && kek[i].first >= kek[j].first))
                ok = false;
            if (ok && check(kek[i].first, kek[i].second, kek[j].first, kek[j].second)){
                int d = max(kek[j].second - kek[i].second, abs(kek[i].first - kek[j].first));
                g[i].push_back(make_pair(j, (1 << d)));
                g[j].push_back(make_pair(i, (1 << d)));
            }
        }
    }
    /*for (int i = 0; i < k; i++){
        cout << i << endl;
        for (int j = 0; j < g[i].size(); j++)
            cout << g[i][j].first << " " << g[i][j].second << endl;
        cout << endl;
    }/**/
    dijkstra(0, k);
    //cout << dist[k - 1] << endl;
    /*for (int i = 0; i < k; i++)
        cout << dist[i] << " ";
    cout << endl;
    for (int i = 0; i < k; i++)
        cout << parent[i] << " ";
    cout << endl;/**/
    int cur = k - 1;
    vector<int> answer;
    while (cur != -1){
        answer.push_back(cur + 1);
        cur = parent[cur];
    }
    cout << answer.size() << endl;
    reverse(answer.begin(), answer.end());
    print(answer);
    return 0;
}
