#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stdio.h>
#include <map>


using namespace std;

const int MAX = 1100000;
int treeMin[MAX];

const int INF = 1e9 + 7;

int getMin(int v, int vl, int vr, int l, int r){
    if (vl > r || vr < l)
        return INF;
    if (vl >= l && vr <= r)
        return treeMin[v];
    int vm = (vl + vr) / 2;
    return min(getMin(v * 2 + 1, vl, vm, l, r), getMin(v * 2 + 2, vm + 1, vr, l, r));
}


int treeMax[MAX];
int s[MAX];

int getMax(int v, int vl, int vr, int l, int r){
    if (vl > r || vr < l)
        return -1;
    if (vl >= l && vr <= r)
        return treeMax[v];
    int vm = (vl + vr) / 2;
    int x = getMax(v * 2 + 1, vl, vm, l, r);
    int y = getMax(v * 2 + 2, vm + 1, vr, l, r);
    if (x == -1 || (y > -1 && s[y] >= s[x]))
        return y;
    return x;
}

int main()
{
    #ifdef ONPC
        freopen("test.in", "r", stdin);
    #endif // ONPC
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> s[i];
    int b = 1;
    while (b < n)
        b *= 2;
    for (int i = 0; i < n; i++)
        treeMin[i + b - 1] = s[i];
    for (int i = b - 2; i >= 0; i--)
        treeMin[i] = min(treeMin[i * 2 + 1], treeMin[i * 2 + 2]);
    for (int i = 0; i < MAX; i++)
        treeMax[i] = -1;
    for (int i = 0; i < n; i++)
        treeMax[i + b - 1] = i;
    for (int i = b - 2; i >= 0; i--){
        if (s[treeMax[i * 2 + 2]] >= s[treeMax[i * 2 + 1]])
            treeMax[i] = treeMax[i * 2 + 2];
        else
            treeMax[i] = treeMax[i * 2 + 1];
    }

    int cur = 0, answer = 0;
    while (cur < n){
        int l = 1;
        int r = n - cur + 1;
        while (l + 1 < r){
            int m = (l + r) / 2;
            if (getMin(0, 0, b - 1, cur, cur + m - 1) >= s[cur])
                l = m;
            else
                r = m;
        }
        int x = getMax(0, 0, b - 1, cur, cur + l - 1);
        cur = x + 1;
        answer++;
    }
    cout << answer << endl;
    return 0;
}
