#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

const int N = (int)5e2 + 7;

int n, p;
int pos[N][N];
set <int> m[N];
vector <int> v[N];

void read() {
	cin >> n;
	for (int i = 1; i <= n; i++) {
		for (int j = 0; j < n; j++) {
			int x; cin >> x;
			v[i].push_back(x);
		}
	}
	cin >> p;
}

void make_set() {
	for (int i = 1; i <= n; i++) {
		int j = 0;
		while (v[i][j] != i)
			m[i].insert(v[i][j++]);
		m[i].insert(i);
	}
}

void get_pos() {
	for (int i = 1; i <= n; i++) {
		fill(pos[i], pos[i] + n + 1, -1);
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			if (i == j)
				continue;
			int k = n - 1;
			while (k >= 0) {
				if (m[j].count(v[i][k]) == 1) {
					pos[i][j] = k;
					break;
				}
				k--;
			}
		}
	}
}

void easy() {
	set <int> ans;
	for (int i = 1; i <= n; i++)
		if (i == v[i][0])
			ans.insert(v[i][0]);
	cout << (int)ans.size() << endl;
	for (auto x : ans)
		cout << x << ' ';
}

void solve() {
	if (p == 1) {
		easy();
		exit(0);
	}
	make_set();
	get_pos();
	set <int> ans;
	for (int i = 1; i <= n; i++) {
		ans.insert(v[i][0]);
		for (int j = 0; j < n; j++) {
			if (j && v[i][j - 1] == i)
				break;
			if (ans.count(v[i][j]) == 1)
				continue;
			bool fl = true;
			for (int k = 1; k <= n; k++) {
				if (i == k)
					continue;
				if (pos[i][k] < j) {
					fl = false;
					break;
				}
			}
			if (fl)
				ans.insert(v[i][j]);
		}
	}
	cout << (int)ans.size() << endl;
	for (int x : ans)
		cout << x << ' ';
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	read();
	solve();
}