#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cassert>
#include <vector>
#include <set>
#include <map>

using namespace std;

const int INF = (int)1e9;
const int N = (int)3e5;

int n;
pair <int, int> tr[4 * N];
vector <int> arr;

void relax(int v) {
	int p1 = tr[2 * v].first, p2 = tr[2 * v + 1].first;
	if (arr[p1] <= arr[p2])
		tr[v].first = p1;
	else
		tr[v].first = p2;
	p1 = tr[2 * v].second, p2 = tr[2 * v + 1].second;
	if (arr[p1] > arr[p2])
		tr[v].second = p1;
	else
		tr[v].second = p2;
}

void build(int v, int l, int r) {
	if (l == r) {
		tr[v].first = tr[v].second = l;
		return;
	}
	int m = (r + l) / 2;
	build(2 * v, l, m);
	build(2 * v + 1, m + 1, r);
	relax(v);
}

pair <int, int> query(int v, int l, int r, int ql, int qr) {
	if (ql <= l && r <= qr)
		return tr[v];
	if (ql > r || l > qr)
		return make_pair(n + 1, 0);
	int m = (l + r) / 2;
	auto p1 = query(2 * v, l, m, ql, qr), p2 = query(2 * v + 1, m + 1, r, ql, qr);
	pair <int, int> res;
	if (arr[p1.first] <= arr[p2.first])
		res.first = p1.first;
	else
		res.first = p2.first;
	if (arr[p1.second] > arr[p2.second])
		res.second = p1.second;
	else
		res.second = p2.second;
	return res;
}

int rec(int l, int r) {
	if (l > r)
		return 0;
	if (l == r)
		return 1;
	int mn, mx;
	auto cur = query(1, 1, n, l, r);
	mn = cur.first, mx = cur.second;
	if (mn == l && mx == r)
		return 1;
	if (mn > mx)
		return rec(l, mx) + rec(mx + 1, mn - 1) + rec(mn, r);
	else
		return rec(l, mn - 1) + rec(mx + 1, r) + 1;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	cin >> n;
	arr.resize(n + 2);
	arr[0] = -INF, arr[n + 1] = INF;
	for (int i = 1; i <= n; i++)
		cin >> arr[i];
	build(1, 1, n);
	cout << rec(1, n);
}