#include <bits/stdc++.h>
#define int long long

const int INF = (int)(1e12);
const int maxLog = (int)(20);


using namespace std;


struct sparse {
    vector< vector<int>> mx, mn;

    vector<int> pow;

    sparse(vector<int>& a) {
        int n = a.size();
        mx.resize(maxLog);
        mn.resize(maxLog);

        mx[0].resize(n);
        mn[0].resize(n);

        for (int i = 0; i < n; ++i) {
            mx[0][i] = a[i];
            mn[0][i] = a[i];
        }
        for (int pw = 1; pw < maxLog; ++pw) {
            mx[pw].resize(n);
            mn[pw].resize(n);
            for (int i = 0; i < n; ++i) {
                mx[pw][i] = mx[pw - 1][i];
                mn[pw][i] = mn[pw - 1][i];
                if (i + (1 << (pw - 1)) < n) {
                    mx[pw][i] = max(mx[pw][i], mx[pw - 1][i + (1 << (pw - 1))]);
                    mn[pw][i] = min(mn[pw][i], mn[pw - 1][i + (1 << (pw - 1))]);
                }
            }
        }

        /*
        cout << "sparse: " << endl;
        for (int pw = 0; pw < maxLog; ++pw) {
            for (int i = 0; i < n; ++i) {
                cout << i << " " << pw << " : " << mx[pw][i] << " " << mn[pw][i] << endl;
            }
        }
        */
        pow.resize(n + 1);
        pow[1] = 0;
        for (int i = 2; i <= n; ++i) {
            if (i == (1 << (pow[i - 1] + 1))) {
                pow[i] = pow[i - 1] + 1;
            } else {
                pow[i] = pow[i - 1];
            }
        }
    }

    int get_min(int l, int r) { // get min on [l, r)
        int maxPow = pow[r - l];
        return min(mn[maxPow][l], mn[maxPow][r - (1 << maxPow)]);
    }
    int get_max(int l, int r) { // get min on [l, r)
        int maxPow = pow[r - l];
        return max(mx[maxPow][l], mx[maxPow][r - (1 << maxPow)]);
    }
};

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    sparse s(a);

    /*
    //packing
    set<int> s;
    for (int x : a) {
        s.insert(x);
    }
    map<int, int> packed;
    int it = 0;
    for (int x : s) {
        packed[x] = it;
        ++it;
    }
    for (int i = 0; i < n; ++i) {
        a[i] = packed[a[i]];
    }
    */
    /*
    // min calc
    vector< vector<int> > mx(n, vector<int>(n + 1, -INF)); // mx[i][j] = max[i, j)
    vector< vector<int> > mn(n, vector<int>(n + 1, INF)); // mn[i][j] = min[i, j)

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            mx[i][j] = max(mx[i][j - 1], a[j - 1]);
            mn[i][j] = min(mn[i][j - 1], a[j - 1]);
        }
    }
    */


    int res = 0;


    //min
    for (int i = 0; i < n;) {


        int l = i, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (s.get_min(i, m + 1) < a[i]) {
                r = m;
            } else {
                l = m;
            }
        }

        l = i;
        int right_border = r;
        int cur_mx = s.get_max(i, r);

        while (r - l > 1) {
            int m = (l + r) / 2;
            if (s.get_max(i, m) == cur_mx) {
                r = m;
            } else {
                l = m;
            }
        }


        r = right_border;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (s.get_max(m, right_border) == cur_mx) {
                l = m;
            } else {
                r = m;
            }
        }

        ++res;
        i = r;
    }

    cout << res << "\n";

}