#include <bits/stdc++.h>
#define ll long long

using namespace std;

const ll INF = 2e9 + 7;
const ll MAXN = 1e6 + 7;
const double EPS = 1e-7;

ll lt[MAXN], rt[MAXN], sum[MAXN];

ll last = 0;

ll get_sum(ll v, ll L, ll R, ll l = 0, ll r = INF) {
    if (v == -1 || l >= R || L >= r) {
        return 0;
    }
    if (L <= l && r <= R) {
        return sum[v];
    }
    ll m = (l + r) / 2;
    return get_sum(lt[v], L, R, l, m) + get_sum(rt[v], L, R, m, r);
}

void add(ll v, ll p, ll x, ll l = 0, ll r = INF) {
    if (l > p || r <= p) {
        return;
    }
    sum[v] += x;
    if (r - l == 1) {
        return;
    }
    if (lt[v] == -1) {
        lt[v] = last++;
    }
    if (rt[v] == -1) {
        rt[v] = last++;
    }
    ll m = (l + r) / 2;
    add(lt[v], p, x, l, m);
    add(rt[v], p, x, m, r);
}

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    ll n, p;
    cin >> n >> p;
    vector <ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    fill_n(lt, MAXN, -1);
    fill_n(rt, MAXN, -1);
    fill_n(sum, MAXN, 0);
    last = 2;
    for (ll i = 0; i < n; i++) {
        add(0, a[i] + i, 1);
    }
    for (ll i = 0; i < n; i++) {
        ll res = get_sum(0, 0, a[i] + i) + get_sum(1, 0, a[i] - i + MAXN) + 1;
        add(0, a[i] + i, -1);
        add(1, a[i] - i + MAXN, 1);
        cout << res << "\n";
    }
}
