#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 3e9 + 7;
const int MAXN = 1e6 + 7;
const double EPS = 1e-7;

struct TNode {
    int L, R;
    TNode *left, *right;
    int sum;
};

TNode *new_node(int L, int R) {
    return new TNode({L, R, nullptr, nullptr, 0});
}

int safe_sum(TNode *root) {
    return (root ? root->sum : 0);
}

void relax(TNode *root) {
    root->sum = safe_sum(root->left) + safe_sum(root->right);
}

int get_sum(TNode *root, int L, int R) {
    if (!root || root->L >= R || L >= root->R) {
        return 0;
    }
    if (L <= root->L && root->R <= R) {
        return root->sum;
    }
    return get_sum(root->left, L, R) + get_sum(root->right, L, R);
}

void add(TNode *root, int v, int x) {
    if (root->L > v || root->R <= v) {
        return;
    }
    root->sum += x;
    if (root->R - root->L == 1) {
        return;
    }
    int M = (root->L + root->R) / 2;
    if (!root->left) {
        root->left = new_node(root->L, M);
    }
    if (!root->right) {
        root->right = new_node(M, root->R);
    }
    add(root->left, v, x);
    add(root->right, v, x);
}


int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    int n, p;
    cin >> n >> p;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    TNode *left = new_node(-INF, INF), *right = new_node(-INF, INF);
    for (int i = 0; i < n; i++) {
        add(right, a[i] + i, 1);
    }
    for (int i = 0; i < n; i++) {
        int res = get_sum(right, -INF, a[i] + i) + get_sum(left, -INF, a[i] - i) + 1;
        add(right, a[i] + i, -1);
        add(left, a[i] - i, 1);
        cout << res << "\n";
    }
}
