#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 2e9 + 7;
const int MAXN = 1e6 + 7;
const double EPS = 1e-7;

struct TNode {
    TNode *left, *right;
    int sum;
};

TNode *new_node() {
    return new TNode({nullptr, nullptr, 0});
}

int safe_sum(TNode *root) {
    return (root ? root->sum : 0);
}

void relax(TNode *root) {
    root->sum = safe_sum(root->left) + safe_sum(root->right);
}

int get_sum(TNode *root, int L, int R, int l = -INF, int r = INF) {
    if (!root || l >= R || L >= r) {
        return 0;
    }
    if (L <= l && r <= R) {
        return root->sum;
    }
    int m = (l + r) / 2;
    return get_sum(root->left, L, R, l, m) + get_sum(root->right, L, R, m, r);
}

void add(TNode *root, int v, int x, int l = -INF, int r = INF) {
    if (l > v || r <= v) {
        return;
    }
    root->sum += x;
    if (r - l == 1) {
        return;
    }
    int m = (l + r) / 2;
    if (!root->left) {
        root->left = new_node();
    }
    if (!root->right) {
        root->right = new_node();
    }
    add(root->left, v, x, l, m);
    add(root->right, v, x, m, r);
}


int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    int n, p;
    cin >> n >> p;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    TNode *left = new_node(), *right = new_node();
    for (int i = 0; i < n; i++) {
        add(right, a[i] + i, 1);
    }
    for (int i = 0; i < n; i++) {
        int res = get_sum(right, -INF, a[i] + i) + get_sum(left, -INF, a[i] - i) + 1;
        add(right, a[i] + i, -1);
        add(left, a[i] - i, 1);
        cout << res << "\n";
    }
}
