#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<string>
#include<cmath>

using namespace std;
typedef long long ll;
const ll INF = 1e18;

class bigint {
public:
	vector<ll> a;
	bigint()
		:a()
	{}
	bigint(ll z) {
		a.resize(z + 1, 0);
		a[z] = 1;
	}
	bool operator<(bigint& up) {
		if (a.size() != up.a.size())
			return a.size() < up.a.size();
		for (int i = a.size() - 1; i >= 0; --i) {
			if (a[i] != up.a[i])
				return a[i] < up.a[i];
		}
		return false;
	}
	bool operator==(bigint& up) {
		if (a.size() != up.a.size())
			return false;
		for (int i = a.size() - 1; i >= 0; --i) {
			if (a[i] != up.a[i])
				return false;
		}
		return true;
	}
	bool operator<=(bigint& up) {
		if (a.size() != up.a.size())
			return a.size() < up.a.size();
		for (int i = a.size() - 1; i >= 0; --i) {
			if (a[i] != up.a[i])
				return a[i] < up.a[i];
		}
		return true;
	}
	bigint operator+(bigint& up) {
		bigint t;
		ll i = 0, r = 0, siz = max(a.size(), up.a.size()), p;
		while (i < siz) {
			p = r;
			if (i < a.size())
				p += a[i];
			if (i < up.a.size())
				p += up.a[i];
			if (p > 0 || (p == 0 && i < siz)) {
				t.a.push_back(p % 2);
				r = p / 2;
			}
			else
				break;
			++i;
		}
		while (t.a.back() == 0)
			t.a.pop_back();
		return t;
	}
};

vector<pair<ll, bigint> > g[10000];

int main() {
	ios_base::sync_with_stdio(false);
	ll n, m, k;
	cin >> n >> m >> k;
	vector<pair<ll, ll> > a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	for (int i = 0; i < k; ++i) {
		for (int j = i + 1; j < k; ++j) {
				ll d = max(llabs(a[i].first - a[j].first), llabs(a[i].second - a[j].second));
				bigint dist = bigint(d);
				g[i].push_back({ j, dist });
				g[j].push_back({ i, dist });
		}
	}
	vector<bigint> dist(k, bigint(20000));
	vector<ll> pr(k, -1), used(k);
	dist[0] = bigint(0);
	for (int i = 0; i < k; ++i) {
		ll v = -1;
		for (int i = 0; i < k; ++i) {
			if (!used[i] && (v == -1 || dist[i] < dist[v]))
				v = i;
		}
		used[v] = 1;
		if (v == k - 1) {
			break;
		}
		for (int i = 0; i < g[v].size(); ++i) {
			ll to = g[v][i].first;
			bigint cost = g[v][i].second + dist[v];
			if (!used[to] && cost < dist[to]) {
				dist[to] = cost;
				pr[to] = v;
			}
		}
	}
	vector<ll> ans(1, k - 1);
	ll p = pr[k - 1];
	while (p != -1) {
		ans.push_back(p);
		p = pr[p];
	}
	cout << ans.size() << '\n';
	for (int i = ans.size() - 1; i >= 0; --i)
		cout << ans[i] + 1 << ' ';
	return 0;
}

/*
5 6 9
1 1 4 3 4 6 2 5 3 1 3 3 3 6 5 4 5 6
*/