#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<iostream>
#include<cmath>
#include<ctime>
#include<random>

using namespace std;

const int INF = 1e18;

class tree {
public:
	int value, q, cnt, pusher;
	tree *L, *R;
	tree()
		:value()
		, q(rand())
		, cnt(1)
		, pusher(0)
		, L(NULL)
		, R(NULL)
	{}
	tree(int v)
		:value(v)
		, q(rand())
		, cnt(1)
		, pusher(0)
		, L(NULL)
		, R(NULL)
	{}
	void update() {
		cnt = 1 + ((L) ? L->cnt : 0) + ((R) ? R->cnt : 0);
	}
	void push() {
		if (L)
			L->pusher += pusher;
		if (R)
			R->pusher += pusher;
		value += pusher;
		pusher = 0;
	}
};

typedef tree* ptree;

ptree merge(ptree &L, ptree &R) {
	if (!L || !R) {
		return ((L) ? L : R);
	}
	L->push();
	R->push();
	if (L->q < R->q) {
		R->L = merge(L, R->L);
		R->update();
		return R;
	}
	else {
		L->R = merge(L->R, R);
		L->update();
		return L;
	}
}

void split(ptree T, ptree &L, ptree &R, int x) {
	if (!T) {
		L = R = NULL;
		return;
	}
	T->push();
	if (T->value >= x) {
		split(T->L, L, T->L, x);
		R = T;
	}
	else {
		split(T->R, T->R, R, x);
		L = T;
	}
	if (R)
		R->update();
	if (L)
		L->update();
}

void add(ptree &T, int v) {
	if (!T)
		T = new tree(v);
	else {
		T->push();
		ptree L, R, d = new tree(v);
		split(T, L, R, v);
		L = merge(L, d);
		T = merge(L, R);
		T->update();
	}
}

void erase(ptree &T, int v) {
	ptree L, d, R;
	split(T, L, R, v);
	split(R, d, R, v + 1);
	if (d)
		d = merge(d->L, d->R);
	L = merge(L, d);
	T = merge(L, R);
}

void search(ptree &T, int x, int &c) {
	if (!T) {
		return;
	}
	T->push();
	if (T->value >= x) {
		c -= 1 + ((T->R) ? T->R->cnt : 0);
		search(T->L, x, c);
	}
	else
		search(T->R, x, c);
}

int main() {
	srand(time(NULL));
	ios_base::sync_with_stdio(false);
	int n, p;
	cin >> n >> p;
	vector<int> a(n);
	vector<pair<int, int> > ans;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	if (p == 1) {
		vector<int> ans_L(n), ans_R(n);
		ptree LL = NULL, RR = NULL;
		for (int i = 0; i < n; ++i) {
			ans_L[i] = i;
			search(LL, a[i], ans_L[i]);
			add(LL, a[i]);
			LL->pusher += 1;
		}
		for (int i = n - 1; i >= 0; --i) {
			ans_R[i] = n - 1 - i;
			search(RR, a[i], ans_R[i]);
			add(RR, a[i]);
			RR->pusher += 1;
		}
		for (int i = 0; i < n; ++i) {
			cout << ans_L[i] + ans_R[i] + 1 << '\n';
		}
		return 0;
	}
	else {
		vector<int> ans(n);
		for (int l = 0; l < n; ++l) {
			for (int r = l; r < n; ++r) {
				if (l == 0 && r == n - 1)
					continue;
				ptree root = NULL;
				for (int i = 0; i < l; ++i)
					add(root, a[i]);
				for (int i = r + 1; i < n; ++i)
					add(root, a[i]);
				for (int i = l; i < r + 1; ++i) {
					int d;
					if (l == 0) {
						d = a[i] + abs(i - r) + 1;
					}
					else if (r == n - 1)
						d = a[i] + abs(i - l) + 1;
					else
						d = a[i] + min(abs(i - l), abs(i - r)) + 1;
					add(root, d);
				}
				vector<int> answer(n, n);
				for (int i = 0; i < n; ++i) {
					int d = a[i];
					if (i >= l && i <= r) {
						if (l == 0) {
							d = a[i] + abs(i - r) + 1;
						}
						else if (r == n - 1)
							d = a[i] + abs(i - l) + 1;
						else
							d = a[i] + min(abs(i - l), abs(i - r)) + 1;
					}
					search(root, d, answer[i]);
					ans[i] = max(ans[i], answer[i]);
				}
			}
		}
		for (int i = 0; i < n; ++i)
			cout << ans[i] + 1 << '\n';
		return 0;
	}
	return 0;
}