#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse4,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cstdlib>
#include <cassert>
#include <iterator>
#include <functional>
#include <numeric>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int N = 20;
int RMAX = N - 1;

bool operator<(const bitset<N> &b1, const bitset<N> &b2) {
	for (int i = RMAX; i >= 0; i--) {
		if (b1[i] != b2[i])
			return b1[i] < b2[i];
	}
	return false;
}

struct number {
	bitset<N> bs;
	number() {}

	bool operator<(const number &n) const {
		return bs < n.bs;
	}

	void operator+=(int kek) {
		int carry = bs[kek] + 1;
		int pos = kek;
		while (carry) {
			bs[pos] = carry & 1;
			carry >>= 1;
			pos++;
			carry += bs[pos];
		}
	}
};

int calc(pair<int, int> a, pair<int, int> b) {
	return max(abs(a.first - b.first), abs(a.second - b.second));
}

number dist[N];
int pred[N];

void run() {

	int n, m, k;
	cin >> n >> m >> k;

	vector<pair<int, int>> verts;
	for (int i = 0; i < k; i++) {
		int x, y;
		cin >> x >> y;
		verts.emplace_back(x, y);
	}

	for (int i = 1; i < k; i++) {
		dist[i] += N - 2;
	}

	auto cmp = [&](int a, int b) {
		return dist[a] < dist[b];
	};
	set<int> st;
	st.insert(0);
	pred[0] = -1;
	while (!st.empty()) {
		int v = *st.begin();
		st.erase(st.begin());
		for (int to = 1; to < k; to++) {
			if (to == v)
				continue;
			number nn = dist[v];
			nn += calc(verts[v], verts[to]);
			if (nn < dist[to]) {
				st.erase(to);
				dist[to] = nn;
				st.insert(to);
				pred[to] = v;
			}
		}
	}

	for (int i = 0; i < k; i++) {
		cout << dist[i].bs.to_string() << endl;;
	}

	vector<int> ans;
	int cur = k - 1;
	while (cur != -1) {
		ans.push_back(cur);
		cur = pred[cur];
	}
	reverse(all(ans));
	cout << sz(ans) << endl;
	for (auto it : ans)
		cout << it + 1 << ' ';
}