#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)

using namespace std;

inline void setmin(int &x, int y) { if (y < x) x = y; }
inline void setmax(int &x, int y) { if (y > x) x = y; }
inline void setmin(ll &x, ll y) { if (y < x) x = y; }
inline void setmax(ll &x, ll y) { if (y > x) x = y; }

const int N = 150000;
const int inf = (int)1e9 + 1;
const ll big = (ll)1e18 + 1;
const int MOD = (int)1e9 + 7;

struct Point
{
    ld x, y;
    Point() {}
    Point(ld x, ld y) : x(x), y(y) {}
};

bool operator < (Point p1, Point p2) { return p1.x < p2.x; }

struct Line
{
    ll k, b;
    Line() {}
    Line(ll k, ll b) : k(k), b(b) {}
    ll val(ll x) { return k * x + b; }
    ld val(ld x) { return k * x + b; }
};

Point LIL(Line &l1, Line &l2)
{
    ld x = -(ld)(l1.b - l2.b) / (l1.k - l2.k);
    return Point(x, l1.val(x));
}

struct CHT
{
    vector<Point> points;
    vector<Line> lines;
    CHT() {}
    void add_line(Line l)
    {
        while (sz(points) > 0 && l.val(points.back().x) >= points.back().y)
        {
            points.pop_back();
            lines.pop_back();
        }
        if (sz(lines) > 0)
            points.push_back(LIL(l, lines.back()));
        lines.push_back(l);
    }
    // TODO - moving index
    ll get_val(ll x)
    {
        return lines[lower_bound(points.begin(), points.end(), Point(x, 0)) - points.begin()].val(x);
    }
};

const int B = 5;
ll vals[N];
ll ans[N];

ll add[N];
CHT cht[N];

void build_cht(int p, int l, int r, int to_upd)
{
    cht[p].points.clear();
    cht[p].lines.clear();
    rep(i, l, r)
        ans[i] += vals[i] * add[p];
    rep(i, l, to_upd)
        ans[i] += vals[i];
    add[p] = 0;
    rep(i, l, r)
        cht[p].add_line(Line(vals[i], ans[i]));
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    int n;
    cin >> n;
    pair<int, int> a[n];
    rep(i, 0, n)
        cin >> a[i].fi >> a[i].se;
    sort(a, a + n, [](pair<int, int> a, pair<int, int> b) { return a > b; });
    /*rep(i, 0, n)
        cout << a[i].fi << " " << a[i].se << "\n";*/
    vector<int> diff;
    rep(i, 0, n)
        diff.push_back(a[i].se);
    sort(diff.begin(), diff.end());
    diff.resize(unique(diff.begin(), diff.end()) - diff.begin());
    int blocks = (sz(diff) + B - 1) / B, V = sz(diff);
    rep(i, 0, V)
        vals[i] = diff[i];
    rep(i, 0, blocks)
        build_cht(i, i * B, min(V, (i + 1) * B), i * B);
    ll suff[n + 1]; fill(suff, suff + n + 1, 0);
    repb(i, n - 1, -1)
    {
        int pos = lower_bound(diff.begin(), diff.end(), a[i].se) - diff.begin();
        int block_id = pos / B;
        rep(j, 0, block_id)
            add[j]++;
        build_cht(block_id, block_id * B, min(V, (block_id + 1) * B), pos + 1);
        rep(j, 0, blocks)
            setmax(suff[i], cht[j].get_val(add[j]));
    }
    /*rep(i, 0, n + 1)
        cout << suff[i] << " ";
    cout << "\n";*/
    ll ans = 0;
    rep(i, 0, n + 1)
    {
        ll cnt = 0;
        if (i - 1 >= 0)
            cnt += (ll)a[i - 1].fi * i;
        setmax(ans, cnt + suff[i]);
    }
    cout << ans << "\n";
    return 0;
}