#include <bits/stdc++.h>

using namespace std;

//typedef long long int;

const int INF = 1e9;

struct Tree {
    int key, priority, size;
    Tree *left, *right;
};

Tree *newTree(int key) {
    return new Tree{key, rand(), 1, nullptr, nullptr};
}

int safeSize(Tree *tree) {
    if (!tree) {
        return 0;
    }
    return tree->size;
}

void recalc(Tree *tree) {
    if (!tree) {
        return;
    }
    tree->size = 1 + safeSize(tree->left) + safeSize(tree->right);
}

Tree *merge(Tree *ta, Tree *tb) {
    if (!ta) {
        return tb;
    }
    if (!tb) {
        return ta;
    }
    if (ta->priority > tb->priority) {
        ta->right = merge(ta->right, tb);
        recalc(ta);
        return ta;
    } else {
        tb->left = merge(ta, tb->left);
        recalc(tb);
        return tb;
    }
}

pair<Tree *, Tree *> split(Tree *tree, int key) {
    if (!tree) {
        return {nullptr, nullptr};
    }
    if (tree->key >= key) {
        auto p = split(tree->left, key);
        tree->left = p.second;
        recalc(tree);
        return {p.first, tree};
    } else {
        auto p = split(tree->right, key);
        tree->right = p.first;
        recalc(tree);
        return {tree, p.second};
    }
}

Tree *insert(Tree *tree, int val) {
    Tree *nt = newTree(val);
    auto p = split(tree, val);
    return merge(p.first, merge(nt, p.second));
}

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n, p;
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> p;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (p == 2) {
        int ans[n];
        fill_n(ans, n, 1);
        for (int mask = 1; mask < (1 << n); ++mask) {
            int fin[n];
            fill_n(fin, n, INF);
            for (int i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    fin[i] = 0;
                } else {
                    if (i) {
                        fin[i] = fin[i - 1] + 1;
                    }
                }
            }
            for (int i = n - 1; i >= 0; --i) {
                if (mask & (1 << i)) {
                    fin[i] = 0;
                } else {
                    if (i != n - 1) {
                        fin[i] = min(fin[i + 1] + 1, fin[i]);
                    }
                }
            }
            vector<int> data(n);
            for (int i = 0; i < n; ++i) {
                data[i] = {-fin[i] - a[i]};
            }
            sort(data.begin(), data.end());
            for (int i = 0; i < n; ++i) {
                int tm = n - (upper_bound(data.begin(), data.end(), -fin[i] - a[i]) - data.begin());
                ans[i] = max(ans[i], tm + 1);
            }
        }
        for (auto x: ans) {
            cout << x << "\n";
        }
    } else {
//        int ans[n];
//        fiint_n(ans, n, INF);
//        for (int q = 0; q < n; ++q) {
//            int mask = (1 << q);
//            int fin[n];
//            fiint_n(fin, n, INF);
//            for (int i = 0; i < n; ++i) {
//                if (mask & (1 << i)) {
//                    fin[i] = 0;
//                } else {
//                    fin[i] = abs(i - q);
//                }
//            }
//            int tm = 0;
//            for (int i = 0; i < n; ++i) {
//                if (a[i] + fin[i] < a[q] + fin[q]) {
//                    ++tm;
//                }
//            }
//            ans[q] = min(ans[q], tm + 1);
//        }
//        for (auto x: ans) {
//            cout << x << " ";
//        }
//        cout << "\n";
//        return 0;
        int place[n];
        fill_n(place, n, 0);
        Tree *tree = nullptr;
        int now = n;
        for (int i = 0; i < n; ++i) {
            int val = a[i] + now;
            auto pr = split(tree, val);
            place[i] += safeSize(pr.first);
            tree = merge(pr.first, pr.second);
            tree = insert(tree, a[i] + now);
            now--;
        }
        now = n;
        tree = nullptr;
        for (int i = n - 1; i >= 0; --i) {
            int val = a[i] + now;
            auto pr = split(tree, val);
            place[i] += safeSize(pr.first);
            tree = merge(pr.first, pr.second);
            tree = insert(tree, val);
            --now;
        }
        for (auto x: place) {
            cout << x + 1 << "\n";
        }
    }
}