#include<bits/stdc++.h>
using namespace std;

struct tree{
    tree *l = nullptr, *r = nullptr;
    int x, y, add, sz;
    tree(int _x){
        x = _x;
        y = (rand() << 15) + rand();
        add = 0;
        sz = 1;
    }
};

int getsz(tree *t){
    if(t == nullptr) return 0;
    return t->sz;
}

void push(tree *t){
    if(t == nullptr) return;
    if(t->add == 0) return;
    t->x += t->add;
    if(t->l != nullptr){
        t->l->add += t->add;
    }
    if(t->r != nullptr){
        t->r->add += t->add;
    }
    t->add = 0;
}

void upd(tree *t){
    if(t == nullptr) return;
    push(t);
    t->sz = 1 + getsz(t->l) + getsz(t->r);
}

void merge(tree *&t, tree *l, tree *r){
    upd(l);
    upd(r);
    if(l == nullptr){
        t = r;
        upd(t);
        return;
    }
    if(r == nullptr){
        t = l;
        upd(t);
        return;
    }
    if(l->y > r->y){
        merge(l->r, l->r, r);
        t = l;
    }
    else{
        merge(r->l, l, r->l);
        t = r;
    }
    upd(t);
}

void split(tree *t, tree *&l, tree *&r, int x){
    upd(t);
    if(t == nullptr){
        l = t;
        r = t;
        upd(l);
        upd(r);
        return;
    }
    if(t->x < x){
        split(t->r, t->r, r, x);
        l = t;
    }
    else{
        split(t->l, l, t->l, x);
        r = t;
    }
    upd(r);
    upd(l);
}

void spl(tree *t, tree *&l, tree *&r, int x){
    upd(t);
    if(t == nullptr){
        l = t;
        r = t;
        upd(l);
        upd(r);
        return;
    }
    int v = getsz(t->l) + 1;
    if(v <= x){
        spl(t->r, t->r, r, x);
        l = t;
    }
    else{
        spl(t->l, l, t->l, x);
        r = t;
    }
    upd(r);
    upd(l);
}

void insert(tree *&t, tree *x){
    upd(x);
    tree *l, *r;
    split(t, l, r, x->x);
    merge(l, l, x);
    merge(t, l, r);
}

void erase(tree *&t, int x){
    tree *l, *r;
    split(t, l, r, x);
    tree *m;
    spl(r, m, r, 1);
    merge(t, l, r);
}

signed main(){
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, p;
    cin >> n >> p;
    vector<int> q(n);
    for(int i = 0; i < n; i++){
        cin >> q[i];
    }
    if(p != 1) return 1;
    tree *l = nullptr, *r = nullptr;
    for(int i = 0; i < n; i++){
        insert(r, new tree(q[i] + i + 1));
    }
    for(int i = 0; i < n; i++){
        if(r != nullptr)r->add--;
        cerr << getsz(l) << ' ' <<getsz(r) << '\n';
        erase(r, q[i]);
        tree *L, *R;
        split(l, L, R, q[i]);
        int ans = getsz(L);
        merge(l, L, R);
        split(r, L, R, q[i]);
        ans += getsz(L);
        merge(r, L, R);
        cout << ans + 1 << '\n';
        insert(l, new tree(q[i]));
        if(l != nullptr) l->add++;
    }
    return 0;
}

