//
// Created by roi on 05.04.2018.
//
#include <iostream>
#include <vector>

const int INF = 1000000000;

struct Node {
    int cnt;
    int first_max;
    int first_min;
    int last_max;
    int last_min;
    Node(): cnt(0), first_max(0), first_min(0), last_max(0), last_min(0) {}
    Node(int val): cnt(1), first_max(val), first_min(val), last_max(val), last_min(val) {}
    Node operator+(const Node &other) const {
        Node ans;
        ans.cnt = cnt + other.cnt;
        ans.last_max = other.last_max;
        ans.first_min = first_min;
        ans.last_min = other.last_min;
        ans.first_max = first_max;
        if (last_min <= other.first_min && last_max <= other.first_max) {
            --ans.cnt;
            if (cnt == 1) {
                ans.first_max = other.first_max;
            }
            if (other.cnt == 1) {
                ans.last_min = last_min;
            }
        }
        return ans;
    }
};

int n = 0;
std::vector<Node> tree;
std::vector<int> a;

void Build(int v, int CurL, int CurR) {
    if (CurL == CurR) {
        tree[v] = Node(a[CurL]);
        return;
    }
    int mid = (CurL + CurR) >> 1;
    Build(2 * v, CurL, mid);
    Build(2 * v + 1, mid + 1, CurR);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> n;
    a.resize(n);
    for (auto &i : a) {
        std::cin >> i;
    }
    int t = 1;
    while (t <= a.size()) {
        t <<= 1;
    }
    t <<= 1;
    tree.resize(t);
    Build(1, 0, n - 1);
    std::cout << tree[1].cnt;
    return 0;
}

/*
6
2 3 1 1 5 1
 */