/*#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

#define int long long

const int INF = 1e15;

struct buy
{
	int a = 0, b = 0;
	friend bool operator<(const buy &a, const buy &b)
	{
		if (a.a == b.a)
			return a.b > b.b;
		return a.a > b.a;
	}
};

int find(const vector<int> &a, int x)
{
	if (a.size() == 0)
		return 0;
	int l = 0, r = a.size();
	if (x < a.front())
		return 0;
	if (x > a.back())
		return a.size();
	while (r - l > 1)
	{
		int m = (l + r) >> 1;
		if (a[m] > x)
			r = m;
		else
			l = m;
	}
	return l + 1;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n; cin >> n;
	vector<buy> v(n);
	vector<int> all;
	for (int i = 0; i < n; i++)
	{
		cin >> v[i].a >> v[i].b;
		all.push_back(v[i].a);
		all.push_back(v[i].b);
	}
	sort(v.begin(), v.end());
	sort(all.begin(), all.end());
	all.resize(unique(all.begin(), all.end()) - all.begin());
	vector<vector<int>> d(n, vector<int>(all.size()));
	vector<int> cur, mx(n + 1);
	for (int i = n - 1; i >= 0; i--)
	{
		for (int j = 0; j < all.size(); j++)
		{
			int x = all[i];
			int ind = find(cur, x);
			d[i][j] = max(ind * x, i > 0 ? d[i - 1][j] : -INF);
		}
		cur.push_back(v[i].b);
		sort(cur.begin(), cur.end());
		for (auto i : cur)
			cout << i << " ";
		cout << endl;
	}
	int ans = 0;
	for (int i = 0; i < n; i++)
		ans = max(ans, v[i].a * (i + 1) + d[i][all.size() - 1]);
	cout << ans << endl;
	system("pause");
}*/
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

#define int long long

struct buy
{
	int a = 0, b = 0;
	friend bool operator<(const buy &a, const buy &b)
	{
		if (a.a == b.a)
			return a.b > b.b;
		return a.a > b.a;
	}
};


signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n; cin >> n;
	vector<buy> v(n);
	vector<int> all;
	for (int i = 0; i < n; i++)
	{
		cin >> v[i].a >> v[i].b;
		all.push_back(v[i].a);
		all.push_back(v[i].b);
	}
	sort(v.begin(), v.end());
	sort(all.begin(), all.end());
	all.resize(unique(all.begin(), all.end()) - all.begin());
	int ans = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < all.size() && v[i].a >= all[j]; j++)
		{
			int cur = 0, x = v[i].a, y = all[j];
			for (int k = 0; k < n; k++)
				if (x <= v[k].a)
					cur += x;
				else if (y <= v[k].b)
					cur += y;
			ans = max(ans, cur);
		}
	}
	cout << ans << endl;
	system("pause");
}