#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
using namespace std;

#define int long long

const int INF = 1e15;

int n, m;

int get(int x1, int y1, int x2, int y2)
{
	return 1LL << max(abs(x2 - x1), abs(y2 - y1));
}

struct cell
{
	int x = 0, y = 0;
};

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int k; cin >> n >> m >> k;
	int N = n * m;
	vector<cell> a(N);
	for (int i = 0; i < k; i++)
		cin >> a[i].x >> a[i].y;
	vector<int> d(k, INF);
	vector<bool> used(k);
	vector<int> p(k, -1);
	d[0] = 0;
	for (int i = 0; i < k; i++)
	{
		int v = -1;
		for (int j = 0; j < k; j++)
			if (d[j] != INF && (v == -1 || d[v] > d[j]) && !used[j])
				v = j;
		if (v == -1)
			break;
		used[v] = true;
		for (int i = 0; i < k; i++)
		{
			int cost = get(a[v].x, a[v].y, a[i].x, a[i].y);
			if (cost + d[v] < d[i])
			{
				d[i] = cost + d[v];
				p[i] = v;
			}
		}
	}
	vector<int> ans;
	int ind = k - 1;
	while (true)
	{
		ans.push_back(ind + 1);
		ind = p[ind];
		if (ind == -1)
			break;
	}
	cout << ans.size() << endl;
	for (int i = ans.size() - 1; i >= 0; i--)
		cout << ans[i] << " ";
	system("pause");
}