#include <iostream>
#include <algorithm>
#include <queue>
#include <vector>
using namespace std;

#define int long long

const int INF = 1e15;

int n;
vector<int> a;

int get(vector<bool> &used, int num)
{
	queue<pair<int, int>> q;
	for (int i = 0; i < n; i++)
		if (used[i])
			q.emplace(i, 0);
	vector<int> x(n, INF);
	int cnt = 0;
	while (q.size())
	{
		cnt++;
		int cur = q.front().first, k = q.front().second;
		q.pop();
		if (cur < 0 || cur == n || k >= x[cur])
			continue;
		x[cur] = k;
		q.emplace(cur - 1, k + 1);
		q.emplace(cur + 1, k + 1);
	}
	int ans = 0;
	for (int i = 0; i < n; i++)
		if (a[i] + x[i] < a[num] + x[num])
			ans++;
	return ans + 1;
}

int ans = 0;

void force(int ind, int num, vector<bool> &used)
{
	if (ind == n)
	{
		bool yes = 0;
		for (auto i : used)
			yes |= i;
		if (!yes)
			return;
		ans = max(ans, get(used, num));
		return;
	}
	force(ind + 1, num, used);
	if (num == ind)
		return;
	used[ind] = true;
	force(ind + 1, num, used);
	used[ind] = false;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int p; cin >> n >> p;
	a.resize(n);
	for (auto &i : a)
		cin >> i;
	for (int i = 0; i < n; i++)
	{
		vector<bool> used(n);
		ans = 0;
		force(0, i, used);
		cout << ans << "\n";
	}
	system("pause");
}