#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;

int solvefast(int n, vector <int> &a) {
	int ans = 0;
	for (int l = 0; l < n; ++l) {
		int mx = a[l];
		int r = l;
		while (r < n && a[r] >= mx) {
			mx = max(mx, a[r]);
			++r;
		}
		++ans;
		l = r;
	}
	return ans;
}

int solveslow(int n, vector <int> &a) {
	int ans = 0;
	for (int l = 0; l < n; ++l) {
		int mx = -1;
		int x = n;
		for (int r = l; r < n; ++r) {
			if (a[r] < a[l]) {
				x = r;
				break;
			}
		}
		for (int r = l; r < x; ++r) {
			mx = max(mx, a[r]);
		}
		for (int r = x - 1; r >= l; --r) {
			if (a[r] == mx) {
				++ans;
				l = r;
			}
		}
	}
	return ans; 
}
void stress() {
	while (true) {
		int n = 8;
		vector <int> a(n);
		for (int i = 0; i < n; ++i) {
			a[i] = rand() % 10 + 1;
		}
		if (solveslow(n, a) != solvefast(n, a)) {
			cout << n << "\n";
			for (auto e : a) {
				cout << e << " ";
			}
			cout << "\n";
			cout << solveslow(n, a) << " " << solvefast(n, a) << "\n";
			exit(0);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	} 
	//stress();
	cout << solvefast(n, a) << "\n";
}