#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cassert>
#include <stack>

using namespace std;

typedef long long ll;


const int bs = 150;
const int N = 4e5 + 7;

vector <pair <int, int>> groups[N / bs + 1];
int mod[N / bs + 1];

void modify(int l, int r) {
	int b1 = l / bs;
	int b2 = r / bs;
	if (b1 == b2) {
		for (auto &e : groups[b1]) {
			if (l <= e.second && e.second <= r) {
				++e.first;
			}
		}
		sort(groups[b1].begin(), groups[b1].end());
	}
	else {
		for (int i = b1 + 1; i < b2; ++i) {
			mod[i] += 1;
		}
		for (auto &e : groups[b1]) {
			if (l <= e.second && e.second <= r) {
				++e.first;
			}
		}
		sort(groups[b1].begin(), groups[b1].end());
		for (auto &e : groups[b2]) {
			if (l <= e.second && e.second <= r) {
				++e.first;
			}
		}
		sort(groups[b2].begin(), groups[b2].end());
	}
}

int get(int l, int r, int val) {
	int b1 = l / bs;
	int b2 = r / bs;
	if (b1 == b2) {
		int ans = 0;
		for (auto &e : groups[b1]) {
			if (l <= e.second && e.second <= r) {
				if (e.first + mod[b1] < val) ++ans;
			}
		}
		return ans;
	}
	else {
		int ans = 0;
		for (int i = b1 + 1; i < b2; ++i) {
			ans += lower_bound(groups[i].begin(), groups[i].end(), make_pair(val - mod[i], 0)) - groups[i].begin();
		}
		for (auto &e : groups[b1]) {
			if (l <= e.second && e.second <= r) {
				if (e.first + mod[b1] < val) ++ans;
			}
		}
		for (auto &e : groups[b2]) {
			if (l <= e.second && e.second <= r) {
				if (e.first + mod[b2] < val) ++ans;
			}
		}
		return ans;
	}
}

int ans[N];
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n, p;
	cin >> n >> p;
	vector <int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	if (p == 1) {
		for (int i = 0; i < n; ++i) {
			groups[i / bs].push_back({a[i], i});
		}
		for (int i = 0; i < (n / bs + 1); ++i) {
			sort(groups[i].begin(), groups[i].end());
		}
		for (int i = 1; i < n; ++i) {
			modify(0, i - 1);
			ans[i] += get(0, i - 1, a[i]);
		}
		for (int i = 0; i < (n / bs + 1); ++i) {
			mod[i] = 0;
			groups[i].clear();
		}
		for (int i = 0; i < n; ++i) {
			groups[i / bs].push_back({a[i], i});
		}
		for (int i = 0; i < (n / bs + 1); ++i) {
			sort(groups[i].begin(), groups[i].end());
		}
		for (int i = n - 2; i >= 0; --i) {
			modify(i + 1, n);
			ans[i] += get(i + 1, n, a[i]);
		}
		for (int i = 0; i < n; ++i) {
			cout << ans[i] + 1 << "\n";
		}
	}
}