#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e5 + 1000;

typedef long long ll;

ll n, arr[MAXN];

struct Tree {
    ll val;
    ll pos;
    Tree *left, *right;
    Tree (ll vl, ll ps) : val(vl), pos(ps), left(NULL), right(NULL) {}
};

void init(Tree *&root, int l, int r) {
    root = new Tree(0, 0);
    if (l + 1 == r) {
        root->val = arr[l];
        root->pos = l;
        return;
    }
    init(root->left, l, (l + r) / 2);
    init(root->right, (l + r) / 2, r);
    if (root->left->val > root->right->val) {
        root->pos = root->left->pos;
    }
    else {
        root->pos = root->right->pos;
    }
    root->val = max(root->left->val, root->right->val);
}

pair <ll, int> MAX(Tree *&root, int l, int r, int a, int b) {
    if (l >= b || a >= r) {
        return make_pair(-1, -1);
    }
    if (l + 1 == r) {
        return make_pair(arr[l], l);
    }
    if (l >= a && r <= b) {
        return make_pair(root->val, root->pos);
    }
    return max(MAX(root->left, l, (l + r) / 2, a, b), MAX(root->right, (l + r) / 2, r, a, b));
}

int main() {

    //freopen("in.in", "r", stdin);

    cin >> n;

    for(int i = 0; i < n; i++) {
        cin >> arr[i];
    }

    int l = 0, r = 0;

    Tree *root;

    init(root, 0, n);

    int ans = 0;

    for(int i = 1; i < n; i++) {
        if (arr[i] >= arr[l]) {
            r++;
        }
        else {
            while(l <= r) {
                pair <ll, int> p;
                p = MAX(root, 0, n, l, r + 1);
                ans++;
                l = p.second + 1;
            }
            r = l;
        }
    }

    while(l <= r) {
        pair <ll, int> p;
        p = MAX(root, 0, n, l, r + 1);
        ans++;
        l = p.second + 1;
    }

    cout << ans;

    return 0;
}
