#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Node{
    int x = 0;
    int l = 0, r = 0;
    Node * left = 0;
    Node * right = 0;
    Node()
    {
        x = 0;
        l = 0;
        r = 0;
    }
};

vector<int> v;

Node *build (int l, int r)
{
    Node * root = new Node();
    root->l = l;
    root->r = r;
    if (l == r - 1)
    {
        root->x = v[l];
    }
    else
    {
        int m = (l + r) / 2;
        root->left = build(l, m);
        root->right = build(m, r);
        root->x = max(root->left->x, root->right->x);
    }
    return root;
}

int get(Node *root,  int l, int r)
{
    if (l <= root->l && r >= root->r)
    {
        return root->x;
    }
    else
    {
        int m1 = 0;
        int m2 = 0;
        if (r > (root->r + root->l) / 2)
        {
            m2 = get(root->right, l, r);
        }
        if (l < (root->r + root->l) / 2)
        {
            m1 = get(root->left, l, r);
        }
        return max(m1, m2);
    }
}

struct Node1{
    int x = 0;
    int l = 0, r = 0;
    Node1 * left = 0;
    Node1 * right = 0;
    Node1()
    {
        x = 0;
        l = 0;
        r = 0;
    }
};

Node1 *build1 (int l, int r)
{
    Node1 * root = new Node1();
    root->l = l;
    root->r = r;
    if (l == r - 1)
    {
        root->x = v[l];
        return root;
    }
    else
    {
        int m = (l + r) / 2;
        root->left = build1(l, m);
        root->right = build1(m, r);
        root->x = min(root->left->x, root->right->x);
        return root;
    }
}

int get1(Node1 *root,  int l, int r)
{
    if (l <= root->l && r >= root->r)
    {
        return root->x;
    }
    else
    {
        int m1 = 1e10;
        int m2 = 1e10;
        if (r > (root->r + root->l) / 2)
        {
            m2 = get1(root->right, l, r);
        }
        if (l < (root->r + root->l) / 2)
        {
            m1 = get1(root->left, l, r);
        }
        return min(m1, m2);
    }
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    v.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> v[i];
    }
    Node * root = build(0, n);
    vector<int> nb(n, n + 1);
    for(int i = n - 1; i >= 0; i--)
    {
        int l = i, r = n;
        while (l + 1 < r)
        {
            int m = (l + r) / 2;
            if (get(root, i + 1, m + 1) >= v[i])
            {
                r = m;
            }
            else
            {
                l = m;
            }
        }
        nb[i] = r;
    }
    Node1 * root1 = build1(0, n);
    vector<int> nm(n, n + 1);
    for(int i = n - 1; i >= 0; i--)
    {
        int l = i, r = n;
        while (l + 1 < r)
        {
            int m = (l + r) / 2;
            if (get1(root1, i + 1, m + 1) < v[i])
            {
                r = m;
            }
            else
            {
                l = m;
            }
        }
        nm[i] = r;
    }
    int s = 0;
    int ans = 0;
    while (s < n)
    {
        ans++;
        if (s == n - 1)
        {
            s++;
            continue;
        }
        if (v[s + 1] < v[s])
        {
            s++;
            continue;
        }
        int i = s + 1;
        while (nb[i] < nm[s] && i < n)
        {
            i = nb[i];
        }
        s = i + 1;
    }
    cout << ans;
    return 0;
}




//set<pair<int, int>> s1;
//    vector<int> nb(n, n + 1);
//    for(int i = n - 1; i >= 0; i--)
//    {
//        auto x = s1.lower_bound({v[i], i});
//        if (x != s1.end())
//        {
//            nb[i] = (*x).second;
//        }
//        s1.insert({v[i] - 1, i});
//    }
//    set<pair<int, int>> s2;
//    vector<int> nm(n, n + 1);
//    for(int i = n - 1; i >= 0; i--)
//    {
//        auto x = s2.lower_bound({-v[i], i});
//        if (x != s2.end())
//        {
//            nm[i] = (*x).second;
//        }
//        s2.insert({-(v[i]) - 1, i});
//    }
//    for (int i = 0; i < n; i++)
//    {
//        cout << nm[i] << nb[i] << endl;
//    }
