#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
#define mp make_pair
#define pb push_back
#define int long long
typedef vector<int> lint;

const int LEN = 10009;
const ll INF = (ll)1e18;
const int BASE = 1e9;

lint operator + (lint a, lint b) {
    if (a.size() < b.size())
        swap(a, b);

    int curr = 0;
    for (int i = 0; i < a.size() || curr != 0; i++) {
        if (i >= a.size())
            a.pb(0);

            a[i] += curr + (i >= b.size() ? 0 : b[i]);

            curr = (a[i] / BASE);

            if (curr) {
                a[i] -= BASE;
            }
    }

    while (a.size() > 0 && a.back() == 0)
        a.pop_back();

    return a;
}

lint operator * (lint a, lint b) {
    lint c = vector <int>(a.size() + b.size(), 0);

    for (int i = 0; i < a.size(); i++) {
        for (int j = 0, curr = 0; j < b.size() || curr != 0; j++) {
            ll tmp = (ll)c[i + j] + (ll)curr + (ll)a[i] * (j >= b.size() ? 0 : b[j]);

            c[i + j] = tmp % BASE;

            curr =  tmp / (ll)BASE;

            if (curr) {

                c[i + j] -= (ll)curr * BASE;
            }
        }
    }

    while (c.size() > 0 && c.back() == 0)
        c.pop_back();

    return c;
}

bool operator < (lint a, lint b) {
    if (a.size() < b.size())
        return true;

    if (a.size() > b.size())
        return false;

    for (int i = a.size() - 1; i >= 0; i--) {
        if (a[i] == b[i])
            continue;

        return a[i] < b[i];
    }

    return false;
}


lint binPow(lint a, int b) {
    if (b == 0)
        return vector<int>(1, 1);

    if (b % 2 == 0) {
        lint c = binPow(a, b / 2);

        return c * c;
    } else {
        lint c = binPow(a, b - 1);

        return c * a;
    }
}

bool operator < (pair<lint, int> a, pair<lint, int> b) {
    return a.first < b.first;
}

int n, m, k;

pair <int, int> coord[LEN];
lint dist[LEN];
bool used[LEN];
int par[LEN];

lint two = vector<int>(1, 2);
lint inf = vector<int>(3);

signed main() {
    inf[2] = 1;

    cin >> n >> m >> k;

    fill(dist, dist + LEN, inf);

    for (int i = 0; i < k; i++) {
        cin >> coord[i].first >> coord[i].second;
    }

    dist[0] = vector<int>(1, 0);

    set <pair<lint, int> > st;
    st.insert(mp(vector<int>(1, 0), 0));

    while (!st.empty()) {
        int v = (*st.begin()).second;

        st.erase(st.begin());

        for (int i = 0; i < k; i++) {
            if (i == v)
                continue;

            if (dist[i] < dist[v] + binPow(two,
                                           max(abs(
                                            coord[v].first - coord[i].first
                                            ),
                                        abs(
                                            coord[v].second - coord[i].second
                                            ))
                                           ))
            continue;

            st.erase(mp(dist[i], i));
            dist[i] = dist[v] + binPow(two,
                                           max(abs(
                                            coord[v].first - coord[i].first
                                            ),
                                        abs(
                                            coord[v].second - coord[i].second
                                            ))
                                           );
            par[i] = v;
            st.insert(mp(dist[i], i));
        }
    }

    int v = k - 1;

    vector <int> ans;

    while (v != 0) {
        ans.pb(v + 1);

        v = par[v];
    }

    ans.pb(1);

    cout << ans.size() << "\n";
    for (int i = ans.size() - 1; i >= 0; i--)
        cout << ans[i] << " ";

    return 0;
}


