#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <functional>

using namespace std;

#pragma warning (disable : 4996)

const int MAXN = 1e4;

int n, m, k, a[MAXN], b[MAXN], pr[MAXN], was[MAXN];
long double dist[MAXN];

long double pw(int x) {
	if (x == 0) return 1;
	if (x % 2 == 0) {
		return pw(x / 2) * pw(x / 2);
	}
	else {
		return pw(x / 2) * pw(x / 2) * 2;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	cin >> n >> m >> k;
	for (int i = 0; i < k; i++) {
		cin >> a[i] >> b[i];
		a[i]--;
		b[i]--;
		dist[i] = 1;
	}

	std::priority_queue<pair < long double, int >, std::vector <pair < long double, int > >, std::greater< pair < long double, int > > > q;

	q.push(make_pair(0, 0));
	dist[0] = 0;

	while (q.size()) {
		while (q.size() && was[q.top().second] == 1) q.pop();
		if (!q.size()) continue;
		int v = q.top().second;
		long double d = q.top().first;
		was[v] = 1;
		for (int i = 0; i < k; i++) {
			if (was[i] == 0) {
				if (dist[i] == 1 || dist[i] >= dist[v] + pw(max(abs(a[v] - a[i]), abs(b[v] - b[i])))) {
					dist[i] = dist[v] + pw(max(abs(a[v] - a[i]), abs(b[v] - b[i])));
					pr[i] = v;
					q.push(make_pair(dist[i], i));
				}
			}
		}
	}
	int now = k - 1;
	vector < int > ans;
	while (now != 0) {
		ans.push_back(now);
		now = pr[now];
	}
	cout << ans.size() + 1 << "\n" << "1 ";
	reverse(ans.begin(), ans.end());
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] + 1 << " ";
	}
}