#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <functional>
#include <string>
#include <cstring>
#include <string.h>

using namespace std;

#pragma warning (disable : 4996)

const int MAXN = 1e4 + 9;
const __int128 MOD = __int128(1) << 120;

int n, m, k, a[MAXN], b[MAXN], pr[MAXN], was[MAXN];
vector < __int128 > dorov[MAXN], dist[MAXN];

vector < __int128 > pw(int x) {
	vector < __int128 > ans(9);
	int l = 9 - x / 120;
	ans[l] += __int128(1) << (x % 120);
	for (; l > -1; l--) {
		ans[l - 1] += ans[l] >> 120;
		ans[l] &= MOD - 1;
	}
	return ans;
}

vector < __int128 > sum(const vector < __int128 > &a, const vector < __int128 > &b) {
	vector < __int128 > ans = a;
	ans[9] += b[9];
	for (int i = 9; i > -1; i--) {
		ans[i] += ans[i + 1] >> 120;
		ans[i + 1] &= MOD - 1;
		ans[i] += b[i];
	}
	return ans;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	cin >> n >> m >> k;
	n = max(n, m);
	vector<__int128> inf(9, -1);
	for (int i = 0; i < k; i++) {
		cin >> a[i] >> b[i];
		a[i]--;
		b[i]--;
		dist[i] = inf;
	}
	for (int i = 0; i < n; i++) {
		dorov[i] = pw(i);
	}

	std::priority_queue<pair < vector < __int128 >, int >, std::vector <pair < vector < __int128 >, int > >, std::greater< pair < vector < __int128 >, int > > > q;

	q.push(make_pair(vector<__int128>(9, 0), 0));
	dist[0] = vector<__int128>(9, 0);


	while (q.size()) {
		while (q.size() && was[q.top().second] == 1) q.pop();
		if (!q.size()) continue;
		int v = q.top().second;
		was[v] = 1;
		for (int i = 0; i < k; i++) {
			if (was[i] == 0) {
				int l = max(abs(a[v] - a[i]), abs(b[v] - b[i]));
				if (dist[i] == inf || dist[i] >= sum(dist[v], dorov[l])) {
					dist[i] = sum(dist[v], dorov[l]);
					pr[i] = v;
					q.push(make_pair(dist[i], i));
				}
			}
		}
	}
	int now = k - 1;
	vector < int > ans;
	while (now != 0) {
		ans.push_back(now);
		now = pr[now];
	}
	cout << ans.size() + 1 << "\n" << "1 ";
	reverse(ans.begin(), ans.end());
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] + 1 << " ";
	}
}