#include <iostream>
#include <vector>
#include <random>
#include <ctime>

using namespace std;

uniform_int_distribution <int> rnd1(-1e9, 1e9);
mt19937 rnd2;

int rnd(){
    return rnd1(rnd2);
}

struct node {
    node *left, *right;
    int cnt, add;
    int x, y;
    node(int _x, int _y){
        x = _x;
        y = _y;
        cnt = 1;
        add = 0;
        left = nullptr;
        right = nullptr;
    }
};

int get_cnt(node* root){
    return (root == nullptr ? 0 : root -> cnt);
}

void update(node* root){
    int cnt = 1;
    if (root -> left != nullptr){
        root -> left -> add += root -> add;
        cnt += root -> left -> cnt;
    }
    if (root -> right != nullptr){
        root -> right -> add += root -> add;
        cnt += root -> right -> cnt;
    }
    root -> x += root -> add;
    root -> add = 0;
    root -> cnt = cnt;
}

node* merge(node* left, node* right){
    if (left == nullptr){
        return right;
    }
    if (right == nullptr){
        return left;
    }
    if (left -> y > right -> y){
        update(left);
        left -> right = merge(left -> right, right);
        update(left);
        return left;
    }
    else {
        update(right);
        right -> left = merge(left, right -> left);
        update(right);
        return right;
    }
}

pair <node*, node*> split(node* root, int need){
    if (root == nullptr){
        return {nullptr, nullptr};
    }
    update(root);
    if (root -> x >= need){
        auto r1 = split(root -> left, need);
        root -> left = r1.second;
        update(root);
        return {r1.first, root};
    }
    else {
        auto r1 = split(root -> right, need);
        root -> right = r1.first;
        update(root);
        return {root, r1.second};
    }
};

pair <node*, int> add(node* root, int x){
    auto r1 = split(root, x);
    int res = get_cnt(r1.first);
    root = merge(r1.first, merge(new node(x, rnd()), r1.second));
    root -> add++;
    return {root, res};
}

void print(node* root){
    if (root == nullptr){
        return;
    }
    update(root);
    print(root -> left);
    cout << root -> x << " ";
    print(root -> right);
}

int count(node* root, int x){
    auto r1 = split(root, x);
    int res = get_cnt(r1.first);
    merge(r1.first, r1.second);
    return res;
}

void pls(node* root){
    if (root != nullptr){
        root -> add++;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    rnd2.seed(time(NULL));
    int n, p;
    cin >> n >> p;
    vector <int> a(n);
    vector <int> res(n, 1);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    node* root = nullptr;
    for (int i = 0; i < n; i++){
        auto k = add(root, a[i]);
        res[i] += k.second;
        root = k.first;
    }
    root = nullptr;
    for (int i = n - 1; i >= 0; i--){
        auto k = add(root, a[i]);
        res[i] += k.second;
        root = k.first;
    }
    for (int i = 0; i < n; i++){
        cout << res[i] << endl;
    }
    return 0;
}