#include <iostream>
#include <vector>
#include <random>
#include <ctime>
#include <algorithm>

using namespace std;

uniform_int_distribution <int> rnd1(-1e9, 1e9);
mt19937 rnd2;

int rnd(){
    return rnd1(rnd2);
}

struct node {
    node *left, *right;
    int cnt, add;
    int rcnt;
    int x, y;
    node(int _x, int _y){
        x = _x;
        y = _y;
        cnt = 1;
        rcnt = 1;
        add = 0;
        left = nullptr;
        right = nullptr;
    }
};

int get_cnt(node* root){
    return (root == nullptr ? 0 : root -> cnt);
}

void update(node* root){
    int cnt = root -> rcnt;
    if (root -> left != nullptr){
        root -> left -> add += root -> add;
        cnt += root -> left -> cnt;
    }
    if (root -> right != nullptr){
        root -> right -> add += root -> add;
        cnt += root -> right -> cnt;
    }
    root -> x += root -> add;
    root -> add = 0;
    root -> cnt = cnt;
}

node* merge(node* left, node* right){
    if (left == nullptr){
        return right;
    }
    if (right == nullptr){
        return left;
    }
    if (left -> y > right -> y){
        update(left);
        left -> right = merge(left -> right, right);
        update(left);
        return left;
    }
    else {
        update(right);
        right -> left = merge(left, right -> left);
        update(right);
        return right;
    }
}

pair <node*, node*> split(node* root, int need){
    if (root == nullptr){
        return {nullptr, nullptr};
    }
    update(root);
    if (root -> x >= need){
        auto r1 = split(root -> left, need);
        root -> left = r1.second;
        update(root);
        return {r1.first, root};
    }
    else {
        auto r1 = split(root -> right, need);
        root -> right = r1.first;
        update(root);
        return {root, r1.second};
    }
};

pair <node*, int> add(node* root, int x, int pls = 0){
    auto r1 = split(root, x);
    auto r2 = split(r1.second, x + 1);
    int res = get_cnt(r1.first);
    if (r2.first == nullptr){
        r2.first = new node(x, rnd());
    }
    else {
        r2.first -> rcnt++;
        r2.first -> cnt++;
    }
    root = merge(r1.first, merge(r2.first, r2.second));
    root -> add += pls;
    return {root, res};
}

void print(node* root){
    if (root == nullptr){
        return;
    }
    update(root);
    print(root -> left);
    cout << root -> x << " ";
    print(root -> right);
}

int count(node* root, int x){
    auto r1 = split(root, x);
    int res = get_cnt(r1.first);
    merge(r1.first, r1.second);
    return res;
}

void pls(node* root){
    if (root != nullptr){
        root -> add++;
    }
}

node* dell(node* root, int x){
    auto r1 = split(root, x);
    auto r2 = split(r1.second, x + 1);
    r2.first -> rcnt--;
    r2.first -> cnt--;
    if (r2.first -> cnt == 0){
        return merge(r1.first, r2.second);
    }
    return merge(r1.first, merge(r2.first, r2.second));
}

int read_int(){
    int c = getchar();
    while (c > '9' || c < '0'){
        c = getchar();
    }
    int res = 0;
    while ('0' <= c && c <= '9'){
        res *= 10;
        res += c - '0';
        c = getchar();
    }
    return res;
}

int rev(int n, int k){
    return n - 1 - k;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    rnd2.seed(time(NULL));
    int n = read_int(), p = read_int();
    vector <int> res1(n, 1), res2(n, 1), res3(n, 1);
    vector <int> a(n);
    vector <pair <int, int> > ska, poa;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        ska.push_back(make_pair(a[i] + i, i));
        poa.push_back(make_pair(a[i] - i, i));
    }
    sort(poa.begin(), poa.end());
    sort(ska.begin(), ska.end());
    int pr = 0;
    int pr2 = 0;
    for (int i = 0; i < n; i++){
        if (i != 0 && ska[i].first != ska[i - 1].first){
            pr = i;
        }
        if (i != 0 && poa[i].first != poa[i - 1].first){
            pr2 = i;
        }
        res1[ska[i].second] = pr + 1;
        res2[poa[i].second] = pr2 + 1;
    }
    for (int i = 0; i < n; i++){
        cout << res1[i] << " " << res2[i] << endl;
    }
    node* root = nullptr;
    node* root2 = nullptr;
    for (int i = 0; i < (n + 1) / 2; i++){
        auto k = add(root, a[i], 1);
        res3[i] += k.second;
        k = add(root2, a[n - 1 - i], 1);
        res3[n - 1 - i] += k.second;
    }
    root = nullptr;
    root2 = nullptr;
    for (int i = 2; i < n / 2; i++){
        add(root, a[i * 2 - 2], 1);
        add(root, a[i * 2 - 1], 1);
        res3[i] += count(root, a[i] + i);
        dell(root, a[i] + i);
        add(root2, a[rev(n, i * 2 - 2)], 1);
        add(root2, a[rev(n, i * 2 - 1)], 1);
        res3[i] += count(root2, a[n - 1 - i] + i);
        dell(root2, a[n - 1 - i] + i);
    }
    root = nullptr;
    root2 = nullptr;
    if (n % 2 == 1){
        add(root, a[n - 1]);
        add(root2, a[0]);
        for (int i = 1; i < n / 2; i++){
            add(root, a[n - 1 - i * 2]);
            add(root, a[n - i * 2]);
            res3[n / 2 - i] += count(root, a[n / 2 - i]);
            add(root2, a[i * 2]);
            add(root2, a[i * 2 - 1]);
            res3[n / 2 + i] += count(root2, a[n / 2 + i]);
        }
    }
    else {
        for (int i = 1; i < n / 2; i++){
            add(root, a[n - 1 - i * 2]);
            add(root, a[n - i * 2]);
            res3[n / 2 - i] += count(root, a[n / 2 - i]);
            add(root2, a[i * 2]);
            add(root2, a[i * 2 - 1]);
            res3[n / 2 + i] += count(root2, a[n / 2 + i]);
        }
    }
    for (int i = 0; i < n; i++){
        cout << max(res1[i], max(res2[i], res3[i]));
    }
    return 0;
}