#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <bitset>
#define ll long long
#define fr first
#define sc second
using namespace std;
struct point {
	int x, y;
	point(int a = 0, int b = 0) : x(a), y(b) {}
};
bitset <1000> inf, bnull;

bool operator<(const bitset<1000> &a, const  bitset<1000> &b) {
	for (int i = 999; i >= 0; i--) {
		if (a[i] != b[i])
			return a[i] < b[i];
	}
	return 0;
}
bitset<1000> operator+(const bitset<1000> &a, const bitset<1000> &b) {
	int d = 0;
	bitset <1000> c;
	for (int i = 0; i < 1000; i++) {
		int cur = d;
		if (a[i])
			cur++;
		if (b[i])
			cur++;
		if (cur >= 2)
			d = 1, cur -= 2;
		else
			d = 0;
		c[i] = cur;
	}
	return c;
}

int dist(point a, point b) {
	return max(abs(a.x - b.x), abs(a.y - b.y));
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	vector <point> p(k);
	for (int i = 0; i < k; i++)
		cin >> p[i].x >> p[i].y;
	inf.flip();

	vector <bitset<1000> > d(k, inf);
	d[0] = bnull;
	vector <int> used(k, 0);
	vector <int> prev(k, -1);
	for (int i = 0; i < k; i++) {
		int num = -1;
		for (int j = 0; j < k; j++)
			if ((!used[j]) && ((num == -1) || (d[j] < d[num])))
				num = j;
		used[num] = 1;
		for (int j = 0; j < k; j++) {
			if (used[j])
				continue;
			bitset<1000> w = bnull;
			w[dist(p[num], p[j])] = 1;
			if ((d[j] == inf) || ((w + d[num]) < d[j]))
				d[j] = w + d[num], prev[j] = num;
		}
	}
	vector <int> way;
	int v = k - 1;
	while (v != -1)
		way.push_back(v), v = prev[v];
	reverse(way.begin(), way.end());
	cout << way.size() << "\n";
	for (int v : way)
		cout << v + 1 << " ";
	return 0;
}