#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>

using namespace std;

vector<int> solve1(vector<vector<int> > a, int n) {
	vector<vector<int> > pos(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			pos[i][a[i][j]] = j;
		}
	}
	vector<bool> ok(n);
	vector<int> ans;
	for (int i = 0; i < n; i++) {
		vector<vector<int> > all;
		for (int j = 0; j <= i; j++) {
			int cur = a[i][j];
			bool bad = 0;
			for (int x = 0; x < (int)all.size(); x++) {
				int mx;
				if (all[x].empty()) mx = -1;
				else mx = *(max_element(all[x].begin(), all[x].end()));
				if (mx < j) {
					bad = 1;
					break;
				}
			}
			if (!bad) {
				ok[cur] = 1;
			}
			all.push_back({});
			for (int x = 0; x < pos[cur][cur]; x++) {
				int elem = a[cur][x];
				//cout << "added " << pos[i][elem] << endl;
				all.back().push_back(pos[i][elem]);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (ok[i]) ans.push_back(i);
	}
	return ans;
}

vector<int> solve2(vector<vector<int> > a, int n) {
	vector<vector<int> > pos(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			pos[i][a[i][j]] = j;
		}
	}
	vector<int> ans;
	for (int cur = 0; cur < n; cur++) {
		bool ok = 0;
		for (int i = 0; i < n; i++) {
			if (pos[i][cur] > pos[i][i]) continue;
			bool found = 0;
			for (int j = 0; j < pos[i][cur]; j++) {
				int nxt = a[i][j];
				bool t = 0;
				for (int k = 0; k < pos[nxt][nxt]; k++) {
					if (pos[i][i] <= pos[i][a[nxt][k]]) {
						t = 1;
						break;
					}
				}
				if (!t) {
					found = 1;
					break;
				}
			}
			if (!found) {
				ok = 1;
				break;
			}
		}
		if (ok) {
			ans.push_back(cur);
		}
	}
	return ans;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n;
	cin >> n;
	vector<vector<int> > a(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> a[i][j];
			a[i][j]--;
		}
	}
	vector<int> ans;
	int p;
	cin >> p;
	if (p == 1) {
		for (int i = 0; i < n; i++) {
			if (a[i][0] == i) ans.push_back(i);
		}
	}
	else {
		//auto ans1 = solve1(a, n);
		auto ans2 = solve2(a, n);
		//assert(ans1.size() >= ans2.size());
		ans = ans2;
	}
	cout << (int)ans.size() << endl;
	for (int elem : ans) {
		cout << elem + 1 << ' ';
	}
	cout << endl;
    return 0;
}

