#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

struct line {
	double k = 0, b = 0;
};

double inter(line l1, line l2) {
	return (l1.b - l2.b) / (l2.k - l1.k);
}

double at(line l, int x) {
	return l.k * x + l.b;
}

vector<pair<double, int> > st;
vector<line> all;

void add(int i) {
	while (!st.empty()) {
		int num = st.back().second;
		double x = st.back().first;
		if (inter(all[num], all[i]) > x) break;
		st.pop_back();
	}
	pair<double, int> elem = { 0, i };
	if (!st.empty()) elem.first = inter(all[st.back().second], all[i]);
	st.push_back(elem);
}

double query(int x) {
	auto elem = *--upper_bound(st.begin(), st.end(), make_pair((double)x, 1000000000));
	int num = elem.second;
	return at(all[num], x);
}

int main()
{
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		a[i] = x;
	}
	sort(a.begin(), a.end());
	all.resize(n);
	for (int i = 0; i < n; i++) {
		all[i].k = a[i], all[i].b = -i * a[i];
	}
	double ans = 0;
	for (int i = 0; i < n; i++) {
		add(i);
		ans = max(ans, query(i) + a[i] * (n - i));
	}
	ans = max(ans, query(n));
	cout << (long long)ans << endl;
    return 0;
}

