#include <iostream>
#include <vector>
#include <algorithm>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,avx,mmx,abm,popcnt,tune=native")

using namespace std;

const int maxn = 4001;

static int ans[maxn];

struct fenw {
	vector<int> t;
	void init(int n) {
		t.assign(n, 0);
	}
	void update(int i, int d) {
		while (i < (int)t.size()) {
			t[i] += d;
			i = (i | (i + 1));
		}
	}
	int sum(int i) {
		int ans = 0;
		while (i >= 0) {
			//cout << i << endl;
			ans += t[i];
			i = (i & (i + 1)) - 1;
		}
		return ans;
	}
};

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n, p;
	cin >> n >> p;
	vector<int> a(n), ax(n), ay(n), az(n), a1(n), a2(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		a1[i] = a[i] + i;
		a2[i] = a[i] + (n - i - 1);
	}
	vector<int> all;
	for (int i = 0; i < n; i++) {
		all.push_back(a[i]);
		all.push_back(a[i] + i);
		all.push_back(a[i] - i);
	}
	sort(all.begin(), all.end());
	sort(a1.begin(), a1.end());
	sort(a2.begin(), a2.end());
	for (int i = 0; i < n; i++) {
		ax[i] = lower_bound(all.begin(), all.end(), a[i] - i) - all.begin();
		ay[i] = lower_bound(all.begin(), all.end(), a[i]) - all.begin();
		az[i] = lower_bound(all.begin(), all.end(), a[i] + i) - all.begin();
	}
	fenw t1, t2;
	t1.init(all.size()), t2.init(all.size());
	t1.update(ay[0], 1);
	int j = 0;
	for (int i = 1; i < n - 1; i++) {
		int d = n - i - 1;
		while (j < i - d) {
			j++;
			int ind1 = ay[j];
			int ind2 = az[j];
			t1.update(ind1, 1), t2.update(ind2, -1);
		}
		ans[i] += t1.sum(lower_bound(all.begin(), all.end(), a[i] + min(i, d)) - all.begin() - 1) +
			t2.sum(az[i] - 1);
		t2.update(az[i], 1);
	}
	t1.init(all.size()), t2.init(all.size());
	t1.update(ay[n - 1], 1);
	j = n - 1;
	for (int i = n - 2; i >= 1; i--) {
		int d = i;
		while (j > i + d) {
			j--;
			int ind1 = ay[j];
			int ind2 = ax[j];
			t1.update(ind1, 1), t2.update(ind2, -1);
		}
		ans[i] += t1.sum(lower_bound(all.begin(), all.end(), a[i] + min(n - i - 1, d)) - all.begin() - 1) +
			t2.sum(ax[i] - 1);
		t2.update(ax[i], 1);
	}
	for (int i = 0; i < n; i++) {
		int var1 = lower_bound(a1.begin(), a1.end(), a[i] + i) - a1.begin();
		int var2 = lower_bound(a2.begin(), a2.end(), a[i] + (n - i - 1)) - a2.begin();
		if (i == 0 || i == n - 1) {
			cout << max(var1, var2) + 1 << '\n';
		}
		else {
			cout << max(max(var1, var2), ans[i]) + 1 << '\n';
		}
	}
    return 0;
}

