#include <iostream>
#include <cstdio>
#include <vector>
#include <deque>
#include <cmath>
#include <algorithm>
typedef long long ll;
typedef long double ld;

using namespace std;

const int N = 400001, M = 1 << 19;
int n, p;
int a[N], ans[N];
int tr[M * 2];

void init() {
	for (int i = 0; i < M * 2; i++)
		tr[i] = 0;
}
void add(int v) {
	for (int i = M + v; i > 0; i /= 2)
		tr[i]++;
}
int sum(int cl, int cr, int v=1, int l=0, int r=M) {
	if (cr <= l || r <= cl)
		return 0;
	if (cl <= l && r <= cr)
		return tr[v];
	return sum(cl, cr, v * 2, l, (l + r) / 2) + sum(cl, cr, v * 2 + 1, (l + r) / 2, r);
}

void solve1() {
	vector<int> x(n);
	for (int i = 0; i < n; i++)
		x[i] = a[i] - i;
	sort(x.begin(), x.end());
	init();
	for (int i = 0; i < n; i++) {
		int pos = lower_bound(x.begin(), x.end(), a[i] - i) - x.begin();
		ans[i] += sum(0, pos);
		add(pos);
	}
	for (int i = 0; i < n; i++)
		x[i] = a[i] + i;
	sort(x.begin(), x.end());
	init();
	for (int i = n - 1; i >= 0; i--) {
		int pos = lower_bound(x.begin(), x.end(), a[i] + i) - x.begin();
		ans[i] += sum(0, pos);
		add(pos);
	}
}


void solve2() {
	vector<int> x(n);
	for (int i = 0; i < n; i++)
		x[i] = a[i] + i;
	sort(x.begin(), x.end());
	for (int i = 0; i < n; i++)
		ans[i] = max(ans[i], (int) (lower_bound(x.begin(), x.end(), a[i] + i) - x.begin()));
	for (int i = 0; i < n; i++)
		x[i] = a[i] + n - 1 - i;
	sort(x.begin(), x.end());
	for (int i = 0; i < n; i++)
		ans[i] = max(ans[i], (int) (lower_bound(x.begin(), x.end(), a[i] + n - 1 - i) - x.begin()));
	for (int i = 0; i < n; i++)
		x[i] = min(a[i] + i, a[i] + n - 1 - i);
	sort(x.begin(), x.end());
	for (int i = 0; i < n; i++)
		ans[i] = max(ans[i], (int) (lower_bound(x.begin(), x.end(), min(a[i] + i, a[i] + n - 1 - i)) - x.begin()));
}

void solve3() {
	int ca;
	for (int i = 0; i < n; i++) {
		for (int j = min(i, n - 1 - i); j <= min(i, n - 1 - i); j++) {
			ca = 0;
			for (int k = 0; k < n; k++)
				if (a[k] + max(j - abs(i - k), 0) < a[i] + j)
					ca++;
			ans[i] = max(ans[i], ca);
		}
		ca = 0;
		for (int k = 0; k < n; k++)
			if (a[k] + k < a[i] + i)
				ca++;
		ans[i] = max(ans[i], ca);
		ca = 0;
		for (int k = 0; k < n; k++)
			if (a[k] + max(n - 1 - k, 0) < a[i] + max(n - 1 - i, 0))
				ca++;
		ans[i] = max(ans[i], ca);
	}
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d", &n, &p);
	for (int i = 0; i < n; i++)
		scanf("%d", &a[i]);
	if (p == 1)
		solve1();
	else
		solve3();
	for (int i = 0; i < n; i++)
		printf("%d\n", ans[i] + 1);
}