#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

const int MAXN = 507;

int a[MAXN][MAXN];
int num[MAXN][MAXN];

void solve1(int n) {
    vector <int> ans;
    for (int i = 1; i <= n; ++i) {
        if (num[i][i - 1] == 0) {
            ans.push_back(i);
        }
    }

    cout << ans.size() << '\n';
    for (int elem : ans) {
        cout << elem << ' ';
    }
    cout << '\n';
}

bool check1(int n, int c, int want, vector <bool> get) {
    vector <bool> want_del(n + 1);
    for (int i = 0; i < num[c][want]; ++i) {
        want_del[a[want][i]] = true;
    }

    vector <bool> can(n + 1);
    for (int i = 0; i < n; ++i) {
        if (!get[i] && !want_del[i + 1]) {
            can[i + 1] = true;
        }
    }

    for (int i = 0; i < n; ++i) {
        if (!get[i] && want_del[i + 1]) {
            bool can_del = false;
            for (int j = 0; j < num[i + 1][i]; ++j) {
                if (can[a[i][j]]) {
                    can_del = true;
                    break;
                }
            }
            if (!can_del) return false;
        }
    }

    return true;
}

bool check(int n, int c) {
    vector <bool> get(n);
    for (int i = 0; i < n; ++i) {
        if (num[c][i] <= num[i + 1][i]) get[i] = true;
    }

    for (int i = 0; i < n; ++i) {
        if (get[i]) {
            if (check1(n, c, i, get)) return true;
        }
    }

    return false;
}

void solve2(int n) {
    vector <int> ans;
    for (int i = 1; i <= n; ++i) {
        if (check(n, i)) ans.push_back(i);
    }

    cout << ans.size() << '\n';
    for (int elem : ans) {
        cout << elem << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);

    int n;
    cin >> n;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
            num[a[i][j]][i] = j;
        }
    }

    int p;
    cin >> p;

    if (p == 1) {
        solve1(n);
    }
    else {
        solve2(n);
    }

    return 0;
}

