#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

const int MAXN = 11007;

struct Point {
    int x, y, num;
};

bool dist[MAXN][MAXN];
int anc[MAXN];
bool nv[MAXN];

void mcopy(bool a[], bool b[]) {
    for (int i = 0; i < MAXN; ++i) b[i] = a[i];
}

bool mless(bool a[], bool b[]) {
    for (int i = MAXN - 1; i >= 0; --i) {
        if (!a[i] && b[i]) return true;
        if (!b[i] && a[i]) return false;
    }
    return false;
}

void add(bool a[], int pos) {
    for (int i = pos; i < MAXN; ++i) {
        if (!a[i]) {
            a[i] = true;
            break;
        }
        else {
            a[i] = false;
        }
    }
}

int getr(Point a, Point b) {
    return max(abs(a.x - b.x), abs(a.y - b.y));
}

void print(bool a[]) {
    for (int i = 0; i < 10; ++i) cout << a[i];
    cout << '\n';
}

bool comp(Point a, Point b) {
    return max(a.x, a.y) < max(b.x, b.y);
}

int pos[MAXN];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    freopen("input.txt", "r", stdin);

    int n, m, k;
    cin >> n >> m >> k;

    vector <Point> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].x >> a[i].y;
        a[i].num = i;
    }
    sort(a.begin(), a.end(), comp);

    for (int i = 1; i < k; ++i) {
        if (max(a[i].x, a[i].y) == max(a[i - 1].x, a[i - 1].y)) {
            pos[i] = pos[i - 1];
        }
        else {
            pos[i] = pos[i - 1] + 1;
        }
    }

    for (int i = 0; i < k; ++i) anc[i] = -1;

    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < MAXN; ++j) {
            dist[i][j] = true;
        }
    }

    for (int i = 0; i < MAXN; ++i) dist[0][i] = false;

    for (int i = 0; i < k; ++i) {
        for (int j = i + 1; j < k; ++j) {
            mcopy(dist[i], nv);
            add(nv, getr(a[i], a[j]));
            if (mless(nv, dist[j])) {
                anc[a[j].num] = a[i].num;
                mcopy(nv, dist[j]);
            }
        }
    }

    vector <int> ans;
    int curr = k - 1;
    while (curr != -1) {
        ans.push_back(curr);
        curr = anc[curr];
    }
    reverse(ans.begin(), ans.end());

    cout << ans.size() << '\n';
    for (int elem : ans) {
        cout << elem + 1 << ' ';
    }
    cout << '\n';

    return 0;
}

