#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <fstream>
#include <queue>
#include <random>
#include <time.h>

using namespace std;

const int MAXN = 4e5 + 7;
const int INF = 2e9 + 7;

mt19937 rnd(rand());

int a[MAXN];
int ans[MAXN];

void upd(int p, int n) {
    multiset <int> ms;

    int rs = min(p, n - 1 - p);
    int curr = 0;

    for (int i = 0; i < n; ++i) {
        if (i == p) continue;

        if (rs <= abs(i - p)) {
            ms.insert(a[i]);
        }
        else {
            if (a[i] < a[p] + abs(i - p)) {
                ++curr;
            }
        }
    }

    ans[p] = max(ans[p], curr + 1);

    --rs;
    while (rs > 0) {
        int l = p - rs;
        int r = p + rs;

        curr -= (a[l] < a[p] + abs(l - p));
        ms.insert(a[l]);

        curr -= (a[r] < a[p] + abs(r - p));
        ms.insert(a[r]);

        while (ms.size() && *ms.begin() < a[p] + rs) {
            ++curr;
            ms.erase(ms.begin());
        }

        ans[p] = max(ans[p], curr + 1);
        --rs;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    freopen("input.txt", "r", stdin);

    int n, p;
    cin >> n >> p;
    for (int i = 0; i < n; ++i) cin >> a[i];

    for (int i = 0; i < n; ++i) {
        int np = 0;
        for (int j = 0; j < n; ++j) {
            np += (a[j] < a[i]);
        }
        ans[i] = np + 1;
    }

    map <int, vector <int> > ms1;
    for (int pr = 0; pr < n; ++pr) {
        for (int i = 0; i <= pr; ++i) {
            ms1[a[i]].push_back(i);
        }
        for (int i = pr + 1; i < n; ++i) {
            ms1[a[i] + i - pr].push_back(i);
        }

        int have = 0;
        for (pair <int, vector <int> > elem : ms1) {
            for (int el : elem.second) {
                ans[el] = max(ans[el], have + 1);
            }
            have += elem.second.size();
        }

        ms1.clear();
    }

    map <int, vector <int> > ms2;
    for (int ps = n - 1; ps >= 0; --ps) {
        for (int i = ps; i < n; ++i) {
            ms2[a[i]].push_back(i);
        }
        for (int i = 0; i < ps; ++i) {
            ms2[a[i] + ps - i].push_back(i);
        }

        int have = 0;
        for (pair <int, vector <int> > elem : ms2) {
            for (int el : elem.second) {
                ans[el] = max(ans[el], have + 1);
            }
            have += elem.second.size();
        }

        ms2.clear();
    }

    for (int i = 0; i < n; ++i) {
        upd(i, n);
    }

    for (int i = 0; i < n; ++i) {
        cout << ans[i] << '\n';
    }

    return 0;
}

