#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef long double ld;

bool comp(pair<ll, ll> p1, pair<ll, ll> p2)
{
	if (p1.first >= p2.first && p1.second >= p2.second)
	{
		return true;
	}
	return false;
}

struct point
{
	ll x, y;
	set<ll> cost;

	point() {}

	point(ll x1, ll y1)
	{
		x = x1, y = y1;
	}

	const bool contain(const point &p) const
	{
		return x <= p.x && y <= p.y;
	}

	const bool operator<(const point &p) const
	{
		auto  it1 = --cost.end(), it2 = --p.cost.end();
		while (1)
		{
			if (it1 == cost.end())
			{
				return true;
			}
			if (it2 == p.cost.end())
			{
				return false;
			}
			if (*it1 < *it2)
			{
				return true;
			}
			if (*it1 > *it2)
			{
				return false;
			}
			--it1, --it2;
		}
	}

	void insert(ll k)
	{
		if (cost.find(k) == cost.end())
		{
			cost.insert(k);
		}
		else
		{
			cost.erase(k);
			this->insert(k + 1);
		}
	}
};

int main()
{
	ll n, m, k;
	cin >> n >> m >> k;
	map<pair<ll, ll>, ll> key;
	vector <pair<ll, ll>> v(k);
	for (int i = 0; i < k; ++i)
	{
		cin >> v[i].first >> v[i].second;
		key[v[i]] = i + 1;
	}
	sort(v.begin(), v.end(), comp);
	vector <point> dp;
	vector <ll> prevs(k, 0);
	prevs[0] = -1;
	for (int i = 0; i < k; ++i)
	{
		dp.push_back({ v[i].first, v[i].second });
		dp[i].cost = { max(n - dp[i].x, m - dp[i].y) };
		for (int j = 0; j < i; ++j)
		{
			if (dp[i].contain(dp[j]))
			{
				point temp = dp[j];
				temp.insert(max(dp[j].x - dp[i].x, dp[j].y - dp[i].y));
				if (temp < dp[i])
				{
					dp[i].cost = temp.cost;
					prevs[i] = j;
				}
			}
		}
	}
	vector <ll> ans;
	ll temp = k - 1;
	while (temp != -1)
	{
		ans.push_back(temp + 1);
		temp = prevs[temp];
	}
	cout << ans.size() << endl;
	reverse(ans.begin(), ans.end());
	for (int i = 0; i < ans.size(); ++i)
	{
		cout << key[v[ans[i] - 1]] << " ";
	}
	return 0;
}
/*
4 5 3
1 1
2 3
4 5
*/
/*
5 6 9
1 1
4 3
4 6
2 5
3 1
3 3
3 6
5 4
5 6
*/