#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

struct query{
    int p, c;
    char a;
    query() {}
    query(int p, int c, char a) {
        this->p = p;
        this->c = c;
        this->a = a;
    }
};

bool cmp(query a, query b) {
    if (a.c == b.c) {
        return (a.a < b.a);
    }
    return (a.c < b.c);
}

const int MAX_N = 1e5;
int a[MAX_N], b[MAX_N];

void solve_b_is_0(int n) {
    query q[n];
    for (int i = 0; i < n; i++) {
        q[i] = query(i, a[i], '(');
    }
    sort(q, q + n, cmp);
    long long summ = 0, cnt = n;
    for (int i = 0; i < n; i++) {
        summ = max(summ, cnt * q[i].c);
        cnt--;
    }
    cout << summ << endl;
}

void solve_a_is_b(int n) {
    sort(a, a + n);
    vector <pair <long long, long long> > a2;
    pair <long long, long long> now = {a[0], 1};
    for (int i = 1; i < n; i++) {
        if (a[i] == now.first) now.second++;
        else {
            a2.push_back(now);
            now = {a[i], 1};
        }
    }
    a2.push_back(now);
    long long cnt_r = n;
    n = a2.size();
    //cout << n << endl;
    long long l = -1, summ = 0, s1, s2, cnt_l = 0;
    for (int r = 0; r < n; r++) {
        if (r == 0) {
            summ = a2[r].first * cnt_r;
            cnt_l += a2[r].second;
            cnt_r -= a2[r].second;
            continue;
        }
        s1 = a2[r].first * cnt_r;
        while (l <= r && cnt_l > 0 && l + 1 < n && ((cnt_l - a2[l].second) * (a2[l + 1].first) > (cnt_l * a2[l].first))) {
            cnt_l -= a2[l].second;
            l++;
        }
        cout << l << ' ' << r << ' ' << cnt_l << ' ' << cnt_r << endl;
        summ = max(summ, s1 + cnt_l * a2[l].first);
        cnt_r -= a2[r].second;
        cnt_l += a2[r].second;
    }
    cout << summ << endl;
}

int main() {
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    query q[2 * n];
    bool inn_plus[n];
    bool a_is_b = 1, b_is_0 = 1;
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        if (b[i] != 0) b_is_0 = 0;
        if (a[i] != b[i]) a_is_b = 0;
        q[2 * i] = query(i, b[i], '(');
        q[2 * i + 1] = query(i, a[i], ')');
    }
    if (a_is_b) {
        solve_a_is_b(n);
        return 0;
    }
    if (b_is_0) {
        solve_b_is_0(n);
        return 0;
    }
    sort(q, q + 2 * n, cmp);
    query now;
    long long summ = 0, now_s, now_s2, cnt;
    for (int i = 0; i < 2 * n; i++) {
        now = q[i];
        cnt = 0;
        if (q[i].a == ')') {
            for (int j = 0; j < n; j++) {
                if (a[j] >= q[i].c) inn_plus[j] = 1;
                else inn_plus[j] = 0, cnt++;
            }
            now_s = 0;
            now_s2 = (n - cnt) * q[i].c;
            for (int j = 0; j < 2 * n; j++) {
                if (q[j].a == '(') {
                    now_s = max(now_s, cnt * q[j].c);
                    if (!inn_plus[q[j].p]) cnt--;
                }
            }
            summ = max(summ, now_s + now_s2);
        }
    }
    cout << summ << endl;
    return 0;
}
