#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9 + 7;

const int MAX_N = 1 << 19, MAX_K = 20;
int dp[MAX_N], arr[MAX_N], pref_max[MAX_N];

int sparse[MAX_K][MAX_N];

void build_sparse() {
    for (int i = 0; i < MAX_N; i++) {
        sparse[0][i] = arr[i];
    }
    for (int i = 1; i < MAX_K; i++) {
        for (int j = 0; j <= MAX_N - (1 << i); j++) {
            sparse[i][j] = max(sparse[i - 1][j], sparse[i - 1][j + (1 << (i - 1))]);
        }
    }
}

int find_max(int l, int r) {
    int i = 31 - __builtin_clz(r - l + 1);
    return max(sparse[i][l], sparse[i][r - (1 << i) + 1]);
}

int my_bs(int pos) {
    int l = -1, r = pos, m;
    while (r - l > 1) {
        m = (l + r) / 2;
        if (find_max(m, pos) == arr[pos]) r = m;
        else l = m;
    }
    return r;
}

int t[2 * MAX_N];

void build(int num, int l, int r) {
    if (l == r) return;
    int m = (l + r) / 2;
    build(2 * num, l, m);
    build(2 * num + 1, m + 1, r);
    t[num] = min(t[2 * num], t[2 * num + 1]);
}

int find_min(int num, int l, int r, int a, int b) {
    if (a <= l && r <= b) return t[num];
    if (a > r || b < l) return INF;
    int m = (l + r) / 2;
    return min(find_min(2 * num, l, m, a, b), find_min(2 * num + 1, m + 1, r, a, b));
}

void upd(int pos, int x) {
    pos = MAX_N + pos;
    t[pos] = x;
    while (pos > 1) {
        pos /= 2;
        t[pos] = min(t[2 * pos], t[2 * pos + 1]);
    }
}

void print() {
    for (int i = 0; i < 2 * MAX_N; i++) cout << t[i] << ' ';
    cout << endl;
}

int main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //find_max(0, 3);
    int n;
    cin >> n;
    pref_max[0] = -INF;
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    for (int i = n; i < MAX_N; i++) {
        arr[i] = 0;
    }
    build_sparse();
    for (int i = 0; i < MAX_N; i++) {
        t[MAX_N + i] = INF;
    }
    build(1, 1, MAX_N);
    //cout << t[1] << endl;
    upd(0, 0);
    dp[0] = 0;
    vector <int> now;
    int now_min = INF;
    for (int i = 0; i < n; i++) {
        while (!now.empty() && arr[now.back()] > arr[i]) {
            upd(now.back(), INF);
            now.pop_back();
        }
        dp[i + 1] = dp[i] + 1;
        int l = my_bs(i);
        //cout << i << ' ' << dp[i] << ": ";
        //print();
        //cout << i << ' ' << l << ' ' << dp[i] << ' ' << find_min(1, 1, MAX_N, l + 1, i + 1) << endl << endl << endl;
        dp[i + 1] = min(dp[i + 1], find_min(1, 1, MAX_N, l + 1, i + 1) + 1);
        now.push_back(i);
        upd(i + 1, dp[i + 1]);
    }
    cout << dp[n] << endl;
    return 0;
}
