#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int MAX_N = 20000;
bool use[MAX_N];
int n;
int ans[MAX_N], a[MAX_N], dist[MAX_N];
pair <int, int> pp[MAX_N];

void check(int l, int r) {
    for (int i = 0; i < n; i++) dist[i] = n + 1;
    for (int i = 0; i < n; i++) {
        if (i < l || i >= r) dist[i] = 0;
        else {
            if (l > 0) dist[i] = i - l + 1;
            if (r < n) dist[i] = min(dist[i], r - i);
        }
    }
    for (int i = 0; i < n; i++) pp[i] = {dist[i] + a[i], i};
    sort(pp, pp + n);
    int place = 1;
    for (int i = 0; i < n; i++) {
        //cout << now[i].first << ' ' << now[i].second << endl;
        if (i != 0 && pp[i].first != pp[i - 1].first) place = i + 1;
        ans[pp[i].second] = max(ans[pp[i].second], place);
    }
    //cout << endl << endl;
}

void gen() {
    for (int i = 1; i < (1 << n); i++) check(i, i);
}

/*void solve_slow_p_is_2() {
    for (int i = 0; i < n; i++) ans[i] = -1;
    gen();
    for (int i = 0; i < n; i++) {
        cout << ans[i] << "\n";
    }
}*/

void solve_p_is_2() {
    int num;
    for (int i = 0; i < n; i++) ans[i] = -1;
    for (int l = 0; l <= n; l++) {
        for (int r = 0; l + r <= n; r++) {
            if (l + r == 0) continue;
            check(l, n - r);
        }
    }
    for (int i = 0; i < n; i++) cout << ans[i] << "\n";
}

void all_the_same(int p) {
    if (p == 1) {
        for (int i = 0; i < n; i++) cout << 1 << "\n";
    } else {
        for (int i = 0; i < n; i++) cout << n << "\n";
    }
}

int main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int p;
    cin >> n >> p;
    bool the_same = 1, sorted = 1;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (i > 0 && a[i] != a[i - 1]) the_same = 0;
        if (i > 0 && a[i] <= a[i - 1]) sorted = 0;
    }
    if (sorted && p == 1&& n > 20) {
        for (int i = 0; i < n; i++) {
            cout << i + 1 << "\n";
        }
        return 0;
    }
    if (the_same) {
        all_the_same(p);
        return 0;
    }
    if (p == 2) {
        solve_p_is_2();
        return 0;
    }
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        cnt = 0;
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (a[j] + abs(i - j) < a[i]) cnt++;
        }
        ans[i] = cnt + 1;
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << "\n";
    }
    return 0;
}
