#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<algorithm>
#include<stdio.h>
#include<queue>
#include<stack>
#include<set>
#include<map>
#include<string>
#include<tuple>
#include<math.h>
#include<iomanip>

using namespace std;

const long long INF = 1e18;

const int N = 1e4;

struct BI {
	bool v[N];
	BI() {
		for (int i = 0; i < N; i++) {
			v[i] = 0;
		}
	}
	BI(long long x) {
		for (int i = 0; i < N; i++) {
			v[i] = x % 2;
			x /= 2;
		}
	}
	bool&operator[](int x) {
		return v[x];
	}
	BI operator+(BI b) {
		bool c = 0;
		for (int i = 0; i < N; i++) {
			bool d = v[i] ^ b[i] ^ c;
			c = (v[i] & b[i])|((v[i]|b[i])&c);
			b[i] = d;
		}
		return b;
	}
	void operator<<=(int x) {
		for (int i = N - 1; i >= 0; i--) {
			v[i] = i >= x ? v[i - x] : 0;
		}
	}
	BI operator*(BI b) {
		BI n;
		for (int i = 0; i < N; i++) {
			if (v[i]) {
				n = n + b;
			}
			b <<= 1;
		}
		return n;
	}
	bool operator<(BI b) {
		for (int i = N-1; i >=0; i--) {
			if (v[i] ^ b[i]) {
				return b[i];
			}
		}
		return 0;
	}
	bool operator>(BI b) {
		for (int i = N-1; i >= 0; i--) {
			if (v[i] ^ b[i]) {
				return v[i];
			}
		}
		return 0;
	}
};

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n, m, k;
	cin >> n >> m >> k;
	vector<BI>deg;
	deg.push_back(1);
	for (int i = 0; i < 60; i++) {
		deg.push_back(deg[i]);
		deg[i + 1] <<= 1;
	}
	vector<vector<BI>>g(k,vector<BI>(k));
	vector<pair<int, int>>v(k);
	for (int i = 0; i < k; i++) {
		cin >> v[i].first >> v[i].second;
		g[i][i] = 0;
		for (int j = 0; j < i; j++) {
			g[i][j] = deg[max(abs(v[i].first - v[j].first), abs(v[i].second - v[j].second))];
			g[j][i] = g[i][j];
		}
	}
	vector<pair<BI,int>>dist(k);
	dist[0].first = 0;
	for (int i = 1; i < k; i++) {
		dist[i].first = g[0][i];
		dist[i].second = 0;
	}
	for (int i = 1; i <= k; i++) {
		BI d = INF;
		long long x;
		for (int j = 0; j < k; j++) {
			if ((BI)0<dist[j].first && dist[j].first < d) {
				d = dist[j].first;
				x = j;
			}
		}
		for (int j = 0; j < k; j++) {
			if (dist[j].first > dist[x].first + g[x][j]) {
				dist[j].first = dist[x].first + g[x][j];
				dist[j].second = x;
			}
		}
		if (x == k - 1) {
			vector<int>ans;
			while (x) {
				ans.push_back(x);
				x = dist[x].second;
			}
			ans.push_back(0);
			cout << ans.size() << '\n';
			for (int j = ans.size()-1; j >=0; j--) {
				cout << ans[j]+1 << ' ';
			}
			return 0;
		}
		dist[x].first = 0;
	}
}