#include <bits/stdc++.h>

using namespace std;

const long long M = 1ll << 60;

struct number {
    vector <long long> p;
    number() {
        p.resize(9, 0);
    }
    number(int x) {
        p.resize(9, 0);
        if (x != -1) {
            int id = x / 60, k = x % 60;
            p[id] += 1ll << k;
        }
    }
    number operator+(const number &b) const {
        long long add = 0;
        number res;
        for (int i = 0; i < 9; i++) {
            long long k = p[i] + b.p[i] + add;
            add = k / M;
            res.p[i] = k % M;
        }
        return res;
    }
    bool operator<(const number &b) const {
        for (int i = 8; i >= 0; i--) {
            if (p[i] < b.p[i]) return true;
            if (p[i] > b.p[i]) return false;
        }
        return false;
    }
};

const number INF = number(510);
vector <pair <int, int> > a;

number f(int i, int j) {
    return number(max(abs(a[i].first - a[j].first), abs(a[i].second - a[j].second)));
}

int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    a.resize(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i].first >> a[i].second;
    }
    vector <number> dist(k, INF);
    dist[0] = number(-1);
    vector <bool> used(k, false);
    vector <int> pred(k, -1);
    for (int i = 0; i < k; i++) {
        int id = -1;
        number d = INF;
        for (int j = 0; j < k; j++) {
            if (!used[j] && dist[j] < d) {
                d = dist[j];
                id = j;
            }
        }
        used[id] = true;
        for (int j = 0; j < k; j++) {
            if (!used[j] && d + f(id, j) < dist[j]) {
                dist[j] = d + f(id, j);
                pred[j] = id;
            }
        }
    }
    vector <int> ans;
    int cur = k - 1;
    while (cur != 0) {
        ans.push_back(cur);
        cur = pred[cur];
    }
    ans.push_back(0);
    reverse(ans.begin(), ans.end());
    cout << ans.size() << endl;
    for (int i : ans) {
        cout << i + 1 << " ";
    }

    /*cout << endl << endl;
    for (int i = 0; i < k; i++) {
        cout << dist[i].p[0] << " ";
    }*/
    return 0;
}
