#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

using namespace std;

const int INF = 1e9 + 7;

struct Node{
    Node* left;
    Node* right;
    pair <int, int> val;
    int l, r;
    Node(int l1, int r1) {
        left = nullptr;
        right = nullptr;
        val = {0, 0};
        l = l1;
        r = r1;
    }
};

Node* build(int l, int r) {
    Node* v = new Node(l, r);
    if (r - l > 1) {
        v -> left = build(l, (l + r) / 2);
        v -> right = build((l + r) / 2, r);
    }
    return v;
}

void update(Node* v) {
    v -> val = max(v -> left -> val, v -> right -> val);
}

void update2(Node* v) {
    v -> val = min(v -> left -> val, v -> right -> val);
}

void change(Node* v, int k, int x) {
    if (k < v -> l || k >= v -> r) return;
    if (v -> l == k && v -> r == k + 1) {
        v -> val = {x, k};
        return;
    }
    change(v -> left, k, x);
    change(v -> right, k, x);
    update(v);
}

void change2(Node* v, int k, int x) {
    if (k < v -> l || k >= v -> r) return;
    if (v -> l == k && v -> r == k + 1) {
        v -> val = {x, k};
        return;
    }
    change2(v -> left, k, x);
    change2(v -> right, k, x);
    update2(v);
}

pair <int, int> get(Node* v, int l, int r) {
    if (v -> l >= r || v -> r <= l) return {0, 0};
    if (v -> l >= l && v -> r <= r) return v -> val;
    return max(get(v -> left, l, r), get(v -> right, l, r));
}

pair <int, int> get2(Node* v, int l, int r) {
    if (v -> l >= r || v -> r <= l) return {INF, INF};
    if (v -> l >= l && v -> r <= r) return v -> val;
    return min(get2(v -> left, l, r), get2(v -> right, l, r));
}

int main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <int> a(n);
    Node* root = build(0, n);
    set <int> q;
    map <int, int> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        change(root, i, a[i]);
        q.insert(a[i]);
    }
    int k = 0;
    for (int i : q) {
        m[i] = k;
        k++;
    }
    Node* root2 = build(0, n);
    for (int i = 0; i < n; i++) {
        change2(root2, i, n);
    }
    vector <int> next(n);
    for (int i = n - 1; i >= 0; i--) {
        if (m[a[i]] == 0) {
            next[i] = n;
        } else {
            auto temp = get2(root2, 0, m[a[i]]);
            next[i] = temp.first;
        }
        change2(root2, m[a[i]], i);
    }

    int cur = 0, ans = 0;
    while (cur < n) {
        auto temp = get(root, cur, next[cur]);
        cur = temp.second + 1;
        ans++;
    }
    cout << ans;
    return 0;
}
