#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

using namespace std;

const int INF = 1e9 + 7;

struct Node{
    Node* left;
    Node* right;
    pair <int, int> val;
    int l, r;
    Node(int l1, int r1) {
        left = nullptr;
        right = nullptr;
        val = {0, 0};
        l = l1;
        r = r1;
    }
};

Node* build(int l, int r) {
    Node* v = new Node(l, r);
    if (r - l > 1) {
        v -> left = build(l, (l + r) / 2);
        v -> right = build((l + r) / 2, r);
    }
    return v;
}

/*void update(Node* v) {
    v -> val = max(v -> left -> val, v -> right -> val);
}*/

void update2(Node* v) {
    v -> val = min(v -> left -> val, v -> right -> val);
}

/*void change(Node* v, int k, int x) {
    if (k < v -> l || k >= v -> r) return;
    if (v -> l == k && v -> r == k + 1) {
        v -> val = {x, k};
        return;
    }
    change(v -> left, k, x);
    change(v -> right, k, x);
    update(v);
}*/

void change2(Node* v, int k, int x) {
    if (k < v -> l || k >= v -> r) return;
    if (v -> l == k && v -> r == k + 1) {
        v -> val = {x, k};
        return;
    }
    change2(v -> left, k, x);
    change2(v -> right, k, x);
    update2(v);
}

/*pair <int, int> get(Node* v, int l, int r) {
    if (v -> l >= r || v -> r <= l) return {0, 0};
    if (v -> l >= l && v -> r <= r) return v -> val;
    return max(get(v -> left, l, r), get(v -> right, l, r));
}*/

pair <int, int> get2(Node* v, int l, int r) {
    if (v -> l >= r || v -> r <= l) return {INF, INF};
    if (v -> l >= l && v -> r <= r) return v -> val;
    return min(get2(v -> left, l, r), get2(v -> right, l, r));
}

vector <vector <pair <int, int> > > st;
vector <int> p;

void build_st(int n, vector <int> a) {
    int powern = 1, logn = 0;
    while (powern < n) {
        powern *= 2;
        logn++;
    }
    p.resize(n + 1);
    int k = 0;
    for (int i = 1; i <= n; i++) {
        if ((1 << (k + 1)) == i) k++;
        p[i] = k;
    }
    st.resize(logn + 1, vector <pair <int, int> > (powern, {0, 0}));
    for (int i = 0; i < n; i++) {
        st[0][i] = {a[i], i};
    }
    for (int i = 1; i <= logn; i++) {
        int shift = (1 << (i - 1));
        for (int j = 0; (j + (1 << i) - 1) < powern; j++) {
            st[i][j] = max(st[i - 1][j], st[i - 1][j + shift]);
        }
    }
    /*for (int i = 0; i <= logn; i++) {
        for (int j = 0; (j + (1 << i) - 1) < powern; j++) {
            cout << "{" << st[i][j].first << " " << st[i][j].second << "} ";
        }
        cout << endl;
    }*/
}

int get(int l, int r) {
    int len = r - l + 1;
    auto res = st[p[len]][l];
    if (len != (1 << p[len])) {
        res = max(res, st[p[len]][r - (1 << p[len]) + 1]);
    }
    return res.second;
}

int main()
{
    int n;
    cin >> n;
    vector <int> a(n);
    map <int, int> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    build_st(n, a);
    int k = 0;
    vector <int> q = a;
    sort(q.begin(), q.end());
    for (int i = 0; i < n; i++) {
        if (i != 0 && q[i] != q[i - 1]) k++;
        m[q[i]] = k;
    }
    for (int i = 0; i < n; i++) {
        a[i] = m[a[i]];
    }
    Node* root2 = build(0, n);
    for (int i = 0; i < n; i++) {
        change2(root2, i, n);
    }
    vector <int> next(n);
    for (int i = n - 1; i >= 0; i--) {
        if (a[i] == 0) {
            next[i] = n;
        } else {
            auto temp = get2(root2, 0, a[i]);
            next[i] = temp.first;
        }
        change2(root2, a[i], i);
    }

    int cur = 0, ans = 0;
    while (cur < n) {
        cur = get(cur, next[cur] - 1) + 1;
        //cout << cur << " " << next[cur] << " " << get(cur, next[cur] - 1) << endl;
        ans++;
    }
    cout << ans;
    return 0;
}
