#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

using namespace std;

struct Node {
    Node* left;
    Node* right;
    int val, y, sz;
    Node(int x) {
        left = nullptr;
        right = nullptr;
        val = x;
        sz = 1;
        y = rand() * RAND_MAX + rand();
    }
};

void update(Node* v) {
    v -> sz = 1;
    if (v -> left != nullptr) v -> sz += v -> left -> sz;
    if (v -> right != nullptr) v -> sz += v -> right -> sz;
}

Node* merge1(Node* v1, Node* v2) {
    if (v1 == nullptr) return v2;
    if (v2 == nullptr) return v1;
    if (v1 -> y > v2 -> y) {
        v1 -> right = merge1(v1 -> right, v2);
        update(v1);
        return v1;
    } else {
        v2 -> left = merge1(v1, v2 -> left);
        update(v2);
        return v2;
    }
}

pair <Node*, Node*> split(Node* v, int k) {
    if (v == nullptr) return {nullptr, nullptr};
    if (v -> val >= k) {
        auto temp = split(v -> left, k);
        v -> left = temp.second;
        update(v);
        return {temp.first, v};
    } else {
        auto temp = split(v -> right, k);
        v -> right = temp.first;
        update(v);
        return {v, temp.second};
    }
}

Node* insert1(Node* root, int k) {
    auto temp = split(root, k);
    temp.first = merge1(temp.first, new Node(k));
    root = merge1(temp.first, temp.second);
    return root;
}

int main()
{
    int n, p;
    cin >> n >> p;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (p == 1) {
        vector <int> ans(n, 1);
        Node* root = nullptr;
        for (int i = 0; i < n; i++) {
            auto temp = split(root, a[i] - i);
            if (temp.first != nullptr) {
                ans[i] += temp.first -> sz;
            }
            temp.first = merge1(temp.first, new Node(a[i] - i));
            root = merge1(temp.first, temp.second);
        }
        root = nullptr;
        for (int i = n - 1; i >= 0; i--) {
            auto temp = split(root, a[i] - (n - i - 1));
            if (temp.first != nullptr) {
                ans[i] += temp.first -> sz;
            }
            temp.first = merge1(temp.first, new Node(a[i] - (n - i - 1)));
            root = merge1(temp.first, temp.second);
        }
        for (int i = 0; i < n; i++) {
            cout << ans[i] << "\n";
        }
    } else {
        vector <int> ans(n, 1);
        for (int i = -1; i < n; i++) {
            for (int j = n; j > i; j--) {
                //cout << i << " " << j << endl;
                if (i == -1 && j == n) continue;
                vector <pair <int, int> > res(n);
                for (int k = 0; k < n; k++) {
                    int z = n;
                    if (i != -1) {
                        z = min(z, max(k - i, 0));
                    }
                    if (j != n) {
                        z = min(z, max(j - k, 0));
                    }
                    res[k] = {a[k] + z, k};
                }
                sort(res.begin(), res.end());
                vector <int> place(n, 1);
                for (int k = 1; k < n; k++) {
                    if (res[k].first == res[k - 1].first) {
                        place[res[k].second] = place[res[k - 1].second];
                    } else {
                        place[res[k].second] = k + 1;
                    }
                }
                /*for (int k = 0; k < n; k++) {
                    cout << res[k].first << " " << res[k].second << " " << place[res[k].second] << endl;
                }
                cout << endl;*/
                for (int k = 0; k < n; k++) {
                    ans[k] = max(ans[k], place[k]);
                }
            }
        }
        for (int i = 0; i < n; i++) {
            cout << ans[i] << "\n";
        }
    }
    return 0;
}
