#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <fstream>

using namespace std;
typedef long long ll;

int n, m, q;
vector<vector<int>> p, w;
vector<int> mxN, mxM;

const int ts = 1 << 18;
int st[2 * ts];

int tcr(int i, int j) {
	return i * m + j;
}

void up(int v, int val) {
	st[v + ts] = val;
	for (v = v + ts >> 1; v; v >>= 1)
		st[v] = st[2 * v] + st[2 * v + 1];
}

void update(int x, int y, int val) {
	if (w[x][y] == 1) {
		p[x][y] = val;
		return;
	}
	int i = mxM[y], j = mxN[x];
	if (i != x && j != y) {
		if (val > p[x][j] && val > p[i][y])
			up(tcr(x, y), w[x][y] = 1);
		if (p[x][j] < val) {
			if (w[x][j])
				up(tcr(x, j), w[x][j] = 0);
			mxN[x] = y;
		}
		if (p[i][y] < val) {
			if (w[i][y] < val)
				up(tcr(i, y), w[i][y] = 0);
			mxM[y] = x;
		}
		p[x][y] = val;
	}
	if (i == x) {
		if (p[x][j] < val) {
			up(tcr(x, y), w[x][y] = 1);
			if (w[x][j])
				up(tcr(x, j), w[x][j] = 0);
			mxN[x] = y;
		}
		p[x][y] = val;
	}
	if (j == y) {
		if (p[i][y] < val) {
			up(tcr(x, y), w[x][y] = 1);
			if (w[i][y])
				up(tcr(i, y), w[i][y] = 0);
			mxM[y] = x;
		}
		p[x][y] = val;
	}
}

void build() {
	for (int i = 0; i < n; ++i) {
		mxN[i] = 0;
		for (int j = 1; j < m; ++j)
			if (p[i][j] > p[i][mxN[i]])
				mxN[i] = j;
	}
	for (int j = 0; j < m; ++j) {
		mxM[j] = 0;
		for (int i = 1; i < n; ++i)
			if (p[i][j] > p[mxM[j]][j])
				mxM[j] = i;
	}
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			if (i == mxM[j] && j == mxN[i])
				w[i][j] = 1;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			st[tcr(i, j) + ts] = w[i][j];
	for (int i = ts - 1; i; --i)
		st[i] = st[2 * i] + st[2 * i + 1];
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m >> q;
	p.resize(n, vector<int>(m));
	w = p;
	for (auto &arr : p)
		for (auto &x : arr)
			cin >> x;
	mxN.resize(n);
	mxM.resize(m);
	build();
	while (q--) {
		int x, y, val;
		cin >> x >> y >> val;
		--x, --y;
		update(x, y, val);
		cout << st[1] << '\n';
	}
	system("pause");
	return 0;
}