#include <iostream>
#include <algorithm>
#include <queue>
#include <stack>
#include <cassert>
#include <vector>

using namespace std;
typedef long long ll;

#define size(v) ((int)v.size())
#define all(v) v.begin(), v.end()

const int maxn = 20;
int a[maxn], b[maxn], c[maxn];
int n;
vector<int> g[maxn];

void bfs() {
	queue<int> q;
	for (int i = 0; i < n; ++i)
		if (b[i] == 0)
			q.push(i);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto u : g[v])
			if (b[u] > b[v] + 1) {
				b[u] = b[v] + 1;
				q.push(u);
			}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> a[0];
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	assert(n <= 15);
	for (int i = 1; i < n - 1; ++i) {
		g[i].push_back(i + 1); g[i].push_back(i - 1);
	}
	g[0].push_back(1);
	g[n - 1].push_back(n - 2);
	for (int m = 1; m < (1 << n); ++m) {
		fill(b, b + n, (int)1e9);
		for (int i = 0; i < n; ++i)
			if (m & (1 << i))
				b[i] = 0;
		bfs();
		vector<pair<int, int>> s(n);
		for (int i = 0; i < n; ++i)
			s[i] = { b[i] + a[i], i };
		sort(all(s));
		for (int i = 0; i < n; ++i) {
			int j = s[i].second;
			c[j] = max(c[j],(int)(lower_bound(all(s), make_pair(s[i].first, -1)) - s.begin()));
		}
	}
	for (int i = 0; i < n; ++i)
		cout << c[i] + 1 << '\n';
	return 0;
}