#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <fstream>
#include <algorithm>
#include <iomanip>
#include <ctime>
#define ll long long
#define null NULL

using namespace std;

const ll MOD = 1e9 + 7;

const int mx = 550;

vector<int> INF(mx, 1), ZERO(mx, 0);

void add_pos(vector<int> &a, int pos) {
	for (int i = pos; i < mx; ++i) {
		if (a[i] == 0) {
			a[i] = 1;
			break;
		}
		else {
			a[i] = 0;
		}
	}
}

bool smaller(vector<int> &a, vector<int> &b) {
	for (int i = mx - 1; i >= 0; --i) {
		if (a[i] < b[i])
			return 1;
		if (a[i] > b[i])
			return 0;
	}
	return 0;
}

struct kek {
	int x, y, num;
};


int dist(kek a, kek b) {
	return max(abs(a.x - b.x), abs(a.y - b.y));
}


bool operator < (kek a, kek b) {
	return make_pair(a.x, a.y) < make_pair(b.x, b.y);
}

vector<int> dp[mx];
int p[mx], used[mx];
int X, Y, n;
vector<kek> a;

int main() {
	cin >> X >> Y >> n;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		a.push_back({x, y, i});
	}
	sort(a.begin(), a.end());
	for (int i = 0; i < n; ++i) {
		dp[i] = INF;
	}
	dp[0] = ZERO;
	for (int i = 0; i < n; ++i) {
		int best = -1;
		for (int j = 0; j < n; ++j) {
			if (used[j] == 0 && (best == -1 || smaller(dp[j], dp[best]))) {
				best = j;
			}
		}
		used[best] = 1;
		for (int j = 0; j < n; ++j) {
			int D = dist(a[best], a[j]);
			vector<int> cur = dp[best];
			add_pos(cur, D);
			if (smaller(cur, dp[j])) {
				dp[j] = cur;
				p[j] = best;
			}
		}
	}
	vector<int> ans;
	int v = n - 1;
	while (v != 0) {
		ans.push_back(a[v].num);
		v = p[v];
	}
	ans.push_back(a[0].num);
	reverse(ans.begin(), ans.end());
	int sz = ans.size();
	cout << sz << endl;
	for (int i = 0; i < sz; ++i) {
		cout << ans[i] + 1 << " ";
	}
	cout << endl;
}