#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#define ll long long
#define null NULL

using namespace std;

const int INF = 2e9;

struct st_min {

	vector<pair<int, int> > t;
	int n;

	void build(int *a, int v, int tl, int tr) {
		if (tl == tr)
			t[v] = {a[tl], tl};
		else {
			int tm = (tl + tr) >> 1;
			build(a, v * 2, tl, tm);
			build(a, v * 2 + 1, tm + 1, tr);
			t[v] = min(t[v * 2], t[v * 2 + 1]);
		}
	}

	void build(int *a, int _n) {
		n = _n;
		t.resize(4 * n);
		build(a, 1, 0, n - 1);
	}

	pair<int, int> get(int l, int r, int v, int tl, int tr) {
		if (l > r)
			return {INF, -1};
		if (l == tl && r == tr)
			return t[v];
		int tm = (tl + tr) >> 1;
		pair<int, int> res_l = get(l, min(r, tm), v * 2, tl, tm);
		pair<int, int> res_r = get(max(l, tm + 1), r, v * 2 + 1, tm + 1, tr);
		return min(res_l, res_r);
	}

	int get(int l, int r) {
		return get(l, r, 1, 0, n - 1).second;
	}

};

struct st_max {

	vector<pair<int, int> > t;
	int n;

	void build(int *a, int v, int tl, int tr) {
		if (tl == tr)
			t[v] = {a[tl], tl};
		else {
			int tm = (tl + tr) >> 1;
			build(a, v * 2, tl, tm);
			build(a, v * 2 + 1, tm + 1, tr);
			t[v] = max(t[v * 2], t[v * 2 + 1]);
		}
	}

	void build(int *a, int _n) {
		n = _n;
		t.resize(4 * n);
		build(a, 1, 0, n - 1);
	}

	pair<int, int> get(int l, int r, int v, int tl, int tr) {
		if (l > r)
			return {0, -1};
		if (l == tl && r == tr)
			return t[v];
		int tm = (tl + tr) >> 1;
		pair<int, int> res_l = get(l, min(r, tm), v * 2, tl, tm);
		pair<int, int> res_r = get(max(l, tm + 1), r, v * 2 + 1, tm + 1, tr);
		return max(res_l, res_r);
	}

	int get(int l, int r) {
		return get(l, r, 1, 0, n - 1).second;
	}

};

const int mx = 4e5;
int n, a[mx];
st_min t1;
st_max t2;

int get(int l, int r) {
	//cout << "getting " << l << " " << r << endl;
	if (l > r)
		return 0;
	int pos2 = t2.get(l, r);
	//cout << "pos2 = " << pos2 << endl;
	//cout << "pos2 = " << pos2 << endl;
	if (pos2 == r) {
		int pos1 = t1.get(l, r);
		//cout << "pos1 = " << pos1 << endl;
		//cout << "pos1 = " << pos1 << endl;
		return get(l, pos1 - 1) + 1;
	}
	return get(l, pos2) + get(pos2 + 1, r);
}

int main() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	t1.build(a, n);
	t2.build(a, n);
	cout << get(0, n - 1) << endl;
}