#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;

#define inb push_back
#define X first
#define Y second
#define all(v) (v).begin(), (v).end()

const int M = 4e5 + 5;
const int INF = 1e9;

int n, p, a[M], ans[M], mx[M], mn[M], d[M], bans[M], t[M];

int nxt(int k) { return k | (k + 1); }
int prv(int k) { return (k & (k + 1)) - 1; }

int get(int x)
{
	int ans = 0;
	for (int i = x; i >= 0; i = prv(i))
		ans += t[i];
	return ans;
}

void upd(int x, int val)
{
	for (int i = x; i < n; i = nxt(i))
		t[i] += val;
}

void check(int l, int r, int ind)
{
	if (r >= n && l <= -1) return;
	if (r >= n) r = INF;
	if (l <= -1) l = -INF;
	for (int i = 0; i < n; ++i)
	{
		ans[i] = a[i];
		if (l < i && i < r) ans[i] += min(i - l, r - i);
	}
	int x = 0;
	for (int i = 0; i < n; ++i)
		if (ans[i] < ans[ind]) ++x;
	mx[ind] = max(mx[ind], x + 1);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> p;
	for (int i = 0; i < n; ++i) cin >> a[i];

	if (p == 1)
		exit(0);
	int x = (n - 1) / 2;

	fill(t, t + n, 0);
	{
		for (int i = 0; i <= x; ++i)
			if (a[0] < a[i] + i) ++mx[i];
		for (int i = 0; i < n; ++i)
			bans[i] = a[i];
		sort(bans, bans + n);
		for(int i = n - 1; i >= 2 * x; --i)
			upd(lower_bound(bans, bans + n, a[i]) - bans, 1);
		for (int i = 2 * x - 1; i > 0; --i)
		{
			mx[i] += get(lower_bound(bans, bans + n, a[i]) - bans);
			for(int j = min(n - 1, (i + 1) * 2 - 1); j >= i * 2; --j)
				upd(lower_bound(bans, bans + n, a[j]) - bans, -1);
		}
		int bal = 0;
		for (int i = 0; i < n; ++i)
			bans[i] = a[i] + min(i, x * 2 - i);
		sort(bans, bans + n);
		for(int i = x * 2 - 1; i > x; --i)
			upd(lower_bound(bans, bans + n, a[i] + min(i, x * 2 - i)) - bans, 1);
		for (int i = x; i > 0; --i)
		{
			mx[i] += get(lower_bound(bans, bans + n, a[i] + min(i, x * 2 - i) + bal) - bans);
			for (int j = min(n - 1, i * 2 - 1); j >= (i - 1) * 2; --j)
				upd(lower_bound(bans, bans + n, a[j] + min(j, x * 2 - j)) - bans, -1);
			bal += 2;
		}
	}

	for (int i = 0; i < n; ++i)
	{
		check(0, n, i);
		check(-1, n - 1, i);
		if (i + i >= n)
			check(i + i - (n - 1), n - 1, i);
	}
	for (int i = 0; i < n; ++i)
		cout << mx[i] << '\n';
}