#include <iostream>
#include <vector>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <bitset>
#include <ctime>
#include <string>
#include <cstring>

#define fi first
#define se second

using namespace std;
const int MAXN = 3e5 + 100;
const int INF = 1e9 + 100;

struct TreeMin{
    int sz;
    pair<int, int> mas[MAXN * 4];

    void Build(int v, int l, int r, int* mm){
        if (v == 0){
            sz = r;
        }

        if (l + 1 == r){
            mas[v] = {mm[l], l};
            return;
        }

        int m = (l + r) / 2;
        Build(v * 2 + 1, l, m, mm);
        Build(v * 2 + 2, m, r, mm);

        mas[v] = min(mas[v * 2 + 1], mas[v * 2 + 2]);
    }

    pair<int, int> Get(int v, int l, int r, int cl, int cr){
        if ((cr <= l) || (r <= cl)){
            return {INF, INF};
        }

        if ((l <= cl) && (cr <= r)){
            return mas[v];
        } else {
            int cm = (cl + cr) / 2;
            return min(Get(v * 2 + 1, l, r, cl, cm), Get(v * 2 + 2, l, r, cm, cr));
        }
    }

    int Get(int l, int r){
        return Get(0, l, r, 0, sz).second;
    }
};

struct TreeMax{
    int sz;
    pair<int, int> mas[MAXN * 4];

    void Build(int v, int l, int r, int* mm){
        if (v == 0){
            sz = r;
        }

        if (l + 1 == r){
            mas[v] = {mm[l], l};
            return;
        }

        int m = (l + r) / 2;
        Build(v * 2 + 1, l, m, mm);
        Build(v * 2 + 2, m, r, mm);

        mas[v] = max(mas[v * 2 + 1], mas[v * 2 + 2]);
    }

    pair<int, int> Get(int v, int l, int r, int cl, int cr){
        if ((cr <= l) || (r <= cl)){
            return {-INF, -INF};
        }

        if ((l <= cl) && (cr <= r)){
            return mas[v];
        } else {
            int cm = (cl + cr) / 2;
            return max(Get(v * 2 + 1, l, r, cl, cm), Get(v * 2 + 2, l, r, cm, cr));
        }
    }

    int Get(int l, int r){
        return Get(0, l, r, 0, sz).second;
    }
};


TreeMin tr_min;
TreeMax tr_max;

int n;
int mas[MAXN];
int ans = 0;

void f(int l, int r){
    if (l == r){
        return;
    } else if (l + 1 == r){
        ans++;
        return;
    }

    int max_i = tr_max.Get(l, r);
    int min_i = tr_min.Get(l, max_i + 1);

    ans++;
    f(l, min_i);
    f(max_i + 1, r);
    return;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    for (int i = 0; i < n; ++i){
        cin >> mas[i];
    }

    tr_min.Build(0, 0, n, mas);
    tr_max.Build(0, 0, n, mas);

    f(0, n);

    cout << ans << endl;

    return 0;
}
