#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <time.h>

using namespace std;

int n, p, x;
int viruses[500][500], state[500], zar[500][500];
vector<int> answer, availl;
bool avail[500], dangerous[500];

bool is_living(int vir) {
	availl.clear();
	for (int i = 0; i < n; i++) state[i] = i;
	for (int i = 0; i < n; i++)
		if (viruses[i][vir] < viruses[i][state[i]]) state[i] = vir;
	for (int i = 0; i < n; i++) avail[i] = false;
	for (int i = 0; i < n; i++)
		if (state[i] != vir) {
			if (!avail[state[i]]) availl.push_back(state[i]);
			avail[state[i]] = true;
		}
	for (int i = 0; i < n; i++)
		if (state[i] == vir)
			for (int j : availl)
				if (viruses[i][state[i]] > viruses[i][j]) {
					state[i] = j;
				}
	for (int i = 0; i < n; i++)
		if (state[i] == vir) return true;
	return false;
}

bool is_living_plus(int vir) {
	availl.clear();
	for (int i = 0; i < n; i++) state[i] = i;
	for (int i = 0; i < n; i++) avail[i] = true;
	for (int i = 0; i < n; i++)
		if (viruses[i][vir] < viruses[i][state[i]]) {
			state[i] = vir;
			avail[i] = false;
		}
	for (int i = 0; i < n; i++) dangerous[i] = false;
	for (int i = 0; i < n; i++)
		if (state[i] == vir)
			for (int j = 0; zar[i][j] != vir; j++)
				dangerous[zar[i][j]] = true;

	bool q;
	for (int i = 0; i < n; i++)
		if (dangerous[state[i]]) {
			q = true;
			for (int j = 0; (zar[i][j] != i) && q; j++)
				if (!dangerous[zar[i][j]]) q = false;
			if (q) availl.push_back(i);
		}

	for (int i = 0; i < n; i++)
		if (state[i] == vir)
			for (int j : availl)
				if (viruses[i][state[i]] > viruses[i][j]) {
					state[i] = j;
				}
	for (int i = 0; i < n; i++)
		if (state[i] == vir) return true;
	return false;
}

bool is_living_plus_plus(int vir) {
	int c1, c2;
	bool q = false;
	for (int i = 0; i < n; i++) {
		for (int i = 0; i < n; i++) state[i] = i;
		for (int i = 0; i < 10000; i++) {
			c1 = rand() % n;
			c2 = rand() % n;
			if (viruses[c1][state[c1]] > viruses[c1][state[c2]]) state[c1] = c2;
		}
		for (int i = 0; i < n; i++)
			if (state[i] == vir) q = true;
	}
	return q;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(1337);

	cin >> n;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++) {
			cin >> x;
			x--;
			viruses[i][x] = j;
			zar[i][j] = x;
		}
	cin >> p;
	if (p == 1) {
		for (int i = 0; i < n; i++)
			if (viruses[i][i] == 0) answer.push_back(i + 1);
	}
	else {
		if (n <= 5) {
			for (int i = 0; i < n; i++)
				if (is_living(i)) answer.push_back(i + 1);
		}
		else {
			for (int i = 0; i < n; i++)
				if (is_living_plus_plus(i)) answer.push_back(i + 1);
		}
	}

	sort(answer.begin(), answer.end());
	cout << answer.size() << endl;
	for (int i : answer) cout << i << ' ';

	//system("pause");
	return 0;
}