#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

struct Vertex {
	int x, y, dist = 1000000000, parent = -1;
	bool used = false;
	Vertex() {}
	Vertex(int _x, int _y) {
		x = _x;
		y = _y;
	}
};

int n, m, k, x, y, cv;
vector<Vertex> v;
vector<int> answer;

int get_min() {
	int mmin = -1;
	for (int i = 0; i < k; i++)
		if ((!v[i].used) && ((mmin == -1) || (v[mmin].dist > v[i].dist))) mmin = i;
	return mmin;
}

int get_dist(Vertex v1, Vertex v2) {
	return max(abs(v1.x - v2.x), abs(v1.y - v2.y));
}

int main() {
	cin >> n >> m >> k;
	for (int i = 0; i < k; i++) {
		cin >> x >> y;
		v.push_back(Vertex(x, y));
	}
	v[0].dist = 0;
	cv = get_min();
	while (cv != -1) {
		v[cv].used = true;
		for (int i = 0; i < k; i++)
			if ((!v[i].used) && (v[cv].dist + get_dist(v[cv], v[i]) < v[i].dist)) {
				v[i].dist = v[cv].dist + get_dist(v[cv], v[i]);
				v[i].parent = cv;
			}
		cv = get_min();
	}
	cv = k - 1;
	while (cv != 0) {
		answer.push_back(cv);
		cv = v[cv].parent;
	}
	answer.push_back(0);
	cout << answer.size() << endl;
	for (int i = answer.size() - 1; i >= 0; i--) cout << answer[i] + 1 << ' ';

	//system("pause");

	return 0;
}