#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

struct Action {
	int l, r;
	Action() {}
	Action(int _l, int _r) {
		l = _l;
		r = _r;
	}
};

int n, a[3000], a2[3000], minwrong, profit, maxprofit, l, r;
vector<Action> answer;

struct Heap {
	vector<int> elem;
	void push(int x) {
		elem.push_back(x);
		int i = elem.size() - 1;
		while (a[x] < a[elem[(i - 1) / 2]]) {
			swap(elem[i], elem[(i - 1) / 2]);
			i = (i - 1) / 2;
		}
	}
	void pop() {
		swap(elem[elem.size() - 1], elem[0]);
		elem.pop_back();
		int i = 0, ni;
		while (true) {
			ni = -1;
			if (2 * i + 1 < elem.size()) ni = 2 * i + 1;
			if ((2 * i + 2 < elem.size()) && (a[elem[ni]] > a[elem[2 * i + 2]])) ni = 2 * i + 2;
			if ((ni < 0) || (a[elem[ni]] >= a[elem[i]])) break; else {
				swap(elem[ni], elem[i]);
				i = ni;
			}
		}
	}
};
Heap heap;

int get_min_wrong() {
	int ans = -1;
	for (int i = 0; i < n; i++)
		if (a[i] != i && (ans < 0 || a[i] < a[ans])) ans = i;
	return ans;
}

int get_profit(int l, int r) {
	int ans = 0, npos;
	for (int i = l; i <= r; i++) {
		if ((i - l) % 2 == 1) npos = l + (i - l) / 2; else npos = r - (r - i) / 2;
		ans += abs(a[i] - i) - abs(a[i] - npos);
	}
	return ans;
}

void do_action(int l, int r) {
	int npos;
	for (int i = 0; i < n; i++) a2[i] = a[i];
	for (int i = l; i <= r; i++) {
		if ((i - l) % 2 == 1) npos = l + (i - l) / 2; else npos = r - (r - i) / 2;
		a[npos] = a2[i];
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i < n; i++) heap.push(i);
	for (int i = 0; i < n; i++) {
		a[heap.elem[0]] = i;
		heap.pop();
	}

	minwrong = get_min_wrong();
	while (minwrong >= 0) {
		l = minwrong - 1;
		r = minwrong;
		maxprofit = get_profit(l, r);
		for (int i = minwrong + 1; i < n; i++) {
			profit = get_profit(l, i);
			if (profit > maxprofit) {
				maxprofit = profit;
				r = i;
			}
		}
		answer.push_back(Action(l, r));
		do_action(l, r);
		minwrong = get_min_wrong();
	}

	cout << answer.size() << endl;
	for (Action ac : answer) cout << ac.l + 1 << ' ' << ac.r + 1 << endl;

	//system("pause");
	return 0;
}