#include <algorithm>
#include <ctime>
#include <cassert>
#include <vector>
#include <iostream>
#include <fstream>

using namespace std;

const int SZ = 500000000;
char mem[SZ];
int ptr = 0;
vector<int> as;
void* operator new(size_t n)
{
	ptr += n;
	if (ptr >= SZ)
		ptr = SZ / 2;
	return (void*)(mem + ptr - n);
}
void operator delete(void*){}

const int N = 1 << 20;

int inf = 2e9;


struct it
{
	int t[2 * N];
	it()
	{
		fill(t, t + 2 * N, 0);
	}
	void add(int x, int y)
	{
		x = lower_bound(as.begin(), as.end(), x) - as.begin();
		x += N;
		t[x] += y;
		while (x > 1)
			t[x >> 1] = t[x] + t[x ^ 1], x >>= 1;
	}
	int get(int l, int r)
	{
		l = 0;
//		l = lower_bound(as.begin(), as.end(), l) - as.begin();
		r = lower_bound(as.begin(), as.end(), r) - as.begin();
		l += N;
		r += N;
		int ans = 0;
		while (l < r)
		{
			if (l & 1)
				ans += t[l++];
			if (r & 1)
				ans += t[--r];
			l >>= 1, r >>= 1;
		}
		return ans;
	}
	int sz()
	{
		return t[1];
	}
};


int main()
{
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	int p;
	cin >> p;
	vector<int> a(n);
	for (auto& x : a)
		cin >> x;
	for (int i = 0; i < n; ++i)
	{
		int x = a[i];
		as.push_back(x);
	   	as.push_back(x + i);
	   	as.push_back(x - i);
//		as.push_back(x + n - i - 1);
	}
	as.push_back(-inf);
	sort(as.begin(), as.end());
	as.resize(unique(as.begin(), as.end()) - as.begin());
	/*
	it plus, minus;
	for (int i = 0; i < n; ++i)
	{
		plus.add(1, 0, n, i, a[i] + i);
		minus.add(1, 0, n, i, a[i] - i);
	}
	plus.build();
	minus.build();
	*/
//	cerr << clock() << '\n';
	it plus, minus;
	if (p == 1)
	{
		for (int i = 0; i < n; ++i)
			plus.add(a[i] + i, 1);
		for (int i = 0; i < n; ++i)
		{
			int ans = 0;
			int ans1 = plus.get(-inf, a[i] + i);
			ans += ans1;
			ans += minus.get(-inf, a[i] - i);
			plus.add(a[i] + i, -1);
			minus.add(a[i] - i, 1);
			cout << ans + 1 << '\n';
		}
	}
	else
	{
		vector<int> ans(n);
		it mem;
		for (int i = 0; i < n; ++i)
			minus.add(a[i] - i, 1);
		for (int i = 0; i < n; ++i)
			plus.add(a[i] + i, 1);
		for (int i = 0; i < n; ++i)
		{
			if (i < n / 2)
				ans[i] = minus.get(0, a[i] - i);
			else
				ans[i] = plus.get(0, a[i] + i);
		}
		fill(minus.t, minus.t + 2 * N, 0);
		fill(plus.t, plus.t + 2 * N, 0);
		for (int i = 0; i < n; ++i)
			mem.add(a[i], 1);
		for (int i = 0; i < n / 2; ++i)
		{
			int ans2 = plus.get(0, a[i] + i);
			ans2 += minus.get(0, a[i] - i);
			ans2 += mem.get(0, a[i] + i);
			ans[i] = max(ans[i], ans2);

			plus.add(a[i] + i, 1);
			for (int j = 2 * i; j < 2 * (i + 1); ++j)
			{
				minus.add(a[j] - j, 1);
				mem.add(a[j], -1);
			}
			minus.add(a[i] - i, -1);
		}
		fill(minus.t, minus.t + 2 * N, 0);
		fill(plus.t, plus.t + 2 * N, 0);
		fill(mem.t, mem.t + 2 * N, 0);
		for (int i = 0; i < n - 1; ++i)
			mem.add(a[i], 1);
		for (int i = n - 1; i >= n / 2; --i)
		{
			int ans2 = minus.get(0, a[i] - i);
			int act = 2 * i - n + 1;
			ans2 += plus.get(0, a[i] + i);
			ans2 += mem.get(0, a[i] + n - i - 1);
			
			ans[i] = max(ans[i], ans2);

			minus.add(a[i] - i, 1);
			for (int j = act - 2; j < act; ++j)
				plus.add(a[j] + j, 1), mem.add(a[j], -1);
			plus.add(a[i - 1] + (i - 1), -1);
		}
		for (int i = 0; i < n; ++i)
			cout << ans[i] + 1 << '\n';
	}
//	cerr << clock() << '\n';
}
