#include <algorithm>
#include <cassert>
#include <vector>
#include <iostream>
#include <fstream>

using namespace std;

const int N = 1 << 19;

struct it
{
	vector<int> t[2 * N];
	vector<int> gol[2 * N], gor[2 * N];
	void add(int x, int l, int r, int ind, int val)
	{
		t[x].push_back(val);
		if (r - l == 1)
			return;
		int m = (l + r) / 2;
		if (ind < m)
			add(2 * x, l, m, ind, val);
		else
			add(2 * x + 1, m, r, ind, val);
	}
	void build()
	{
		for (int i = 0; i < 2 * N; ++i)
			sort(t[i].begin(), t[i].end());
		for (int i = 0; i < N; ++i)
		{
			gol[i].resize(t[i].size());
			gor[i].resize(t[i].size());
			for (int j = 0; j < t[i].size(); ++j)
			{
				int ind = lower_bound(t[2 * i].begin(), t[2 * i].end(), t[i][j]) - t[2 * i].begin();
				gol[i][j] = ind;
				ind = lower_bound(t[2 * i + 1].begin(), t[2 * i + 1].end(), t[i][j]) - t[2 * i + 1].begin();
				gor[i][j] = ind;
			}
		}
	}
	int getcnt(int x, int l, int r, int ql, int qr, int from, int to)
	{
		if (l >= qr || ql >= r)
			return 0;
		if (ql <= l && r <= qr)
			return lower_bound(t[x].begin(), t[x].end(), to) - lower_bound(t[x].begin(), t[x].end(), from);
		int m = (l + r) / 2;
		return getcnt(2 * x, l, m, ql, qr, from, to) + getcnt(2 * x + 1, m, r, ql, qr, from, to);
	}
};

int main()
{
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	int p;
	cin >> p;
	vector<int> a(n);
	for (auto& x : a)
		cin >> x;
	it plus, minus;
	for (int i = 0; i < n; ++i)
	{
		plus.add(1, 0, n, i, a[i] + i);
		minus.add(1, 0, n, i, a[i] - i);
	}
	plus.build();
	minus.build();
	if (p == 1)
	{
		for (int i = 0; i < n; ++i)
		{
			int ans = 0;
			int ans1 = plus.getcnt(1, 0, n, i + 1, n, 0, a[i] + i);
			ans += ans1;
			ans += minus.getcnt(1, 0, n, 0, i, -1e9, a[i] - i);
			cout << ans + 1 << '\n';
		}
	}
}
