#include <bits/stdc++.h>

const int N = 400100;

class Node {
public:
    int value, priority, push, subtreeSize;
    Node* lSon;
    Node* rSon;
    Node()
            : value()
            , priority()
            , push()
            , subtreeSize()
            , lSon()
            , rSon()
    {}
    Node(int value)
            : value(value)
            , priority(rand())
            , push(0)
            , subtreeSize(1)
            , lSon(NULL)
            , rSon(NULL)
    {}
};

typedef Node* pNode;

int getSize(pNode t) {
    if (t == NULL) {
        return 0;
    }
    return t->subtreeSize;
}

inline void update(pNode& t) {
    t->subtreeSize = getSize(t->lSon) + getSize(t->rSon) + 1;
}

void makePush(pNode& t) {
    if (t == NULL || t->push == 0) {
        return;
    }
    if (t->lSon != NULL) {
        t->lSon->push += t->push;
    }
    if (t->rSon != NULL) {
        t->rSon->push += t->push;
    }
    t->value += t->push;
    t->push = 0;
}

void split(pNode t, pNode& l, pNode& r, int x) {
    //makePush(t);
    if (t == NULL) {
        l = r = NULL;
        return;
    }
    if (t->value < x) {
        split(t->rSon, t->rSon, r, x);
        l = t;
        update(l);
    } else {
        split(t->lSon, l, t->lSon, x);
        r = t;
        update(r);
    }
}

void split1(pNode t, pNode& l, pNode& r, int x) {
    if (t == NULL) {
        l = r = NULL;
        return;
    }
    int sz = getSize(t->lSon) + 1;
    if (x >= sz) {
        split1(t->rSon, t->rSon, r, x - sz);
        l = t;
        update(l);
    } else {
        split1(t->lSon, l, t->lSon, x);
        r = t;
        update(r);
    }
}

pNode merge(pNode l, pNode r) {
    //makePush(l);
    //makePush(r);
    if (l == NULL) {
        return r;
    }
    if (r == NULL) {
        return l;
    }
    if (l->priority > r->priority) {
        l->rSon = merge(l->rSon, r);
        update(l);
        return l;
    } else {
        r->lSon = merge(l, r->lSon);
        update(r);
        return r;
    }
}

void insert(pNode& t, int x) {
    pNode l = NULL, r = NULL;
    split(t, l, r, x);
    t = merge(merge(l, new Node(x)), r);
}

void erase(pNode& t, int x) {
    pNode l = NULL, r = NULL, m = NULL;
    split(t, l, r, x);
    split1(r, m, r, 1);
    t = merge(l, r);
}

int getLess(pNode t, int x) {
    if (t == NULL) {
        return 0;
    }
    if (t->value >= x) {
        return getLess(t->lSon, x);
    }
    return getSize(t->lSon) + 1 + getLess(t->rSon, x);
}

void print(pNode t) {
    if (t == NULL) {
        return;
    }
    print(t->lSon);
    std::cerr << t->value << ' ';
    print(t->rSon);
}

int n;
int a[N];
int max[N];

int solveMin(int pos) {
    int res = 0;
    for (int i = 0; i < n; ++i) {
        if (i != pos && abs(pos - i) + a[i] < a[pos]) {
            ++res;
        }
    }
    return res + 1;
}

void solveMax() {
    for (int mask = 1; mask < (1 << n); ++mask) {
        std::map<int, std::vector<int>> sh;
        int need;
        for (int i = 0; i < n; ++i) {
            int min = -1;
            for (int j = 0; j < n; ++j) {
                if (((mask >> j) & 1) && (min == -1 || abs(i - min) > abs(i - j))) {
                    min = j;
                }
            }
            sh[a[i] + abs(i - min)].push_back(i);
        }
        int cur = 0;
        for (auto i: sh) {
            for (auto j: i.second) {
                max[j] = std::max(max[j], cur + 1);
            }
            cur += i.second.size();
        }
    }
}

int main(void) {
    srand(time(NULL));
    int p;
    scanf("%d%d", &n, &p);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &a[i]);
    }
    if (p == 2) {
        solveMax();
        for (int i = 0; i < n; ++i) {
            printf("%d\n", max[i]);
        }
        return 0;
    }
    assert(p == 1);
    pNode l = NULL, r = NULL;
    for (int i = 0; i < n; ++i) {
        insert(r, a[i] + i);
    }
    //print(r);
    //std::cerr << '\n';
    for (int i = 0; i < n; ++i) {
        erase(r, a[i] + i);
        int res = getLess(l, a[i] - i) + getLess(r, a[i] + i) + 1;
        printf("%d\n", res);
        insert(l, a[i] - i);
        //print(r);
        //std::cerr << '\n';
        //printf("%d\n", solveMin(i));
    }
    return 0;
}