#include <fstream>
#include <algorithm>
#include <string>
#include <bitset>
#include <vector>

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 1 << 14;

int ard[MAXN];
int ina[MAXN];
ll a[MAXN];
ll sum[MAXN];
vector<int>	RMQ[MAXN + MAXN];
int MOD[MAXN + MAXN];
int b[MAXN];
int byb[MAXN];

void Update(int v) {
	RMQ[v].clear();
	int s = RMQ[2 * v].size();
	for (int i = 0; i < s && sum[RMQ[2 * v][i]] > sum[RMQ[2 * v + 1][0]]; ++i) {
		RMQ[v].push_back(RMQ[2 * v][i]);
	}
	s = RMQ[2 * v + 1].size();
	for (int i = 0; i < s; ++i)
		RMQ[v].push_back(RMQ[2 * v + 1][i]);
}

void Init() {
	for (int i = 0; i < MAXN; ++i) {
		RMQ[i + MAXN].push_back(i);
	}
	for (int i = MAXN - 1; i; --i) {
		Update(i);
	}
}

void Ord(int v) {
	int s = RMQ[v].size();
	int j = 0;
	for (int i = 0; i < s - 1; ++i) {
		if (sum[RMQ[v][i]] > sum[RMQ[v][i + 1]]) {
			RMQ[v][j++] = RMQ[v][i];
		}
	}
	RMQ[v][j++] = RMQ[v][s - 1];
	RMQ[v].resize(j);
}

void ChMod(int v, int mod) {
	MOD[v] += mod;
	int s = RMQ[v].size();
	for (int i : RMQ[v])
		sum[i] += a[ard[i]] * mod;
	Ord(v);
}

void Push(int v) {
	Ord(2 * v);
	Ord(2 * v + 1);
	MOD[v] = 0;
}

int Max(int i, int j) {
	if (i == -1) return j;
	if (j == -1) return i;
	if (sum[i] < sum[j])
		return j;
	return i;
}

int Get(int v, int l, int r, int L, int R) {
	if (R <= l || r <= L) return -1;
	if (L <= l && r <= R)
		return RMQ[v][0];
	Push(v);
	int m = (l + r) / 2;
	return Max(Get(2 * v, l, m, L, R), 
			   Get(2 * v + 1, m, r, L, R));
}

void Add(int v, int l, int r, int L, int R, ll mod) {
	if (R <= l || r <= L) return;
	if (L <= l && r <= R) {
		ChMod(v, mod);
		return;
	}
	if (v < MAXN)
		Push(v);
	int m = (l + r) / 2;
	Add(2 * v, l, m, L, R, mod);
	Add(2 * v + 1, m, r, L, R, mod);
	Update(v);
}

bool LessA(int i, int j) {
	return a[i] < a[j];
}

bool LessB(int i, int j) {
	return b[i] < b[j];
}

int main() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i];
		byb[i] = i;
		ard[i] = i;
		// ret ard
	}
	sort(byb, byb + n, LessB);
	sort(ard, ard + n, LessA);
	int m = 0;
	for (int i = 0; i < n; ++i) {
		if (i == 0 || a[ard[i]] != a[ard[i - 1]]) {
			ard[m++] = ard[i];
		}
		ina[ard[i]] = m - 1;
	}
	Init();
	ll res = 0;
	int ci = 0;
	for (int i = 0; i < n; ++i) {
		if (i == 0 || b[byb[i]] != b[byb[i - 1]]) {
			ll cres = b[byb[i]] * (n - i);
			//cout << cres << ' ';
			cres += sum[Get(1, 0, MAXN, 0, m)];
			//cout << cres << '\n';
			chkmax(res, cres);
		}
		int j = upper_bound(ard, ard + m, byb[i], LessA) - ard;
		Add(1, 0, MAXN, 0, j, 1);
	}
	chkmax(res, sum[Get(1, 0, MAXN, 0, m)]);
	cout << res << '\n';
	//int m = unique(a, a + n) - a;
}

