#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

#define int int64_t

int inters(int k1, int b1, int k2, int b2)
{
	return floor(double(b2 - b1) / (k1 - k2));
}

struct cht
{
	vector<int> k, b, x;
	void add(int K, int B)
	{
		if (k.empty())
		{
			k.push_back(K);
			b.push_back(B);
			return;
		}
		int X;
		for (X = inters(K, B, k.back(), b.back()); x.size() && X <= x.back(); X = inters(K, B, k.back(), b.back()))
		{
			k.pop_back();
			b.pop_back();
			x.pop_back();
		}
		k.push_back(K);
		b.push_back(B);
		x.push_back(X);
	}
	int get_v(int X)
	{
		int l = upper_bound(x.begin(), x.end(), X) - x.begin();
		return k[l] * X + b[l];
	}
};

int32_t main()
{
	cht T;
	int n;
	cin >> n;
	vector<int> arr(n);
	for (int &i : arr)
	{
		int x;
		cin >> i >> x;
	}
	sort(arr.begin(), arr.end());
	reverse(arr.begin(), arr.end());
	int out = arr.back() * n;
	T.add(arr.back(), out);
	for (int i = n - 2; i >= 0; --i)
	{
		out = max(out, arr[i] * (i + 1) + T.get_v(-i - 1));
		T.add(arr[i], arr[i] * (i + 1));
	}
	cout << out;
	return 0;
}
