#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

struct ord_set
{
	vector<int> arr0;
	vector<int> tree;
	ord_set(vector<int> x) : arr0(x), tree(x.size(), 0) 
	{
		sort(arr0.begin(), arr0.end());
		arr0.resize(unique(arr0.begin(), arr0.end()) - arr0.begin());
	}
	void change(int x, int val)
	{
		int k = lower_bound(arr0.begin(), arr0.end(), x) - arr0.begin();
		for (int i = k; i < tree.size(); i = i | i + 1)
			tree[i] += val;
	}
	int ord(int x)
	{
		int k = lower_bound(arr0.begin(), arr0.end(), x) - arr0.begin(), ret = 0;
		for (int i = k - 1; i >= 0; i = (i & i + 1) - 1)
			ret += tree[i];
		return ret;
	}
};

int main()
{
	ios::sync_with_stdio(0);
	int n, p;
	cin >> n >> p;
	assert(p == 1);
	vector<int> arr(n);
	for (int &i : arr)
		cin >> i;
	vector<int> ap(n), am(n);
	for (int i = 0; i < n; i++)
	{
		ap[i] = arr[i] + i;
		am[i] = arr[i] - i;
	}
	ord_set L(am);
	ord_set R(ap);
	for (int i : ap)
		R.change(i, 1);
	for (int i = 0; i < n; i++)
	{
		cout << L.ord(am[i]) + R.ord(ap[i]) + 1 << "\n";
		L.change(am[i], 1);
		R.change(ap[i], -1);
	}
	return 0;
}