#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

struct ord_set
{
	vector<int> arr0;
	vector<int> tree;
	ord_set(vector<int> x) : arr0(x), tree(x.size(), 0) 
	{
		sort(arr0.begin(), arr0.end());
		arr0.resize(unique(arr0.begin(), arr0.end()) - arr0.begin());
	}
	void change(int x, int val)
	{
		int k = lower_bound(arr0.begin(), arr0.end(), x) - arr0.begin();
		for (int i = k; i < tree.size(); i = i | i + 1)
			tree[i] += val;
	}
	int ord(int x)
	{
		int k = lower_bound(arr0.begin(), arr0.end(), x) - arr0.begin(), ret = 0;
		for (int i = k - 1; i >= 0; i = (i & i + 1) - 1)
			ret += tree[i];
		return ret;
	}
};

int main()
{
	ios::sync_with_stdio(0);
	int n, p;
	cin >> n >> p;
	assert(p == 2);
	vector<int> arr(n);
	for (int &i : arr)
		cin >> i;
	vector<int> ap(n), am(n);
	for (int i = 0; i < n; i++)
	{
		ap[i] = arr[i] + i;
		am[i] = arr[i] - i;
	}
	ord_set L(ap);
	ord_set R(am);
	ord_set T(arr);
	vector<int> ans(n);
	for (int i = 0; i < n; i++)
	{
		L.change(ap[i], 1);
		R.change(am[i], 1);
		if (i)
			T.change(arr[i], 1);
	}
	for (int i = 0; i < n; i++)
		ans[i] = max(L.ord(ap[i]), R.ord(am[i])) + 1;
	for (int i = 0; i < n; i++)
	{
		L.change(ap[i], -1);
		R.change(am[i], -1);
	}
	int l = 0, r = 0;
	for (int i = 0; i < n; i++)
	{
		while (r < n && r - i <= i - l)
		{
			T.change(arr[r], -1);
			R.change(am[r++], 1);
		}
		while (i - l >= r - i)
		{
			T.change(arr[l], 1);
			L.change(ap[l++], -1);
		}
		cout << max(ans[i], T.ord(arr[i] + min(i, n - i - 1)) + L.ord(ap[i]) + R.ord(am[i]) + 1) << "\n";
		L.change(ap[i], 1);
		R.change(am[i], -1);
	}
	return 0;
}