#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void copy_to(vector<int> &vect, vector<int> &res)
{
    res.clear();
    for (auto v : vect)
        res.push_back(v);
}

void add_to(vector<int> &vect, int ind)
{
    while (vect.size() <= ind)
        vect.push_back(0);
    vect.push_back(0);
    for (int i = ind; i < vect.size() - 1; i++) {
        vect[i + 1] += vect[i] / 2;
        vect[i] %= 2;
    }
    while (vect[vect.size() - 1] == 0)
        vect.pop_back();
}

bool is_less(vector<int> &a, vector<int> &b)
{
    if (a.size() != b.size())
        return a.size() < b.size();
    for (int i = a.size() - 1; i >= 0; i--) {
        if (a[i] != b[i])
            return a[i] < b[i];
    }
    return false;
}

int n, m, k;
vector<pair<int, int> > vect;
int ans, ans_now;
int res;

vector<pair<int, int> > dop;

bool cmp(pair<int, int> a, pair<int, int> b)
{
    if (max(a.first, a.second) != max(b.first, b.second))
        return max(a.first, a.second) < max(b.first, b.second);
    return a.first + a.second < b.first + b.second;
}

bool new_cmp(int a, int b)
{
    if (max(vect[a].first, vect[a].second) != max(vect[b].first, vect[b].second))
        return max(vect[a].first, vect[a].second) < max(vect[b].first, vect[b].second);
    return vect[a].first + vect[a].second < vect[b].first + vect[b].second;
}

void action(int mask)
{
    int copy_mask = mask;
    dop.clear();
    int ind = 0;
    while (mask > 0) {
        if (mask & 1)
            dop.push_back(vect[ind]);
        mask >>= 1;
        ind++;
    }
    sort(dop.begin(), dop.end(), cmp);
    int now = 0;
    for (int i = 1; i < dop.size(); i++) {
        int step = max(abs(dop[i].first - dop[i - 1].first), abs(dop[i].second - dop[i - 1].second));
        now += (1 << step);
    }
    if (now < ans) {
        res = copy_mask;
        ans = now;
    }
}


int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    cin >> n >> m >> k;
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        vect.push_back({x, y});
    }
    ans = (int)1e9;
    int MAX_MASK = (1 << (k - 1));
    for (int i = 1; i < MAX_MASK; i += 2)
        action(i + MAX_MASK);
    int ind = 0;
    vector<int> my_res;
    while (res > 0) {
        if (res & 1)
            my_res.push_back(ind);
        res >>= 1;
        ind++;
    }
    sort(my_res.begin(), my_res.end(), new_cmp);
    cout << my_res.size() << "\n";
    for (int x : my_res)
        cout << x + 1 << ' ';
    return 0;
}
