#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

void copy_to(vector<ll> &vect, vector<ll> &res)
{
    res.clear();
    for (auto v : vect)
        res.push_back(v);
}

void add_to(vector<ll> &vect, ll ind)
{
    while (vect.size() <= ind)
        vect.push_back(0);
    vect.push_back(0);
    for (ll i = ind; i < vect.size() - 1; i++) {
        vect[i + 1] += vect[i] / 2;
        vect[i] %= 2;
    }
    while (vect[vect.size() - 1] == 0)
        vect.pop_back();
}

bool is_less(vector<ll> &a, vector<ll> &b)
{
    if (a.size() != b.size())
        return a.size() < b.size();
    for (ll i = a.size() - 1; i >= 0; i--) {
        if (a[i] != b[i])
            return a[i] < b[i];
    }
    return false;
}

ll n, m, k;
vector<pair<ll, ll> > vect;
ll ans, ans_now;
ll res;

vector<pair<ll, ll> > dop;

bool cmp(pair<ll, ll> a, pair<ll, ll> b)
{
    ll to_a = 1 << max(a.first - 1, a.second - 1);
    ll to_b = 1 << max(b.first - 1, b.second - 1);
    ll from_a = 1 << max(n - a.first, m - a.second);
    ll from_b = 1 << max(n - b.first, m - b.second);
    return to_a + from_b < to_b + from_a;
}

bool new_cmp(ll a, ll b)
{
    return cmp(vect[a], vect[b]);
}

void action(ll mask)
{
    ll copy_mask = mask;
    dop.clear();
    ll ind = 0;
    while (mask > 0) {
        if (mask & 1)
            dop.push_back(vect[ind]);
        mask >>= 1;
        ind++;
    }
    sort(dop.begin(), dop.end(), cmp);
    ll now = 0;
    for (ll i = 1; i < dop.size(); i++) {
        ll step = max(abs(dop[i].first - dop[i - 1].first), abs(dop[i].second - dop[i - 1].second));
        now += (1 << step);
    }
    if (now < ans) {
        res = copy_mask;
        ans = now;
    }
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    cin >> n >> m >> k;
    for (ll i = 0; i < k; i++) {
        ll x, y;
        cin >> x >> y;
        vect.push_back({x, y});
    }
    ans = (ll)1e18;
    ll MAX_MASK = (1 << (k - 1));
    for (ll i = 1; i < MAX_MASK; i += 2)
        action(i + MAX_MASK);
    ll ind = 0;
    vector<ll> my_res;
    while (res > 0) {
        if (res & 1)
            my_res.push_back(ind);
        res >>= 1;
        ind++;
    }
    sort(my_res.begin(), my_res.end(), new_cmp);
    cout << my_res.size() << "\n";
    for (ll x : my_res)
        cout << x + 1 << ' ';
    return 0;
}
