#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

void copy_to(vector<ll> &vect, vector<ll> &res)
{
    res.clear();
    for (auto v : vect)
        res.push_back(v);
}

ll n, m, k;
vector<pair<ll, ll> > vect;
ll ans, ans_now;
ll res;

vector<ll> dop;

bool cmp(pair<ll, ll> a, pair<ll, ll> b)
{
    return a.first + a.second < b.first + b.second;
}

bool new_cmp(ll a, ll b)
{
    return cmp(vect[a], vect[b]);
}

ll get_dist(ll a, ll b)
{
    ll step = max(abs(vect[a].first - vect[b].first), abs(vect[a].second - vect[b].second));
    return (1 << step);
}

void sort_dop()
{
    for (ll ind = 0; ind < dop.size() - 1; ind++) {
        for (ll i = ind + 1; i < dop.size(); i++) {
            if (get_dist(dop[i], dop[ind]) < get_dist(dop[ind], dop[ind + 1]))
                swap(dop[i], dop[ind + 1]);
        }
    }
}

ll get_ans_now()
{
    ll now = 0;
    for (ll i = 1; i < dop.size(); i++) {
        ll step = max(abs(vect[dop[i]].first - vect[dop[i - 1]].first), abs(vect[dop[i]].second - vect[dop[i - 1]].second));
        now += (1 << step);
    }
    return now;
}

void action(ll mask)
{
    ll copy_mask = mask;
    dop.clear();
    ll ind = 0;
    while (mask > 0) {
        if (mask & 1)
            dop.push_back(ind);
        mask >>= 1;
        ind++;
    }
    sort_dop();
    ll now = get_ans_now();
    if (now < ans) {
        ans = now;
        res = copy_mask;
    }
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    cin >> n >> m >> k;
    for (ll i = 0; i < k; i++) {
        ll x, y;
        cin >> x >> y;
        vect.push_back({x, y});
    }
    ans = (ll)1e18;
    ll MAX_MASK = (1 << (k - 1));
    for (ll i = 1; i < MAX_MASK; i += 2)
        action(i + MAX_MASK);
    ll ind = 0;
    dop.clear();
    while (res > 0) {
        if (res & 1)
            dop.push_back(ind);
        res >>= 1;
        ind++;
    }
    sort_dop();
    cout << dop.size() << "\n";
    for (ll x : dop)
        cout << x + 1 << ' ';
    return 0;
}
