#include <iostream>
#include <vector>
#include <stack>

using namespace std;

const int SZ = 3e5 + 10;

int n;
int mnext[SZ];
int tree[SZ * 4];
int sz = 1;

void build()
{
    cin >> n;
    while (sz < n)
        sz <<= 1;
    for (int i = 0; i < n; i++)
        cin >> tree[sz + i];
    for (int i = sz - 1; i > 0; i--)
        tree[i] = max(tree[i * 2], tree[i * 2 + 1]);

    stack<int> st;
    for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && tree[sz + st.top()] >= tree[sz + i])
            st.pop();
        if (st.empty())
            mnext[i] = n;
        else
            mnext[i] = st.top();
        st.push(i);
    }
}

int get_max_ind(int ind)
{
    while (ind < sz) {
        if (tree[ind * 2 + 1] == tree[ind])
            ind = ind * 2 + 1;
        else
            ind = ind * 2;
    }
    return ind;
}

int get_max(int L, int R)
{
    L += sz;
    R += sz;
    int res = 0, ind = -1;
    while (L <= R) {
        if (L & 1) {
            if (tree[L] > res) {
                res = tree[L];
                ind = get_max_ind(L);
            }
            else if (tree[L] == res)
                ind = max(ind, get_max_ind(L));
            L++;
        }
        if (~R & 1) {
            if (tree[R] > res) {
                res = tree[R];
                ind = get_max_ind(R);
            }
            else if (tree[R] == res)
                ind = max(ind, get_max_ind(R));
            R--;
        }
        L >>= 1;
        R >>= 1;
    }
    return ind;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    build();
    int L = 0;
    int res = 0;
    while (L < n) {
        int R = mnext[L];
        R = get_max(L, R - 1);
        R -= sz;
        L = R + 1;
        res++;
    }
    cout << res;
    return 0;
}
