#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

const int SZ = 4e5 + 10;

struct node {
    node *left, *right;
    int x, y;
    int cnt;

    ~node() {
        delete left;
        delete right;
    }
};

int get_cnt(node *v)
{
    if (!v)
        return 0;
    return v -> cnt;
}

void upd_cnt(node *v)
{
    v -> cnt = get_cnt(v -> left) + get_cnt(v -> right) + 1;
}

pair<node*, node*> split_dt(node *v, int val)
{
    pair<node*, node*> res = {nullptr, nullptr};
    if (!v)
        return res;
    if (v -> x < val) {
        res = split_dt(v -> right, val);
        v -> right = res.first;
        upd_cnt(v);
        res.first = v;
        return res;
    }
    res = split_dt(v -> left, val);
    v -> left = res.second;
    upd_cnt(v);
    res.second = v;
    return res;
}

node* merge_dt(node *L, node *R)
{
    if (!L)
        return R;
    if (!R)
        return L;
    if (L -> y > R -> y) {
        L -> right = merge_dt(L -> right, R);
        upd_cnt(L);
        return L;
    }
    R -> left = merge_dt(L, R -> left);
    upd_cnt(R);
    return R;
}

int get_cnt_less_than(node *v, int numb)
{
    pair<node*, node*> t = split_dt(v, numb);
    int res = get_cnt(t.first);
    v = merge_dt(t.first, t.second);
    return res;
}

node* add_node(node *v, int numb)
{
    pair<node*, node*> t = split_dt(v, numb);
    node *now = new node({nullptr, nullptr, numb, rand(), 1});
    t.first = merge_dt(t.first, now);
    return v = merge_dt(t.first, t.second);
}

int n, p;
int arr[SZ];
node *root = nullptr;

int ans[SZ];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> p;
    int add_to_all = 0;
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        ans[i] = get_cnt_less_than(root, arr[i] - add_to_all) + 1;
        root = add_node(root, arr[i] - add_to_all);
        add_to_all++;
    }
    delete root;
    root = nullptr;
    add_to_all = 0;
    for (int i = n - 1; i >= 0; i--) {
        ans[i] += get_cnt_less_than(root, arr[i] - add_to_all);
        root = add_node(root, arr[i] - add_to_all);
        add_to_all++;
    }
    for (int i = 0; i < n; i++)
        cout << ans[i] << "\n";
    return 0;
}
