#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <sstream>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;

int n;

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios::sync_with_stdio(false);

	int t;
	cin >> n;

	vector<vector<int>> p(n, vector<int> (n));
	vector<vector<int>> l(n);

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			int x;
			cin >> x;
			x--;
			p[i][x] = j;
			l[i].push_back(x);
		}
	}
	cin >> t;

	vector<bool> stable(n, false);

	for (int i = 0; i < n; i++) {
		if (p[i][i] == 0) {
			stable[i] = true;
		}
	}

	if (t == 1) {
		vector<int> ans;
		
		for (int i = 0; i < n; i++) {
			if (stable[i])
				ans.push_back(i);
		}
		cout << ans.size() << endl;
		for (int i : ans)
			cout << i + 1 << ' ';
		return 0;
	}

	vector<int> ans;

	vector<bitset<550>> can(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (p[i][j] <= p[i][i])
				can[j][i] = true;
		}
	}

	vector<vector<bool>> h(n, vector<bool> (n, false));
	vector<bool> in(n, false);

	for (int i = 0; i < n; i++) {
		bitset<550> able;
		for (int j = n - 1; j >= 0; j--) {
			int u = l[i][j];

			able |= can[u];
			
			if(able.count() == n)
				h[i][j] = true;
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (h[j][p[j][i]])
				in[i] = true;
		}
		if (in[i])
			ans.push_back(i);
	}

	cout << ans.size() << endl;
	for (int i : ans)
		cout << i + 1 << ' ';

	return 0;
}