#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <sstream>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 4e9;

const int MAX_SZ = 550;

struct num {
	bitset<MAX_SZ> dig;
	bool is_inf;
	num() {
		is_inf = true;
	}

	bool operator > (const num &b) const {
		if (is_inf)
			return true;
		if (b.is_inf)
			return false;

		for (int i = MAX_SZ - 1; i >= 0; i--) {
			if (dig[i] && !b.dig[i])
				return true;
			else if (!dig[i] && b.dig[i])
				return false;
		}
		return false;
	}

	void set(int ind) {
		if (!dig[ind]) {
			dig[ind] = true;
			return;
		}

		for (int i = ind; i < MAX_SZ; i++) {
			if (!dig[i]) {
				dig[i] = true;
				break;
			}
			else
				dig[i] = false;
		}
	}
};

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n, m, k;
	cin >> n >> m >> k;

	vector<int> x(k), y(k);

	for (int i = 0; i < k; i++) {
		cin >> x[i] >> y[i];
		x[i]--, y[i]--;
	}

	vector<num> dist(k);
	vector<bool> used(k);
	dist[0].is_inf = false;

	vector<int> prev(k);

	while(true) {
		int ind = -1;
		num mi;
		for (int j = 0; j < k; j++) {
			if (!used[j] && !dist[j].is_inf && mi > dist[j]) {
				mi = dist[j];
				ind = j;
			}
		}

		if (ind == -1)
			break;

		//cout << ind + 1 << endl;

		used[ind] = true;

		for (int i = 0; i < k; i++) {
			num now = dist[ind];
			now.set(max(abs(x[ind] - x[i]), abs(y[ind] - y[i])));
			if (dist[i] > now) {
				dist[i] = now;
				prev[i] = ind;
			}
		}
	}

	int now = k - 1;
	vector<int> ans;
	while (now > 0) {
		ans.push_back(now);
		now = prev[now];
	}
	ans.push_back(0);
	reverse(ans.begin(), ans.end());

	cout << ans.size() << endl;
	for (int i : ans)
		cout << i + 1 << ' ';

	return 0;
}