#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cstdio>
#include <algorithm>

using namespace std;

const int INF = 1e9 + 5;

struct node {
	int ma_ind, mi_ind;
};

vector<node> tree;

void build(int i, int L, int R, vector<int> &val) {
	if (L + 1 == R) {
		tree[i].ma_ind = L;
		tree[i].mi_ind = L;
		return;
	}
	int m = (L + R) >> 1;
	build(2 * i + 1, L, m, val);
	build(2 * i + 2, m, R, val);

	if (val[tree[2 * i + 1].mi_ind] <= val[tree[2 * i + 2].mi_ind])
		tree[i].mi_ind = tree[2 * i + 1].mi_ind;
	else
		tree[i].mi_ind = tree[2 * i + 2].mi_ind;

	if (val[tree[2 * i + 1].ma_ind] > val[tree[2 * i + 2].ma_ind])
		tree[i].ma_ind = tree[2 * i + 1].ma_ind;
	else
		tree[i].ma_ind = tree[2 * i + 2].ma_ind;
}

int get_ma(int i, int L, int R, int l, int r, vector<int> &v) {
	if (l <= L && R <= r)
		return tree[i].ma_ind;
	if (R <= l || r <= L)
		return -1;

	int m = (L + R) >> 1;
	int a = get_ma(2 * i + 1, L, m, l, r, v), b = get_ma(2 * i + 2, m, R, l, r, v);
	if (b == -1)
		return a;
	if (a == -1)
		return b;
	if (v[b] >= v[a])
		return b;
	else
		return a;
}

int f(int l, int r, vector<int> &v) {
	if (l >= r)
		return 0;

	int ma_ind = get_ma(0, 0, v.size(), l, r, v), mi_ind = l;

	int mi = INF;
	for (int i = ma_ind; i >= l; i--) {
		mi = min(mi, v[i]);
		if (mi == v[i]) {
			mi_ind = i;
		}
	}

	return f(l, mi_ind, v) + f(ma_ind + 1, r, v) + 1;
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n;
	cin >> n;

	vector<int> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}

	tree.assign(4 * n, node());
	build(0, 0, n, v);

	cout << f(0, n, v) << endl;

	return 0;
}