#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#pragma comment(linker, "/STACK:536870912")
using namespace std;

int tmin[1200000];
int tmax[1200000];

map<pair<int, int>, int> mem;

void build(int v, int l, int r, vector<int> &seq)
{
	if (l == r)
	{
		tmin[v] = seq[l];
		tmax[v] = seq[l];
		return;
	}
	int m = (l + r) / 2;
	build(v * 2, l, m, seq);
	build(v * 2 + 1, m + 1, r, seq);
	tmin[v] = min(tmin[v * 2], tmin[v * 2 + 1]);
	tmax[v] = max(tmax[v * 2], tmax[v * 2 + 1]);
}

int getmin(int v, int l, int r, int tl, int tr)
{
	if ((l < tl && r < tl) || (tl < l && tr < l))
		return 1000000001;
	if (l > r)
		return 1000000001;
	if (tl == l && tr == r)
		return tmin[v];
	int m = (tl + tr) / 2;
	return min(getmin(v * 2, l, min(r, m), tl, m), getmin(v * 2 + 1, max(l, m + 1), r, m + 1, tr));
}

int getmax(int v, int l, int r, int tl, int tr)
{
	if ((l < tl && r < tl) || (tl < l && tr < l))
		return -1;
	if (l > r)
		return -1;
	if (tl == l && tr == r)
		return tmax[v];
	int m = (tl + tr) / 2;
	return max(getmax(v * 2, l, min(r, m), tl, m), getmax(v * 2 + 1, max(l, m + 1), r, m + 1, tr));
}

int dp(int l, int r, int n, vector<int> &seq)
{
	if (l == r)
		return 1;
	//if (l + 1 == r)
	//{
	//	if (l <= r)
	//		return 1;
	//	else
	//		return 2;
	//}
	//if (mem.find(make_pair(l, r)) != mem.end())
	//	return mem[make_pair(l, r)];
	if (getmin(1, l, r, 0, n - 1) == seq[l] && getmax(1, l, r, 0, n - 1) == seq[r])
		return 1;
	int minv = 1000000001;
	for (int i = l; i < r; i++)
		minv = min(minv, dp(l, i, n, seq) + dp(i + 1, r, n, seq));
	if (minv == 1000000001)
		cout << l << ' ' << r << endl;
	//mem[make_pair(l, r)] = minv;
	return minv;
}



int main()
{
	int n;
	cin >> n;
	vector<int> seq(n);
	for (int i = 0; i < n; i++)
		cin >> seq[i];
	build(1, 0, n - 1, seq);
	cout << dp(0, n - 1, n, seq);
	return 0;
}