#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;

const int maxn = 4e5 + 7;

mt19937 rnd(322);

int x[2 * maxn];
int y[2 * maxn];
int sz[2 * maxn];
int r[2 * maxn];
int l[2 * maxn];
int first_empty;

int rootr = -1, rootl = -1;

inline int newnode(int key){
    x[first_empty] = key;
    y[first_empty] = rnd();
    sz[first_empty] = 1;
    l[first_empty] = r[first_empty] = -1;
    return first_empty++;
}

inline int get_sz(int T){
    return (T == -1 ? 0 : sz[T]);
}

inline void recalc(int T){
    if (T == -1)
        return;
    sz[T] = get_sz(l[T]) + get_sz(r[T]) + 1;
}

inline int merge(int L, int R){
    if (L == -1)
        return R;
    if (R == -1)
        return L;
    if (y[L] > y[R]){
        r[L] = merge(r[L], R);
        recalc(L);
        return L;
    }

    l[R] = merge(L, l[R]);
    recalc(R);
    return R;
}

inline pair<int, int> split(int T, int key){
    if (T == -1)
        return {-1, -1};
    if (x[T] <= key){
        auto tmp = split(r[T], key);
        r[T] = tmp.first;
        recalc(T);
        return {T, tmp.second};
    }

    auto tmp = split(l[T], key);
    l[T] = tmp.second;
    recalc(T);
    return {tmp.first, T};
}

inline int insert(int T, int x){
    int v = newnode(x);
    auto tmp = split(T, x);
    T = merge(merge(tmp.first, v), tmp.second);
    return T;
}

inline int erase(int T, int x){
    auto tmp = split(T, x);
    auto tmp2 = split(tmp.first, x - 1);
    if (tmp2.second != -1)
        T = merge(tmp2.first, merge(l[tmp2.second], merge(r[tmp2.second], tmp.second)));
    else
        T = merge(tmp2.first, tmp.second);
    return T;
}

inline int mless(int T, int x){
    auto tmp = split(T, x - 1);

    int ret = get_sz(tmp.first);
    T = merge(tmp.first, tmp.second);
    return ret;
}

int a[maxn];
int al = 0, ar = 0;

int main()
{
    #ifdef ONPC
        ifstream cin("in.txt");
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    #endif // ONPC

    int n, x;
    cin >> n >> x;

    for (int i = 0; i < n; ++i){
        cin >> a[i];
        rootr = insert(rootr, a[i] + i);
    }

    for (int i = 0; i < n; ++i){
        rootr = erase(rootr, a[i] + i);

        int ans = mless(rootr, a[i] - ar) + mless(rootl, a[i] - al);
        cout << ans + 1 << '\n';

        rootl = insert(rootl, a[i] - al);
        ++al;
        --ar;
    }

    return 0;
}
