#include <bits/stdc++.h>

using namespace std;

const int maxn = 4e5;

mt19937 rnd(322);

struct node{
    int x, y, sz;
    node *l, *r;
    node (){}
    node(int x) : x(x), y(rnd()), sz(1), l(nullptr), r(nullptr){}
};

node *rootr, *rootl;

inline int get_sz(node *T){
    return (T == nullptr ? 0 : T->sz);
}

inline void recalc(node *T){
    if (T == nullptr)
        return;
    T->sz = get_sz(T->l) + get_sz(T->r) + 1;
}

inline node *merge(node *L, node *R){
    if (L == nullptr)
        return R;
    if (R == nullptr)
        return L;
    if (L->y > R->y){
        L->r = merge(L->r, R);
        recalc(L);
        return L;
    }

    R->l = merge(L, R->l);
    recalc(R);
    return R;
}

inline pair<node*, node*> split(node *T, int key){
    if (T == nullptr)
        return {nullptr, nullptr};
    if (T->x <= key){
        auto tmp = split(T->r, key);
        T->r = tmp.first;
        recalc(T);
        return {T, tmp.second};
    }

    auto tmp = split(T->l, key);
    T->l = tmp.second;
    recalc(T);
    return {tmp.first, T};
}

inline node *insert(node *T, int x){
    node *v = new node(x);
    auto tmp = split(T, x);
    T = merge(merge(tmp.first, v), tmp.second);
    return T;
}

inline node *erase(node *T, int x){
    auto tmp = split(T, x);
    auto tmp2 = split(tmp.first, x - 1);
    if (tmp2.second != nullptr)
        T = merge(tmp2.first, merge(tmp2.second->l, merge(tmp2.second->r, tmp.second)));
    else
        T = merge(tmp2.first, (tmp.second));
    return T;
}

inline int mless(node *T, int x){
    auto tmp = split(T, x - 1);

    int ret = get_sz(tmp.first);
    T = merge(tmp.first, tmp.second);
    return ret;
}

int a[maxn];
int al = 0, ar = 0;

int main()
{
    #ifdef ONPC
        ifstream cin("in.txt");
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    #endif // ONPC

    int n, x;
    cin >> n >> x;

    for (int i = 0; i < n; ++i){
        cin >> a[i];
        rootr = insert(rootr, a[i] + i);
    }

    for (int i = 0; i < n; ++i){
        rootr = erase(rootr, a[i] + i);

        int ans = mless(rootr, a[i] - ar) + mless(rootl, a[i] - al);
        cout << ans + 1 << '\n';

        rootl = insert(rootl, a[i] - al);
        ++al;
        --ar;
    }

    return 0;
}
