import java.util.Arrays;
import java.util.PriorityQueue;
import java.util.Scanner;

public class A {
    class Elem implements Comparable<Elem>{
        int val;
        int idx;
        Elem(int val, int idx){
            this.val = val;
            this.idx = idx;
        }

        @Override
        public int compareTo(Elem o) {
            return -Integer.compare(this.val, o.val);
        }
    }
    final int POW = 20;
    int log(int a){
        int left = 0;
        int right = POW-1;
        while(right-left>1){
            int mid = (left+right)/2;
            if(a>power[mid]) left = mid;
            else if(a<power[mid]) right = mid-1;
            else return mid;
        }
        if(a>=power[right]) return right;
        return left;
    }
    int[] arr;
    int n;
    int[][] st;
    int[] power;
    int max(int idx1, int idx2){
        if(arr[idx1]>arr[idx2]) return idx1;
        if(arr[idx1]<arr[idx2]) return idx2;
        return Math.max(idx1, idx2);
    }
    A(){
        Scanner in = new Scanner(System.in);
        n = in.nextInt();
        arr = new int[n];
        for(int i=0;i<n;i++){
            arr[i] = in.nextInt();
        }
        power = new int[POW];
        power[0] = 1;
        for(int i=1;i<POW;i++){
            power[i] = 2*power[i-1];
        }
        //System.out.println(Arrays.toString(power));
        st = new int[n][POW];
        for(int i=0;i<n;i++){
            st[i][0] = i;
        }
        for(int j=1;j<POW;j++){
            for(int i=0;i<n;i++){
                st[i][j] = max(st[i][j-1], st[Math.min(i+power[j-1], n-1)][j-1]);
            }
        }
        /*for(int j=0;j<POW;j++){
            System.out.print(j+": ");
            for(int i=0;i<n;i++){
                System.out.print((st[i][j]+1)+" ");
            }
            System.out.println();
        }*/
        int[] len = new int[n];
        PriorityQueue<Elem> q = new PriorityQueue<>();
        for(int i=0;i<n;i++){
            while(!q.isEmpty() && q.peek().val>arr[i]){
                Elem e = q.poll();
                len[e.idx] = i-e.idx;
            }
            q.add(new Elem(arr[i], i));
        }
        while(!q.isEmpty()){
            Elem e = q.poll();
            len[e.idx] = n-e.idx;
        }
        /*for(int i=0;i<n;i++){
            System.out.print(len[i]+" ");
        }*/
        int curStart = 0;
        int ans = 0;
        while(curStart<n){
            int left = curStart;
            int right = curStart+len[curStart]-1;
            int log = log(len[curStart]);
            //System.out.println("log "+len[curStart]+" = "+log);
            int end = max(st[left][log], st[right-power[log]+1][log]);
            //System.out.println("("+left+";"+end+")");
            curStart = end+1;
            ++ans;
        }
        System.out.println(ans);
    }
    public static void main(String[] args){
        new A();
    }
}
