#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <string>
typedef long long ll;

using namespace std;
const int Q = 1 << 21;
int tmin[2 * Q];
int tmax[2 * Q];
int min(int a, int b)
{
	return a < b ? a : b;
}
int max(int a, int b)
{
	return a > b ? a : b;
}
const int INF = 1e9+10;
void add(int x, int p)
{
	p += Q;
	tmin[p] = x;
	tmax[p] = x;
	p /= 2;
	while (p > 0)
	{
		tmin[p] = min(tmin[p * 2], tmin[p * 2 + 1]);
		tmax[p] = max(tmax[p * 2], tmax[p * 2 + 1]);
		p /= 2;
	}
}
int searchmin(int L, int R)
{
	int ans = INF;
	for (L += Q, R += Q; L < R; L /= 2, R /= 2)
	{
		if (L & 1)
			ans = min(ans, tmin[L++]);
		if (R & 1)
			ans = min(ans, tmin[--R]);
	}
	return ans;
}
int searchmax(int L, int R)
{
	int ans = 0;
	for (L += Q, R += Q; L < R; L /= 2, R /= 2)
	{
		if (L & 1)
			ans = max(ans, tmax[L++]);
		if (R & 1)
			ans = max(ans, tmax[--R]);
	}
	return ans;
}

int main()
{
	int n;
	cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		add(a[i], i);
	}
		
	vector <int> dp(n,INF);
	dp[0] = 1;
	for (int i = 1; i < n; i++)
	{
		int mi = searchmin(0, i + 1);
		int ma = searchmax(0, i + 1);
		if (a[0] == mi && a[i] == ma)
			dp[i] = 1;
		else
			for (int j = 0; j < i; j++)
			{
				int L = j + 1, R = i + 1;
				int mi = searchmin(L, R);
				int ma = searchmax(L, R);
				if (mi == a[j + 1] && ma == a[i])
				{
					dp[i] = min(dp[i], dp[j] + 1);
				}
				//cout << mi << " " << ma << "\n";
			}
		
	}
	cout << dp[n - 1];
	system("pause");
	return 0;
}