#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <string>
typedef long long ll;

using namespace std;
const int Q = 1 << 21;
int tmin[2 * Q];
int tmax[2 * Q];
int ptmax[2 * Q];
int ptmin[2 * Q];
int min(int a, int b)
{
	return a < b ? a : b;
}
int max(int a, int b)
{
	return a > b ? a : b;
}
const int INF = 1e9+10;
void add(int x, int p)
{
	p += Q;
	tmin[p] = x;
	tmax[p] = x;
	ptmin[p] = p - Q;
	ptmax[p] = p - Q;
	p /= 2;
	while (p > 0)
	{
		tmin[p] = min(tmin[p * 2], tmin[p * 2 + 1]);
		if (tmin[p] == tmin[p * 2 + 1])
			ptmin[p] = ptmin[p * 2 + 1];
		if (tmin[p] == tmin[p * 2])
			ptmin[p] = ptmin[p * 2];
		tmax[p] = max(tmax[p * 2], tmax[p * 2 + 1]);
		if (tmax[p] == tmax[p * 2])
			ptmax[p] = ptmax[p * 2];
		if (tmax[p] == tmax[p * 2 + 1])
			ptmax[p] = ptmax[p * 2 + 1];
		p /= 2;
	}
}
int searchmin(int L, int R)
{
	int ans = INF;
	int anst = 0;
	for (L += Q, R += Q; L < R; L /= 2, R /= 2)
	{
		if (L & 1)
		{
			ans = min(ans, tmin[L++]);
			if (ans == tmin[L - 1])
				anst = ptmin[L - 1];
		}
		if (R & 1)
		{
			ans = min(ans, tmin[--R]);
			if (ans == tmin[R])
				anst = ptmin[R];
		}
	}
	return anst; 
}
int searchmax(int L, int R)
{
	int ans = 0;
	int anst = 0;
	for (L += Q, R += Q; L < R; L /= 2, R /= 2)
	{
		if (L & 1)
		{
			ans = max(ans, tmax[L++]);
			if (ans == tmax[L-1])
				anst = ptmax[L - 1];
		}
		if (R & 1)
		{
			ans = max(ans, tmax[--R]);
			if (ans == tmax[R])
				anst = ptmax[R];
		}
	}
	return anst;
}
int solve(int st, vector <int> &a)
{
	int L = st, R = a.size();
	int mi = searchmin(L, R);
	if (a[mi] == a[st])
	{
		int ma = searchmax(L, R);
		return ma + 1;
	}
	else
	{
		if (a[st + 1] > a[st])
			return mi;
		else
			return st + 1;
	}
}
int main()
{
	//freopen("out.txt", "r", stdin);
	int n;
	cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; i++)
	{
		scanf("%d", &a[i]);
		add(a[i], i);
	}
	int i = 0;
	int ans = 0;
	while (i < n)
	{
		i = solve(i, a);
		ans++;
	}
	cout << ans;
	system("pause");
	return 0;
}