typedef long long ll;
typedef long double ld;
#include<iostream>
#include<vector>
#include<string>
#include<iomanip>
#include<map>
#include<set>
#include<algorithm>
#include<deque>

using namespace std;

ll INF = 1e16;
ll last = 2;
ll t[10000000], l[10000000], r[10000000];

void push(ll v) {
	if (l[v] == 0) {
		l[v] = ++last;
	}
	if (r[v] == 0) {
		r[v] = ++last;
	}
}

void update(ll v, ll tl, ll tr, ll pos, ll val) {
	push(v);
	if (tl == tr) {
		t[v] += val;
		return;
	}
	ll tm = (tl + tr) / 2;
	if (pos <= tm) {
		update(l[v], tl, tm, pos, val);
	}
	else {
		update(r[v], tm + 1, tr, pos, val);
	}
	t[v] = t[l[v]] + t[r[v]];
}

ll get_sum(ll v, ll tl, ll tr, ll left, ll right) {
	left = max(left, tl);
	right = min(right, tr);
	if (left > right) {
		return 0;
	}
	push(v);
	if (tl == left && tr == right) {
		return t[v];
	}
	ll tm = (tl + tr) / 2;
	return get_sum(l[v], tl, tm, left, right) + get_sum(r[v], tm + 1, tr, left, right);
}


int main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	ll n;
	cin >> n;
	ll p;
	cin >> p;
	vector<ll>v(n);
	for (ll i = 0; i < n; i++) {
		cin >> v[i];
		v[i] += 10000000;
	}
	vector<ll>ans(n);
	for (ll i = 0; i < n; i++) {
		ans[i] += get_sum(1, 0, INF, 0, v[i] - i-1);
		update(1, 0, INF, v[i] - i, 1);
	}

	last = 2;
	for (ll i = 0; i < 10000000; i++) {
		t[i] = 0; l[i] = 0; r[i] = 0;
	}
	reverse(v.begin(), v.end());

	for (ll i = 0; i < n; i++) {
		ans[n-i-1] += get_sum(1, 0, INF, 0,v[i] - i-1);
		update(1, 0, INF, v[i] - i, 1);
	}

	for (auto now : ans) {
		cout << now + 1<< '\n';
	}

	return 0;
}