#include <iostream>
#include <vector>
#include <cmath>
#include <unordered_set>
#include <algorithm>

using namespace std;

namespace std
{
template<>
struct hash<pair<long double, int> >
{
auto operator()(const pair<long double, int>&it) const
{
    return std::hash<long double>()(it.first)^std::hash<int>()(it.second);
}
};
}

int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    pair<int, int> items[k];
    for(int i = 0; i < k; i++)
        cin >> items[i].first >> items[i].second;
    unordered_set<pair<long double, int> > needupd;
    needupd.insert(make_pair(0.l, 0));
    long double dist[k];
    for(int i = 0; i < k; i++)
        dist[i] = 1. / 0;
    dist[0] = 0;
    int prev[k];
    for(int i = 0; i < k; i++)
        prev[i] = -1;
    while(!needupd.empty())
    {
        pair<long double, int> i = *min_element(needupd.begin(), needupd.end());
        needupd.erase(i);
        if(i.first != dist[i.second]) continue;
        for(int j = 0; j < k; j++)
        {
            long double d = pow(2, max(abs(items[i.second].first - items[j].first), abs(items[i.second].second - items[j].second)));
            d += i.first;
            if(d < dist[j])
            {
                needupd.erase(make_pair(dist[j], j));
                dist[j] = d;
                needupd.insert(make_pair(d, j));
                prev[j] = i.second;
            }
        }
    }
    vector<int> ans;
    int cur = k - 1;
    while(cur >= 0)
    {
        ans.push_back(cur + 1);
        cur = prev[cur];
    }
    cout << ans.size() << endl;
    reverse(ans.begin(), ans.end());
    cout << ans[0];
    for(int i = 1; i < ans.size(); i++)
        cout << ' ' << ans[i];
    cout << endl;
    return 0;
}
