#include <iostream>
#include <vector>

using namespace std;

int log2(int n)
{
    return 31 - __builtin_clz(n);
}

int solve(vector<vector<pair<int, int> > >& sparse, int n, int a, int b)
{
    if(a == b)
        return 0;
    int idx = log2(b - a);
    int dist = 1 << idx;
    int minidx = min(sparse[idx][a], sparse[idx][b - dist]).second;
    int maxidx = -min(sparse[idx][a + n], sparse[idx][b - dist + n]).second;
    if(minidx <= maxidx)
        return solve(sparse, n, a, minidx) + 1 + solve(sparse, n, maxidx + 1, b);
    else
        return solve(sparse, n, a, maxidx + 1) + solve(sparse, n, maxidx, minidx - 1) + solve(sparse, n, minidx, b);
}

int main()
{
    int n;
    cin >> n;
    int data[n];
    for(int i = 0; i < n; i++)
        cin >> data[i];
    vector<vector<pair<int, int> > > sparse(1, vector<pair<int, int> >(2 * n));
    for(int i = 0; i < n; i++)
    {
        sparse[0][i] = make_pair(data[i], i);
        sparse[0][i + n] = make_pair(-data[i], -i);
    }
    int cur = 1;
    while(sparse.back().size() != 0)
    {
        int oldlen = sparse.size();
        sparse.push_back(vector<pair<int, int> >());
        for(int i = 0; i + cur < sparse[oldlen - 1].size(); i++)
            sparse[oldlen].push_back(min(sparse[oldlen - 1][i], sparse[oldlen - 1][i + cur]));
        cur <<= 1;
    }
    cout << solve(sparse, n, 0, n) << endl;
    return 0;
}
