#include <iostream>

using namespace std;

inline int clz(int x)
{
    return __builtin_clz(x);
}

inline int ctz(int x)
{
    return 31 - clz(x ^ (x - 1));
}

inline int nearest_nonzero(int x, int bit)
{
    return min(clz(x << (31 - bit)), ctz(x >> bit));
}

int main()
{
    int n, q;
    cin >> n >> q;
    int data[n];
    for(int i = 0; i < n; i++)
        cin >> data[i];
    for(int i = 0; i < n; i++)
    {
        int best_place = (q == 1) ? n : 1;
        for(int mask = 0; mask < (1 << n); mask++)
        {
            int cur = data[i] + nearest_nonzero(mask, i);
            int cnt = 1;
            for(int j = 0; j < n; j++)
                cnt += (data[j] + nearest_nonzero(mask, j) < cur);
            if(q == 1)
                best_place = min(best_place, cnt);
            else
                best_place = max(best_place, cnt);
        }
        cout << best_place << endl;
    }
    return 0;
}
