#include <iostream>

using namespace std;

//inline int clz(int x)
//{
//    return __builtin_clz(x);
//}

inline int clz(unsigned int x)
{
    if(x == 0)
        return 32;
    int ans = 0;
    if((x & 0xffff0000) == 0)
    {
        ans += 16;
        x <<= 16;
    }
    if((x & 0xff000000) == 0)
    {
        ans += 8;
        x <<= 8;
    }
    if((x & 0xf0000000) == 0)
    {
        ans += 4;
        x <<= 4;
    }
    if((x & 0xc0000000) == 0)
    {
        ans += 2;
        x <<= 2;
    }
    if((x & 0x80000000) == 0)
        ans += 1;
    return ans;
}

inline int ctz(int x)
{
    return 31 - clz(x ^ (x - 1));
}

inline int nearest_nonzero(int x, int bit)
{
    return min(clz(x << (31 - bit)), ctz(x >> bit));
}

int main()
{
    int n, q;
    cin >> n >> q;
    int data[n];
    for(int i = 0; i < n; i++)
        cin >> data[i];
    for(int i = 0; i < n; i++)
    {
        int best_place = (q == 1) ? n : 1;
        for(int mask = 1; mask < (1 << n); mask++)
        {
            int cur = data[i] + nearest_nonzero(mask, i);
            int cnt = 1;
            for(int j = 0; j < n; j++)
                cnt += (data[j] + nearest_nonzero(mask, j) < cur);
            if(q == 1)
                best_place = min(best_place, cnt);
            else
                best_place = max(best_place, cnt);
        }
        cout << best_place << endl;
    }
    return 0;
}
