#include <iostream>
#include <set>
using namespace std;

#define MAX_N 200000

int *matrix[MAX_N];
int maxV[MAX_N], maxG[MAX_N];
pair<int, int> maxGIndexes[MAX_N], maxVIndexes2[MAX_N];
set<pair<int, int> > ans;

int main() {
#ifdef AC
    freopen("input.txt", "r", stdin);
#endif // AC

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, q;
    cin >> n >> m >> q;

    for (int i = 0; i < n; ++i) {
        matrix[i] = new int[m];
        for (int j = 0; j < m; ++j) {
            cin >> matrix[i][j];
            if (matrix[i][j] > maxG[i]) {
                maxG[i] = matrix[i][j];
                maxGIndexes[i] = {i, j};
            }
        }
    }

    for (int i = 0; i < m; ++i) {
        int locBest = 0;
        for (int j = 1; j < n; ++j)
            if (matrix[locBest][i] < matrix[j][i])
                locBest = j;
        maxV[i] = matrix[locBest][i];
        maxVIndexes2[i] = {locBest, i};
    }

    for (int i = 0; i < n; ++i)
        if (maxVIndexes2[maxGIndexes[i].second].first == i)
            ans.insert(maxGIndexes[i]);

    int x, y, v;
    for (int i = 0; i < q; ++i) {
        cin >> x >> y >> v;
        matrix[--x][--y] = v;
        if (maxG[x] < v) {
            auto it = ans.find(maxGIndexes[x]);
            maxGIndexes[x].second = y;
            maxG[x] = v;
            if(it != ans.end())
                ans.erase(it);
        }
        if (maxV[y] < v) {
            auto it = ans.find(maxVIndexes2[y]);
            maxVIndexes2[y].first = x;
            maxV[y] = v;
            if(it != ans.end())
                ans.erase(it);
        }
        if (maxGIndexes[x].second == y && maxVIndexes2[y].first == x)
            ans.insert({x, y});

        cout << ans.size() << "\n";
    }


    return 0;
}
