#include <cstdio>
#include <cassert>
#include <iostream>
using namespace std;

#define MAX_N 5001

int a[MAX_N], prefixMin[MAX_N], suffixMin[MAX_N], suffixMax[MAX_N], dp[MAX_N];

int main() {
#ifdef AC
    freopen("input.txt", "r", stdin);
#endif // AC
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    assert(n <= 5000);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    suffixMax[0] = -1;
    for (int i = 1; i < n; ++i) {
        suffixMax[i] = i - 1;
        while (suffixMax[i] != -1)
            if (a[suffixMax[i]] <= a[i])
                suffixMax[i] = suffixMax[suffixMax[i]];
            else
                break;
    }
    suffixMin[0] = -1;
    for (int i = 1; i < n; ++i) {
        suffixMin[i] = i - 1;
        while (suffixMin[i] != -1)
            if (a[suffixMin[i]] >= a[i])
                suffixMin[i] = suffixMin[suffixMin[i]];
            else
                break;
    }
    prefixMin[n - 1] = n;
    for (int i = n - 1; i-- > 0;) {
        prefixMin[i] = i + 1;
        while (prefixMin[i] != n)
            if (a[prefixMin[i]] >= a[i])
                prefixMin[i] = prefixMin[prefixMin[i]];
            else
                break;
    }
    dp[0] = 0;
    for (int i = 1, idec = 0; i <= n; ++i, ++idec) {
        dp[i] = dp[i - 1] + 1;
        for (int j = idec; j > suffixMax[idec]; j = suffixMin[j])
            if (prefixMin[j] > idec)
                dp[i] = min(dp[i], dp[j] + 1);
    }

    cout << dp[n] << endl;
/*
    for (int i = 0; i <= n; ++i)
        cout << dp[i] << " ";
    cout << endl;
    for (int i = 0; i < n; ++i)
        cout << suffixMax[i] << " ";
    cout << endl;
    for (int i = 0; i < n; ++i)
        cout << suffixMin[i] << " ";
    cout << endl;
    for (int i = 0; i < n; ++i)
        cout << prefixMin[i] << " ";
    cout << endl;
*/  return 0;
}
