#include <cstdio>
#include <cassert>
#include <iostream>
using namespace std;

#define MAX_N 524288
#define MAX_TREE 1048576

int a[MAX_N], prefixMin[MAX_N], suffixMin[MAX_N], suffixMax[MAX_N], dp[MAX_N];

int index[MAX_TREE];

void build(int v) {
    if(v >= MAX_N) {
        index[v] = v - MAX_N;
        return;
    }
    build(v * 2);
    build(v * 2 + 1);
    if(a[index[v * 2 + 1]] >= a[index[v * 2]])
        index[v] = index[v * 2];
    else
        index[v] = index[v * 2 + 1];
}

int minIndex(int l, int r) {
    l += MAX_N;
    r += MAX_N;
    int ans = l - MAX_N;
    while(l <= r) {
        if(l & 1)       if(a[ans] > a[index[l]] || (a[ans] == a[index[l]] && ans > index[l]))    ans = index[l];
        if(!(r & 1))    if(a[ans] > a[index[r]] || (a[ans] == a[index[l]] && ans > index[l]))    ans = index[r];
        l = (l + 1) / 2;
        r = (r - 1) / 2;
    }
    return ans;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef AC
    freopen("input.txt", "r", stdin);
#endif // AC
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = n; i < MAX_N; ++i)
        a[i] = 2000000000;
    build(1);
    suffixMax[0] = -1;
    for (int i = 1; i < n; ++i) {
        suffixMax[i] = i - 1;
        while (suffixMax[i] != -1)
            if (a[suffixMax[i]] <= a[i])
                suffixMax[i] = suffixMax[suffixMax[i]];
            else
                break;
    }
    suffixMin[0] = -1;
    for (int i = 1; i < n; ++i) {
        suffixMin[i] = i - 1;
        while (suffixMin[i] != -1)
            if (a[suffixMin[i]] > a[i])
                suffixMin[i] = suffixMin[suffixMin[i]];
            else
                break;
    }
    prefixMin[n - 1] = n;
    for (int i = n - 1; i-- > 0;) {
        prefixMin[i] = i + 1;
        while (prefixMin[i] != n)
            if (a[prefixMin[i]] >= a[i])
                prefixMin[i] = prefixMin[prefixMin[i]];
            else
                break;
    }
    dp[0] = 0;
    for (int i = 1, idec = 0; i <= n; ++i, ++idec) {
        dp[i] = dp[i - 1] + 1;
        if(suffixMax[idec] + 1 != idec)
            dp[i] = min(dp[i], dp[minIndex(suffixMax[idec] + 1, idec - 1)] + 1);
    }
    cout << dp[n] << endl;
    return 0;
}
