#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <set>
#include <map>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define int ll


int maxN = 3 * 1e5 + 5;
vector <int> tree;

void init(int n)
{
	maxN = n;
	tree.resize(n + 3);
}

void fBig(int  &x)
{
	x = x | (x + 1);
}

void fLess(int &x)
{
	x = (x & (x + 1)) - 1;
}

void upd(int ind, int delta)
{
	for (int i = ind; i < maxN; fBig(i))
	{
		tree[i] += delta;
	}
}

int sum(int ind)
{
	int ans = 0;
	for (int i = ind; i >= 0; fLess(i))
	{
		ans += tree[i];
	}
	return ans;
}

int get(int l)
{
	if (l == 0)
		return sum(maxN - 1);
	return sum(maxN - 1) - sum(l - 1);
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector <pair<int, int>>A(n);
	map<int, int> inFen;
	for (int i = 0; i < n; i++)
	{
		cin >> A[i].first >> A[i].second;
		inFen[A[i].second] = 0;
	}
	int i = 0;
	for (auto it = inFen.begin(); it != inFen.end(); it++)
	{
		it->second = i++;
	}
	init(maxN);


	for (int i = 0; i < n; i++)
	{
		upd(inFen[A[i].second], 1);
	}

	sort(all(A));
	reverse(all(A));
	int ans = 0;

	for (int j = 0; j < n; j++)
	{
		int plus = get(inFen[A[j].second]) * A[j].second;
		ans = max(ans, plus);
	}

	for (int i = 0; i < n; i++)
	{
		upd(inFen[A[i].second], -1);
		int curSum = A[i].first * (i + 1);
		ans = max(ans, curSum);

		int l = i + 1, r = n - 1;
		while (r - l > 100)
		{
			int L = l + (r - l) / 3;
			int R = r - (r - l) / 3;
			if (get(inFen[A[L].second]) * A[L].second < get(inFen[A[R].second] * A[R].second))
			{
				l = L;
			}
			else
			{
				r = R;
			}
		}
		for (int z = l; z <= r; z++)
		{
			ans = max(ans, curSum + get(inFen[A[z].second]) * A[z].second);
		}
	}

	cout << ans;
	return 0;
}