#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <string>

using namespace std;

#define all(x) x.begin(),x.end()


const int maxN = 3 * 1e5 + 5;
int logs[maxN];
vector <vector <int>>tree;

void build(vector <int> &A)
{
	int n = A.size();
	tree.resize(logs[n] + 1, vector <int>(n, 1e9));
	for (int i = 0; i < n; i++)
	{
		tree[0][i] = A[i];
	}
	for (int i = 1; i <= logs[n]; i++)
	{
		for (int j = 0; j + (1 << (i - 1)) < n; j++)
		{
			tree[i][j] = min(tree[i - 1][j], tree[i - 1][j + (1 << (i - 1))]);
		}
	}
}

int get(int l, int r)
{
	int len = r - l + 1;
	int curlog = logs[len];
	return min(tree[curlog][l], tree[curlog][r - (1 << curlog) + 1]);
}


signed main()
{
#ifdef  _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	for (int i = 2; i < maxN; i++)
	{
		logs[i] = logs[i / 2] + 1;
	}
	vector <int> A(n);
	vector <int> maxs(n);
	for (int i = 0; i < n; i++)
	{
		cin >> A[i];
	}
	maxs[n - 1] = n - 1;
	vector <int> Stack = { n - 1 };
	for (int i = n - 2; i >= 0; i--)
	{
		while (Stack.size() > 0 && A[Stack.back()] < A[i])
			Stack.pop_back();
		if (Stack.size() == 0)
			maxs[i] = i;
		else
			maxs[i] = Stack.back();
		Stack.push_back(i);
	}

	build(A);
	/*for (int i = 0; i <= logs[n]; i++)
	{
		for (int j = 0; j + max(0, (1 << (i - 1))) < n; j++)
		{
			cout << tree[i][j] << " ";
		}
		cout << endl;
	}
	cout << endl;*/
	int last = 0;
	int cnt = 0;
	for (int i = 0; i < n; i = last + 1)
	{
		cnt++;
		int save = i;
		for (int j = i; true; j = maxs[j])
		{
			int next = maxs[j];
			if (get(i, next) < A[i])
				break;
			save = j;
			if (j == maxs[j])
				break;
		}
		last = save;
	}
	cout << cnt;
	return 0;
}
