#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <string>

using namespace std;

#define all(x) x.begin(),x.end()


const int maxN = 3 * 1e5 + 5;
int logs[maxN];
vector <vector <int>>tree;

void build(vector <int> &A)
{
	int n = A.size();
	tree.resize(logs[n] + 1, vector <int>(n, 1e9));
	for (int i = 0; i < n; i++)
	{
		tree[0][i] = A[i];
	}
	for (int i = 1; i <= logs[n]; i++)
	{
		for (int j = 0; j + (1 << (i - 1)) < n; j++)
		{
			tree[i][j] = min(tree[i - 1][j], tree[i - 1][j + (1 << (i - 1))]);
		}
	}
}

int get(int l, int r)
{
	int len = r - l + 1;
	int curlog = logs[len];
	return min(tree[curlog][l], tree[curlog][r - (1 << curlog) + 1]);
}


signed main()
{
#ifdef  _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, p;
	cin >> n >> p;
	vector <pair<int, int>> A(n);
	for (int i = 0; i < n; i++)
	{
		cin >> A[i].first;
		A[i].second = i;
	}
	sort(all(A));
	vector <int> Ans(n);
	for (int i = 0; i < n; i++)
	{
		int cnt = 0;
		for (int j = 0; j < i; j++)
		{
			if (A[i].first > A[j].first + abs(A[i].second - A[j].second))
			{
				cnt++;
			}
		}
		Ans[A[i].second] = cnt + 1;
	}
	for (int i = 0; i < n; i++)
	{
		cout << Ans[i] << endl;
	}
	return 0;
}
