#define _CRT_SECURE_NO_WARNINGS

#pragma gcc ooptimize("Ofast,unroll-loops")
#pragma gcc options("sse,sse2,sse3,sse4,popcnt,tune=native")

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <math.h>
#include <deque>
#include <iterator>
#include <algorithm>
#include <climits>

using namespace std;
using ll = long long;
using ld = long double;
using ipair = pair<int, int>;
using llpair = pair<ll, ll>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define vect vector

struct lint {
	vect<int> num;

	const bool operator<(const lint& lnt) const {
		if (num.size() == lnt.num.size()) { 
			int i = num.size() - 1;
			while (i > 0 && num[i] == lnt.num[i]) { --i; }
			return num[i] < lnt.num[i];
		}
		return num.size() < lnt.num.size();
	}

	lint operator+(lint lnt) {
		vect<int> nm = num;
		if (nm.size() < lnt.num.size()) { swap(nm, lnt.num); }
		for (int i = 0; i < lnt.num.size(); ++i) {
			nm[i] += lnt.num[i];
			int t = nm[i] / 10;
			nm[i] %= 10;
			if (t && i == nm.size() - 1) {
				nm.pb(t);
			}
			else if (t) {
				nm[i + 1] += t;
			}
		}
		for (int i = lnt.num.size(); i < nm.size(); ++i) {
			int t = nm[i] / 10;
			nm[i] %= 10;
			if (t && i == nm.size() - 1) {
				nm.pb(t);
			}
			else if (t) {
				nm[i + 1] += t;
			}
		}
		return lint(nm);
	}

	lint(vect<int> num) : num(num) {}
	lint() { num = { 1 }; }
};

signed main() {
	int n, m, k; cin >> n >> m >> k;
	vect<lint> pc(n + 1);
	pc[0] = lint();
	for (int i = 1; i <= n; ++i) { pc[i] = pc[i - 1] + pc[i - 1]; }

	vect<ipair> cells;
	for (int i = 0; i < k; ++i) {
		int x, y; cin >> x >> y;
		cells.pb({ x, y });
	}

	sort(all(cells), [](ipair l, ipair r) {
		return (l.first + l.second) < (r.first + r.second);
	});

	vect<vect<pair<lint, int>>> ways(cells.size());
	for (int i = 0; i < cells.size(); ++i) {
		for (int j = i + 1; j < cells.size(); ++j) {
			ways[i].pb({pc[max(abs(cells[i].first - cells[j].first), abs(cells[i].second - cells[j].second))], j });
		}
	}

	vect<pair<lint, int>> dist(cells.size(), { pc.back(), 0 });
	set<pair<lint, int>> st;
	st.insert({ lint(vect<int>(0, 0)), 0 });
	while (!st.empty()) {
		lint dst = (*st.begin()).first;
		int v = (*st.begin()).second;
		st.erase(st.begin());
		for (int i = 0; i < ways[v].size(); ++i) {
			int to = ways[v][i].second;
			lint d = ways[v][i].first;
			if ((d + dst) < dist[to].first) {
				dist[to].first = d + dst;
				dist[to].second = v;
				st.insert({dist[to].first, to});
			}
		}
	}
	deque<int> ans = { k };
	while (ans.front() - 1 != dist[ans.front() - 1].second) {
		ans.push_front(dist[ans.front() - 1].second + 1);
	}
	cout << ans.size() << endl;
	for (auto it : ans) { cout << it << " "; }
	system("pause");
}