import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.lang.reflect.Executable;
import java.util.*;

public class Main {
    class P implements Comparable<P> {
        long a, b; int num;
        boolean t = false;

        P(int a, int b, int num, boolean t) {
            this.a = a;
            this.b = b;
            this.num = num;
            this.t = t;
        }

        @Override
        public int compareTo(P o) {
            if (t) {
                return Long.compare(o.b, b);
            }
            return Long.compare(a, o.a);
        }
    }

    int tree[];
    int sz, l, r;

    void build() {
        while (sz < n) {
            sz <<= 1;
        }
        tree = new int[2 * sz];
    }

    int sum(int x, int y, int k) {
        if (x > r || y < l) return 0;
        if (x >= l && y <= r) return tree[k];
        return sum(x, (x + y) / 2, 2 * k) + sum((x + y) / 2 + 1, y, 2 * k + 1);
    }

    void add(int x) {
        x += sz;
        tree[x]++;
        x >>= 1;
        while (x > 0) {
            tree[x] = tree[2 * x] + tree[2 * x + 1];
            x >>= 1;
        }
    }

    int n;
    int a[], b[];
    P p[];

    public void solve() throws IOException {
        n = nextInt();
        Random rand = new Random();
        a = new int[n];
        b = new int[n];
        p = new P[n];
        P pb[] = new P[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
            b[i] = nextInt();
            p[i] = new P(a[i], b[i], i, false);
            pb[i] = new P(a[i], b[i], i, true);
        }
        Arrays.sort(p);
        Arrays.sort(pb);
        int pr[] = new int[n];
        for (int i = 0; i < n; i++) {
            pr[pb[i].num] = i;
        }
        long res = p[0].a * n;
        int cnt = -1;
        long minc = Long.MAX_VALUE;
        int t[] = new int[n];
        for (int i = 0; i < n; i++) {
            int pos = pr[p[i].num];
            t[pos]++;
            long res1 = (i == n- 1 ? 0 : p[i  + 1].a * (n - 1 - i));
            if(n <= 50000){
                if(rand.nextInt(20)  ==0) continue;
                int cur = 0;
                for (int j = 0; j < n; j++) {
                    if(t[j] == 1) {
                        cur++;
                        res = Math.max(res, res1 + pb[j].b * cur);
                    }
                }
            }else{
                minc = Math.min(minc, p[i].b);
                res = Math.max(res, res1 + minc * (i + 1));
            }
        }
        out.print(res);
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

}
