import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Executable;
import java.util.Arrays;
import java.util.Locale;
import java.util.Random;
import java.util.StringTokenizer;

public class Main {


    public void solve() throws IOException {
        int n = nextInt();

        int sz[] = new int[n];
        String s[] = new String[n];
        int max = 0;
        for (int i = 0; i < n; i++) {
            s[i] = nextToken();
            sz[i] = s[i].length();
            max = Math.max(sz[i], max);
        }

        int is[] = new int[n + max];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < sz[i]; j++) {
                is[j] += s[i].charAt(sz[i] - 1 - j) - '0';
            }
        }
        int cnt = 0;
        for (int i = 0; i < n + max; i++) {
            cnt += is[i];
            is[i] = 0;
            if(cnt != 0){
                is[i]++;
                cnt--;
            }
        }

        boolean rt = false;
        for (int i = n+ max - 1; i >= 0; i--) {
            if (is[i] != 0) {
                out.print(1);
                rt = true;
            } else if (rt) {
                out.print(0);
            }
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
}