#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <vector>
#include <map>

using namespace std;

const int MAXN = 2e5 + 10;

vector <vector <int> > a;
int x[MAXN], y[MAXN];
map <int, pair <int, int> > pos;

bool check(int c) {
    pair <int, int> p = pos[c];
    return x[p.first] == c && y[p.second] == c;
}

void update(int i, int j, int c) {
    x[i] = max(x[i], c);
    y[j] = max(y[j], c);
    pos[c] = make_pair(i, j);
    a[i][j] = c;
}

int main() {
    ios_base::sync_with_stdio(false);
    int n, m, q; cin >> n >> m >> q;
    fill(x, x + MAXN, 0);
    fill(y, y + MAXN, 0);
    a.resize(n);
    for (int i = 0; i < n; i++) {
        a[i].resize(m);
        for (int j = 0; j < m; j++) {
            int c; cin >> c;
            update(i, j, c);
        }
    }

    int res = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (x[i] == y[j])
                res++;

    for (int test = 0; test < q; test++) {
        int i, j, c; cin >> i >> j >> c; i--, j--;
        if (x[i] < c && check(x[i]))
            res--;
        if (y[j] < c && y[j] != a[i][j] && check(y[j]))
            res--;
        update(i, j, c);
        if (check(c))
            res++;
        cout << res << endl;
    }

    return 0;
}
