#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <vector>
#include <map>

using namespace std;

const int MAXN = 2e5 + 10;

vector <vector <int> > a;
pair <int, pair <int, int> > x[MAXN], y[MAXN];

bool check(int i, int j) {
    return x[i].first == a[i][j] && y[j].first == a[i][j];
}

void update(int i, int j, int c) {
    if (x[i].first < c)
        x[i] = make_pair(c, make_pair(i, j));
    if (y[j].first < c)
        y[j] = make_pair(c, make_pair(i, j));
    a[i][j] = c;
}

int main() {
    ios_base::sync_with_stdio(false);
    int n, m, q; cin >> n >> m >> q;
    fill(x, x + MAXN, make_pair(0, make_pair(-1, -1)));
    fill(y, y + MAXN, make_pair(0, make_pair(-1, -1)));
    a.resize(n);
    for (int i = 0; i < n; i++) {
        a[i].resize(m);
        for (int j = 0; j < m; j++) {
            int c; cin >> c;
            update(i, j, c);
        }
    }

    int res = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (x[i].first == y[j].first)
                res++;

    for (int test = 0; test < q; test++) {
        int i, j, c; cin >> i >> j >> c; i--, j--;
        if (x[i].first < c && check(x[i].second.first, x[i].second.second))
            res--;
        if (y[j].first < c && y[j].first != a[i][j] && check(y[j].second.first, y[j].second.second))
            res--;
        update(i, j, c);
        if (check(i, j))
            res++;
        cout << res << endl;
    }

    return 0;
}
