#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <vector>
#include <set>

using namespace std;

const int MAXN = 501;

bool a[MAXN][MAXN];

#define type vector <bool>

bool operator <(type a, type b) {
    if ((int)a.size() != (int)b.size())
        return a.size() < b.size();
    for (int i = (int)a.size() - 1; i >= 0; i--)
        if (a[i] != b[i])
            return a[i] < b[i];
    return false;
}

void print(type a) {
    for (int i = (int)a.size() - 1; i >= 0; i--)
        cout << a[i];
}

type operator +(type a, type b) {
    while (a.size() > b.size())
        b.push_back(0);
    while (b.size() > a.size())
        a.push_back(0);
    type c;
    int k = 0;
    for (int i = 0; i < (int)a.size(); i++) {
        k += (int)a[i] + (int)b[i];
        c.push_back(k % 2);
        k /= 2;
    }
    if (k != 0)
        c.push_back(k);
    return c;
}

type get_t(int p) {
    type c;
    for (int i = 0; i < p; i++)
        c.push_back(0);
    c.push_back(1);
    return c;
}

type d[MAXN];

vector <pair <int, int> > all;

int distk(int x, int y) {
    return max(abs(all[x].first - all[y].first), abs(all[x].second - all[y].second));
}

int parent[MAXN];
bool was[MAXN];

int32_t main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(false);

    int n, m, k; cin >> n >> m >> k;
    for (int i = 0; i < k; i++) {
        int x, y; cin >> x >> y;
        all.push_back(make_pair(x, y));
    }

    for (int i = 1; i < (int)all.size(); i++)
        d[i] = get_t(MAXN);
    int x = 0;
    while (!was[(int)all.size() - 1]) {
        was[x] = true;
        for (int i = 0; i < (int)all.size(); i++) {
            int curk = distk(x, i);
            type cur = d[x] + get_t(curk);
            if (cur < d[i]) {
                d[i] = cur;
                parent[i] = x;
            }
        }

        x = -1;
        for (int i = 0; i < (int)all.size(); i++)
            if (!was[i] && (x == -1 || d[i] < d[x]))
                x = i;
    }

    int i = (int)all.size() - 1;
    vector <int> ans;
    while (i != 0) {
        ans.push_back(i);
        i = parent[i];
    }
    ans.push_back(0);

    reverse(ans.begin(), ans.end());

    cout << (int)ans.size() << endl;
    for (int i = 0; i < (int)ans.size(); i++)
        cout << ans[i] + 1 << " ";
    cout << endl;

    return 0;
}
