#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int MAXN = (1 << 19);
const int MAXK = 19;
const int INF = 1e9 + 7;

int a[MAXN];
int nxt[MAXN];
int n;

set <pair <int, int> > s;

pair <int, int> sp_max[MAXN][MAXK];
pair <int, int> sp_min[MAXN][MAXK];

void init() {
    for (int i = 0; i < n; i++)
        sp_min[i][0] = sp_max[i][0] = make_pair(a[i], i);
    for (int i = n; i < MAXN; i++)
        sp_min[i][0] = make_pair(INF, i), sp_max[i][0] = make_pair(-1, i);
    for (int k = 1; k < MAXK; k++)
        for (int i = 0; i < n; i++) {
            sp_min[i][k] = min(sp_min[i][k - 1], sp_min[i + (1 << (k - 1))][k - 1]);
            sp_max[i][k] = max(sp_max[i][k - 1], sp_max[i + (1 << (k - 1))][k - 1]);
        }
}

int get_min(int l, int r) {
    int k = 0;
    while (l + (1 << k) < r - (1 << k) + 1)
        k++;
    return min(sp_min[l][k], sp_min[r - (1 << k) + 1][k]).first;
}

int get_max_id(int l, int r) {
    int k = 0;
    while ((1 << (k + 1)) < r - l + 1)
        k++;
    return max(sp_max[l][k], sp_max[r - (1 << k) + 1][k]).second;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];

    init();

    for (int i = 0; i < n; i++) {
        int l = i, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (get_min(i, m) == a[i])
                l = m;
            else
                r = m;
        }
        nxt[i] = l;
    }

    int l = 0, res = 0;
    while (l < n) {
        int r = get_max_id(l, nxt[l]);
        //cout << "max_id(" << l << ", " << nxt[l] << ") = " << r << endl;
        l = r + 1;
        res++;
    }

    cout << res << endl;

    return 0;
}
