#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int MAXN = 2e6;

int n;
int a[MAXN], res[MAXN];

vector <int> all;

int find_all(int val) {
    int l = 0, r = (int)all.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (all[m] == val)
            return m;
        if (all[m] < val)
            l = m + 1;
        if (all[m] > val)
            r = m;
    }
    return l;
}

struct Kek {

    int n;
    int f[MAXN];

    void init(int n1) {
        n = n1;
        for (int i = 0; i < n; i++)
            f[i] = 0;
    }

    void insert(int pos) {
        for (; pos < n; pos = pos | (pos + 1))
            f[pos]++;
    }

    int get_lt(int v) {
        v--;
        int res = 0;
        for (; v >= 0; v = (v & (v + 1)) - 1)
            res += f[v];
        return res;
    }

} kek;

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    int p; cin >> n >> p;
    azssert(n <= 280000);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    fill(res, res + MAXN, 0);

    for (int i = 0; i < n; i++)
        all.push_back(a[i] - i);
    for (int i = 0; i < n; i++)
        all.push_back(a[i] - (n - i - 1));
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());

    int add;
    kek.init((int)all.size()); add = 0;
    for (int i = 0; i < n; i++) {
        res[i] += kek.get_lt(find_all(a[i] - add));
        kek.insert(find_all(a[i] - add));
        add++;
    }
    kek.init((int)all.size()); add = 0;
    for (int i = n - 1; i >= 0; i--) {
        res[i] += kek.get_lt(find_all(a[i] - add));
        kek.insert(find_all(a[i] - add));
        add++;
    }

    for (int i = 0; i < n; i++)
        cout << res[i] + 1 << endl;

    return 0;
}
