#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int MAXN = 1000;

int n;
int a[MAXN];

vector <int> all;

int find_all(int val) {
    int l = 0, r = (int)all.size();
    while (r - l > 1) {
        int m = (l + r) >> 1;
        if (all[m] == val)
            return m;
        if (all[m] < val)
            l = m + 1;
        if (all[m] > val)
            r = m;
    }
    return l;
}

struct Kek {

    int n = 0;
    int f[2 * MAXN];

    void init() {
        for (int i = 0; i < n; i++)
            f[i] = 0;
    }

    void insert(int pos) {
        for (; pos < n; pos = pos | (pos + 1))
            f[pos]++;
    }

    int get_lt(int v) {
        v--;
        int res = 0;
        for (; v >= 0; v = (v & (v + 1)) - 1)
            res += f[v];
        return res;
    }

} kek;

int res[MAXN][MAXN];

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    int p; cin >> n >> p;
    for (int i = 0; i < n; i++)
        cin >> a[i];

    for (int i = 0; i < n; i++)
        for (int j = -n; j < n; j++)
            all.push_back(a[i] - j);
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());

    kek.n = (int)all.size();
    kek.init();
    for (int i = 0; i < n; i++) {
        int c = find_all(a[i] - i);
        for (int j = 0; j < n; j++)
            res[j][i] += kek.get_lt(find_all(a[j] - i + abs(j - i)));
        kek.insert(c);
    }
    kek.init();
    for (int i = n - 1; i >= 0; i--) {
        int c = find_all(a[i] - (n - i - 1));
        kek.insert(c);
        for (int j = 0; j < n; j++)
            res[j][i] += kek.get_lt(find_all(a[j] - (n - i - 1) + abs(i - j)));
    }

    for (int i = 0; i < n; i++) {
        int ans = 0;
        for (int j = 0; j < n; j++)
            ans = max(ans, res[i][j]);
        cout << ans + 1 << endl;
    }

    return 0;
}
