#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int MAXN = 4e5 + 100;

int n;
int a[MAXN], res[MAXN];

vector <int> all;

int find_all(int val) {
    int l = 0, r = (int)all.size();
    while (r - l > 1) {
        int m = (l + r) >> 1;
        if (all[m] == val)
            return m;
        if (all[m] < val)
            l = m + 1;
        if (all[m] > val)
            r = m;
    }
    return l;
}

    int f[2 * MAXN];

    void init() {
        for (int i = 0; i < 2 * n; i++)
            f[i] = 0;
    }

    void insert(int pos) {
        for (; pos < 2 * n; pos = pos | (pos + 1))
            f[pos]++;
    }

    int get_lt(int v) {
        v--;
        int res = 0;
        for (; v >= 0; v = (v & (v + 1)) - 1)
            res += f[v];
        return res;
    }

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    int p; cin >> n >> p;
    assert(p == 2);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    fill(res, res + MAXN, 0);

    for (int i = 0; i < n; i++)
        all.push_back(a[i] - i);
    for (int i = 0; i < n; i++)
        all.push_back(a[i] - (n - i - 1));
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());

    init();
    for (int i = 0; i < n; i++) {
        int c = find_all(a[i] - i);
        res[i] += get_lt(c);
        insert(c);
    }
    init();
    for (int i = n - 1; i >= 0; i--) {
        int c = find_all(a[i] - (n - i - 1));
        res[i] += get_lt(c);
        insert(c);
    }

    for (int i = 0; i < n; i++)
        cout << res[i] + 1 << endl;

    return 0;
}
