#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int MAXN = 1000;

int n;
int a[MAXN], res[MAXN];

struct Kek {

    int n;
    int f[2 * MAXN];

    void init() {
        for (int i = 0; i < 2 * n; i++)
            f[i] = 0;
    }

    void insert(int pos) {
        for (; pos < 2 * n; pos = pos | (pos + 1))
            f[pos]++;
    }

    void erase(int pos) {
        for (; pos < 2 * n; pos = pos | (pos + 1))
            f[pos]--;
    }

    int get_lt(int v) {
        v--;
        int res = 0;
        for (; v >= 0; v = (v & (v + 1)) - 1)
            res += f[v];
        return res;
    }
} k1, k2;

vector <int> all;

int find_all(int val) {
    int l = 0, r = (int)all.size();
    while (r - l > 1) {
        int m = (l + r) >> 1;
        if (all[m] == val)
            return m;
        if (all[m] < val)
            l = m + 1;
        if (all[m] > val)
            r = m;
    }
    return l;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    int p; cin >> n >> p;
    for (int i = 0; i < n; i++)
        cin >> a[i];

    for (int i = 0; i < n; i++) {
        for (int j = -n; j <= n; j++)
            all.push_back(a[i] - j);
    }
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());

    k1.n = k2.n = (int)all.size();
    for (int i = 0; i < n; i++) {
        int maxcnt = 0, add = 0;
        k1.init(); k2.init();
        for (int j = 0; j < n; j++)
            k2.insert(find_all(a[j]));
        for (int j = 0; i + j < n - 1 && i - j > 0; j++) {
            k1.insert(find_all(a[i - j] - add));
            k2.erase(find_all(a[i - j]));
            if (j != 0) {
                k1.insert(find_all(a[i + j] - add));
                k2.erase(find_all(a[i + j]));
            }
            add++;
            int ival = a[i] + max(0, j + 1 - abs(i - j));
            int cnt = k1.get_lt(find_all(ival - add)) + k2.get_lt(find_all(ival));
            if (cnt > maxcnt)
                maxcnt = cnt;
        }

        for (int j = 0; j < n; j++) {
            int cnt = 0;
            for (int k = 0; k < n; k++)
                res[k] = a[k] + max(k - j, 0);
            for (int k = 0; k < n; k++)
                if (res[k] < res[i])
                    cnt++;
            if (cnt > maxcnt)
                maxcnt = cnt;
        }
        for (int j = n - 1; j >= 0; j--) {
            int cnt = 0;
            for (int k = 0; k < n; k++)
                res[k] = a[k] + max(j - k, 0);
            for (int k = 0; k < n; k++)
                if (res[k] < res[i])
                    cnt++;
            if (cnt > maxcnt)
                maxcnt = cnt;
        }

        cout << maxcnt + 1 << endl;
    }

    return 0;
}
