#include <iostream>
#include <vector>
#include <cassert>
#include <set>
#include <algorithm>
#include <cstdio>
#define FOR(i, n) for (int i = 0; i < n; ++i)
typedef long long ll;
struct fenwick {
	std::vector<int> f;

	fenwick(int n) {
		f.resize(n + 10);
	}

	void add(int x, int val) {
		for (int i = x; i < f.size(); i = (i | (i + 1))) {
			f[i] += val;
		}
	}
	int get(int r) {
		int sum = 0;
		for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
			sum += f[i];
		}
		return sum;
	}
	int get(int l, int r) {
		return get(r) - get(l - 1);
	}
};

int getInd(int x, std::vector<int>&a) {
	auto it = std::lower_bound(a.begin(), a.end(), x);
	return it - a.begin();
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	int n, p;
	std::cin >> n >> p;
	assert(p == 1);
	std::vector<int>a(n), answ(n);
	std::vector<int> compress1, compress2;
	fenwick first(n), second(n);
	FOR(i, n) {
		std::cin >> a[i];
		compress1.push_back(a[i] - i);
		compress2.push_back(a[i] + i);
	}
	std::sort(compress1.begin(), compress1.end());
	std::sort(compress2.begin(), compress2.end());
	FOR(i, n) {
		second.add(getInd(a[i] + i, compress2), 1);
	}
	FOR(j, n) {
		int f1 = second.get(getInd(a[j] + j, compress2) - 1);
		int f2 = first.get(getInd(a[j] - j, compress1) - 1);
		second.add(getInd(a[j] + j, compress2), -1);
		first.add(getInd(a[j] - j, compress1), 1);
		std::cout << f1 + f2 + 1 << '\n';
	}
	return 0;
}