#pragma GCC optimize ("Ofast")

#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <deque>
#include <algorithm>
#include <ctime>
#include <cmath>

using namespace std;

#define int long long
#define sz(a) ((int)a.size())
#define pb emplace_back
#define double long double

double distance(pair<int, int> a, pair<int, int> b) {
	return pow(2, max(abs(a.first - b.first), abs(a.second - b.second)));
}

void dijkstra(int s, vector<bool> &used, vector<int> &dist, vector<vector<pair<double,pair<int, int>>>> &graph, vector<int> &p) {
	set<pair<double, pair<int, int>>> edges;
	for (auto edge : graph[0]) {
		edges.insert(edge);
	}
	while (sz(edges) > 0) {
		pair<double, pair<int, int>> cur = *edges.begin();
		edges.erase(cur);
		while (used[cur.second.second] && sz(edges) > 0) {
			cur = *edges.begin();
			edges.erase(cur);
		}
		if (sz(edges) == 0) break;
		p[cur.second.second] = cur.second.first;
		used[cur.second.second] = true;
		dist[cur.second.second] = cur.first;
		for (auto edge : graph[cur.second.second]) {
			edges.insert(make_pair(dist[cur.second.second] + edge.first, edge.second));
		}
	}
}

signed main() {
	int n, m, k;
	cin >> n >> m >> k;
	vector<pair<int, int>> vertexes(k);
	for (int i = 0; i < k; i++) {
		int x, y;
		cin >> x >> y;
		vertexes[i] = { x, y };
	}
	vector<vector<pair<double,pair<int, int>>>> graph(k);
	for (int i = 0; i < k; i++) {
		for (int j = i + 1; j < k; j++) {
			graph[i].pb(make_pair(distance(vertexes[i], vertexes[j]), make_pair(i, j)));
			graph[j].pb(make_pair(distance(vertexes[i], vertexes[j]), make_pair(j, i)));
		}
	}
	vector<bool> used(k);
	vector<int> dist(k);
	vector<int> p(k);
	used[0] = true;
	dist[0] = 0;
	dijkstra(0, used, dist, graph, p);
	int i = k - 1;
	vector<int> ans = { i };
	while (i != 0) {
		ans.pb(p[i]);
		i = p[i];
	}
	reverse(ans.begin(), ans.end());
	cout << sz(ans) << "\n";
	for (int i = 0; i < sz(ans); i++) {
		cout << ans[i] + 1 << " ";
	}
	return 0;
}