#include <iostream>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <climits>
#include <cstdlib>
#include <vector>
#include <algorithm>

using namespace std;
typedef unsigned int index;

struct Block
{
	vector<int> zn;
	vector<pair<int, long long>> st;
	bool sr(const pair<int, long long> &a, const pair<int, long long> &b, const pair<int, long long> &c)
	{
		return (b.second - a.second) * (b.first - c.first) < (c.second - b.second) * (a.first - b.first);
	}
	void gen()
	{
		st.clear();
		for (index i = 0; i < zn.size(); i++)
		{
			pair<int, long long> cur = {zn[i], zn[i] * (long long)(zn.size() - i)};
			while (st.size() > 1 and not sr(st[st.size() - 2], st[st.size() - 1], cur))
				st.pop_back();
			st.push_back(cur);
		}
	}
	long long get(long long add)
	{
		while (st.size() > 2 and (st[st.size() - 2].second - st[st.size() - 1].second) >= add * (st[st.size() - 1].first - st[st.size() - 2].first))
			st.pop_back();
		return st.back().first * add + st.back().second;
	}
	Block(const vector<int> &nw): zn(nw)
	{
		gen();
	}
	void erase(int a)
	{
		for (index i = 0; i < zn.size(); i++)
		{
			if (zn[i] == a)
			{
				zn.erase(zn.begin() + i);
				gen();
				break;
			}
		}
	}
};

long long get(vector<Block> &blocks)
{
	long long ans = 0;
	int prf = 0;
	for (index i = 0; i < blocks.size(); i++)
	{
		ans = max(ans, blocks[blocks.size() - i - 1].get(prf));
		prf += (int)blocks[blocks.size() - i - 1].zn.size();
	}
	return ans;
}

void erase(vector<Block> &blocks, int a)
{
	for (index i = 0; i < blocks.size(); i++)
	{
		if (blocks[i].zn.back() >= a)
		{
			blocks[i].erase(a);
			if (blocks[i].zn.size() == 0)
			{
				blocks.erase(blocks.begin() + i);
			}
			return;
		}
	}
}

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	size_t n;
	cin >> n;
	vector<pair<int, int>> a(n);
	const size_t MAX_BLOCK = 600;
	vector<Block> blocks;
	for (auto &i: a)
		cin >> i.first >> i.second;
	sort(a.begin(), a.end(), [](pair<int, int> as, pair<int, int> b)
			{
				return as.second < b.second;
			});
	vector<int> cur;
	for (index i = 0; i < n; i++)
	{
		cur.push_back(a[i].second);
		if ((cur.size()) % MAX_BLOCK == 0)
		{
			blocks.push_back(Block(cur));
			cur.clear();
		}
	}
	if (cur.size() > 0)
	{
		blocks.push_back(Block(cur));
		cur.clear();
	}
	sort(a.rbegin(), a.rend());
	long long ans = get(blocks);
	for (index i = 0; i < n; i++)
	{
		erase(blocks, a[i].second);
		ans = max(ans, a[i].first * (long long)(i + 1) + get(blocks));
	}
	cout << ans << endl;
	return 0;
}
