#include <iostream>
#include <set>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <climits>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <bitset>

using namespace std;
typedef unsigned int index;

const size_t SIZE = 60;
const size_t BLOCKS = 540 / SIZE;
const long long MAX_BLOCK = (1ll << SIZE);

struct Long/*{{{*/
{
	long long *arr;
	long long &operator [](size_t i) const
	{
		return arr[i];
	}
	Long()
	{
		arr = new long long[BLOCKS];
		for (index i = 0; i < BLOCKS; i++)
			arr[i] = 0;
	}
	Long(size_t s)
	{
		arr = new long long[BLOCKS];
		for (index i = 0; i < BLOCKS; i++)
			arr[i] = 0;
		arr[s / SIZE] += 1 << (s % SIZE);
	}
};/*}}}*/

bool operator <(const Long &a, const Long &b)/*{{{*/
{
	for (index i = (index)BLOCKS - 1; i != (index)-1; i--)
	{
		if (a[i] < b[i])
			return true;
		if (b[i] < a[i])
			return false;
	}
	return false;
}/*}}}*/

Long operator +(const Long &a, const Long &b)/*{{{*/
{
	long long p = 0;
	Long ans;
	for (index i = 0; i < BLOCKS; i++)
	{
		ans[i] = (a[i] + b[i] + p) % MAX_BLOCK;
		p = (a[i] + b[i] + p) / MAX_BLOCK;
	}
	return ans;
}/*}}}*/

int dist(pair<int, int> a, pair<int, int> b)
{
	return max(abs(a.first - b.first), abs(a.second - b.second));
}

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	size_t n, m, ko;
	cin >> ko >> m >> n;
	vector<pair<int, int>> a(n);
	for (auto &i: a)
		cin >> i.first >> i.second;
	vector<vector<pair<index, Long>>> g(n);
	for (index i = 0; i < n; i++)
	{
		for (index j = 0; j < n; j++)
		{
			if (i != j)
			{
				bool flag = true;
				for (index k = 0; k < n; k++)
					if (i != k and j != k and max(dist(a[i], a[k]), dist(a[k], a[j])) < dist(a[i], a[j]))
					{
						flag = false;
						break;
					}
				if (flag)
					g[i].push_back({j, Long(max(abs(a[i].first - a[j].first), abs(a[i].second - a[j].second)))});
			}
		}
	}
	vector<Long> dist(n, Long(514));
	vector<index> p(n, (index)-1);
	vector<bool> used(n);
	dist[0] = Long();
	for (index i = 0; i < n; i++)
	{
		index cur = (index)-1;
		for (index j = 0; j < n; j++)
		{
			if (!used[j] and (cur == (index)-1 or dist[j] < dist[cur]))
				cur = j;
		}
		used[cur] = true;
		for (auto j: g[cur])
		{
			if (dist[cur] + j.second < dist[j.first])
			{
				dist[j.first] = dist[cur] + j.second;
				p[j.first] = cur;
			}
		}
	}
	vector<index> ans;
	index cur = (index)n - 1;
	while (cur != (index)-1)
	{
		ans.push_back(cur);
		cur = p[cur];
	}
	cout << ans.size() << endl;
	reverse(ans.begin(), ans.end());
	for (auto i: ans)
		cout << i + 1 << " ";
	cout << endl;
}
