#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cassert>
#include <climits>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;
typedef unsigned int index;

void splice(index l, size_t r, vector<index> &a)
{
	vector<index> cp(a.begin() + l, a.begin() + r);
	index cur = 0;
	for (index i = 1; i < r - l; i += 2)
		a[l + cur] = cp[i], cur++;
	for (index i = 0; i < r - l; i += 2)
		a[l + cur] = cp[i], cur++;
}

index find(index i, vector<index> &a)
{
	for (index j = 0; j < a.size(); j++)
		if (a[j] == i)
			return j;
	return (index)-1;
}

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	size_t n;
	cin >> n;
	vector<index> a(n);
	for (auto &i: a)
		cin >> i, i--;
	vector<pair<index, size_t>> ans;
	for (index i = 0; i < n; i++)
	{
		index cur = find(i, a);
		while (cur != i)
		{
			if ((cur - i) % 2 == 1)
			{
				size_t r = cur + 1 + (rand() % (n - cur);
				splice(i, r, a); 
				ans.push_back({i, r});
			}
			else
			{
				size_t r = cur + 1 + (rand() % (n - cur);
				splice(i + 1, r, a); 
				ans.push_back({i + 1, r});
			}
			cur = find(i, a);
		}
	}
	cout << ans.size() << endl;
	for (auto i: ans)
		cout << i.first + 1 << " " << i.second << endl;
}
