#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
//#include "Source.h"

using namespace std;

typedef long long ll;

const int MSIZE = 3e5;
const ll INF = 2e9;
pair<ll, ll> treemin[MSIZE * 4];
pair<ll, ll> treemax[MSIZE * 4];
int n;
void buildmin(vector<ll>& a, int v, int tl, int tr) {
	if (tl == tr) {
		treemin[v] = { a[tl], tl };
		return;
	}
	int tm = (tl + tr) / 2;
	buildmin(a, v * 2, tl, tm);
	buildmin(a, v * 2 + 1, tm + 1, tr);
	treemin[v] = min(treemin[v * 2], treemin[v * 2 + 1]);
}

pair<ll, ll> getmin(int v, int tl, int tr, int l, int r) {
	if (l > r)
		return { INF, INF };
	if (tl == l && tr == r)
		return treemin[v];
	int tm = (tl + tr) / 2;
	return min(getmin(v * 2, tl, tm, l, min(r, tm)), getmin(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r));
}

void buildmax(vector<ll>& a, int v, int tl, int tr) {
	if (tl == tr) {
		treemax[v] = { a[tl], tl };
		return;
	}
	int tm = (tl + tr) / 2;
	buildmax(a, v * 2, tl, tm);
	buildmax(a, v * 2 + 1, tm + 1, tr);
	treemax[v] = max(treemax[v * 2], treemax[v * 2 + 1]);
}

pair<ll, ll> getmax(int v, int tl, int tr, int l, int r) {
	if (l > r)
		return {0, 0};
	if (tl == l && tr == r)
		return treemax[v];
	int tm = (tl + tr) / 2;
	return max(getmax(v * 2, tl, tm, l, min(r, tm)), getmax(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r));
}

int rec(int l, int r) {
	if (l > r)
		return 0;
	if (l == r)
		return 1;
	pair<ll, ll> a = getmin(1, 0, n - 1, l, r);
	pair<ll, ll> b = getmax(1, 0, n - 1, l, r);
	//cout << l << " " << r << " " << a.second << << endl;
	if (a.second == l)
		return 1 + rec(b.second + 1, r);
	else
		return rec(l, a.second - 1) + rec(a.second, r);
}

void solve() {
	cin >> n;
	vector<ll> v(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i];
	for (int i = 0; i < MSIZE * 4; ++i) {
		treemin[i] = { INF, INF };
		treemax[i] = { 0, 0 };
	}
	buildmin(v, 1, 0, n - 1);
	buildmax(v, 1, 0, n - 1);
	int res = rec(0, n - 1);
	cout << res;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

#ifdef Sam
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif 
	solve();

	return 0;
}
