#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <algorithm>
#include <functional>
#include <climits>
#include <cassert>
#include <cmath>
using namespace std;
typedef long long ll;
typedef unsigned long long llu;
//#define DEBUG
#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif // DEBUG
#define endl '\n'

typedef long long bint;
typedef pair<bint, int> edge;
struct point {
	int x, y;
};

vector<edge> *g;

bint dist(point &a, point &b) {
	int l = max(abs(a.x - b.x), abs(a.y - b.y));
	return (1 << l);
}
vector<int> from;

typedef pair<edge, int> edge_f;
void dijkstra(int n) {
	priority_queue<edge_f, vector<edge_f>, greater<edge_f> > q;
	q.push({ {0,0},-1 });
	vector<bool> used(n, false);
	while (!q.empty()) {
		auto v = q.top(); q.pop();
		int node = v.first.second;
		if (used[node])continue;
		from[node] = v.second;
		used[node] = true;
		for (auto d : g[node]) {
			q.push({ {v.first.first + d.first, d.second}, v.first.second});
		}
	}
}

void print(int n) {
	int tec = n - 1;
	vector<int> ans;
	while (tec != -1) {
		ans.push_back(tec + 1);
		tec = from[tec];
	}
	reverse(ans.begin(), ans.end());
	cout << ans.size() << endl;
	for (auto v : ans) {
		cout << v << " ";
	}
}

int main() {

	int n, m, k;
	cin >> n >> m >> k;
	point *p = new point[k];
	for (int i = 0; i < k; i++) {
		cin >> p[i].x >> p[i].y;
	}
	
	g = new vector<edge>[k];
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			g[i].push_back({ dist(p[i], p[j]), j });
		}
	}
	from.assign(k, -1);
	dijkstra(k);
	print(k);
	return 0;
}

