#include <iostream>
#include <fstream>
#include <set>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <stack>
#include <queue>
#include <algorithm>
#include <string>
#include <functional>
#include <cassert>
#include <cmath>
#include <climits>
#include <ctime>
using namespace std;
//#define DEBUG
#ifdef  DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif //  DEBUG
typedef long long ll;
typedef pair<int, int> pii;
list<pii> ans;

struct point
{
	int x, y;
};
bool xcomp(const point &a,const point &b) {
	return (a.x < b.x);
}

bool ycomp(const point &a, const point &b) {
	return (a.y < b.y);
}

vector<point> ps;

int orthSearch(int xmax, int ymin) {
	int res = 0;
	for (auto p : ps)if (p.x < xmax && p.y > ymin)res++;
	return res;
}

struct node {
	node *left = nullptr, *right = nullptr;
	int xl, xr;
	vector<point> ysort;
};

node *Build(vector<point> xsorted, int l, int r) {
	if (l > r) return nullptr;

	node *root = new node();
	for (int i = l; i <= r; i++)root->ysort.push_back(xsorted[i]);
	sort(root->ysort.begin(), root->ysort.end(), ycomp);
	int m = (l + r) >> 1;
	if (r == l) {
	   
	}
	else {
	   root->left = Build(xsorted, l, m);
	   root->right = Build(xsorted, m + 1, r);
	}

	root->xr = xsorted[r].x;
	root->xl = xsorted[l].x;
	return root;
}

int Query(node *tree, int xmax, int ymin) {
	if (tree == nullptr)return 0;
	if (tree->xl >= xmax)return 0;
	if (tree->xr < xmax) {
		return tree->ysort.end() - upper_bound(tree->ysort.begin(), tree->ysort.end(), point{ 0,ymin }, ycomp);
	}
	int res =  Query(tree->left, xmax, ymin) + Query(tree->right, xmax, ymin);
	return res;
}


int main() {
	int n, p;
	cin >> n >> p;
	int *a = new int[n];
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		point p = { i + a[i], i - a[i] };
		ps.push_back(p);
	}
	assert(p == 1);

	vector<point> psx = ps;
	sort(psx.begin(), psx.end(), xcomp);
	node *tree = Build(psx, 0, psx.size() - 1);

	for (int i = 0; i < n; i++) {
		//int ans = (orthSearch(ps[i].x, ps[i].y) + 1);
		int ans1 = (Query(tree, ps[i].x, ps[i].y) + 1);
		//assert(ans == ans1);
		cout << ans1 << endl;
	}

	return 0;
}
