#include <bits/stdc++.h>
using namespace std;
 
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
 
#define all(x) (x).begin(), (x).end()
#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second
 
const int MAXN = 150005;
const int MAXV = 1e9 + 7;
 
struct node {
    ll cnt;
    node *left, *right;
    node() {
        left = right = nullptr;
        cnt = 0;
    }
};
 
int n;
pair<ll, ll> a[MAXN];
node *root;
 
ll get(node *v) {
    if (v == nullptr) return 0;
    return v->cnt;
}
 
ll query(node *v, int tl, int tr, int l, int r) {
    if (r <= tl || tr <= l) return 0;
    if (l <= tl && tr <= r) return get(v);
    if (v == nullptr) return 0;
     
    int tm = tl + (tr - tl) / 2;
    ll a = query(v->left, tl, tm, l, r);
    ll b = query(v->right, tm, tr, l, r);
    return a + b;
}
 
node* update(node *v, int tl, int tr, int pos, int val) {
    if (v == nullptr) v = new node();
    if (tr - tl == 1) {
        v->cnt += val;
        return v;
    }
    int tm = tl + (tr - tl) / 2;
    if (pos < tm) {
        v->left = update(v->left, tl, tm, pos, val);
    } else {
        v->right = update(v->right, tm, tr, pos, val);
    }
    v->cnt = get(v->left) + get(v->right);
    return v;
}
 
int main() {
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
 
    cin >> n;
    rep(i, n) {
        cin >> a[i].f >> a[i].s;
    }
    // cout << endl;
 
    sort(a, a + n);
    reverse(a, a + n);
 
    rep(i, n) {
        root = update(root, 0, MAXV, a[i].s, 1);
    }
 
    ll res = INT_MIN;
    for (int i = 0; i < n; ++i) {
        ll s1 = (i + 1) * a[i].f;
        root = update(root, 0, MAXV, a[i].s, -1);
        for (int j = 0; j < n; ++j) {
            if (a[j].s > a[i].f) continue;
            ll s2 = query(root, 0, MAXV, a[j].s, MAXV) * a[j].s;
 
            if (s1 + s2 > res) {
                res = s1 + s2;
                // cout << a[i].f << ' ' << a[j].s << " = " << res << endl;
            }
        }
    }
 
    cout << res << endl;
}
