#include <bits/stdc++.h>
using namespace std;
 
#define int long long

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
 
#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second
#define all(x) (x).begin(), (x).end()
 

struct node {
    int val;
    node *left, *right;
    node(int x) {
        left = right = nullptr;
        val = x;
    }
};
 
int get(node *v) {
    if (v == nullptr) return 0;
    return v->val;
}
 
node* update(node *v, int tl, int tr, int pos) {
    if (v == nullptr) v = new node(0);
    if (tr - tl == 1) {
        v->val++;
        return v;
    }
 
    int tm = tl + (tr - tl) / 2;
    if (pos < tm) {
        v->left = update(v->left, tl, tm, pos);
    } else {
        v->right = update(v->right, tm, tr, pos);
    }
    v->val = get(v->left) + get(v->right);
    return v;
}
 
int query(node *v, int tl, int tr, int l, int r) {
    if (v == nullptr) return 0;
    if (r <= tl || tr <= l) return 0;
    if (l <= tl && tr <= r) return get(v);
 
    int tm = tl + (tr - tl) / 2;
    int a = query(v->left, tl, tm, l, r);
    int b = query(v->right, tm, tr, l, r);
    return a + b;
}
 
const int MAXV = 1e9 + 100;
const int MAXN = 400005;
int n, p;
int a[MAXN];
 
vector<int> solve() {
    vector<int> res(n);
    node *root = nullptr;
    for (int i = n - 1; i >= 0; --i) {
        // cout << i << endl;
        int v = a[i] + i;
        res[i] = query(root, 0, MAXV, 0, v);
        root = update(root, 0, MAXV, v);
    }
    return res;
}
 
vector<int> solve2() {
    vector<int> res(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (a[i] + i > a[j] + j) {
                res[i]++;
            }
        }
    }
    return res;
}
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
 
    cin >> n >> p;
    rep(i, n) {
        cin >> a[i];
    }
 
    auto res = solve();
    reverse(a, a + n);
    auto t = solve();
    reverse(all(t));
 
    rep(i, n) {
        cout << res[i] + t[i] + 1 << '\n';
    }
 
    // n = 20;
    // srand(time(0));
    // while (true) {
    //  n = rand() % 10 + 1;
    //  cout << n << endl;
    //  rep(i, n) {
    //      a[i] = rand() % 10;
    //      cout << a[i] << ' ';
    //  }
    //  cout << endl;
    //  auto p = solve();
    //  auto q = solve2();
    //  rep(i, n) {
    //      if (p[i] != q[i]) {
    //          rep(i, n) {
    //              cout << p[i] << ' ';
    //          } cout << endl;
    //          rep(i, n) {
    //              cout << q[i] << ' ';
    //          } cout << endl;
    //          return 0;
    //      }
    //  }
    // }
}