#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second
#define all(x) (x).begin(), (x).end()

const int MAXN = 400005;
int n, p;
int a[MAXN];
int t[MAXN * 4];

void update(int v, int tl, int tr, int pos) {
	if (tr - tl == 1) {
		t[v]++;
		return;
	}
	int tm = tl + (tr - tl) / 2;
	if (pos < tm) {
		update(v * 2 + 1, tl, tm, pos);
	} else {
		update(v * 2 + 2, tm, tr, pos);
	}
	t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}

int query(int v, int tl, int tr, int l, int r) {
	if (r <= tl || tr <= l) return 0;
	if (l <= tl && tr <= r) return t[v];

	int tm = tl + (tr - tl) / 2;
	int a = query(v * 2 + 1, tl, tm, l, r);
	int b = query(v * 2 + 2, tm, tr, l, r);
	return a + b;
}

vector<int> compress(const vector<int> &a) {
	int n = a.size();
	vector<int> res(n);
	vector<int> t(all(a));
	sort(all(t));
	t.erase(unique(all(t)), t.end());
	map<int, int> mp;
	rep(i, t.size()) {
		mp[t[i]] = i;
	}

	for (int i = 0; i < n; ++i) {
		res[i] = mp[a[i]];
	}
	return res;
}

vector<int> solve() {
	vector<int> res(n);
	vector<int> arr(n);
	for (int i = n - 1; i >= 0; --i) {
		arr[i] = a[i] + i;
	}

	arr = compress(arr);

	fill(t, t + MAXN * 4, 0);
	for (int i = n - 1; i >= 0; --i) {
		res[i] = query(0, 0, n, 0, arr[i]);
		update(0, 0, n, arr[i]);
	}
	return res;
}

int main() {
	cin >> n >> p;
	rep(i, n) {
		cin >> a[i];
	}

	auto t1 = solve();
	reverse(a, a + n);
	auto t2 = solve();
	reverse(all(t2));

	rep(i, n) {
		cout << t1[i] + t2[i] + 1 << '\n';
	}
}